{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit addContactDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  contacts, StdCtrls, Mask, ICQv7, JvMenus,  Buttons, ExtCtrls,
  Menus;

type
  TaddContactFrm = class(TForm)
    Label1: TLabel;
    menu: TJvPopupMenu;
    addBtn: TBitBtn;
    uinBox: TLabeledEdit;
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure addBtnClick(Sender: TObject);
    procedure addcontactAction(sender:Tobject);
    procedure FormShow(Sender: TObject);
    procedure uinBoxChange(Sender: TObject);
    procedure uinBoxKeyPress(Sender: TObject; var Key: Char);
  private
    c:Tcontact;
  public procedure destroyHandle;
  end;

var
  addContactFrm: TaddContactFrm;

implementation

uses
  utilLib, globalLib, mainDlg, roasterLib;

{$R *.DFM}

procedure TaddContactFrm.FormPaint(Sender: TObject);
begin drawTiled(canvas, getPic(PIC_WALLPAPER)) end;

procedure TaddContactFrm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
destroyHandle;
end;

procedure TaddContactFrm.addBtnClick(Sender: TObject);
var
  uin,i:integer;
begin
val(trim(uinBox.text), uin, i);
if (i>0) or not validUIN(uin) then
  msgDlg(___('invalid uin'), mtError)
else
  begin
  c:=contactsDB.get(uin);
  if c=icq.myinfo then
    msgDlg(___('invalid uin'),mtWarning)
  else
    if roasterLib.exists(c) then
      begin
      roasterLib.focus(c);
      msgDlg(___('already exists',[intTostr(uin)]),mtWarning)
      end
    else
      begin
      addGroupsToMenu(self,menu.items, addcontactAction);
      with clientToScreen(addBtn.BoundsRect.bottomRight) do
        menu.popup(x,y);
      end;
  end
end;

procedure TaddContactFrm.addcontactAction(sender:Tobject);
begin
addToRoaster(c, (sender as Tmenuitem).tag);
close;
saveLists;
end;

procedure TaddContactFrm.destroyHandle; begin inherited end;

procedure TaddContactFrm.FormShow(Sender: TObject);
begin
addBtn.glyph.assign(getPic(PIC_ADD_CONTACT));
icon:=pic2ico(PIC_ADD_CONTACT);
uinbox.text:='';
uinbox.setFocus;
applyTaskButton(self);
end;

procedure TaddContactFrm.uinBoxChange(Sender: TObject);
begin onlydigits(sender) end;

procedure TaddContactFrm.uinBoxKeyPress(Sender: TObject; var Key: Char);
begin
case key of
  #27: close;
  #13: addBtnClick(self);
  end;
end;

end.
