{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit automsgDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons;

type
  TautomsgFrm = class(TForm)
    msgBox: TMemo;
    popupChk: TCheckBox;
    okBtn: TBitBtn;
    cancelBtn: TBitBtn;
    predBox: TListBox;
    ok2enterChk: TCheckBox;
    nameBox: TEdit;
    Panel1: TPanel;
    saveBtn: TButton;
    deleteBtn: TButton;
    Bevel1: TBevel;
    procedure FormShow(Sender: TObject);
    procedure okBtnClick(Sender: TObject);
    procedure cancelBtnClick(Sender: TObject);
    procedure saveBtnClick(Sender: TObject);
    procedure deleteBtnClick(Sender: TObject);
    procedure predBoxClick(Sender: TObject);
    procedure msgBoxKeyPress(Sender: TObject; var Key: Char);
    procedure ok2enterChkClick(Sender: TObject);
    procedure nameBoxKeyPress(Sender: TObject; var Key: Char);
  public
    lastKey:char;
    procedure saveautomsg;
  public procedure destroyHandle;
  end;

var
  automsgFrm: TautomsgFrm;

implementation

{$R *.dfm}

uses
  globalLib, utilLib;

procedure TautomsgFrm.destroyHandle; begin inherited end;

procedure TautomsgFrm.FormShow(Sender: TObject);
var
  i:integer;
begin
applyTaskButton(self);
msgBox.text:=automessages[0];
popupChk.checked:=popupAutomsg;
ok2enterChk.checked:=okOn2enter_autoMsg;
msgBox.setFocus;
msgBox.SelectAll;

predBox.items.clear;
for i:=1 to automessages.count-1 do
  if odd(i) then
    predBox.items.add(automessages[i]);
end;

procedure TautomsgFrm.okBtnClick(Sender: TObject);
begin
autoaway.bakmsg:='';
popupAutomsg:=popupChk.checked;
setAutomsg(msgBox.text);
close;
end;

procedure TautomsgFrm.cancelBtnClick(Sender: TObject);
begin close end;

procedure TautomsgFrm.saveautomsg;
var
  i:integer;
begin
if trim(nameBox.text)='' then
  exit;
nameBox.visible:=FALSE;
deleteBtn.enabled:=TRUE;
i:=1;
while i < automessages.count do
  begin
  if compareText(automessages[i], nameBox.text)=0 then
    break;
  inc(i,2);
  end;
if i >= automessages.count then
  begin
  predBox.items.add(nameBox.text);
  automessages.add(nameBox.text);
  automessages.add('');
  end;
automessages[i+1]:=msgBox.text;
end; // saveAutomsg

procedure TautomsgFrm.saveBtnClick(Sender: TObject);
begin
if nameBox.visible then
  saveAutomsg
else
  begin
  deleteBtn.enabled:=FALSE;
  nameBox.visible:=TRUE;
  nameBox.setFocus;
  end
end;

procedure TautomsgFrm.deleteBtnClick(Sender: TObject);
var
  i:integer;
  name:string;
begin
if predBox.itemIndex < 0 then exit;
name:=predBox.items[predBox.itemIndex];
predBox.items.delete(predBox.itemIndex);
i:=1;
while i < automessages.count do
  begin
  if compareText(automessages[i], name)=0 then
    begin
    automessages.delete(i);
    automessages.delete(i);
    break;
    end;
  inc(i,2);
  end;
end;

procedure TautomsgFrm.predBoxClick(Sender: TObject);
begin
msgBox.text:=automessages[succ(predBox.itemIndex)*2]
end;

procedure TautomsgFrm.msgBoxKeyPress(Sender: TObject; var Key: Char);
begin
if (key=#13) and (lastKey=#13) and okOn2enter_automsg then
  begin
  key:=#0;
  okBtnClick(sender);
  end;
lastKey:=key;
end;

procedure TautomsgFrm.ok2enterChkClick(Sender: TObject);
begin
okOn2enter_autoMsg:=ok2enterChk.checked;
end;

procedure TautomsgFrm.nameBoxKeyPress(Sender: TObject; var Key: Char);
begin
if key=#27 then
  begin
  deleteBtn.enabled:=TRUE;
  nameBox.visible:=FALSE;
  end;
if key=#13 then
  begin
  key:=#0;
  saveautomsg;
  end;
end;

end.
