{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit chatDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Menus, ExtCtrls, ICQv7, contacts, history, historyVCL,
  Clipbrd, Buttons, Spin, CommCtrl,  selectContactsDlg,
  incapsulate, shellapi, events, strutils, types, ToolWin, ImgList, JvMenus,
  JvScrollBar, ThemeMgr;

const
  minimizedScroll=5;
  maximizedScroll=16;

type
  TscrollBarEx=class(Tjvscrollbar)
  protected
    P_entering :boolean;
    procedure CMMouseEnter(var msg: TMessage); message CM_MOUSEENTER;
    procedure CMMouseLeave(var msg: TMessage); message CM_MOUSELEAVE;
  public
    onEnter, onLeave:procedure of object;
    property entering:boolean read P_entering;
    end;

  TchatInfo=class
    who:Tcontact;
    single:boolean;        // single-message
    whole:boolean;         // see whole history
    autoscroll:boolean;    // auto scrolls along messages
    newSession:integer;    // where, in the history, does start new session
    lastInputText:string;  // last input.text before quoting sequence
    quoteIdx:integer;
    input:Tmemo;
    historyBox:ThistoryBox;
    splitter:Tsplitter;
    rsb:TscrollBarEx;
    lsb:TscrollbarEx;
    constructor create;
    function  historyNowCount:integer;
    function  historyNowOffset:integer;
    procedure updateAutoscroll();
    procedure setAutoscroll(v:boolean);
    procedure repaint();
    procedure repaintAndUpdateAutoscroll();
    end; // TchatInfo

  Tchats=class(Tlist)
    function validIdx(i:integer):boolean;
    function idxOf(c:Tcontact):integer;
    function idxOfUIN(uin:integer):integer;
    function byIdx(i:integer):TchatInfo;
    function byContact(c:Tcontact):TchatInfo;
    end; // Tchats

  TchatFrm = class(TForm)
    histmenu: TJvPopupMenu;
    copylinktoclipboard1: TMenuItem;
    copytoclipboard1: TMenuItem;
    selectall1: TMenuItem;
    viewmessageinwindow1: TMenuItem;
    saveas1: TMenuItem;
    html1: TMenuItem;
    txt1: TMenuItem;
    delete1: TMenuItem;
    favMenu: TJvPopupMenu;
    addlinktofavorites1: TMenuItem;
    panel: TPanel;
    sbar: TStatusBar;
    sendmenu: TJvPopupMenu;
    Sendmultiple1: TMenuItem;
    Sendwhenimvisibletohimher1: TMenuItem;
    pagectrl: TPageControl;
    SpinButton1: TSpinButton;
    closemenu: TJvPopupMenu;
    Closeall1: TMenuItem;
    Closeallbutthisone1: TMenuItem;
    CloseallOFFLINEs1: TMenuItem;
    chatsendmenuopen1: TMenuItem;
    chatcloseignore1: TMenuItem;
    sendIL: TImageList;
    sendTB: TToolBar;
    sendBtn: TToolButton;
    closeTB: TToolBar;
    closeBtn: TToolButton;
    toolbar: TToolBar;
    historyBtn: TSpeedButton;
    findBtn: TSpeedButton;
    smilesBtn: TSpeedButton;
    prefBtn: TSpeedButton;
    autoscrollBtn: TSpeedButton;
    infoBtn: TSpeedButton;
    quoteBtn: TSpeedButton;
    singleBtn: TSpeedButton;
    urlBtn: TSpeedButton;
    contactsBtn: TSpeedButton;
    smilesMenu: TJvPopupMenu;
    chatshowlsb1: TMenuItem;
    chatpopuplsb1: TMenuItem;
    N1: TMenuItem;
    addtoroaster1: TMenuItem;
    ThemeManager1: TThemeManager;
    procedure FormResize(Sender: TObject);
    procedure SplitterMoved(Sender: TObject);
    procedure splitterMoving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure sendBtnClick(Sender: TObject);
    procedure pageCtrlMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure pageCtrlChange(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure Viewinfo1Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure selectall1Click(Sender: TObject);
    procedure viewmessageinwindow1Click(Sender: TObject);
    procedure txt1Click(Sender: TObject);
    procedure html1Click(Sender: TObject);
    procedure infoBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure findBtnClick(Sender: TObject);
    procedure quoteBtnClick(Sender: TObject);
    procedure smilesBtnClick(Sender: TObject);
    procedure autoscrollBtnClick(Sender: TObject);
    procedure singleBtnClick(Sender: TObject);
    procedure copylinktoclipboard1Click(Sender: TObject);
    procedure copytoclipboard1Click(Sender: TObject);
    procedure contactsBtnClick(Sender: TObject);
    procedure urlBtnClick(Sender: TObject);
    procedure chatDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure chatDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure addlinktofavorites1Click(Sender: TObject);
    procedure historyBtnClick(Sender: TObject);
    procedure sbarDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
    procedure favMenuPopup(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure sbarMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Sendwhenimvisibletohimher1Click(Sender: TObject);
    procedure Sendmultiple1Click(Sender: TObject);
    procedure delete1Click(Sender: TObject);
    procedure pagectrlDrawTab(Control: TCustomTabControl; TabIndex: Integer; const Rect: TRect; Active: Boolean);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure Closeall1Click(Sender: TObject);
    procedure Closeallbutthisone1Click(Sender: TObject);
    procedure CloseallOFFLINEs1Click(Sender: TObject);
    procedure pagectrlChanging(Sender: TObject; var AllowChange: Boolean);
    procedure chatsendmenuopen1Click(Sender: TObject);
    procedure chatcloseignore1Click(Sender: TObject);
    procedure closeBtnClick(Sender: TObject);
    procedure prefBtnClick(Sender: TObject);
    procedure smilesMenuPopup(Sender: TObject);
    procedure histmenuPopup(Sender: TObject);
    procedure chatshowlsb1Click(Sender: TObject);
    procedure chathide1Click(Sender: TObject);
    procedure chatpopuplsb1Click(Sender: TObject);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure pagectrlMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  protected
    procedure WndProc(var Message: TMessage); override;
  private
    lastClick :Tdatetime;
    lastContact :Tcontact;
    procedure inputChange(Sender: TObject);
    procedure inputPopup(sender:Tobject; MousePos: TPoint; var Handled:Boolean);
    procedure inputKeydown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure insertFav(sender:TObject);
    procedure onHistoryRepaint(sender:TObject);
  public
    chats :Tchats;
    poppedup :Tpoint;
    enterCount :integer;
    selectedUIN :integer;
    function  isChatOpen(otherHand:Tcontact):boolean;
    function  openchat(otherHand:Tcontact):boolean;
    function  addEvent_openchat(otherhand:Tcontact; ev:Thevent):boolean; // opens chat if not already open
    function  addEvent(uin:integer; ev:Thevent):boolean; // tells if ev has been inserted in a list, or can be freed
    procedure openOn(c:Tcontact; focus:boolean=TRUE);
    procedure open(focus:boolean=TRUE);
    function  newIMchannel(c:Tcontact):integer;
    function  thisChat:TchatInfo;
    procedure setTab(idx:integer);
    procedure userChanged(c:Tcontact);
    procedure redrawTab(c:Tcontact);
    function  pageIndex:integer;
    procedure closeThisPage;
    procedure closeAllPages;
    procedure closePageAt(idx:integer);
    procedure closeChatWith(c:Tcontact);
    function  sawAllhere:boolean;
    function  isVisible:boolean;
    procedure applyFormXY;
    procedure rsbScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure lsbScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
    procedure lsbEnter;
    procedure updateRSB;
    procedure updateLSB;
    procedure histScrollEvent(d:integer);
    procedure histScrollLine(d:integer);
    procedure updateContactStatus;
    procedure quote();
    function  pageIdxAt(x,y:integer):integer;
    procedure setCaptionFor(c:Tcontact);
    procedure updateChatfrmXY;
    procedure setStatusbar(s:string);
    procedure moveToTime(c:Tcontact; time:Tdatetime);
    procedure moveToTimeOrEnd(c:Tcontact; time:Tdatetime);
    procedure sendMessageAction(sender:Tobject);
    procedure send; overload;
    procedure send(flags_:integer; msg:string=''); overload;
    procedure select(c:Tcontact);
    function  thisContact:Tcontact;
    procedure flash;
    function  grabThisText:string;
    procedure savePages;
    procedure loadPages;
    procedure updateGraphics;
    procedure addSmileAction(sender:Tobject);
    procedure setLeftSB(visible:boolean);
    procedure addcontactAction(sender:Tobject);
  end; // TchatFrm

var
  chatFrm: TchatFrm;

implementation

uses
  globalLib, viewInfoDlg, searchhistDlg, outboxlib, utilLib, outboxDlg, tipDlg,
  mainDlg, roasterLib, prefDlg;

{$R *.DFM}

procedure TscrollbarEx.CMMouseEnter(var msg: TMessage);
begin
P_entering:=TRUE;
if assigned(onEnter) then onEnter
end;

procedure TscrollbarEx.CMMouseLeave(var msg: TMessage);
begin
P_entering:=FALSE;
if assigned(onLeave) then onLeave
end;

constructor TchatInfo.create;
begin
inherited;
autoscroll:=TRUE;
quoteIdx:=-1;
end;

function Tchatinfo.historyNowCount:integer;
begin result:=historyBox.history.count-historyNowOffset end;

function Tchatinfo.historyNowOffset:integer;
begin if whole then result:=0 else result:=newSession end;

procedure Tchatinfo.updateAutoscroll();
begin
autoscroll:=historybox.lastEventIsFullyVisible or (historyNowCount=0);
chatfrm.autoscrollBtn.down:=autoscroll;
end;

procedure Tchatinfo.setAutoscroll(v:boolean);
begin autoscroll:=v; chatfrm.autoscrollBtn.down:=autoscroll end;

procedure Tchatinfo.repaint();
begin
if chatFrm.visible and not IsIconic(chatFrm.handle) then
	if autoscroll then historyBox.go2end
  else historyBox.repaint
end;

procedure Tchatinfo.repaintAndUpdateAutoscroll();
begin repaint; updateAutoscroll end;

/////////////////////////// Tchats /////////////////////////////////

function Tchats.idxOfUIN(uin:integer):integer;
begin
result:=0;
while result<count do
  begin
  if uin=TchatInfo(items[result]).who.uin then
    exit;
  inc(result);
  end;
result:=-1;
end; // idxOfUIN

function Tchats.idxOf(c:Tcontact):integer;
begin
result:=0;
while result<count do
  begin
  if TchatInfo(items[result]).who.equals(c) then
    exit;
  inc(result);
  end;
result:=-1;
end; // idxOf

function Tchats.byIdx(i:integer):TchatInfo;
begin
result:=NIL;
if validIdx(i) then
  result:=TchatInfo(items[i])
end; // byIdx

function Tchats.byContact(c:Tcontact):TchatInfo;
begin result:=byIdx(idxOf(c)) end;

function Tchats.validIdx(i:integer):boolean;
begin result:=(i >= 0) and (i < count) end;

/////////////////////////////////////////////////////////////////

procedure TchatFrm.FormResize(Sender: TObject);
var
  ch:TchatInfo;
begin
roundWindow(self);
updateChatfrmXY;
ch:=thisChat;
if ch = NIL then exit;
ch.repaintAndUpdateAutoscroll();
end; // formResize

function TchatFrm.addEvent_openchat(otherhand:Tcontact; ev:Thevent):boolean;
begin
openchat(otherHand);
result:=addEvent(otherhand.uin, ev);
end; // addEvent_openchat

function TchatFrm.addEvent(uin:integer; ev:Thevent):boolean;
var
  i:integer;
  ch:TchatInfo;
begin
result:=FALSE;
i:=chats.idxOfUIN(uin);
ch:=chats.byIdx(i);
if ch=NIL then ev.free
else
  begin
  result:=TRUE;
  ch.historyBox.history.add(ev);
  if i = pageIndex then
    ch.repaint();
  end
end; // addEvent

function TchatFrm.pageIndex:integer;
begin
if pageCtrl.activePage=NIL then
  result:=-1
else
  result:=pageCtrl.activePage.pageIndex
end; // pageIndex

function TchatFrm.openchat(otherHand:Tcontact):boolean;
var
  i:integer;
  wasEmpty,alreadyThere:boolean;
begin
wasEmpty:= pageCtrl.pageCount=0;
i:=chats.idxOf(otherHand);
alreadyThere:= i=pageIndex;
result:=i<0;
if result then
  i:=newIMchannel(otherHand);
if wasEmpty then
  setTab(i)
else
  if not alreadyThere then
    pageCtrlChange(self);
end; // openchat

function TchatFrm.isChatOpen(otherHand:Tcontact):boolean;
begin result:=chats.idxOf(otherHand) >= 0 end;

procedure TchatFrm.applyFormXY;
begin
with chatfrmXY do
  if width > 0 then
    begin
    if maximized then
      windowState:=wsMaximized
    else
      begin
      SetBounds(left,top,width,height);
      windowState:=wsNormal
      end;
  end;
end; // applyFormXY

procedure TchatFrm.FormCreate(Sender: TObject);
begin
chats:=Tchats.create;
applyFormXY;
applyTaskButton(self);
end;

procedure TchatFrm.setTab(idx:integer);
var
  bool:boolean;
begin
if assigned(pageCtrl.Onchanging) then
  begin
  bool:=TRUE;
  pageCtrl.OnChanging(self, bool);
  if bool=false then
    exit;
  end;
with pageCtrl do
  if idx < pageCount then
    activePage:=pages[idx]
  else
    msgDlg('error: bad page',mtError);  // should never reach this
if assigned(pageCtrl.onChange) then
  pageCtrl.onChange(self);
end; // setTab

procedure TchatFrm.userChanged(c:Tcontact);
var
  i:integer;
  ch:TchatInfo;
begin
ch:=thisChat;
if ch=NIL then exit;
if ICQ.myinfo.equals(c) then
  begin
  ch.repaintAndUpdateAutoscroll();
  exit;
  end;
i:=chats.idxOf(c);
if i < 0 then exit;
setCaptionFor(c);
redrawTab(c);
updateContactStatus;
if i = pageIndex then
  ch.repaintAndUpdateAutoscroll();
end; // userChanged

procedure TchatFrm.openOn(c:Tcontact; focus:boolean=TRUE);
var
  i:integer;
begin
if c=NIL then exit;
i:=chats.idxOf(c);
if i < 0 then
  i:=newIMchannel(c);
setTab(i);
open(focus);
end; // openOn

function TchatFrm.newIMchannel(c:Tcontact):integer;
var
  sheet:TtabSheet;
  chat:TchatInfo;
  pnl:Tpanel;
begin
chat:=TchatInfo.create;
chat.who:=c;
chat.single:=singleDefault;
if not assigned(TCE(c.data^).history) then
  TCE(c.data^).history:=Thistory.create;

sheet:=TtabSheet.create(self);
chats.Add(chat);
sheet.PageControl:=pageCtrl;
setCaptionFor(c);
result:=sheet.pageIndex;

pnl:=Tpanel.create(self);
pnl.parent:=sheet;
pnl.align:=alClient;
pnl.BevelInner:=bvNone;
pnl.BevelOuter:=bvNone;
pnl.BorderStyle:=bsSingle;

chat.historyBox:=ThistoryBox.create(self);
chat.historyBox.who:=c;
chat.historyBox.color:=theme.history.bgcolor;
chat.historyBox.history:=TCE(c.data^).history as Thistory;
chat.historyBox.align:=alClient;
chat.historyBox.Realign;
chat.historyBox.onDragOver:=chatDragOver;
chat.historyBox.onDragDrop:=chatDragDrop;
chat.historyBox.onPainted:=onHistoryRepaint;

chat.rsb:=TscrollbarEx.create(SELF);
with chat.rsb do
  begin
  parent:=sheet;
  align:=alRight;
  tabStop:=FALSE;
  onScroll:=rsbScroll;
  Kind:=sbVertical;
  position:=0;
  min:=0;
  max:=0;
  width:=maximizedScroll;
  smallChange:=1;
  largeChange:=5;
  enabled:=TRUE;
  visible:=FALSE;
  end;
chat.lsb:=TscrollbarEx.create(self);
with chat.lsb do
  begin
  parent:=sheet;
  align:=alLeft;
  tabStop:=FALSE;
  onScroll:=lsbScroll;
  onEnter:=lsbEnter;
  onLeave:=lsbEnter;
  Kind:=sbVertical;
  position:=0;
  min:=0;
  max:=0;
  if popupLSB then width:=minimizedScroll
  else width:=maximizedScroll;
  smallChange:=1;
  largeChange:=5;
  enabled:=FALSE;
  visible:=showLSB;
  hint:=___('chat byline popup hint');
  end;

pnl.insertControl(chat.historyBox);

chat.input:=Tmemo.create(self);
chat.input.parent:=sheet;
chat.input.align:=alBottom;
chat.input.WordWrap:=TRUE;
chat.input.Font.assign(theme.history.myfont);
chat.input.ScrollBars:=ssVertical;
chat.input.onChange:=inputChange;
chat.input.OnContextPopup:=inputPopup;
chat.input.onKeyDown:=inputKeydown;
chat.input.onDragOver:=chatDragOver;
chat.input.onDragDrop:=chatDragDrop;
if splitY > 0 then
  chat.input.height:=splitY
else
  chat.input.height:=50;
chat.input.color:=theme.history.bgcolor;

chat.splitter:=Tsplitter.create(self);
//chat.splitter.ResizeStyle:=rsUpdate;
chat.splitter.minsize:=1;
chat.splitter.parent:=sheet;
chat.splitter.align:=alBottom;
chat.splitter.cursor:=crVsplit;
chat.splitter.onMoved:=splitterMoved;
chat.splitter.OnCanResize:=splitterMoving;

chat.historyBox.realign;
resize;
savePages;
end; // newIMchannel

procedure TchatFrm.rsbScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
var
  ch:TchatInfo;
begin
with sender as Tscrollbar do
  begin
  if position = scrollpos then
    exit;
  ch:=thisChat;
  if ch=NIL then exit;
  ch.historyBox.topVisible:=scrollpos+ch.historyBox.offset;
  ch.historyBox.topOfs:=0;
  ch.historyBox.repaint;
  ch.updateAutoscroll();
  end;
end; // rsbScroll

procedure TchatFrm.lsbScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos: Integer);
var
  ch:TchatInfo;
begin
with sender as Tscrollbar do
  begin
  if position = scrollpos then
    exit;
  ch:=thisChat;
  if ch=NIL then exit;
  ch.historyBox.topOfs:=scrollpos;
  ch.historyBox.repaint();
  ch.updateAutoscroll();
  end;
end; // lsbScroll

procedure TchatFrm.updateRSB;
var
  ch:Tchatinfo;
begin
ch:=thisChat;
if ch=NIL then exit;
if ch.historyNowCount<2 then
  ch.rsb.visible:=FALSE
else
  begin
  ch.rsb.max:=ch.historyNowCount-1;
  ch.rsb.pagesize:=1;
  ch.rsb.position:=ch.historyBox.topVisible-ch.historyNowOffset;
  ch.rsb.visible:=TRUE;
  end;
end; // updateRSB

procedure TchatFrm.updateLSB;
var
  ch:Tchatinfo;
begin
ch:=thisChat;
if ch=NIL then exit;
if (ch.historyBox.topEventNrows<2) then ch.lsb.enabled:=FALSE
else
  begin
  ch.lsb.min:=0;
  ch.lsb.max:=ch.historyBox.topEventNrows-1;
  ch.lsb.pagesize:=1;
  ch.lsb.position:=ch.historyBox.topOfs;
  ch.lsb.enabled:=TRUE;
  end;
end; // updateLSB

function TchatFrm.thisChat:TchatInfo;
begin
if chats.count = 0 then
  result:=NIL
else
  result:=chats.byIdx(pageCtrl.ActivePage.pageIndex)
end;

procedure TchatFrm.sendBtnClick(Sender: TObject);
begin send end;

function TchatFrm.pageIdxAt(x,y:integer):integer;
var
  R:Trect;
begin
result:=0;
while result < chats.count do
  begin
  SendMessage(pagectrl.Handle, TCM_GETITEMRECT, result, Longint(@R));
  if ptInRect(R, point(x,y)) then
    exit;
  inc(result);
  end;
result:=-1;
end; // pageIdxAt

procedure TchatFrm.pageCtrlMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  diff:TdateTime;
  i:integer;
  ev:Thevent;
  b:boolean;
begin
case button of
  mbRight:
    begin
    i:=pageIdxAt(x,y);
    if i < 0 then exit;
    if i <> pageIndex then
    	begin
      b:=TRUE;
      pagectrlChanging(sender, b);
      if b then
      	begin
	      pagectrl.ActivePage:=pagectrl.Pages[i];
	      pagectrlChange(sender);
        end;
      end;
    end;
  mbLeft:
    begin
    diff:=now-lastClick;
    lastClick:=now;
    if diff < dblClickTime then
      begin
      ev:=eventQ.firstEventFor(thisContact);
      if ev<>NIL then
        begin
        eventQ.removeEvent(ev.kind, ev.who);
        realizeEvent(ev);
        end
      else
        closeThisPage;
      end;
    end;
  end;
end; // pagectrl mousedown

procedure TchatFrm.closeThisPage;
begin
if (pageCtrl.activePage = NIL) or (thisChat = NIL) then exit;
closePageAt(pageCtrl.activePage.TabIndex);
end; // closeThisPage

procedure TchatFrm.updateGraphics;
var
  ch:Tchatinfo;
  i:integer;
begin
ch:=thisChat;
if ch=NIL then exit;
ch.input.Font.assign(theme.history.myfont);
smilesBtn.down:=useSmiles;
historyBtn.down:=ch.whole;
singleBtn.down:=ch.single;
autoscrollBtn.down:=ch.autoscroll;
updateContactStatus;
ch.input.color:=theme.history.bgcolor;
sbar.panels[1].Width:=getPic(PIC_OUTBOX).Width+5;
i:=getPic(PIC_OUTBOX).height+6;
sbar.Height:=boundInt(i,22,50);
sbar.repaint;
if popupLSB then ch.lsb.width:=minimizedScroll
else ch.lsb.width:=maximizedScroll;
ch.historyBox.color:=theme.history.bgcolor;
ch.historyBox.repaint;
panel.Realign;
panel.repaint;
sendTB.Top:=(panel.ClientHeight-sendTB.Height) div 2;
closeTB.Top:=(panel.ClientHeight-closeTB.Height) div 2;
end; // updateGraphics

procedure TchatFrm.pagectrlChanging(Sender: TObject; var AllowChange: Boolean);
begin
lastContact:=thisChat.who;
TCE(thisChat.who.data^).keylay:=GetKeyboardLayout(0)
end;

procedure TchatFrm.pageCtrlChange(Sender: TObject);
var
  ch:TchatInfo;
begin
ch:=thisChat;
if ch=NIL then exit;
lastClick:=0;
inputChange(self);    // update char counter
setLeftSB(showLSB);
if autoSwitchKL
and assigned(lastContact)
and (lastContact<>ch.who)
and (TCE(ch.who.data^).keylay<>0) then
  ActivateKeyboardLayout(TCE(ch.who.data^).keylay,0);

if ch.autoscroll then ch.historyBox.go2end()
else ch.historyBox.repaint();
updateGraphics;
lastContact:=NIL;

if isVisible and enabled and pagectrl.visible and pagectrl.enabled then
  ch.input.setFocus;
end; // pageCtrlChange

procedure TchatFrm.inputKeydown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  x,y,i:integer;
  m:Tmemo;
  s:string;
begin
m:=thisChat.input;
if shift = [ssCtrl] then
  case key of
    VK_BS:
      begin
      x:=m.caretpos.x;
      y:=m.CaretPos.y;
      s:=m.lines[y];
      if x=0 then
        if y=0 then
          exit
        else
          begin
          m.lines.Delete(y);
          dec(y);
          x:=length(m.lines[y]);
          m.lines[y]:=m.lines[y]+s;
          end
      else
        begin
        while (x>0) and (s[x]=' ') do
          dec(x);
        i:=x-1;
        while (i>0) and ((s[x] in ALPHANUMERIC) = (s[i] in ALPHANUMERIC)) do
          dec(i);
        delete(s,i+1,m.caretpos.x-i);
        m.lines[y]:=s;
        x:=i;
        end;
      m.caretpos:=point(x,y);
      key:=0;
      end;
    end;
end;

procedure TchatFrm.inputPopup(Sender: TObject;
  MousePos: TPoint; var Handled:Boolean);
begin enterCount:=0 end;

procedure TchatFrm.inputChange(Sender: TObject);
begin
if thisChat<>NIL then with thisChat do
  begin
  sbar.panels[0].text:=___('chars')+' '+intToStr(length(input.Text));
  quoteIdx:=-1;
  end;
end;

procedure TchatFrm.Close1Click(Sender: TObject);
begin closeThisPage end;

procedure TchatFrm.Viewinfo1Click(Sender: TObject);
begin TviewInfoFrm.doAll(self, thisContact) end;

function TchatFrm.sawAllhere:boolean;
var
  c:Tcontact;
begin
result:=FALSE;
if thisChat=NIL then exit;
c:=thischat.who;
if eventQ.removeEvent(EK_msg, c)
or eventQ.removeEvent(EK_url, c)
or eventQ.removeEvent(EK_auth, c)
or eventQ.removeEvent(EK_authDenied, c)
or eventQ.removeEvent(EK_addedYou, c) then
  begin
  result:=TRUE;
  roasterLib.redraw(c);
  saveinboxDelayed:=TRUE;
  end;
if c.equals(tipfrm.contact) then
  tipfrm.hide();
end; // sawAllHere

procedure TchatFrm.histScrollEvent(d:integer);
var
  ch:Tchatinfo;
begin
ch:=thisChat;
if (ch=NIL)
or not ch.rsb.visible
or (ch.rsb.position=ch.rsb.Min) and (d<0)
or (ch.rsb.position=ch.rsb.Max) and (d>0) then
  exit;
ch.historyBox.startWithLastLine:=FALSE;
ch.rsb.position:=ch.rsb.position+d;
ch.historyBox.topVisible:=ch.historyBox.offset+ch.rsb.position;
ch.historyBox.topOfs:=0;
ch.historyBox.repaint();
ch.updateAutoscroll();
end; // histScrollEvent

procedure TchatFrm.histScrollLine(d:integer);
var
  ch:TchatInfo;
  h:ThistoryBox;
begin
ch:=thisChat;
h:=ch.historyBox;
h.startWithLastLine:=FALSE;
if d > 0 then
  begin
  if h.topOfs < h.topEventNrows-1 then
    begin
    inc(h.topOfs);
    h.repaint;
    end
  else
    if h.topVisible < h.offset+ch.historyNowCount-1 then
      histScrollEvent(+1)
  end
else
  if h.topOfs > 0 then
    begin
    dec(h.topOfs);
    h.repaint;
    end
  else
    if h.topVisible > h.offset then
      begin
      ch.rsb.position:=ch.rsb.position-1;
      h.topVisible:=h.offset+ch.rsb.position;
      h.startWithLastLine:=TRUE;
      h.repaint;
      end;
ch.updateAutoscroll();
end; // histScrollLine

procedure TchatFrm.FormKeyPress(Sender: TObject; var Key: Char);
var
  s:string;
  l:integer;
begin
if key<>#13 then
  enterCount:=0
else
  begin
  inc(enterCount);
  if (enterCount=sendOnEnter) then
    begin
    s:=thisChat.input.text;
    l:=2*pred(enterCount);
    delete(s,1+thisChat.input.SelStart-l, l);
    thisChat.input.text:=s;
    key:=#0;
    send;
    end;
  end;
case key of
  #27:close;
  #127,   // ctrl+bs
  #10:key:=#0;
  end;
end;

procedure TchatFrm.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  ch:TchatInfo;
begin
ch:=thisChat;
if shift = [] then
  case key of
    VK_APPS:
      begin
      clickedContact:=ch.who;
      with ch.historyBox.ClientToScreen(ch.historyBox.margin.TopLeft) do
        mainfrm.contactMenu.popup(x,y);
      end;
    end;
if shift = [ssAlt] then
  case key of
    VK_A:
      begin
      with autoscrollBtn do down:=not down;
      autoscrollBtnClick(self);
      end;
    VK_P:prefBtnClick(self);
    VK_I:infoBtnClick(self);
    VK_Q:quote();
    VK_F:findBtnClick(self);
    VK_H:
      begin
      with historyBtn do down:=not down;
      historyBtnClick(self);
      end;
    VK_M:
      begin
      with smilesBtn do down:=not down;
      smilesBtnClick(self);
      end;
    VK_BS: ch.input.Undo();
    end;
if (shift = [ssAlt]) or (shift = [ssAlt,ssCtrl]) then
  case key of
    VK_LEFT:pageCtrl.SelectNextPage(FALSE);
    VK_RIGHT:pageCtrl.SelectNextPage(TRUE);
    VK_UP,VK_DOWN,VK_PRIOR,VK_NEXT:
      case key of
        VK_UP:histScrollEvent(-1);
        VK_DOWN:histScrollEvent(+1);
        VK_PRIOR:histScrollEvent(-5);
        VK_NEXT:histScrollEvent(+5);
        end;
    VK_HOME:histScrollEvent(-ch.rsb.position);
    VK_END:
      begin
      ch.autoscroll:=TRUE;
      ch.repaintAndUpdateAutoscroll();
      end;
    end;
if shift = [ssCtrl] then
  case key of
    VK_PRIOR:histScrollEvent(-5);
    VK_NEXT:histScrollEvent(+5);
    VK_RETURN:send;
    VK_UP:histScrollLine(-1);
    VK_DOWN:histScrollLine(+1);
    VK_C:if ch.input.selLength=0 then clipboard.asText:=ch.historyBox.getSelText;
    VK_F6:pageCtrl.SelectNextPage(TRUE);
    VK_A:selectall1Click(self);
    end;
if (shift<>[]) or (key <> 13) then
  enterCount:=0;
end; // keydown

procedure TchatFrm.open(focus:boolean=TRUE);
var
  bak:Thandle;
begin
if chats.count = 0 then
  exit;
if not visible then
  bak:=getForegroundWindow
else
  bak:=0;
showForm(self);
if (bak>0) and not focus then
  forceforegroundwindow(bak);
SetWindowPos(Handle, HWND_TOP, 0,0,0,0, SWP_NOMOVE+SWP_NOSIZE); // bring it atop if it is not
if focus then
  begin
  bringForeground:=handle;
  thisChat.input.setFocus;
  end
else
  if isVisible then
    thisChat.input.setFocus;
end; // open

function TchatFrm.isVisible:boolean;
begin result:=getForegroundWindow=handle end;

procedure TchatFrm.quote();
var
  i:integer;
  oldPos:Tpoint;
  selected,s,result,leading:string;

  function addquote(s:string):string;
  begin
  if (length(leading)>0) and (leading[1] = '>') then result:='>'+s
  else result:='> '+s;
  end; // addquote

begin
if thisChat=NIL then exit;
with thisChat do
  begin
  input.setFocus;
  if historyBox.history.count = 0 then  // there's nothing to quote for sure
    exit;

  if quoting.quoteselected then selected:=trim(historyBox.getSelText)
  else selected:='';
  if selected='' then
    begin
    // save original reply at the beginning of a quoting-cycle
    if quoteIdx < 0 then
      lastInputText:=input.text;

    with historyBox.history do
      begin
      // search for a msg to quote
      if quoteIdx < 0 then i:=count-1
      else i:=quoteIdx-1;
      while (i>=0) and (getAt(i).who.equals(ICQ.myinfo)
      or not (getAt(i).kind in [EK_msg, EK_url, EK_automsg])) do
        dec(i);
      if i < 0 then  // nothing found, try restarting search from the end
        begin
        i:=count-1;
        while (i>=0) and (getAt(i).who.equals(ICQ.myinfo)
        or not (getAt(i).kind in [EK_msg, EK_url, EK_automsg])) do
          dec(i);
        end;
      if i < 0 then exit; // nothing found, really
      quoteIdx:=i;
      historyBox.canvas.font.assign(theme.history.myfont);
      selected:=getAt(i).getBodyText();
      end;
    end;

  result:='';
  while selected > '' do
    begin
    s:=trimright(chop(#10,selected));
    if s='' then continue;
    leading:=getLeadingInMsg(s);
    s:=wraptext(s, 50);
    result:=result+addquote(chop(CRLF,s))+CRLF;
    while s > '' do
      result:=result+addquote(chop(CRLF,s))+CRLF;
    end;
  i:=quoteIdx;
  oldPos:=input.CaretPos;
  input.text:=lastInputText;
  input.lines.add(result);
  if quoting.cursorBelow then
    input.selStart:=length(input.text)
  else
    input.CaretPos:=oldPos;
  quoteIdx:=i;
  end;
end; // quote

procedure TchatFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
updatechatfrmXY;
with searchhistFrm do
  if visible then close;
end; // form close

procedure TchatFrm.selectall1Click(Sender: TObject);
var
  ch:TchatInfo;
begin
ch:=thischat;
if ch=NIL then exit;
if ch.historyNowCount > 0 then
  begin
  ch.historyBox.select(ch.historyNowOffset, ch.historyBox.history.count-1);
//  clipboard.asText:=getSelText;
  ch.historyBox.repaint;
  ch.updateAutoscroll();
  end;
end; // select all

procedure TchatFrm.viewmessageinwindow1Click(Sender: TObject);
begin
if thisChat=NIL then exit;
with thisChat.historyBox do
  if somethingIsSelected then
    viewTextWindow(___('chat selection'), getSelText)
  else
    if pointedItem.kind<>PK_NONE then
      viewHeventWindow(pointedItem.ev);
end; // open

procedure TchatFrm.txt1Click(Sender: TObject);
var
  fn:string;
begin
if thisChat=NIL then exit;
fn:=savedlg(self, 'txt');
if fn = '' then exit;
savefile(fn, thisChat.historyBox.getSelText);
end; // txt

procedure TchatFrm.html1Click(Sender: TObject);
var
  fn:string;
begin
if thisChat=NIL then exit;
fn:=savedlg(self, 'html');
if fn = '' then exit;
savefile(fn, thisChat.historyBox.getSelHtml(FALSE));
end; // html

procedure TchatFrm.infoBtnClick(Sender: TObject);
begin viewInfoAbout(thisContact) end;

procedure TchatFrm.updateContactStatus;
var
  c:Tcontact;
  pic:Tbitmap;
begin
c:=thisContact;
if c=NIL then exit;
pic:=getPic(roasterImgIdxFor(c));
sendIL.Clear;
sendIL.width:=pic.width;
sendIL.height:=pic.height;
sendIL.AddMasked(pic,GetNearestColor(canvas.handle,pic.TransparentColor));
end; // updateSendBtn

procedure TchatFrm.closePageAt(idx:integer);
var
  old:TTabSheet;
begin
if (idx<0) or (idx >= pageCtrl.PageCount) then exit;
with chats.byIdx(idx) do
  begin
  lastContact:=who;
  newSession:=0;
  if historyBox.history<>NIL then
    historyBox.history.reset;
  old:=pageCtrl.Pages[idx];
  with old do
    begin
    while controlCount > 0 do
      controls[0].free;
    pageControl:=NIL;
    free;
    end;
  free;
  end;
chats.Delete(idx);
if pageCtrl.pageCount = 0 then
  close
else
  begin
  pagectrl.repaint;
  if pageCtrl.activePage=NIL  then
    pageCtrl.SelectNextPage(true)
  else
    pageCtrlChange(self)
  end;
if userTime > 0 then savePages;
end; // closePageAt

procedure TchatFrm.closeChatWith(c:Tcontact);
begin closePageAt(chats.idxOf(c)) end;

procedure TchatFrm.FormShow(Sender: TObject);
begin
icon:=getIco(ICO_MSG);
applyFormXY;
lastContact:=NIL;
end;

procedure TchatFrm.SpeedButton1Click(Sender: TObject);
begin viewInfoAbout(thisContact) end;

procedure TchatFrm.findBtnClick(Sender: TObject);
begin showForm(searchHistFrm) end;

procedure TchatFrm.quoteBtnClick(Sender: TObject);
begin quote end;

procedure TchatFrm.smilesBtnClick(Sender: TObject);
var
  ch:Tchatinfo;
begin
useSmiles:=smilesBtn.down;
ch:=thischat;
if ch=NIL then exit;
ch.repaintAndUpdateAutoscroll();
if visible then
  ch.input.SetFocus;
end;

procedure TchatFrm.closeAllPages;
begin
pagectrl.hide;
while pagectrl.PageCount > 1 do
  if pageIndex=0 then
    closePageAt(1)
  else
    closePageAt(0);
closePageAt(0);
pagectrl.show;
end;  // closeAllPages

procedure TchatFrm.autoscrollBtnClick(Sender: TObject);
var
  ch:Tchatinfo;
begin
ch:=thisChat;
if ch=NIL then exit;
ch.setAutoscroll(autoscrollBtn.down);
ch.repaint();
if visible then ch.input.SetFocus;
end;

procedure TchatFrm.redrawTab(c:Tcontact);
var
  i:integer;
  R:Trect;
begin
i:=chats.IdxOf(c);
if (i < 0) or (i >= pagectrl.PageCount) then exit;
SendMessage(pagectrl.Handle, TCM_GETITEMRECT, i, Longint(@R));
//R.right:=R.left+20;
invalidateRect(pagectrl.handle, @R, TRUE);
end;

procedure TchatFrm.setCaptionFor(c:Tcontact);
var
  i:integer;
begin
i:=chats.idxOf(c);
if (i >= 0) or (i < pagectrl.PageCount) then
  pageCtrl.pages[i].caption:=c.displayed+    // additional spaces for icon
    StringOfChar('_',1+getPic(PIC_STATUS_ONLINE).width div pagectrl.Canvas.TextWidth('_'));
end; // setCaptionFor

procedure TchatFrm.singleBtnClick(Sender: TObject);
begin thisChat.single:=singleBtn.down end;

procedure TchatFrm.WndProc(var Message: TMessage);
begin
case message.msg of
  WM_SYSCOMMAND: updatechatfrmXY;
  WM_mousewheel:
    if message.wparam shr 31 > 0 then chatFrm.histScrollEvent(+wheelVelocity)
    else chatFrm.histScrollEvent(-wheelVelocity);
  end;
inherited;
end; // WMmouseWheel

procedure TchatFrm.copylinktoclipboard1Click(Sender: TObject);
begin
with thisChat.historyBox do
  if pointedItem.kind=PK_LINK then
    clipboard.asText:=pointedItem.link.str;
end;

procedure TchatFrm.copytoclipboard1Click(Sender: TObject);
begin clipboard.asText:=thisChat.historyBox.getSelText end;

procedure TchatFrm.contactsBtnClick(Sender: TObject);
begin openSendContacts(thisContact) end;

procedure TchatFrm.urlBtnClick(Sender: TObject);
var
  p:Tpoint;
begin
clearMenu(favMenu.Items);
createFavMenu(favMenu.items, insertFav);
getCursorPos(p);
favmenu.Popup(p.x,p.y);
end;

procedure TchatFrm.chatDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin accept:=source=mainFrm.roaster end;

procedure TchatFrm.chatDragDrop(Sender, Source: TObject; X, Y: Integer);
var
  cl:TcontactList;
begin
if clickedContact=NIL then exit;
cl:=TcontactList.create;
cl.add(clickedContact);
outbox.add(OE_contacts, thisContact.uin, 0, cl);
outboxFrm.updateList;
cl.free;
end;

procedure TchatFrm.insertFav(sender:TObject);
var
  s,url:string;
  oldPos:integer;
begin
enterCount:=0;
url:=getURLfromFav((sender as Tmenuitem).hint);
application.hint:=url;
with thisChat.input do
  begin
  s:=text;
  oldPos:=selStart+selLength;
  insert(url, s, selStart+selLength+1);
  text:=s;
  selStart:=oldPos+length(url);
  end;
end; // insertFav

procedure TchatFrm.addlinktofavorites1Click(Sender: TObject);
begin
with thisChat.historyBox.pointedItem do
  if kind=PK_LINK then
    addLinkToFavorites(link.str);
end;

procedure TchatFrm.updatechatfrmXY;
begin
if not visible then exit;
chatfrmXY.top:=top;
chatfrmXY.left:=left;
chatfrmXY.height:=height;
chatfrmXY.width:=width;
chatfrmXY.maximized:=windowState=wsMaximized;
end; // updatechatfrmXY

procedure TchatFrm.historyBtnClick(Sender: TObject);
var
  olds,news:integer;
  ch:TchatInfo;
begin
ch:=thisChat;
if ch=NIL then exit;
ch.whole:=historyBtn.down;
if ch.whole then
  begin
  ch.historyBox.offset:=0;
  with ch.historyBox.history do
    if not loaded then
      begin
      olds:=count;
      Clear;
      fromString(loadFile(userPath+historyPath+intToStr(ch.who.uin)));
      news:=count-olds;
      inc(ch.newSession, news);
      inc(ch.historyBox.startSel.evIdx, news);
      inc(ch.historyBox.endSel.evIdx, news);
      inc(ch.historyBox.topVisible, news)
      end;
  end
else
  begin
  ch.autoscroll:=TRUE;
  ch.historyBox.offset:=ch.newSession;
  if ch.historyBox.topVisible < ch.historyBox.offset then
    ch.historyBox.topVisible:=ch.historyBox.offset;
  end;
ch.repaintAndUpdateAutoscroll();
if visible then ch.input.SetFocus;
end;

procedure TchatFrm.sbarDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel; const Rect: TRect);
begin
case panel.index of
  1:if outbox.stFor(thisContact) then
      drawPic(statusbar.canvas, rect.left,rect.top+1, PIC_OUTBOX)
    else
      drawPic(statusbar.canvas, rect.left,rect.top+1, PIC_OUTBOX_EMPTY)
  end;
end;

procedure TchatFrm.setStatusbar(s:string);
begin with sbar.Panels do items[count-1].text:=s end;

procedure TchatFrm.favMenuPopup(Sender: TObject);
begin hintMode:=HM_url end;

procedure TchatFrm.FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin hintMode:=HM_comm end;

procedure TchatFrm.sbarMouseUp(Sender: TObject; Button: TMouseButton;  Shift: TShiftState; X, Y: Integer);
begin
case whatStatusPanel(sbar, x) of
  1: outboxFrm.open(thisContact)
  end;
end;

procedure TchatFrm.moveToTimeOrEnd(c:Tcontact; time:Tdatetime);
var
  ch:TchatInfo;
  ev:Thevent;
begin
ch:=chats.byContact(c);
if ch=NIL then exit;
with ch.historyBox do
  begin
  go2end;
  ev:=history.getAt(topVisible);
  end;
if (ev=NIL) or (ev.when > time) then
  moveToTime(c,time)
end; // moveToTimeOrEnd

procedure TchatFrm.moveToTime(c:Tcontact; time:Tdatetime);
var
  ch:TchatInfo;
  h:Thistory;
  i:integer;

  function search:integer;
  begin
  result:=h.Count-1;
  while result >= 0 do
    if h.getAt(result).when <= time then
      break
    else
      dec(result);
  if result >= 0 then
    if h.getAt(result).when <> time then
      result:=-1;
  end; // search

begin
ch:=chats.byContact(c);
if ch=NIL then exit;
h:=ch.historyBox.history;
i:=search;
if (i < 0) and not ch.whole then
  begin
  historyBtn.down:=TRUE;
  historyBtnClick(self);
  i:=search;
  if i < 0 then
    begin
    historyBtn.down:=FALSE;
    historyBtnClick(self);
    end;
  end;
if i >= 0 then
  begin
  ch.rsb.position:=i;
  ch.historyBox.topVisible:=ch.historyBox.offset+ch.rsb.position;
  ch.historyBox.topOfs:=0;
  end;
ch.historyBox.repaint;
ch.updateAutoscroll();
end; // moveToTime

procedure TchatFrm.Sendwhenimvisibletohimher1Click(Sender: TObject);
begin send(IF_sendWhenImVisible) end;

procedure TchatFrm.Sendmultiple1Click(Sender: TObject);
var
  wnd:TselectContactsFrm;
  msg:string;
begin
msg:=grabThisText;
if trim(msg) = '' then
  begin
  msgDlg(___('chat cant send empty'),mtWarning);
  exit;
  end;
wnd:=TselectContactsFrm.doAll(mainFrm,
                              ___('send multiple title'),
                              ___('send multiple button'),
                              ICQ.readroaster.clone.add(notinlist),
                              sendMessageAction,
                              [sco_multi,sco_groups,sco_predefined]
                              );
wnd.toggle(thisContact);
wnd.icon:=getIco(ICO_MSG);
wnd.extra:=Tincapsulate.aString(msg);
inputChange(self);
end;

procedure TchatFrm.sendMessageAction(sender:Tobject);
var
  wnd:TselectContactsFrm;
  cl:TcontactList;
  msg:string;
begin
wnd:=(sender as Tcontrol).parent as TselectContactsFrm;
msg:=(wnd.extra as Tincapsulate).str;
cl:=wnd.selectedList;
with cl do
  begin
  resetEnumeration;
  while hasMore do
    begin
    outbox.add(OE_msg, getNext.uin, IF_multiple, msg);
    outboxFrm.updateList;
    end;
  end;
cl.free;
wnd.extra.free;
wnd.close;
end; // sendmessage action

procedure TchatFrm.delete1Click(Sender: TObject);
var
  st,en:integer;
begin
with thisChat.historyBox do
  begin
  if not wholeEventsAreSelected then exit;
  st:=startSel.evIdx;
  en:=endSel.evIdx;
  if st > en then swap(st,en);
  chatFrm.visible:=FALSE;
  history.deleteFromTo(userPath+historyPath+intToStr(thisContact.uin), st,en);
  chatFrm.visible:=TRUE;
  deselect();
  thischat.repaintAndUpdateAutoscroll();
  end;
end;

procedure TchatFrm.pagectrlDrawTab(Control: TCustomTabControl;
  TabIndex: Integer; const Rect: TRect; Active: Boolean);
var
  R:Trect;
  c:Tcontact;
  ev:Thevent;
begin
c:=chats.byIdx(tabindex).who;
with control.Canvas do
  begin
  R:=rect;
  fillrect(r);
  inc(r.left,4); inc(r.top,4);
  dec(r.right); dec(r.bottom);
  if active then
    inc(R.left,2);

  ev:=eventQ.firstEventFor(c);
  if ev<>NIL then
    begin
    if blinking or onStatusDisable[icq.myinfo.status].blinking then
      drawPic(control.canvas, R.left,R.top, ev.pic);
    inc(R.left, 1+getPic(ev.pic).width);
    end
  else
    if showStatusOnTabs then
      begin
      drawPic(control.canvas, R.left,R.top, roasterImgIdxFor(c));
      inc(R.left, 1+getPic(roasterImgIdxFor(c)).width);
      end;

  DrawText(Handle, PChar(c.displayed), -1, R, DT_SINGLELINE {or DT_CENTER or DT_VCENTER});
  end;
end;

procedure TchatFrm.lsbEnter;
begin
if not popupLSB then exit;
with thisChat.lsb do
  if not entering then
    hideScrollTimer:=10
  else
    begin
    hideScrollTimer:=0;
    width:=maximizedScroll;
    end;
end;

procedure TchatFrm.SpinButton1UpClick(Sender: TObject);
begin histScrollLine(-1) end;

procedure TchatFrm.SpinButton1DownClick(Sender: TObject);
begin histScrollLine(+1) end;

procedure TchatFrm.Closeall1Click(Sender: TObject);
begin closeAllPages end;

procedure TchatFrm.Closeallbutthisone1Click(Sender: TObject);
var
  i,sel:integer;
begin
try
  pagectrl.hide;
  sel:=pageIndex;
  for i:=chats.count-1 downto 0 do
    if i<>sel then
      closePageAt(i);
finally
  pagectrl.show;
end;
end;

procedure TchatFrm.CloseallOFFLINEs1Click(Sender: TObject);
var
  i:integer;
  c:Tcontact;
begin
c:=thisContact;
try
  pagectrl.hide;
  for i:=chats.count-1 downto 0 do
    if chats.byIdx(i).who.status = SC_OFFLINE then
      closePageAt(i);
finally
  pagectrl.show;
  select(c);
end;
end;

function TchatFrm.grabThisText:string;
begin
result:=thisChat.input.text;
thisChat.input.text:='';
// update char counter
inputChange(self);
end; // grabThisText

procedure TchatFrm.send;
var
  s:string;
  max:integer;
begin
enterCount:=0;
max:=ICQ.maxCharsFor(thisChat.who);
if length(thisChat.input.text) > max then
  begin
  msgDlg(___('too much chars',[max]),mtWarning);
  exit;
  end;
s:=grabThisText;
if trim(s)='' then
  close
else
  send(0,s)
end; // send

procedure TchatFrm.send(flags_:integer; msg:string='');
begin
if (thisChat=NIL) or not sendBtn.Enabled then exit;
if msg='' then
  msg:=grabThisText;
if trim(msg) = '' then
  begin
  msgDlg(___('chat cant send empty'),mtWarning);
  exit;
  end;
sawAllhere;
outbox.add(OE_msg, thisChat.who.uin, flags_, msg);
outboxFrm.updateList;
thisChat.input.setFocus;
if thisChat.single then
  begin
  closeThisPage;
  close;
  end;
end; // send

procedure TchatFrm.select(c:Tcontact);
var
  i:integer;
begin
if c=NIL then exit;
i:=chats.idxOf(c);
if i >= 0 then setTab(i);
end; // select

function TchatFrm.thisContact:Tcontact;
begin
if thisChat=NIL then
  result:=NIL
else
  thisContact:=thisChat.who
end; // thisContact

procedure TchatFrm.flash;
var
	rec:FLASHWINFO;
begin
if doFlashChat then
	begin
  rec.cbSize:=sizeOf(rec);
  rec.hwnd:=handle;
  rec.dwFlags:=FLASHW_CAPTION OR FLASHW_TRAY OR FLASHW_TIMERNOFG;
  rec.dwTimeout:=0;
  rec.uCount:=dword(-1);
  flashWindowEx(rec);
  end;
end; // flash

procedure TchatFrm.chatsendmenuopen1Click(Sender: TObject);
var
  i:integer;
  s:string;
begin
if (thisChat=NIL) or not sendBtn.Enabled then exit;
s:=grabThisText;
if trim(s) = '' then
  begin
  msgDlg(___('chat cant send empty'),mtWarning);
  exit;
  end;
for i:=0 to chats.count-1 do
  outbox.add(OE_msg, chats.byIdx(i).who.uin, IF_multiple, s);
outboxFrm.updateList;
thisChat.input.setFocus;
end;

procedure TchatFrm.chatcloseignore1Click(Sender: TObject);
begin
sawAllHere;
addToIgnoreList(thischat.who);
if messageDlg(___('remove on ignore', [thischat.who.displayed]), mtConfirmation, [mbYes,mbNo], 0) = mrYes then
  removeFromRoaster(thischat.who);
closeThisPage;
end;

procedure TchatFrm.savePages;
var
  cl:Tcontactlist;
  i:integer;
begin
cl:=Tcontactlist.create;
for i:=0 to chats.count-1 do
  cl.add(chats.byIdx(i).who);
saveFile(userPath+reopenchatsFileName, cl.toString);
cl.free;
end; // savePages

procedure TchatFrm.loadPages;
var
  cl:Tcontactlist;
begin
cl:=Tcontactlist.create;
cl.fromString(loadFile(userPath+reopenchatsFileName), contactsDB);
cl.resetEnumeration;
while cl.hasMore do
  openOn(cl.getNext);
cl.free;
end; // loadPages

procedure TchatFrm.closeBtnClick(Sender: TObject);
begin
sawAllHere;
closeThisPage
end;

procedure TchatFrm.prefBtnClick(Sender: TObject);
begin
showForm(WF_PREF);
prefFrm.pagesBox.ItemIndex:=15;
prefFrm.pagesBoxClick(NIL);
end;

procedure TchatFrm.smilesMenuPopup(Sender: TObject);
begin addSmilesToMenu(self,smilesMenu.Items,addSmileAction) end;

procedure TchatFrm.addSmileAction(sender:Tobject);
begin thisChat.input.SelText:=theme.smiles.ascii[(sender as Tmenuitem).tag-4000] end;

procedure TchatFrm.histmenuPopup(Sender: TObject);
begin
chatshowlsb1.checked:=showLSB;
chatpopuplsb1.visible:=showLSB;
chatpopuplsb1.checked:=popupLSB;
end;

procedure TchatFrm.chatshowlsb1Click(Sender: TObject);
begin setLeftSB(not showLSB) end;

procedure TchatFrm.setLeftSB(visible:boolean);
begin
showLSB:=visible;
thisChat.lsb.visible:=showLSB;
end;

procedure TchatFrm.chathide1Click(Sender: TObject);
begin setLeftSB(FALSE) end;

procedure TchatFrm.chatpopuplsb1Click(Sender: TObject);
begin
popupLSB:=not popupLSB;
updateGraphics;
end;

procedure TchatFrm.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
chatFrm.histScrollEvent(-wheelVelocity);
end;

procedure TchatFrm.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
chatFrm.histScrollEvent(+wheelVelocity);
end;

procedure TchatFrm.onHistoryRepaint(sender:TObject);
var
  ch:TchatInfo;
begin
ch:=thischat;
autoscrollBtn.down:=ch.autoscroll;
updateRSB;
updateLSB;
end; // onHistoryRepaint

procedure TchatFrm.addcontactAction(sender:Tobject);
begin addToRoaster( contactsDB.get(selectedUIN), (sender as Tmenuitem).tag) end;

procedure TchatFrm.pagectrlMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if button = mbRight then
  begin
  clickedContact:=thisChat.who;
  with mousepos do mainfrm.contactMenu.popup(x,y)
  end
end;

var
	// backup the values of autoscroll in the current chat
  bakAutoScroll:boolean;

procedure TchatFrm.splitterMoving(Sender: TObject; var NewSize: Integer; var Accept: Boolean);
begin bakAutoScroll:=thisChat.autoscroll end;

procedure TchatFrm.SplitterMoved(Sender: TObject);
begin
thisChat.autoscroll:=bakAutoScroll;
splitY:=thisChat.input.height;
formresize(self);
end; // splitterMoved

end.
