{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit codes;

interface

type
  Tcodes=class
   protected
    pairs:array [1..300] of record
      s:string;
      i:integer;
      end;
    n:integer;
   public
    constructor createAndLoad(fn:string);
    function fromString(s:string):integer;
    function fromInt(i:integer):string;
    procedure load(fn:string);
    function  strings:string;
    end; // Tcodes

implementation

uses
  sysutils, mainDlg, utilLib, globalLib;

constructor Tcodes.createAndLoad(fn:string);
begin
inherited create;
load(fn);
end; // createAndLoad

procedure Tcodes.load(fn:string);
var
  f:textfile;
  s:string;
  i:integer;
begin
assignFile(f,fn);
reset(f);
while not eof(f) do
  begin
  readln(f,s);
  s:=trim(s);
  i:=pos('=',s);
  if i > 0 then
    begin
    inc(n);
    pairs[n].s:=trim(copy(s,i+1,1000));
    pairs[n].i:=str2valor(trim(copy(s,1,i-1)));
    end;
  end;
closeFile(f);
end; // load

function Tcodes.fromString(s:string):integer;
var
  j:integer;
begin
result:=0;
j:=n;
while j > 0 do
  if pairs[j].s = s then
    begin
    result:=pairs[j].i;
    exit;
    end
  else
    dec(j);
end; // fromString

function Tcodes.fromInt(i:integer):string;
var
  j:integer;
begin
result:='';
j:=n;
while j > 0 do
  if pairs[j].i = i then
    begin
    result:=pairs[j].s;
    exit;
    end
  else
    dec(j);
end; // fromInt

function Tcodes.strings:string;
var
  j:integer;
begin
result:='';
for j:=1 to n do
  result:=result+pairs[j].s+CRLF;
end;

end.
