{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit converthistoriesDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls;

type
  TconvhistFrm = class(TForm)
    Label1: TLabel;
    progTotal: TProgressBar;
    list: TListBox;
    Label2: TLabel;
    progFile: TProgressBar;
    procedure FormPaint(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    oldPwd,newPwd:string;
  public procedure destroyHandle;
  end;

var
  convhistFrm: TconvhistFrm;

implementation

{$R *.dfm}

uses
  utilLib, globalLib, history;

procedure TconvhistFrm.FormPaint(Sender: TObject);
begin wallpaperize(canvas) end;

procedure TconvhistFrm.FormActivate(Sender: TObject);
var
  i:integer;
  h:Thistory;
  sr:TsearchRec;

  procedure update;
  var
    i,key:integer;
  begin
  if histcrypt.enabled then
    h.cryptMode:=CRYPT_KEY1
  else
    h.cryptMode:=CRYPT_SIMPLE;
  for i:=0 to h.Count-1 do
    with h.getAt(i) do
      begin
      // decrypt, if necessary and possible
      case cryptMode of
        CRYPT_SIMPLE: info:=decritted(info, who.uin);
        CRYPT_KEY1: info:=decritted(info, calculate_KEY1(oldPwd));
        else continue;
        end;
      // crypt, if necessary
      cryptMode:=h.cryptMode;
      if histcrypt.enabled then
        key:=histcrypt.pwdKey
      else
        key:=who.uin;
      info:=critted(info, key);
      end;
  end; // update

var
  oldHash,newHash:string;
begin
clientHeight:=progFile.boundsRect.bottom+5;
oldHash:=md5(oldPwd);
newHash:=md5(newPwd);
list.Items.Clear;
progFile.Position:=0;
progTotal.Position:=0;

i:=0;
if findFirst(userPath+historyPath+'*.*', faAnyFile, sr) = 0 then
  repeat
  if isOnlyDigits(sr.name) then inc(i)
  until findNext(sr) <> 0;
findClose(sr);
progTotal.max:=i;
progFile.max:=3;

if newPwd='' then
  histcrypt.enabled:=FALSE
else
  begin
  histcrypt.enabled:=TRUE;
  histcrypt.pwd:=newPwd;
  histcrypt.pwdKey:=calculate_KEY1(newPwd);
  end;

h:=Thistory.Create;
if findFirst(userPath+historyPath+'*.*', faAnyFile, sr) = 0 then
  repeat
  application.ProcessMessages;
  if isOnlyDigits(sr.name) then
    begin
    progTotal.Position:=progTotal.position+1;
    progFile.position:=0;
    h.fromString(loadFile(userPath+historyPath+sr.Name));
    progFile.position:=1;
    if (h.hashed>'') and (h.hashed<>oldHash) then
      list.items.add(sr.name)
    else
      begin
      h.hashed:=newHash;
      update;
      progFile.position:=2;
      saveFile(userPath+historyPath+sr.Name, h.toString);
      progFile.position:=3;
      end;
    h.reset;
    end;
  until findNext(sr) <> 0;
findClose(sr);
h.free;
if list.items.count=0 then
  close
else
  clientHeight:=list.boundsRect.bottom+5;
end;

procedure TconvhistFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin destroyHandle end;

procedure TconvhistFrm.destroyHandle; begin inherited end;

procedure TconvhistFrm.FormShow(Sender: TObject);
begin
applyTaskButton(self)
end;

end.
