{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit dbDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, icqv7, JvMenus, utilLib, contacts, Grids, ExtCtrls,
  Buttons, Menus;

type
  TdbFrm = class(TForm)
    menu: TJvPopupMenu;
    Viewinfo1: TMenuItem;
    Addtocontactlist1: TMenuItem;
    AddALLcontactstolist1: TMenuItem;
    grid: TStringGrid;
    openchat1: TMenuItem;
    panel: TPanel;
    purgeBtn: TButton;
    menudelete1: TMenuItem;
    GroupBox1: TGroupBox;
    nilChk: TRadioButton;
    barPnl: TPanel;
    resizeBtn: TSpeedButton;
    sbar: TStatusBar;
    reportBtn: TButton;
    removenilhistoriesChk: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure Viewinfo1Click(Sender: TObject);
    procedure AddALLcontactstolist1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure gridMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure openchat1Click(Sender: TObject);
    procedure addcontactAction(sender:Tobject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure resizeBtnClick(Sender: TObject);
    procedure purgeBtnClick(Sender: TObject);
    procedure menudelete1Click(Sender: TObject);
    procedure reportBtnClick(Sender: TObject);
  public
    procedure updateList;
    function  currentContact:Tcontact;
    procedure minimizePanel;
    procedure restorePanel;
  public procedure destroyHandle;
  end;

var
  dbFrm: TdbFrm;

implementation

{$R *.DFM}

uses
  globalLib, chatDlg, mainDlg;
var
  panelexpanded:boolean=TRUE;
  report:string='';

procedure TdbFrm.minimizePanel;
begin
if not panelExpanded then exit;
resizeBtn.glyph.assign(getPic(PIC_DOWN));
resizeBtn.width:=resizeBtn.glyph.Width+4;
panel.visible:=FALSE;
height:=height-panel.height;
panelExpanded:=FALSE;
end; // minimizePanel

procedure TdbFrm.restorePanel;
begin
if panelExpanded then exit;
resizeBtn.glyph.assign(getPic(PIC_UP));
resizeBtn.width:=resizeBtn.glyph.Width+4;
height:=height+panel.height;
barPnl.visible:=FALSE;
panel.visible:=TRUE;
barPnl.visible:=TRUE;
FormResize(NIL); // it causes the grid to resize
panelExpanded:=TRUE;
end; // minimizePanel

function TdbFrm.currentContact:Tcontact;
begin result:=Tcontact(grid.objects[0,grid.row]) end;

procedure TdbFrm.updateList;
var
  i,j:integer;
  c:Tcontact;
  cl:TcontactList;
begin
if not visible then exit;
with contactsDB do
  begin
  if count = 0 then
    begin
    grid.rowCount:=2;
    grid.Cells[0,1]:='';
    grid.Cells[1,1]:='';
    exit;
    end
  else
    grid.rowCount:=count+1;
  cl:=TcontactList.create;
  for j:=0 to count-1 do
    begin
    c:=getAt(j);
    i:=0;
    while (i<cl.count) and (compareText(c.displayed, cl.getAt(i).displayed)>0) do
      inc(i);
    cl.putAt(i, c);
    end;
  i:=1;
  cl.resetEnumeration;
  while cl.hasMore do
    begin
    c:=cl.getNext;
    grid.objects[0,i]:=c;
    grid.cells[0,i]:=intTostr(c.uin);
    grid.cells[1,i]:=c.displayed;
    inc(i);
    end;
  cl.free;
  sbar.simpleText:=___('db statusbar',[count]);
  end;
end; // updatelist

procedure TdbFrm.FormShow(Sender: TObject);
begin
minimizePanel;
grid.Cells[0,0]:=___('uin');
grid.Cells[1,0]:=___('nickname');
icon:=pic2ico(PIC_DB);
applyTaskButton(self);
updateList;
end;

procedure TdbFrm.Viewinfo1Click(Sender: TObject);
begin viewInfoAbout(currentContact)  end;

procedure TdbFrm.AddALLcontactstolist1Click(Sender: TObject);
var
  i:integer;
begin
if messageDlg(___('sure?'),mtConfirmation,[mbYes,mbNo],0)=mrNo then exit;
with contactsDB do
  for i:=0 to count-1 do
    addToRoaster(getAt(i));
end;

procedure TdbFrm.FormResize(Sender: TObject);
begin
grid.ColWidths[1]:=grid.clientWidth-grid.ColWidths[0]-5;
sbar.Width:=clientwidth-sbar.left;
end;

procedure TdbFrm.gridMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  row,col:integer;
begin
grid.mouseToCell(x,y,col,row);
if (row>=1) and (row <= contactsDB.count) then
  begin
  grid.row:=row;
  Addtocontactlist1.visible:=not ICQ.readroaster.exists(currentContact);
  if Addtocontactlist1.visible then
    addGroupsToMenu(self, Addtocontactlist1, addcontactAction);
  if shift = [ssRight] then
    with clientToScreen(point(x,y)) do
      menu.Popup(x,y);
  end;
end;

procedure TdbFrm.openchat1Click(Sender: TObject);
begin chatFrm.openOn(currentContact) end;

procedure TdbFrm.addcontactAction(sender:Tobject);
begin addToRoaster(currentContact, (sender as Tmenuitem).tag ) end;

procedure TdbFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin destroyHandle end;

procedure TdbFrm.destroyHandle; begin inherited end;

procedure TdbFrm.resizeBtnClick(Sender: TObject);
begin if panelexpanded then minimizePanel else restorePanel end;

procedure TdbFrm.purgeBtnClick(Sender: TObject);

  procedure purgeHistories;
  var
    sr:Tsearchrec;
    path:string;
    uin:integer;
  begin
  if not removenilhistoriesChk.checked then exit;
  path:=userPath+historyPath;
  if findFirst( path+'*', faAnyfile, sr ) = 0 then
    repeat
    if sr.attr and faDirectory <> 0 then continue;
    try
      uin:=strToInt(sr.name);
      if unexistant(uin) then
        if DeleteFile(path+sr.name) then
          report:=report+___('report history deleted',[sr.name])+CRLF
        else
          report:=report+___('error')+': cannot delete file '+sr.name+CRLF;
    except end;
    until findNext(sr) <> 0;
  findClose( SR );
  end; // purgeHistories

  procedure purgeContacts;
  var
    c:Tcontact;
    i:integer;
    removeIt:boolean;
  begin
  for i:=contactsDB.count-1 downto 0 do
    begin
    c:=contactsDB.getAt(i);
    removeIt:=FALSE;
    if nilChk.checked then removeIt:=unexistant(c.uin);
    if removeIt then
      begin
      contactsDB.remove(c);
      report:=report+___('report contact deleted',[c.displayed+' (UIN '+c.uinAsStr+')'])+CRLF;
      { The c object should be freed but, since objects are shared, we would
      { need a garbage collector system. since we are talking about few kbytes
      { i think it is fair to send back this to the next quit ;)
      }
      end;
    end;
  end; // purgeContacts

begin
report:=report+'---'+___('start')+' '+datetimeToStr(now)+CRLF;
purgeContacts;
updateList;
purgeHistories;
report:=report+'---'+___('end')+' '+datetimeToStr(now)+CRLF;
reportBtn.Visible:=TRUE;
end;

procedure TdbFrm.menudelete1Click(Sender: TObject);
begin
contactsDB.remove(currentContact);
updateList;
end;

procedure TdbFrm.reportBtnClick(Sender: TObject);
begin viewTextWindow(___('db purge report title'), report) end;

end.
