unit events_fr;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, CheckLst, JVSpin, ComCtrls, Mask, JvMaskEdit;

type
  TeventsFr = class(TFrame)
    GroupBox1: TGroupBox;
    Label9: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    trigBox: TCheckListBox;
    tipSpin: TJvSpinEdit;
    oncomingOnAwayChk: TCheckBox;
    tiptimesChk: TCheckBox;
    tipplusSpin: TJvSpinEdit;
    minOnOffSpin: TJvSpinEdit;
    Label4: TLabel;
    minOnOffChk: TCheckBox;
    flashchatChk: TCheckBox;
    Label1: TLabel;
    focuschatpopupChk: TCheckBox;
    eventBox: TComboBox;
    procedure eventBoxSelect(Sender: TObject);
    procedure trigBoxClickCheck(Sender: TObject);
    procedure tipSpinChange(Sender: TObject);
    procedure tiptimesChkClick(Sender: TObject);
    procedure tipplusSpinChange(Sender: TObject);
    procedure minOnOffChkClick(Sender: TObject);
    procedure eventBoxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

implementation

{$R *.dfm}

uses
  globalLib, utilLib, events, prefDlg;

procedure TeventsFr.eventBoxSelect(Sender: TObject);
var
  i:integer;
  ac:Tbehaction;
  b:boolean;
begin
i:=eventBox.itemIndex+1;
trigBox.items.Clear;
for ac:=low(ac) to high(ac) do
  begin
  trigBox.items.add(behactionName(ac));
  trigBox.ItemEnabled[ord(ac)-ord(low(ac))]:=ac in supportedBehactions[i];
  trigBox.checked[ord(ac)-ord(low(ac))]:=ac in tempBeh[i].trig;
  end;
b:=BE_tip in supportedBehactions[i];
tipSpin.enabled:=b;
tipSpin.value:=tempBeh[i].tiptime/10;
tipplusSpin.enabled:=b;
tipplusSpin.value:=tempBeh[i].tiptimeplus/10;
tiptimesChk.enabled:=b;
tiptimesChk.checked:=tempBeh[i].tiptimes;
end;

procedure TeventsFr.trigBoxClickCheck(Sender: TObject);
var
  i:integer;
  ac:Tbehaction;
begin
i:=eventBox.itemIndex+1;
for ac:=low(ac) to high(ac) do
  if trigBox.checked[ord(ac)-ord(low(ac))] then
    include(tempBeh[i].trig, ac)
  else
    exclude(tempBeh[i].trig, ac);
end;

procedure TeventsFr.tipSpinChange(Sender: TObject);
begin tempBeh[eventBox.itemIndex+1].tiptime:=round(tipSpin.value*10) end;

procedure TeventsFr.tiptimesChkClick(Sender: TObject);
begin tempBeh[eventBox.itemIndex+1].tiptimes:=tiptimesChk.checked end;

procedure TeventsFr.tipplusSpinChange(Sender: TObject);
begin tempBeh[eventBox.itemIndex+1].tiptimeplus:=round(tipplusSpin.value*10) end;

procedure TeventsFr.minOnOffChkClick(Sender: TObject);
begin prefFrm.updateVisible end;

procedure TeventsFr.eventBoxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  cnv:Tcanvas;
  x,y:integer;
begin
cnv:=eventBox.canvas;
cnv.fillrect(rect);
x:=2+rect.left;
y:=rect.top;
index:=integer(eventBox.items.objects[index]);
inc(x, 2+drawPic(cnv, x,y,event2imgidx(index)).cx);
cnv.textout(x,y,eventName(index));
end;

end.
