library example1;

uses
  forms, sysutils, types;

{$I plugin.inc }
{$I pluginutil.inc }

var
  callback:TpluginFun;      // &RQ callback function
  form:Tform;               // preferences form
  currentUser:integer;      // keep track of current user uin
  outBuffer:string;


// convert a string to a "plugin communication"
function str2comm(s:string):pointer;
begin
outBuffer:=_int(length(s))+s;
result:=@outBuffer[1];
end; // str2comm

// execute callback on a string instead of pointer
function callStr(s:string):pointer;
begin result:=callback(str2comm( s )) end;

function pluginFun(data:pointer):pointer; stdcall;
begin
result:=NIL;
if (data=NIL) or (_int_at(data)=0) then exit;
case _byte_at(data,4) of
  PM_EVENT:
    case _byte_at(data,5) of
      PE_INITIALIZE:
        begin
        callback:=_ptr_at(data,6);

        data:=callStr( char(PM_GET)+char(PG_USER) );
        currentUser:=_int_at(data, 5);

        result:=str2comm( char(PM_DATA)+_istring('Test plugin')+_int(APIversion) );
        end;
      PE_PREFERENCES:
        begin
        if not assigned(form) then form:=Tform.create(NIL);

        data:=callStr( char(PM_GET)+char(PG_DISPLAYED_NAME)+_int(currentUser) );
        form.caption:='hello '+_istring_at(data, 5);
        form.show;

        callStr(
          char(PM_CMD)+char(PC_SEND_MSG)+
          _int(currentUser)+_int(0)+_istring('sending a message to myself')
        );
        end;
      end;//case
  end;//case
end; // pluginFun

exports
  pluginFun;

end.
