{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit flap;

interface

uses
  sysutils, types;

const
  LOGIN_CHANNEL=1;
  SNAC_CHANNEL=2;
  LOGOUT_CHANNEL=4;
  KEEPALIVE_CHANNEL=5;

  FLAP_HEAD_SIZE=6;
  SNAC_HEAD_SIZE=10;
type
  TsnacService=word;

  TflapQueue=class(Tobject)
    buff:string;
    constructor create;
    procedure add(s:string);
    function  error:boolean;     // errore di protocollo,  necessario invocare popError per continuare
    function  errorTill:integer; // fino a questo byte i dati sono considerati errati
    function  available:boolean; // disponibilit di un pacchetto
    function  pop:string;        // estrale il pacchetto
    function  popError:string;   // estrae i dati errati dalla coda
    function  bodySize:integer;
    procedure reset;
    end; // TflapQueue

function dword_LE2ip(d:dword):string;
function invert(d:integer):integer;
function incPtr(p:pointer;d:integer):pointer;
function findTLV(idx:integer; s:string;ofs:integer=1):integer;
function existsTLV(idx:integer; s:string;ofs:integer=1):boolean;

// snac/flap/mp
function getFlapChannel(s:string):byte;
function getSnacService(s:string):TsnacService;
function getSnacRef(s:string):dword;
function getMPservice(s:string):word;

// build data
function qword_LEasStr(d:int64):string;
function dword_LEasStr(d:dword):string;
function dword_BEasStr(d:dword):string;
function word_BEasStr(w:word):string;
function word_LEasStr(w:word):string;
function SNAC(fam,sub,flags:word; ref:integer):string; overload;
function SNAC(fam,sub:word; ref:integer):string; overload;
function TLV(t:word; v:dword):string; overload;
function TLV(t:word; v:word):string; overload;
function TLV(t:word; v:integer):string; overload;
function TLV(t:word; v:string):string; overload;
function Length_LE(data:string):string;
function Length_BE(data:string):string;
function WNTS(s:string):string;

// read data
function qword_LEat(p:pointer):int64;
function dword_BEat(p:pointer):integer;
function dword_LEat(p:pointer):integer;
function word_LEat(p:pointer):word;
function word_BEat(p:pointer):word; overload;
function ptrWNTS(p:pointer):string;

function word_BEat(s:string; ofs:integer):word; overload;

function getBUIN(s:string; var ofs:integer):integer;
function getDLS(s:string; var ofs:integer):string;
function getWNTS(s:string; var ofs:integer):string;

function getTLV(p:pointer):string; overload;
function getTLVwordBE(p:pointer):word; overload;
function getTLVdwordBE(p:pointer):dword; overload;

function getTLV(idx:integer; s:string;ofs:integer=1):string; overload;
function getTLVwordBE(idx:integer; s:string;ofs:integer=1):word; overload;
function getTLVdwordBE(idx:integer; s:string;ofs:integer=1):dword; overload;

implementation

function getMPservice(s:string):word;
begin
result:=ord(s[16+11]);
if (result=$DA) or (result=$D0) then
  result:=result shl 8+ord(s[16+11+4])
end; // getMPservice

function getSnacRef(s:string):dword;
begin result:=dword_BEat(@s[13]) end;

function getSnacService(s:string):word;
begin result:=ord(s[8]) shl 8+ord(s[10]) end;

function getFlapChannel(s:string):byte;
begin result:=ord(s[2]) end;

function ptrWNTS(p:pointer):string;
begin
setLength(result, word(p^)-1);
move(incPtr(p,2)^, result[1], length(result));
end; // ptrWNTS

function getBUIN(s:string; var ofs:integer):integer;
begin
result:=strToInt(copy(s,ofs+1,ord(s[ofs])));
inc(ofs, 1+ord(s[ofs]));
end; // getBUIN

function getWNTS(s:string; var ofs:integer):string;
var
  i:integer;
begin
i:=word((@s[ofs])^);
result:=copy(s,ofs+2,i-1);
inc(ofs, 2+i);
end; // getWNTS

function getDLS(s:string; var ofs:integer):string;
var
  i:integer;
begin
i:=integer((@s[ofs])^);
if i > 100*1024 then
  result:=''
else
  begin
  result:=copy(s,ofs+4,i);
  inc(ofs, 4+i);
  end;
end; // getDLS

function incPtr(p:pointer;d:integer):pointer;
begin result:=pointer(integer(p)+d) end;

function existsTLV(idx:integer; s:string;ofs:integer):boolean;
begin result:=findTLV(idx,s,ofs)>0 end;

function findTLV(idx:integer; s:string;ofs:integer):integer;
begin
result:=-1;
while word_BEat(@s[ofs])<>idx do
  begin
  inc(ofs, word_BEat(@s[ofs+2])+4);
  if ofs >= length(s) then
    exit;
  end;
result:=ofs;
end; // findTLV

function getTLV(p:pointer):string; 
var
  pw:pword absolute p;
begin
if pw=NIL then
  result:=''
else
  begin
  inc(pw);
  setLength(result, swap(pw^));
  inc(pw);
  move(pw^, result[1], length(result));
  end;
end; // getTLV

function getTLVwordBE(p:pointer):word;
var
  pw:pword absolute p;
begin
inc(pw,2);
result:=swap(pw^);
end; // getTLVwordBE

function getTLVdwordBE(p:pointer):dword;
var
  pw:pword absolute p;
  pd:pinteger absolute p;
begin
inc(pw,2);
result:=invert(pd^);
end;

function getTLV(idx:integer; s:string; ofs:integer):string;
begin result:=getTLV(@s[findTLV(idx,s,ofs)]) end;

function getTLVwordBE(idx:integer; s:string;ofs:integer=1):word;
begin result:=getTLVwordBE(@s[findTLV(idx,s,ofs)]) end;

function getTLVdwordBE(idx:integer; s:string;ofs:integer=1):dword;
begin result:=getTLVdwordBE(@s[findTLV(idx,s,ofs)]) end;

function Length_LE(data:string):string;
begin result:=word_LEasStr(length(data))+data end;

function Length_BE(data:string):string;
begin result:=word_BEasStr(length(data))+data end;

function WNTS(s:string):string;
begin result:=Word_LEasStr(length(s)+1)+s+#0 end;

function TLV(t:word; v:dword):string;
begin result:=TLV(t,dword_BEasStr(v)) end;

function TLV(t:word; v:word):string;
begin result:=TLV(t,word_BEasStr(v)) end;

function TLV(t:word; v:integer):string;
begin result:=TLV(t,dword_BEasStr(v)) end;

function TLV(t:word; v:string):string;
begin result:=word_BEasStr(t)+word_BEasStr(length(v))+v end;

function SNAC(fam,sub,flags:word; ref:integer):string; overload;
begin result:=word_BEasStr(fam)+word_BEasStr(sub)+word_BEasStr(flags)+dword_BEasStr(ref) end;

function SNAC(fam,sub:word; ref:integer):string; overload;
begin result:=word_BEasStr(fam)+word_BEasStr(sub)+word_BEasStr(0)+dword_BEasStr(ref) end;

function invert(d:integer):integer;
begin result:=swap(d shr 16)+swap(d) shl 16 end;

function qword_LEat(p:pointer):int64;
begin result:=int64(p^) end;

function dword_BEat(p:pointer):integer;
begin result:=invert(integer(p^)) end;

function dword_LEat(p:pointer):integer;
begin result:=integer(p^) end;

function word_LEat(p:pointer):word;
begin result:=word(p^) end;

function word_BEat(p:pointer):word;
begin result:=swap(word(p^)) end;

function word_BEat(s:string; ofs:integer):word;
begin result:=word_BEat(@s[ofs]) end;

function dword_LE2ip(d:dword):string;
begin result:=format('%d.%d.%d.%d',[byte(d shr 24),byte(d shr 16),byte(d shr 8),byte(d)]) end;

function word_LEasStr(w:word):string;
begin result:=char(w)+char(w shr 8) end;

function word_BEasStr(w:word):string;
begin result:=char(w shr 8)+char(w) end;

function dword_BEasStr(d:dword):string;
begin result:=char(d shr 24)+char(d shr 16)+char(d shr 8)+char(d) end;

function dword_LEasStr(d:dword):string;
begin result:=char(d)+char(d shr 8)+char(d shr 16)+char(d shr 24) end;

function qword_LEasStr(d:int64):string;
begin
setLength(result,8);
move(d,result[1],8);
end; // qword_LEasStr

////////////////////////////// FLAP QUEUE ////////////////////////////

constructor TflapQueue.create;
begin reset end;

procedure TflapQueue.reset;
begin buff:='' end;

procedure TflapQueue.add(s:string);
begin buff:=buff+s end;

function TflapQueue.error:boolean;
begin
error:=((buff>'') and (buff[1]<>'*'))
  or ((length(buff)>1) and ((buff[2]=#0) or (buff[2]>#5)))
end; // error

function TflapQueue.errorTill:integer;
begin
result:=-1;
if buff='' then exit;
result:=1;
while (result<=length(buff)) and
      ((buff[result]<>'*') or (result<length(buff)) and ((buff[result+1]=#0) or (buff[result+1]>#4))) do
  inc(result);
end; // errorTill

function TflapQueue.popError:string;
var
  i:integer;
begin
i:=errorTill;
result:=copy(buff,1,i);
delete(buff,1,i);
end; // popError

function TflapQueue.bodySize:integer;
begin result:=word_BEat(@buff[5]) end;

function TflapQueue.available:boolean;
begin
result:=not error
   and (length(buff) >= FLAP_HEAD_SIZE)   // bodysize exists only if this is true
   and (length(buff) >= FLAP_HEAD_SIZE+bodySize)
end; // available

function TflapQueue.pop:string;
begin
if not available then
  begin
  result:='';
  exit;
  end;
result:=copy(buff,1,FLAP_HEAD_SIZE+bodysize);
delete(buff,1,FLAP_HEAD_SIZE+bodySize);
end; // pop

end.

