{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit globalLib;

interface

uses
  graphics, controls, comctrls, types, classes, forms, messages,
  icqv7, contacts, groupsLib, codes, events, pluginLib, trayLib,
  outboxLib, uinlistLib, smilesLib, roasterLib, dialogs;

const
  PREVIEWversion=FALSE;
  ANDRQversion:Longword=$00090411;  // remember: it's hex
type
  TwhatForm=(WF_PREF, WF_USERS, WF_WP);
  TformXY=record
    top,left,height,width:integer;
    maximized:boolean;
    end;
  TsortBy=( SB_NONE, SB_ALPHA, SB_EVENT );
  Tmacro=record
    hk :Tshortcut;
    sw :boolean;
    opcode :integer;
    data :string;
    end;
  Tmacros=array of Tmacro;
  Tbehaction=(BE_TRAY, BE_SOUND, BE_OPENCHAT, BE_HISTORY, BE_SAVE, BE_TIP, BE_POPUP);
  TwhatLog=(WL_connected, WL_disconnected, WL_serverGot, WL_serverSent, WL_heSent, WL_meSent);
  Tbehaviour=record
    trig:set of Tbehaction;
    tiptime:integer;
    tiptimes:boolean;
    tiptimeplus:integer;
    end;
  Tbehaviours=array [1..EK_last] of Tbehaviour;

  Tmsg=record
    text:string;
    kind:TMsgDlgType;
    time:Tdatetime;
    end;

  TCE=record
    history:Tobject;  // a probably wanted history, won't be saved to disk
    lastPriority:integer;
    node:Tnode;
    askedAuth:boolean;
    dontdelete:boolean;
    toquery:boolean;
    notes:string;
    keylay:integer;
    lastEventTime:Tdatetime;
    lastMsgTime:TdateTime;
    lastOncoming:Tdatetime;
    lastAutoMsg:string;
    lastAccept:TicqAccept;
    end;
  Thls=record h,l,s:double end; // H=[0,6] L=[0,1] S=[0,1]
  Tvisibility=(VI_invisible, VI_privacy, VI_normal, VI_all);

  TthemePropertyKind=(TP_font,TP_color,TP_file,TP_pic,TP_ico,TP_string,TP_sound);
  TthemeProperty=record
    section,name:string;
    kind:TthemePropertyKind;
    ptr:pointer;
    end;
  TproxyProto = (PP_SOCKS5, PP_SOCKS4, PP_HTTPS);
  Thostport = record host,port:string end;

const
  ANDRQclientID   =$FFFFFF7F;
  MIRANDAclientID =$FFFFFFFF;
  STRICQclientID  =$FFFFFF8F;
  YSMclientID     =$FFFFFFAB;
  MICQclientID    =$7d0001ea;
  MICQ2clientID   =$ffffff42;
  LICQclientID    =$7d000000;
  ALPHANUMERIC    = ['a'..'z','A'..'Z','0'..'9','','','','','','','','','',''];
  WHITESPACES     = [#9,#10,#13,#32];
  EMAILCHARS      = ['a'..'z','A'..'Z','0'..'9','-','_','.'];
  FTPURLCHARS     = [#33..#255];
  WEBURLCHARS     = FTPURLCHARS;
  EDURLCHARS      = WEBURLCHARS;
  DOCK_SNAP=5;
  MAIN_PICS=67;
  WM_DOCK=WM_USER+200;
  progLogonTotal=6.3;
  timeBetweenMsgs=25;
  saveDBdelay=100;
  searchDelay=3;
  DTseconds=1/(24*60*60);
  dblClickTime=0.3*DTseconds;
  statusWithAutoMsg=[SC_away,SC_na,SC_dnd,SC_occupied,SC_f4c];
  allBehactions=[BE_tray,BE_sound,BE_openchat,BE_history,BE_save,BE_tip,BE_popup];
  allBehactionsButTip=allBehactions-[BE_tip];

  // additional flags start from the top, to not collide with ICQv7 flags
  IF_sendWhenImVisible  = 1 shl 31;
  IF_pager = 1 shl 30; // it is a pager message

  // roasterItalic values
  RI_none = 0;
  RI_list = 1;
  RI_visibleto = 2;

  // filenames
  userthemeFilename='user.theme.ini';
  eventslogFilename='events.log';
  packetslogFilename='packets.log';
  automsgFilename='automsg.ini';
  commonFileName='common.ini';
  configFileName='andrq.ini';
  groupsFilename='groups.ini';
  myinfoFilename='myinfo';
  inboxFilename='inbox';
  outboxFilename='outbox';
  macrosFilename='macros';
  dbFilename='db';
  defaultPrefix='default.';
  langFilename='lang.txt';
  uinlistFilename='uinlists';
  reopenchatsFileName='reopen.list.txt';
  cachedThemeFilename='cache.theme';

  // recent version of list files have a trailing .txt
  // here i keep old filenames to be able to load old versions
  roasterFileName='contact.list';
  visibleFileName='visible.list';
  invisibleFileName='invisible.list';
  ignoreFileName='ignore.list';
  nilFilename='not.in.list';
  retrieveFilename='retrieve.list';
  // paths
  historyPath='history\';
  pluginsPath='plugins\';
  themesPath='themes\';
  langsPath='lang\';

  // macro opcodes
  OP_NONE=0;
  OP_CHAT=1;
  OP_ROASTER=2;
  OP_TRAY=3;
  OP_CLEAREVENT=4;
  OP_CLEAREVENTS=5;
  OP_POPEVENT=6;
  OP_QUIT=7;
  OP_SHUTDOWN=8;
  OP_GROUPS=9;
  OP_MAINMENU=10;
  OP_STATUSMENU=11;
  OP_VISIBILITYMENU=12;
  OP_BROWSER=13;
  OP_OFFLINECONTACTS=14;
  OP_AUTOSIZE=15;
  OP_CONNECT=16;
  OP_CD_PLAY=17;
  OP_CD_STOP=18;
  OP_VIEWINFO=19;
  OP_ADDBYUIN=20;
  OP_WP=21;
  OP_TOGGLEBORDER=22;
  OP_PREFERENCES=23;
  OP_LOCK=24;
  OP_HINT=25;
  OP_TIP=26;
  OP_RELOADTHEME=27;
  OP_RELOADLANG=28;
  OP_VISIBLE_TO=29;
  OP_TOGGLE_SOUND=30;
  OP_LAST=30;

  macro2str:array [OP_CHAT..OP_LAST] of string=(
    'chat',
    'roaster',
    'tray',
    'clear event',
    'clear events',
    'pop event',
    'quit',
    'shutdown',
    'groups',
    'main menu',
    'status menu',
    'visibility menu',
    'browser',
    'offline contacts',
    'autosize',
    'connect',
    'cd play',
    'cd stop',
    'view info',
    'by uin',
    'wp',
    'toggle border',
    'preferences',
    'lock',
    'show hint',
    'tip',
    'reload theme',
    'reload language',
    'visible to',
    'toggle sound'
  );

  CRLF=#13#10;
  NL=#10;

  VK_A=65;
  VK_B=66;
  VK_C=67;
  VK_D=68;
  VK_E=69;
  VK_F=70;
  VK_G=71;
  VK_H=72;
  VK_I=73;
  VK_J=74;
  VK_K=75;
  VK_L=76;
  VK_M=77;
  VK_N=78;
  VK_O=79;
  VK_P=80;
  VK_Q=81;
  VK_R=82;
  VK_S=83;
  VK_T=84;
  VK_U=85;
  VK_V=86;
  VK_W=87;
  VK_X=88;
  VK_Y=89;
  VK_Z=90;
  VK_ESC=27;
  VK_BS=8;

  PIC_EMPTY                       =00;
  PIC_STATUS_UNK                  =01;
  PIC_STATUS_ONLINE               =02;
  PIC_STATUS_OCCUPIED             =03;
  PIC_STATUS_DND                  =04;
  PIC_STATUS_NA                   =05;
  PIC_STATUS_AWAY                 =06;
  PIC_STATUS_F4C                  =07;
  PIC_STATUS_OFFLINE              =08;
  PIC_CONNECTING                  =09;
  PIC_INVISIBLE_STATUS_ONLINE     =10;
  PIC_INVISIBLE_STATUS_OCCUPIED   =11;
  PIC_INVISIBLE_STATUS_DND        =12;
  PIC_INVISIBLE_STATUS_NA         =13;
  PIC_INVISIBLE_STATUS_AWAY       =14;
  PIC_INVISIBLE_STATUS_F4C        =15;
  PIC_INVISIBLE_STATUS_OFFLINE    =16;
  PIC_INVISIBLE_CONNECTING        =17;
  PIC_RENAME                      =18;
  PIC_QUIT                        =19;
  PIC_MINIMIZE                    =20;
  PIC_RESTORE                     =21;
  PIC_DELETE                      =22;
  PIC_KEY                         =23;
  PIC_ADD_CONTACT                 =24;
  PIC_INFO                        =25;
  PIC_SEARCH                      =26;
  PIC_1_MSG                       =27;
  PIC_QUOTE                       =28;
  PIC_SMILES                      =29;
  PIC_PREFERENCES                 =30;
  PIC_USERS                       =31;
  PIC_WP                          =32;
  PIC_UIN                         =33;
  PIC_OFFGOING                    =34;
  PIC_MAIL                        =35;
  PIC_CONTACTS                    =36;
  PIC_MSG                         =37;
  PIC_AUTH_REQ                    =38;
  PIC_OTHER_EVENT                 =39;
  PIC_ONCOMING                    =40;
  PIC_URL                         =41;
  PIC_FILE                        =42;
  PIC_GCARD                       =43;
  PIC_NEW_GROUP                   =44;
  PIC_OPEN_GROUP                  =45;
  PIC_CLOSE_GROUP                 =46;
  PIC_OUT_OF_GROUPS               =47;
  PIC_SAVE                        =48;
  PIC_OUTBOX                      =49;
  PIC_OUTBOX_EMPTY                =50;
  PIC_HISTORY                     =51;
  PIC_UNCHECKED                   =52;
  PIC_CHECKED                     =53;
  PIC_RATMAN                      =54;
  PIC_SPECIAL                     =55;
  PIC_EYE                         =56;
  PIC_DOWN                        =57;
  PIC_UP                          =58;
  PIC_RIGHT                       =59;
  PIC_LEFT                        =60;
  PIC_VISIBILITY                  =61;
  PIC_VISIBILITY_NONE             =62;
  PIC_VISIBILITY_PRIVACY          =63;
  PIC_VISIBILITY_NORMAL           =64;
  PIC_VISIBILITY_ALL              =65;
  PIC_VISIBLE_TO                  =66;
  PIC_SMS                         =67;
  PIC_MENUBAR                     =68;
  PIC_WALLPAPER                   =69;
  PIC_LOAD_NET                    =70;
  PIC_SAVE_NET                    =71;
  PIC_SCROLL_UP                   =72;
  PIC_SCROLL_DOWN                 =73;
  PIC_ADDEDYOU                    =74;
  PIC_SPLASH                      =75;
  PIC_DB                          =76;
  PIC_REFRESH                     =77;
  PIC_DOWNLOAD                    =78;
  PIC_SUPPORT                     =79;
  PIC_LAST                        =79;

  pic2str:array [0..PIC_LAST] of string=(
    'empty',
    'status.unk',
    'status.online',
    'status.occupied',
    'status.dnd',
    'status.na',
    'status.away',
    'status.f4c',
    'status.offline',
    'connecting',
    'invisible.status.online',
    'invisible.status.occupied',
    'invisible.status.dnd',
    'invisible.status.na',
    'invisible.status.away',
    'invisible.status.f4c',
    'invisible.status.offline',
    'invisible.connecting',
    'rename',
    'quit',
    'minimize',
    'restore',
    'delete',
    'key',
    'add.contact',
    'info',
    'search',
    '1.msg',
    'quote',
    'smiles',
    'preferences',
    'users',
    'wp',
    'uin',
    'offgoing',
    'mail',
    'contacts',
    'msg',
    'auth.req',
    'other.event',
    'oncoming',
    'url',
    'file',
    'gcard',
    'new.group',
    'open.group',
    'close.group',
    'out.of.groups',
    'save',
    'outbox',
    'outbox.empty',
    'history',
    'unchecked',
    'checked',
    'ratman',
    'special',
    'eye',
    'down',
    'up',
    'right',
    'left',
    'visibility',
    'visibility.none',
    'visibility.privacy',
    'visibility.normal',
    'visibility.all',
    'visible.to',
    'sms',
    'menubar',
    'wallpaper',
    'load.net',
    'save.net',
    'scroll.up',
    'scroll.down',
    'addedyou',
    'splash',
    'db',
    'refresh',
    'download',
    'support'
  );

  ICO_EMPTY                       =00;
  ICO_AUTH_REQ                    =01;
  ICO_OTHER_EVENT                 =02;
  ICO_URL                         =03;
  ICO_MSG                         =04;
  ICO_CONTACTS                    =05;
  ICO_ONCOMING                    =06;
  ICO_OFFGOING                    =07;
  ICO_ADDEDYOU                    =08;
  ICO_GCARD                       =09;
  ICO_FILE                        =10;
  ICO_STATUS_ONLINE               =11;
  ICO_STATUS_OCCUPIED             =12;
  ICO_STATUS_DND                  =13;
  ICO_STATUS_NA                   =14;
  ICO_STATUS_AWAY                 =15;
  ICO_STATUS_F4C                  =16;
  ICO_STATUS_OFFLINE              =17;
  ICO_CONNECTING                  =18;
  ICO_INVISIBLE_STATUS_ONLINE     =19;
  ICO_INVISIBLE_STATUS_OCCUPIED   =20;
  ICO_INVISIBLE_STATUS_DND        =21;
  ICO_INVISIBLE_STATUS_NA         =22;
  ICO_INVISIBLE_STATUS_AWAY       =23;
  ICO_INVISIBLE_STATUS_F4C        =24;
  ICO_INVISIBLE_STATUS_OFFLINE    =25;
  ICO_INVISIBLE_CONNECTING        =26;
  ICO_LAST                        =26;

  ico2str:array [0..ICO_LAST] of string=(
    'empty',
    'auth.req',
    'other.event',
    'url',
    'msg',
    'contacts',
    'oncoming',
    'offgoing',
    'addedyou',
    'gcard',
    'file',
    'status.online',
    'status.occupied',
    'status.dnd',
    'status.na',
    'status.away',
    'status.f4c',
    'status.offline',
    'connecting',
    'invisible.status.online',
    'invisible.status.occupied',
    'invisible.status.dnd',
    'invisible.status.na',
    'invisible.status.away',
    'invisible.status.f4c',
    'invisible.status.offline',
    'invisible.connecting'
  );

  BALLOON_NEVER  = 0;
  BALLOON_ALWAYS = 1;
  BALLOON_BDAY   = 2;
  BALLOON_DATE   = 3;

  icqerror2str:array [TicqError] of string=(
    'rate exceeded',
    'can''t connect',
    'disconnected',
    'unknown',
    'incorrect uin',
    'missing pwd',
    'another login',
    'server disconnected',
    'wrong pwd',
    'can''t change pwd',
    'delay',
    'can''t create uin',
    'invalid flap',
    'bad contact',
    'can''t directly connect',
    'proxy: error',
    'proxy: wrong user/pwd',
    'proxy: unk'
  );
  behactions2str:array [Tbehaction] of string=('tray','sound','openchat',
    'history','save','tip','popupchat');
  sortby2str:array [TsortBy] of string=('none','alpha','event');
  status2str:array [Tstatus] of string=('online','occupied','dnd','na','away',
    'f4c','offline','unk');
  visibility2str:array [Tvisibility] of string=('invisible','privacy','normal',
    'all');
  proxyproto2str:array [TproxyProto] of string=('SOCKS5','SOCKS4','HTTP/S');

var
  myPath, userPath, lang, langPath, defaultLangPath :string;
  ICQ :TicqSession;
  gmtCodes,languageCodes,countryCodes,pastCodes,ageCodes,interestCodes,genderCodes :Tcodes;
  eventQ :TeventQ;
  plugins :Tplugins;
  progLogon :double;
  statusIcon :TstatusIcon;
  hintMode :(HM_null,HM_url,HM_comm);
  usertime :integer;
  startTime :TdateTime;
  WM_TASKBARCREATED :longword;
  contactsPnl, freePnl :TstatusPanel;
  locked, startingLock :boolean;
  outboxSbarRect :Trect;
  hotkeysEnabled :boolean;
  supportedBehactions :array [1..EK_last] of set of Tbehaction;
  availableUsers :array of record name,uinStr,path:string; uin:integer end;
  // here i bookmark last selected node, cause it could change between clicks
  clickedContact :Tcontact;
  clickedGroup :integer;
  clickedNode :Tnode;

  prefHeight :integer;
  loginServer :string;
  lastServerIP :string;
  timeformat :record chat,info,clock,log,automsg:string end;
  hideScrollTimer :integer;
  saveDBtimer :integer;
  cmdLinePar :record
    startUser :string;
    extraini :string;
    end;
  docking :record
    enabled :boolean;
    active :boolean;
    appbar :boolean;
    pos :(DP_right,DP_left);
    bakOfs, bakSize :Tpoint;
    appbarFlag :boolean;
    tempOff :boolean;
    end;
  lastOnTimer :Tdatetime;
  showRoasterTimer :integer;
  removeTempVisibleTimer :integer;
  removeTempVisibleContact :Tcontact;
  inactiveTime :integer;
  noOncomingCounter :integer; // if > 0, IE_oncoming means people was here before (used in the login process)
  childWindows :Tlist;
  offlineMsgsChecked,
  menuViaMacro,
  saveOutboxDelayed,
  saveInboxDelayed,
  saveGroupsDelayed,
  appBarResizeDelayed,
  saveListsDelayed,
  autosizeDelayed,
  dbUpdateDelayed,
  roasterRepaintDelayed,          // requires a roasterLib.repaint
  roasterRebuildDelayed :boolean; // requires a roasterLib.rebuild
  chatfrmXY :TformXY;
  oldForeWindow :Thandle;
  bringForeground :Thandle;
  groups :Tgroups;
  searching :string;
  userCharSet :integer;
  lastUser :integer;
  imAwaySince :Tdatetime;
  lastSearchTime :Tdatetime;
  selectedColor :Tcolor;
  disableSounds, stayConnected, running, resolving, audioPresent :boolean;
  dialogFrm :Tform;
  outbox :Toutbox;
  acks :Toutbox;
  uinlists :Tuinlists;
  status, lastStatus, lastStatusUserSet :Tstatus;
  visibility :Tvisibility;
  visibleList, invisibleList, notInList, ignoreList, updateViewInfoQ, retrieveQ :TcontactList;
  // timers
  blinkCount     :integer;
  blinkExCount   :integer;
  delayCount     :integer;
  longDelayCount :integer;
  outboxCount    :integer;
  blinking       :boolean;
  // options
  usersPath :string;
  sendBalloonOn     :integer;
  sendBalloonOnDate :Tdatetime;
  focusOnChatPopup :boolean;
  quoting :record
    cursorBelow :boolean;
    width :integer;
    quoteselected :boolean;
    end;
  roasterItalic  :integer;
  behaviour :Tbehaviours;
  onStatusDisable :array [SC_ONLINE..pred(SC_OFFLINE)] of record
    tips,blinking,sounds:boolean;
    end;
  spamfilter :record
	  ignoreNIL: boolean;
    warn :boolean;
    ignorepagers: boolean;
    // rules
    notNIL :boolean;
    notEmpty :boolean;
    nobadwords :boolean;
    badwords :string;
    uingt :integer;
    multisend :boolean;
    end;
  histCrypt :record
    enabled :boolean;
    savePwd :boolean;
    pwd :string;
    pwdKey :integer;
    end;
  autoaway :record
    time :integer;
    lastMousePos :Tpoint;
    lastKeybPos :integer;

    away, na, autoexit :boolean;
    awayTime, naTime :integer;
    msg :string;
    triggered:(TR_none, TR_away, TR_na);
    bakstatus :Tstatus;
    bakmsg :string;
    end;
  themeprops :array of TthemeProperty;
  browserCmdLine :string;
  useDefaultBrowser :boolean;
  splitY, inactiveHideTime, blinkSpeed :integer;
  theme :record
    fn :string;

    title,desc:string;
    logo:Tbitmap;
    icons :array [0..ICO_LAST] of Ticon;
    pics :array [0..PIC_LAST] of Tbitmap;
    history :record
      myfont, hisfont, myquoted, hisquoted :Tfont;
      bgcolor :Tcolor;
      bgpic :Tbitmap;
      end;
    roaster :record
      font, groupfont, divfont, barfont :Tfont;
      bgpic :Tbitmap;
      selectionColor, selectionTextColor, bgcolor, barcolor,
      nilColor, onlineColor, offlineColor, contactsColor :Tcolor;
      end;
    smiles :Tsmiles;
    sounds :record
      onStart, onError, onQuit :string;
      onEvent :array [1..EK_last] of string;
      end;
    tip :record
      font, contactfont :Tfont;
      bgcolor :Tcolor;
      end;
    menu :record
      color1, color2 :Tcolor;
      end;
    end;
  msgs :array of Tmsg;
  minOnOff :boolean;
  minOnOffTime :integer; // in seconds
  autostartUIN :integer;
  uin2Bstarted :integer;
  startingStatus :Tstatus;
  startingVisibility :Tvisibility;
  roasterTitle :string;
  automessages:Tstrings;
  keepalive:record
    enabled:boolean;
    freq:integer;
    timer:integer;
    end;
  fixingWindows:record
    lastWidth, lastRightSpace:integer;
    onTheRight: boolean;
    end;
  sendOnEnter,
  tempBlinkTime,
  wheelVelocity:integer;
  disabledPlugins:string;
  sortBy:TsortBy;
  transparency:record
    forRoaster, forChat :boolean;
    active,inactive:integer;
    end;
  macros :Tmacros;
  splashFrm :Tform;
  proxy :record
    enabled   :boolean;
    addr      :array [Tproxyproto] of Thostport;
    proto     :TproxyProto;
    auth      :boolean;
    user, pwd :string;
    end;
  checkupdate :record
    enabled :boolean;
    betas :boolean;
    every :integer;
    last :Tdatetime;
    info :string;
    lastSerial :integer;
    autochecking :boolean;
    end;
  logpref :record
    pkts, evts :record
      onFile,onWindow,clear:boolean;
      end;
    writehistory :boolean;
    end;
  fontstylecodes :record
    enabled: boolean;
    end;
  //booleans
  warnVisibilityExploit,
  warnVisibilityAutoMsgReq,
  showRoasterMinButton,
  hideOnClose,
  popupLSB,
  showLSB,
  showClientID,
  connectOnConnection,
  reopenchats,
  roasterbarOnTop,
  animatedRoaster,
  showVisibilityFlag,
  getOfflineMsgs,
  delOfflineMsgs,
  lockOnStart,
  closeAuthAfterReply,
  autoConsumeEvents,
  enableIgnoreList,
  inactiveHide,
  doFlashChat,
  doFixWindows,
  minimizeRoaster,
  autoReconnect,
  startMinimized,
  autoSwitchKL,
  popupAutoMsg,
  okOn2enter_autoMsg,
  skipSplash,
  oncomingOnAway,
  enteringICQpwd,
  check4readonly,
  dontSavePwd,
  sendTheAddedYou,
  saveNIL,
  showStatusOnTabs,
  webaware,
  singleDefault,
  texturizedWindows,
  roundedWindows,
  showGroups,
  autoCopyHist,
  indentRoaster,
  showDisconnectedDlg,
  autoConnect,
  autoDeselect,
  alwaysOnTop,
  chatAlwaysOnTop,
  useLastStatus,
  playSounds,
  useSmiles,
  quitconfirmation,
  showOncomingDlg,
  showOnlyOnline,
  showOnlyImVisibleTo,
  autosizeFullRoaster,
  autoSizeRoaster:boolean;

implementation

var
  section:string;
  i:integer;

procedure addthemeprop(name:string;kind:TthemePropertyKind; ptr:pointer); overload;
var
  p:^Tthemeproperty;
begin
setlength(themeprops, length(themeprops)+1);
p:=@themeprops[length(themeprops)-1];
p.kind:=kind;
p.section:=section;
p.name:=name;
p.ptr:=ptr;
end; // addthemeprop

initialization
section:='';
addthemeprop('title',TP_string, @theme.title);
addthemeprop('desc',TP_string, @theme.desc);
addthemeprop('logo',TP_pic, @theme.logo);
section:='roaster';
addthemeprop('bg.color',TP_color, @theme.roaster.bgcolor);
addthemeprop('bg.pic',TP_pic, @theme.roaster.bgpic);
addthemeprop('bar.color',TP_color, @theme.roaster.barcolor);
addthemeprop('bar.font', TP_font, @theme.roaster.font);
addthemeprop('font',TP_font, @theme.roaster.font);
addthemeprop('font.color.selected',TP_color, @theme.roaster.selectiontextcolor);
addthemeprop('selection.color',TP_color, @theme.roaster.selectioncolor);
addthemeprop('notinlist.font.color',TP_color, @theme.roaster.nilcolor);
addthemeprop('online.font.color',TP_color, @theme.roaster.onlinecolor);
addthemeprop('offline.font.color',TP_color, @theme.roaster.offlinecolor);
addthemeprop('group.font',TP_font, @theme.roaster.groupfont);
addthemeprop('divisor.font',TP_font, @theme.roaster.divfont);
section:='history';
addthemeprop('bg.color',TP_color, @theme.history.bgcolor);
addthemeprop('my.font',TP_font, @theme.history.myfont);
addthemeprop('his.font',TP_font, @theme.history.hisfont);
addthemeprop('my.quoted.font',TP_font, @theme.history.myquoted);
addthemeprop('his.quoted.font',TP_font, @theme.history.hisquoted);
section:='menu';
addthemeprop('fade.color1',TP_color, @theme.menu.color1);
addthemeprop('fade.color2',TP_color, @theme.menu.color2);
section:='tip';
addthemeprop('font',TP_font, @theme.tip.font);
addthemeprop('contact.font',TP_font, @theme.tip.contactfont);
addthemeprop('bg.color',TP_color, @theme.tip.bgcolor);
section:='pics';
for i:=1 to length(pic2str)-1 do
  addthemeprop(pic2str[i], TP_pic, @theme.pics[i]);
section:='icons';
for i:=1 to length(ico2str)-1 do
  addthemeprop(ico2str[i], TP_ico, @theme.icons[i]);
section:='sounds';
addthemeprop('start', TP_sound, @theme.sounds.onStart);
addthemeprop('quit', TP_sound, @theme.sounds.onQuit);
addthemeprop('error', TP_sound, @theme.sounds.onError);
for i:=1 to length(event2str)-1 do
  addthemeprop(event2str[i], TP_sound, @theme.sounds.onEvent[i]);

theme.logo:=Tbitmap.create;
theme.roaster.font:=Tfont.create;
theme.roaster.groupfont:=Tfont.create;
theme.roaster.divfont:=Tfont.create;
theme.roaster.barfont:=Tfont.create;
theme.roaster.bgpic:=Tbitmap.create;
theme.history.MyFont:=Tfont.create;
theme.history.HisFont:=Tfont.create;
theme.history.MyQuoted:=Tfont.create;
theme.history.HisQuoted:=Tfont.create;
theme.history.bgpic:=Tbitmap.create;
theme.tip.font:=Tfont.create;
theme.tip.contactfont:=Tfont.create;
theme.smiles:=Tsmiles.create;

finalization
theme.roaster.Font.free;
theme.roaster.barFont.free;
theme.roaster.bgpic.free;
theme.history.bgpic.free;
theme.history.MyFont.free;
theme.history.HisFont.free;
theme.history.MyQuoted.free;
theme.history.HisQuoted.free;
theme.smiles.free;

end.
