{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit hashLib;

interface

uses
  classes;

type
  Pcouple=^Tcouple;
  Tcouple=record
    key,val:Tobject
    end;

  ThashTable=class
   private
    enumIdx:integer;
    list:Tlist;
    lastKey,lastVal:Tobject;
    function key2idx(key:Tobject):integer;
   public
    constructor create;
    destructor destroy; override;
    function  existsKey(key:Tobject):boolean;
    function  key2val(key:Tobject):Tobject;
    procedure put(key,val:Tobject);
    procedure clear;
    procedure resetEnumeration;
    function  hasMore:boolean;
    function  getNext:Tobject;
    end;

implementation

constructor ThashTable.create;
begin
inherited;
list:=Tlist.create;
end; // create

destructor ThashTable.destroy;
begin
clear;
list.free;
inherited;
end; // destroy

function ThashTable.existsKey(key:Tobject):boolean;
var
  i:integer;
begin
i:=key2idx(key);
if i < 0 then
  begin
  result:=FALSE;
  exit;
  end;
result:=TRUE;
lastKey:=key;
lastVal:=Pcouple(list.items[i]).val;
end; // existsKey

function ThashTable.key2idx(key:Tobject):integer;
var
  min,max,mid:integer;
begin
{result:=-1;
min:=0;
max:=list.count-1;
while min <= max do
  begin
  mid:=(min+max) div 2;
  if Pcouple(list[mid]).key = key then
    begin
    result:=mid;
    exit;
    end;
  if min=max then
    exit;
  if (min=max+1) or (integer(Pcouple(list[mid]).key) < integer(key)) then
    min:=mid+1
  else
    max:=mid-1;
  end;}
result:=0;
while result < list.count do
  if Pcouple(list[result]).key = key then
    exit
  else
    inc(result);
result:=-1;
end; // key2idx

function ThashTable.key2val(key:Tobject):Tobject;
var
  i:integer;
begin
if key=lastKey then
  begin
  result:=lastVal;
  exit;
  end;
i:=key2idx(key);
if i < 0 then
  result:=NIL
else
 result:=Pcouple(list[i]).val;
end; // key2val

procedure ThashTable.put(key,val:Tobject);
var
  p:Pcouple;
  i:integer;
begin
new(p);
{i:=0;
while (i<list.count) and (integer(key) > integer(Pcouple(list[i]).key)) do
  inc(i);
list.insert(i,p);}
list.add(p);
end; // put

procedure ThashTable.clear;
begin
while list.count > 0 do
  begin
  dispose(Pcouple(list.last));
  list.Delete(list.count-1);
  end;
end; // clear

procedure ThashTable.resetEnumeration;
begin enumIdx:=0 end;

function ThashTable.hasMore:boolean;
begin result:=enumIdx<list.count end;

function ThashTable.getNext:Tobject;
begin
with Pcouple(list[enumIdx])^ do
  begin
  result:=key;
  lastKey:=key;
  lastVal:=val;
  end;
inc(enumIdx);
end; // getNext

end.
