{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit hook;

interface

uses
  windows, sysutils, messages, classes;

const
  HOOK_VER=5;
  DLLname='hook.dll';
  mapfile='andrqHook5';
type
  Tshared=record
    sign:array [1..3] of char;
    ver:integer;
    runs:integer;
    keyMoved :integer;
    end;

procedure installHook;
procedure uninstallHook;
function  isHooked:boolean;

var
  shared:^Tshared;

implementation

uses
  utilLib;

type
  TintFun=function:integer;
var
  hookOn, hookOff, hookVer : procedure; stdcall;
  fileHnd,DLLhnd:Thandle;
  hooked:boolean;

procedure unload;
begin
if shared<>NIL then
  begin
  if shared^.runs=0 then
    hookOff;
  UnmapViewOfFile(shared);
  shared:=NIL;
  end;
if fileHnd<>0 then
  begin
  CloseHandle(fileHnd);
  fileHnd:=0;
  end;
if DLLhnd<>0 then
  begin
  loggaEvt('hook.dll: unloading');
  FreeLibrary(DLLhnd);
  DLLhnd:=0;
  end;
end; // unload

procedure installHook;
begin
// load DLL
DLLhnd:=LoadLibrary(PChar(DLLname));
if DLLhnd = 0 then
  begin
  loggaEvt('hook.dll: unable to load');
  unload;
  exit;
  end;
@hookOn :=GetProcAddress(DLLhnd, 'hookOn');
@hookOff:=GetProcAddress(DLLhnd, 'hookOff');
@hookVer:=GetProcAddress(DLLhnd, 'hookVer');
if not assigned(hookOn)
or not assigned(hookOff)
or not assigned(hookVer)
or (TintFun(HookVer) <> HOOK_VER) then
  begin
  loggaEvt('hook.dll: wrong version');
  unload;
  exit;
  end;
// open mapped file
fileHnd:=OpenFileMapping(FILE_MAP_WRITE,False,mapfile);
if fileHnd=0 then
  begin
  if TintFun(hookOn)<>0 then
    begin
    loggaEvt('hook.dll: unable to init');
    unload;
    exit;
    end;
  fileHnd:=OpenFileMapping(FILE_MAP_WRITE,False,mapfile);
  if fileHnd=0 then
    begin
    loggaEvt('hook.dll: unable to communicate');
    unload;
    exit;
    end;
  end;
shared:=MapViewOfFile(fileHnd,FILE_MAP_WRITE,0,0,0);
if shared=NIL then
  loggaEvt('hook.dll: unable to communicate(2)')
else
  if (shared^.sign<>'&RQ') or (shared^.ver<>HOOK_VER) then
    loggaEvt('hook.dll: wrong version')
  else
    begin
    loggaEvt('hook.dll: on');
    inc(shared^.runs);
    hooked:=TRUE;
    exit;
    end;
unload;
end; // installHook

procedure uninstallHook;
begin
if not hooked then exit;
hooked:=FALSE;
dec(shared^.runs);
loggaEvt('hook.dll: off');
unload;
end; // uninstallHook

function isHooked:boolean;
begin result:=hooked end;

begin
hooked:=FALSE;
shared:=NIL;
DLLhnd:=0;
fileHnd:=0;
end.
