unit hotkeys_fr;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Grids;

type
  ThotkeysFr = class(TFrame)
    hotkey: THotKey;
    Label1: TLabel;
    grid: TStringGrid;
    Label2: TLabel;
    swChk: TCheckBox;
    actionBox: TComboBox;
    Label3: TLabel;
    saveBtn: TButton;
    deleteBtn: TButton;
    Label4: TLabel;
    replaceBtn: TButton;
    winkeyChk: TCheckBox;
    procedure saveBtnClick(Sender: TObject);
    procedure gridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure deleteBtnClick(Sender: TObject);
    procedure replaceBtnClick(Sender: TObject);
  private
    function winkey():integer;
  end;

implementation

{$R *.dfm}

uses
  globalLib, utilLib;

function ThotkeysFr.winkey():integer;
begin result:=ifThen(winkeyChk.Checked,$1000) end;

procedure ThotkeysFr.saveBtnClick(Sender: TObject);
begin
addMacro(hotkey.hotkey+winkey(), swChk.checked, actionBox.itemIndex+1);
fillMacrosGrid(macros);
grid.row:=grid.rowCount-1;
end;

procedure ThotkeysFr.gridSelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
begin
with macros[aRow-1] do
  begin
  hotkey.hotkey:=hk;
  swChk.checked:=sw;
  winkeyChk.Checked:=hk and $1000>0;
  actionBox.itemIndex:=opcode-1;
  end;
end;

procedure ThotkeysFr.deleteBtnClick(Sender: TObject);
begin
if removeMacro(grid.row-1) then
  fillMacrosGrid(macros);
end;

procedure ThotkeysFr.replaceBtnClick(Sender: TObject);
begin
if removeMacro(grid.row-1) then
  begin
  addMacro(hotkey.hotkey+winkey(), swChk.checked, actionBox.itemIndex+1);
  fillMacrosGrid(macros);
  grid.row:=grid.rowCount-1;
  end;
end;

end.
