{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
{$I-}
unit importDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, contacts, Mask, ToolEdit, Animate, dateutils,
  ExtCtrls, ComCtrls, registry, MPlayer, mainDlg, utilLib, groupsLib,
  JvToolEdit;

type
  TimportFrm = class(TForm)
    okBtn: TBitBtn;
    closeBtn: TBitBtn;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    progressBar: TProgressBar;
    status: TStatusBar;
    Panel1: TPanel;
    passwordChk: TCheckBox;
    contactsChk: TCheckBox;
    historyChk: TCheckBox;
    memoryChk: TCheckBox;
    BitBtn1: TBitBtn;
    fnBox: TJvFilenameEdit;
    procedure okBtnClick(Sender: TObject);
    procedure Label4Click(Sender: TObject);
    procedure closeBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  public procedure destroyHandle;
  end;

  TintTable=class
   private
    n:integer;
    enumIdx:integer;
    keys,vals:array [1..2000] of integer;
    function key2idx(key:integer):integer;
   public
    procedure resetEnumeration;
    function  hasMore:boolean;
    function  getNext:integer;
    function  existsKey(key:integer):boolean;
    function  key2val(key:integer):integer;
    procedure put(key,val:integer);
    function  count:integer;
    end;

var
  importFrm:TimportFrm;
  importing:boolean;
  substituting:integer;
  imported:record
    filename:string;
    uin:integer;
    userpath, password:string;
    contacts:TcontactList;
    useMemory,
    result:boolean;
    db:TcontactList;
    Nmsg:integer;
    groups:Tgroups;
    conv:TintTable;
    msgs:TintTable;
    sorting:boolean;
    end;

function getICQfolder:string;
function importICQ(fn:string; doPwd,doContacts,doHistory:boolean):boolean;

implementation

{$R *.DFM}

uses
  globalLib, iniLib, decryptICQpass, usersDlg, icqv7, history, events,
  importnotesDlg, langLib, strutils;

function TintTable.count:integer;
begin result:=n end;

function TintTable.existsKey(key:integer):boolean;
begin result:=key2idx(key) > 0 end;

function TintTable.key2val(key:integer):integer;
begin
key:=key2idx(key);
if key < 0 then
  result:=-1
else
  result:=vals[key];
end;

procedure TintTable.put(key,val:integer);
var
  i:integer;
begin
i:=key2idx(key);
if i < 0 then
  begin
  inc(n);
  keys[n]:=key;
  i:=n;
  end;
vals[i]:=val;
end; // put

function TintTable.key2idx(key:integer):integer;
begin
result:=0;
while result < n do
  begin
  inc(result);
  if keys[result] = key then
    exit;
  end;
result:=-1;
end; // key2idx

procedure TintTable.resetEnumeration;
begin enumIdx:=1 end;

function TintTable.hasMore:boolean;
begin result:=enumIdx<=n end;

function TintTable.getNext:integer;
begin
result:=keys[enumIdx];
inc(enumIdx);
end; // getNext

///////////////////////////////////////////////////////////////////////

procedure updateStatusBar;
begin
with importFrm.status do
  simpleText:=___('import statusbar',[
    imported.contacts.count,
    imported.Nmsg,
    ifThen(imported.sorting, ' (sorting)')
  ]);
end; // updatestatusbar

function uinFromFilename(fn:string):integer;
var
  i:integer;
begin
fn:=extractFilename(fn);
i:=length(fn);
while (i>1) and not (fn[i] in ['0'..'9']) do dec(i);
setLength(fn,i);
i:=1;
while (i<length(fn)) and not (fn[i] in ['0'..'9']) do inc(i);
val(copy(fn,i,20), result, i);
if i<>0 then result:=-1;
end; // uinFromFilename

function importICQ(fn:string; doPwd,doContacts,doHistory:boolean):boolean;
type
  TidxEntry=record
    status,kind,next,prev,datptr:integer;
    end;
  TdatEntry=record
    size,where,kind:integer;
    sign:byte;
    trash:array [1..15] of byte;
    end;

var
  f,fdat:file;
  idx:TidxEntry;
  dat:TdatEntry;
  buf:string;
  bufi:integer;
  ev:Thevent;

  function searchFor(s:string):boolean;
  var
    i:integer;
  begin
  i:=pos(s, copy(buf,bufi,length(buf)) );
  result:=i > 0;
  if result then
    inc(bufi, i+length(s)-1);
  end; // searchFor

  function wordAt(idx:integer):word;
  begin result:=word((@buf[idx])^) end;

  function intAt(idx:integer):integer;
  begin result:=integer((@buf[idx])^) end;

  procedure skip(i:integer);
  begin inc(bufi,i) end;

  function getWord:word;
  begin
  result:=wordAt(bufi);
  skip(2);
  end;

  function getString:string;
  begin
  setLength(result, getWord-1);
  move(buf[bufi], result[1], length(result));
  skip(length(result)+1);
  end;

  function getInt:integer;
  begin
  result:=intAt(bufi);
  skip(4);
  end;

  function getByte:byte;
  begin
  result:=ord(buf[bufi]);
  skip(1);
  end;

  function getStringLabel(lab:string):string;
  begin
  searchFor(lab+#0#$6B);
  result:=getString;
  end; // getString

  function getIntLabel(lab:string):integer;
  begin
  searchFor(lab+#0); skip(1);
  result:=getInt;
  end; // getInt

  procedure importMyInfo;
  var
    b:byte;
    pass, icqGrpName:string;
    c:char;
    key, andrqGrp, icqGrp:integer;
  begin
  searchFor('RESU');
  if getByte <> 6 then exit;
  key:=getIntLabel('99BCryptIV');
  pass:=getStringLabel('Password');
  with imported.db.get(imported.uin) do
    if nick = '' then
      nick:=getStringLabel('NickName');
  while searchFor('GroupID') do
    with imported do
      begin
      skip(2);
      icqGrp:=getInt;
      if (icqGrp=3) or (icqGrp=21) then
        continue;
      icqGrpName:=getStringLabel('GroupName');
      andrqGrp:=groups.name2id(icqGrpName);
      if andrqGrp < 0 then
        with groups do
          begin
          andrqGrp:=add;
          with a[idxOf(andrqGrp)] do
            name:=icqGrpName;
          end;
      conv.put(icqGrp, andrqGrp);
      end;
  if not doPwd then
    exit;
  delete(pass,1,4);
  for b:=1 to length(pass) div 2 do
    begin
    c:=char(strToInt('$'+pass[b*2-1]+pass[b*2]));
    pass[b]:=c;
    end;
  setLength(pass, length(pass) div 2);
  pass:=decryptedPassword(pass,imported.UIN,key);
  if (pass>'') and (pass[length(pass)]=#0) then
    setLength(pass, length(pass)-1);
  imported.password:=pass;
  end; // importMyInfo

  procedure importContact;
  var
    byt:byte;
    str:string;
    int:integer;
    wrd:word;

    contact:Tcontact;
    group_:integer;
    name, separator:string;
  begin
  searchFor('RESU');
  if getInt <> 2 then exit;
  group_:=getInt;
  case group_ of
    3:group_:=0;  // awaiting authorization
    21:exit;      // non icq contacts
    end;
  separator:=char(getByte)+char(getByte);
  if getInt=0 then searchFor(separator);
  searchFor(separator);
  skip(4);
  byt:=0; str:=''; // shut up compiler warnings

  int:=bufi;
  contact:=imported.db.get(getIntLabel('UIN'));
  bufi:=int;

  contact.group:=group_;
  imported.contacts.add(contact);
  if imported.contacts.count=40 then
    byt:=0;
  with contact do
    repeat
    wrd:=getWord;
    if wrd=word((@separator[1])^) then break;
    setLength(name, wrd-1);
    move(buf[bufi], name[1], length(name));
    skip(length(name)+1);
    case getByte of
      $64,$65: byt:=getByte;
      $66,$67: wrd:=getWord;
      $68,$69: int:=getInt;
      $6B: str:=getString;
      $6D: inc(bufi,11); // unknown type
      end;
    if name='FirstName' then first:=str;
    if name='LastName' then last:=str;
    if name='NickName' then nick:=str;
    if name='MyDefinedHandle' then if display='' then display:=str;
    if name='PrimaryEmail' then email:=str;
    if name='Language' then lang[1]:=byt;
    if name='Language1' then lang[2]:=byt;
    if name='Language2' then lang[3]:=byt;
    if name='HomeCell' then cellular:=str;
    if name='HomeCity' then city:=str;
    if name='HomeCountry' then country:=wrd;
    if name='HomeState' then state:=str;
    if name='HomeZipCode' then zip:=str;
    if name='HomeHomepage' then homepage:=str;
    if name='Gender' then gender:=byt;
    if name='TimeZone' then GMThalfs:=Shortint(byt);
    if name='About' then about:=str;
    if name='Age' then age:=byt;
    until FALSE;
  if int=0 then IOresult; // shut up compiler warnings
  updateStatusBar;
  end; // importContact

  procedure importUIN;
  begin imported.uin:=uinFromFilename(fn) end;

  procedure importMsg;
  var
    w:word;
    sent:boolean;
    uin:integer;
    ts:integer;
    s:string;
    h:Thistory;
  begin
  skip(2);
  w:=getWord;
  if (w and $FE<>4) then // deleted item
    exit;
  sent:=w and 1=0;
  skip(2);
  case getWord of
    1:ev.kind:=EK_msg;
    4:ev.kind:=EK_url;
    6:ev.kind:=EK_authReq;
    $C:ev.kind:=EK_addedYou;
    $13:ev.kind:=EK_contacts;
    end;
  uin:=getInt;
  if UIN < 10000 then
    exit; // skip system messages and e-mail
  ev.info:=getString;
  skip(10);
  ts:=getInt;
  case ev.kind of
    EK_msg: ;
    EK_url:
      begin
      s:=chop(#$FE,ev.info);   // s = msg
      ev.info:=ev.info+NL+s;
      end;
    EK_contacts:
      begin
      chop(#$FE,ev.info);   // skip #contacts
      while ev.info > '' do
        begin
        s:=s+chop(#$FE,ev.info)+CRLF;
        chop(#$FE,ev.info); // skip nick
        end;
      ev.info:=s;
      end;
    else ev.info:='';
    end;

  if sent then
    ev.who:=imported.db.get(imported.uin)
  else
    ev.who:=imported.db.get(uin);
  ev.when:=GMToffset+UnixToDatetime(ts);
  if not validUIN(uin) then
    begin
    msgDlg(___('import unknown',[dateTimeToStr(ev.when),ev.info]),mtError);
    exit;
    end;
  if imported.useMemory then
    begin
    if imported.msgs.existsKey(uin) then
      h:=Thistory(imported.msgs.key2val(uin))
    else
      begin
      h:=Thistory.create;
      imported.msgs.put(uin,integer(h));
      end;
    h.Add(ev.new(ev.kind,ev.who,ev.when,ev.info,ev.flags));
    end
  else
    begin
    ev.info:=critted(ev.info, ev.who.uin);
    appendFile(imported.userPath+historyPath+intToStr(uin), ev.toString);
    end;

  inc(imported.Nmsg);
  if imported.Nmsg mod 10=0 then
    updateStatusBar;
  end; // importMsg

  procedure deleteExtension;
  begin fn:=extractFilePath(fn)+intToStr(uinFromFilename(fn)) end;

  procedure createFolder;
  var
    uinS:string;
  begin
  uinS:=intToStr(imported.uin);
  imported.userPath:=myPath+uinS+'\';
  IOresult;
  if not usersFrm.selectUIN(imported.uin) then
    begin
    mkdir(imported.userPath);
    IOresult;
    usersFrm.usersBox.items.add(uinS);
    usersFrm.selectUIN(imported.uin);
    end;
  mkdir(imported.userPath+'history');
  IOresult;
  end; // createFolder

begin
result:=FALSE;
importing:=TRUE;
deleteExtension;
importUIN;
createFolder;
with imported do
  begin
  Nmsg:=0;
  conv:=TintTable.create;
  groups:=Tgroups.create;
  groups.fromString(loadFile(userPath+groupsFilename));
  db:=str2db(loadFile(userPath+dbFilename));
  contacts:=TcontactList.create;
  msgs:=TintTable.create;
  end;

IOresult;
assignFile(f,fn+'.idx');
assignFile(fdat,fn+'.dat');
FileMode:=0;
reset(f,1);
reset(fdat,1);
fileMode:=2;
if IOresult <> 0 then
  exit;
importFrm.progressBar.max:=fileSize(f);

ev:=Thevent.Create;

idx.next:=225;
while importing and (idx.next <> -1) do
  begin
  seek(f,idx.next);
  blockread(f,idx,sizeOf(idx));
  importFrm.progressBar.position:=filepos(f);
  Application.ProcessMessages;
  if idx.next=-1 then
    idx.next:=-1;
  if (idx.status = -2) and ((idx.kind=1005) or (idx.kind >= 2000)) then
    begin
    seek(fdat, idx.datptr);
    blockread(fdat,dat,sizeOf(dat));
    if (dat.kind = idx.kind)  then
      if (dat.sign=$E5) and doContacts or
         (dat.sign=$E0) and doHistory or
         (dat.sign=$50) and doHistory or
         (dat.sign=$E4) then
        begin
        bufi:=1;
        if (dat.size<=0) {or (dat.size>10000)} then
          continue;
        setLength(buf, dat.size-sizeOf(dat) );
        blockRead(fdat,buf[1],length(buf));
        case dat.sign of
          $E0,$50:if doHistory then importMsg;
          $E4:importMyInfo;
          $E5:if doContacts then importContact;
          end;
        end;
    end;
  end;
ev.Free;
result:=TRUE;
closeFile(f);
closeFile(fdat);
IOresult;
with importFrm.progressBar do position:=max;
updateStatusBar;
end; // importICQ

function compareTHevent(Item1, Item2: Pointer): Integer;
begin
if Thevent(item1).when > Thevent(item2).when then result:=+1
else
  if Thevent(item1).when < Thevent(item2).when then result:=-1
  else result:=0;
end; // compareTHevent

  procedure sortHistories;
  var
    sr:TsearchRec;

    function digits:boolean;
    var
      i:integer;
    begin
    result:=FALSE;
    i:=0;
    while i < length(sr.name) do
      begin
      inc(i);
      if not (sr.name[i] in ['0'..'9']) then
        exit
      end;
    result:=TRUE;
    end; // digits

  var
    tot:integer;
    h:Thistory;
  begin
  h:=Thistory.Create;
  tot:=0;
  if findFirst(imported.userPath+historyPath+'*.*', faAnyFile, sr) = 0 then
    repeat
    if digits then
      inc(tot);
    until findNext(sr) <> 0;
  findClose(sr);
  with importFrm.progressBar do
    begin
    max:=tot;
    position:=0;
    end;
  if findFirst(imported.userPath+historyPath+'*.*', faAnyFile, sr) = 0 then
    repeat
    if not importing then break;
    application.ProcessMessages;
    if digits then
      begin
      with importFrm.progressBar do position:=position+1;
      h.fromString(loadFile(imported.userPath+historyPath+sr.Name));
      h.Sort(compareTHevent);
      saveFile(imported.userPath+historyPath+sr.Name, h.toString);
      h.reset;
      end;
    until findNext(sr) <> 0;
  findClose(sr);
  h.free;
  end; // sortHistories

  procedure sortMsgs;
  var
    uinKey:integer;
  begin
  with imported.msgs do
    begin
    with importFrm.progressBar do
      begin
      max:=count;
      position:=0;
      end;
    resetEnumeration;
    while importing and hasMore do
      begin
      application.ProcessMessages;
      uinKey:=integer(getNext);
      with Thistory(key2val(uinKey)) do
        begin
        fromstring(loadFile(imported.userPath+historyPath+intToStr(uinkey)));
        sort(compareTHevent);
        saveFile(imported.userPath+historyPath+intToStr(uinkey), toString);
        with importFrm.progressBar do position:=position+1;
        end;
      end
    end
  end; // sortMsgs

procedure TimportFrm.okBtnClick(Sender: TObject);

  function idxExists:boolean;
  var
    s:string;
  begin
  s:=fnBox.filename;
  s:=ExtractFilePath(s)+intToStr(uinFromFilename(s))+'.idx';
  result:=fileExists(s)
  end; // idxExists

  procedure adjustAndMergeContacts;
  var
    old:TcontactList;
  begin
  with imported.contacts do
    begin
    resetEnumeration;
    while hasMore do
      with getNext do
        with imported.conv do
          if existsKey(group) then
            group:=key2val(group);
            
    old:=TcontactList.create;
    old.fromString(loadNewOrOldVersionContactList(roasterfilename, imported.UserPath), imported.db);
    add(old);
    old.free;
    end;
  end; // adjustAndMergeContacts

var
  s:string;
begin
if (fnbox.filename='') or (fnbox.filename[length(fnbox.filename)]= '\') then
  begin
  msgDlg(___('have to select a file'),mtWarning);
  exit;
  end;
if uinFromFilename(fnbox.filename) < 0 then
  begin
  msgDlg(___('invalid file'),mtWarning);
  exit;
  end;
if not idxExists then
  begin
  msgDlg(___('idx not present'), mtWarning);
  exit;
  end;
if assigned(ICQ.myInfo) and (ICQ.myInfo.uin = uinFromFilename(fnbox.filename)) then
  begin
  if not ICQ.isOffline then
    if messageDlg(___('go offline?'), mtConfirmation, [mbYes,mbNo], 0) = mrYes then
      ICQ.disconnect
    else
      exit;
  substituting:=ICQ.myinfo.uin;
  quitUser;
  end;
if historyChk.checked then
  if messageDlg(___('import history?'), mtConfirmation, [mbYes,mbNo], 0) <> mrYes then
    exit;
progressBar.position:=0;
imported.useMemory:=memoryChk.checked;
imported.filename:=importFrm.fnBox.filename;
okBtn.enabled:=FALSE;
passwordChk.enabled:=FALSE;
contactsChk.enabled:=FALSE;
historyChk.enabled:=FALSE;
memoryChk.enabled:=FALSE;
fnBox.enabled:=FALSE;
imported.result:=importICQ(imported.filename, passwordChk.checked,contactsChk.checked,historyChk.checked);
if imported.result and historyChk.checked then
  begin
  imported.sorting:=TRUE;
  updateStatusBar;
  if imported.useMemory then
    sortMsgs
  else
    sortHistories;
  end;

if importing and imported.result then
  begin
  mkdir(imported.userPath);
  if passwordChk.checked then
    begin
    s:=imported.userPath+configFileName;
    saveFile(s, 'crypted-password='+passCrypt(imported.password)+CRLF+loadFile(s));
    end;
  if contactsChk.checked then
    begin
    adjustAndMergeContacts;
    saveFile(imported.userPath+roasterFileName+'.txt', imported.contacts.toString);
    saveFile(imported.userPath+dbFileName, db2str(imported.db));
    saveFile(imported.userPath+groupsFilename, imported.groups.toString);
    end;
  end;
with imported.msgs do
  begin
  resetEnumeration;
  while hasMore do
    with Thistory(key2val(getNext)) do
      begin
      reset;
      free;
      end;
  free;
  end;
imported.groups.free;
imported.contacts.free;
freeDB(imported.db);
okBtn.enabled:=TRUE;
passwordChk.enabled:=TRUE;
contactsChk.enabled:=TRUE;
historyChk.enabled:=TRUE;
memoryChk.enabled:=TRUE;
fnBox.enabled:=TRUE;
myBeep;
if not importing then
  msgDlg(___('import canceled'),mtInformation)
else
  if imported.result then
    if substituting = 0 then
      usersFrm.startIt:=messageDlg(___('import finished?'),mtConfirmation,[mbYes,mbNo],0) = mrYes
    else
      begin
      msgDlg(___('import finished'),mtInformation);
      usersFrm.startIt:=TRUE
      end
  else
    msgDlg(___('import error'),mtError);
close;
end; // ok

procedure TimportFrm.Label4Click(Sender: TObject);
begin openURL('http://www.headstrong.de') end;

function getICQfolder:string;
const
  keyName='Software\Mirabilis\ICQ\DefaultPrefs';
var
  reg:Tregistry;
begin
result:='';

reg:=Tregistry.create;
if reg.openKey(keyName, FALSE) then
  begin
  result:='';
  if result = '' then result:=reg.readString('2001b Database');
  if result = '' then result:=reg.readString('2001a Database');
  if result = '' then result:=reg.readString('2000b Database');
  if result = '' then result:=reg.readString('2000a Database');
  if result = '' then result:=reg.readString('99b Database');
  reg.closeKey;
  end;
reg.free;

if result > '' then
  result:=result+'\';
end; // getICQfolder

procedure TimportFrm.closeBtnClick(Sender: TObject);
begin
if importing then
  importing:=FALSE
else
  close;
end;

procedure TimportFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
imported.sorting:=FALSE;
action:=caFree;
destroyHandle;
end;

procedure TimportFrm.BitBtn1Click(Sender: TObject);
begin
importnotesFrm:=TimportnotesFrm.create(NIL);
importnotesfrm.rtf.Lines.LoadFromFile(langDependentFile('importnotes.rtf'));
translateWindow(importnotesfrm);
importnotesfrm.showModal;
ForceForegroundWindow(handle);
importnotesfrm.rtf.Lines.clear;
end;

procedure TimportFrm.destroyHandle; begin inherited end;

procedure TimportFrm.FormShow(Sender: TObject);
begin
importing:=FALSE;
substituting:=0;
end;

end.
