{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
{$WARN SYMBOL_PLATFORM OFF}
unit iniLib;

interface

uses
  menus, windows, contacts, graphics, classes, sysutils, forms, roasterlib,
  smilesLib, usersDlg, utilLib, traylib, events, chatDlg, shellapi, globalLib,
  logDlg, pluginLib, dialogs, controls, outboxLib, wsocket, uinlistlib, tipDlg,
  types, strutils;

procedure beforeWindowsCreation;
procedure afterWindowsCreation;
procedure quit;
procedure startUser;
procedure quitUser;
procedure resetCFG;

procedure loadCFG;
procedure saveCFG;
procedure loadCommonCFG;
procedure saveCommonCFG;
procedure saveAutomessages;
procedure loadAutomessages;
procedure loadMacros;
procedure saveMacros;

implementation

uses
  mainDlg, icqv7, hook, codes, prefDlg, groupsLib, langLib, langDlg, themesLib,
  wpDlg;
var
  initOnce:boolean;

procedure resetCFG;
var
  i:integer;
  pp:Tproxyproto;
begin
roasterTitle:='%uin% %nick%';
theme.fn:='default.theme.ini';
icq.publicEmail:=TRUE;
autoMessages.clear;
autoMessages.add('');
sendOnEnter:=0;
skipSplash:=FALSE;
autoSwitchKL:=TRUE;
resetTheme;
lastStatusUserSet:=SC_UNK;
loginServer:='login.icq.com';
sortBy:=SB_event;
visibleList.clear;
invisibleList.clear;
notinlist.clear;
connectOnConnection:=FALSE;
setlength(macros, 0);
addMacro(TextToShortCut('ctrl+shift+i'), TRUE, OP_TRAY);
addMacro(TextToShortCut('ctrl+shift+o'), TRUE, OP_CHAT);
addMacro(TextToShortCut('ctrl+o'), FALSE, OP_OFFLINECONTACTS);
addMacro(TextToShortCut('ctrl+g'), FALSE, OP_GROUPS);
addMacro(TextToShortCut('ctrl+a'), FALSE, OP_AUTOSIZE);
addMacro(TextToShortCut('alt+p'), FALSE, OP_PREFERENCES);
addMacro(TextToShortCut('alt+i'), FALSE, OP_VIEWINFO);
addMacro(TextToShortCut('F11'), FALSE, OP_TOGGLEBORDER);
addMacro(TextToShortCut('F3'), FALSE, OP_HINT);
keepalive.enabled:=FALSE;
keepalive.freq:=60;
with mainFrm do
  begin
  width:=120;
  height:=250;
  left:=screen.width-width-30;
  end;

with transparency do
  begin
  forRoaster:=FALSE;
  forChat:=FALSE;
  active:=200;
  inactive:=86;
  end;
with proxy do
  begin
  enabled:=FALSE;
  for pp:=low(pp) to high(pp) do addr[pp].host:='';
  addr[PP_SOCKS4].port:='1080';
  addr[PP_SOCKS5].port:='1080';
  addr[PP_HTTPS].port:='8080';
  proto:=PP_SOCKS5;
  auth:=FALSE;
  end;
splitY:=-1;
tempBlinkTime:=80;
okOn2enter_autoMsg:=FALSE;
useLastStatus:=TRUE;
startingStatus:=SC_ONLINE;
startingVisibility:=VI_NORMAL;
quoting.cursorBelow:=FALSE;
quoting.width:=300;
quoting.quoteselected:=TRUE;
showClientID:=TRUE;
inactivehide:=FALSE;
inactivehideTime:=50;
checkupdate.lastSerial:=0;
focusOnChatPopup:=TRUE;
checkupdate.betas:=FALSE;
checkupdate.enabled:=TRUE;
checkupdate.every:=24;
prefHeight:=390;
minOnOff:=FALSE;
minOnOffTime:=30;
showVisibilityFlag:=TRUE;
doflashchat:=TRUE;
roasterbarOnTop:=FALSE;
doFixWindows:=TRUE;
animatedRoaster:=FALSE;
blinkSpeed:=5;
userCharSet:=-1;
logpref.writehistory:=TRUE;
logpref.pkts.onWindow:=FALSE;
logpref.pkts.onFile:=FALSE;
logpref.pkts.clear:=FALSE;
logpref.evts.onWindow:=FALSE;
logpref.evts.onFile:=FALSE;
logpref.evts.clear:=FALSE;
roasterItalic:=RI_list;
ICQ.authNeeded:=FALSE;
popupautomsg:=TRUE;
oncomingOnAway:=FALSE;
showOnlyOnline:=FALSE;
showOnlyImVisibleTo:=FALSE;
closeAuthAfterReply:=TRUE;
autoConsumeEvents:=TRUE;
mainfrm.roaster.ShowHint:=TRUE;
warnVisibilityAutoMsgReq:=TRUE;
showStatusOnTabs:=TRUE;
webaware:=TRUE;
indentRoaster:=FALSE;
saveNIL:=FALSE;
dontSavePwd:=FALSE;
startMinimized:=FALSE;
autoReconnect:=TRUE;
quitconfirmation:=FALSE;
minimizeRoaster:=TRUE;
showLSB:=TRUE;
popupLSB:=TRUE;
hideOnClose:=FALSE;
showRoasterMinButton:=TRUE;
getOfflineMsgs:=TRUE;
delOfflineMsgs:=TRUE;
lockOnStart:=FALSE;
autocopyhist:=TRUE;
useSmiles:=TRUE;
sendTheAddedYou:=FALSE;
texturizedWindows:=TRUE;
showOncomingDlg:=FALSE;
autoSizeRoaster:=FALSE;
autosizeFullRoaster:=FALSE;
showDisconnectedDlg:=TRUE;
fontstylecodes.enabled:=TRUE;
playSounds:=TRUE;
autoconnect:=FALSE;
showGroups:=TRUE;
alwaysOnTop:=TRUE;
chatAlwaysOnTop:=FALSE;
sendBalloonOn:=BALLOON_NEVER;
autoDeselect:=FALSE;
warnVisibilityExploit:=TRUE;
roundedWindows:=TRUE;
wheelVelocity:=1;
enableIgnoreList:=TRUE;
ignorelist.clear;
useDefaultBrowser:=TRUE;
browserCmdLine:='';

with spamfilter do
  begin
	ignoreNIL:=FALSE;
  ignorepagers:=FALSE;
  warn:=FALSE;
  notNIL:=FALSE;
  notEmpty:=FALSE;
  nobadwords:=FALSE;
  multisend:=FALSE;
  badwords:='';
  uingt:=0;
  end;
with histcrypt do
  begin
  enabled:=FALSE;
  savePwd:=FALSE;
  pwd:='';
  end;
autoaway.autoexit:=FALSE;
autoaway.away:=TRUE;
autoaway.na:=TRUE;
autoaway.awayTime:=15*(10*60);
autoaway.naTime:=30*(10*60);
autoaway.msg:='';
autoaway.bakmsg:='';
docking.enabled:=TRUE;
docking.appbar:=TRUE;
behaviour[EK_oncoming].trig:=[BE_tray,BE_sound,BE_tip,BE_history];
behaviour[EK_offgoing].trig:=[BE_history,BE_tip];
behaviour[EK_msg].trig:=[BE_tray,BE_openchat,BE_save,BE_sound,BE_history,BE_tip];
behaviour[EK_contacts]:=behaviour[EK_msg];
behaviour[EK_auth]:=behaviour[EK_msg];
behaviour[EK_authDenied]:=behaviour[EK_msg];
behaviour[EK_authreq]:=behaviour[EK_msg];
behaviour[EK_addedyou]:=behaviour[EK_msg];
behaviour[EK_file].trig:=[BE_tray,BE_save,BE_sound,BE_history];
behaviour[EK_automsgreq].trig:=[BE_history];
behaviour[EK_statuschange].trig:=[BE_history];
behaviour[EK_gcard].trig:=[BE_tray,BE_sound,BE_history,BE_openchat,BE_save];
behaviour[EK_automsg].trig:=[BE_openchat,BE_history,BE_sound,BE_popup];
for i:=1 to EK_last do
  begin
  behaviour[i].tiptimes:=FALSE;
  behaviour[i].tiptime:=50;
  behaviour[i].tiptimeplus:=50;
  end;
behaviour[EK_msg].tiptimes:=TRUE;
behaviour[EK_msg].tiptime:=1;
behaviour[EK_url]:=behaviour[EK_msg];

fillChar(onStatusDisable, sizeOf(onStatusDisable), 0);
onStatusDisable[SC_dnd].blinking:=TRUE;
onStatusDisable[SC_dnd].sounds:=TRUE;
end; // resetCFG

const
  yesno:array [boolean] of string=('No','Yes');

function getCFG:string;
var
  i:integer;
  st:Tstatus;
  pp:Tproxyproto;
begin
result:='account-name='+contactsDB.get(ICQ.myInfo.uin).nick+CRLF
+'version='+ip2str(ANDRQversion)+CRLF;

if histcrypt.savePwd then
  result:=result+'history-crypt-password='+passcrypt(histcrypt.pwd)+CRLF;
if not dontSavePwd and not locked then
  result:=result+'crypted-password='+passCrypt(ICQ.pwd)+CRLF;
for i:=1 to EK_last do
  result:=result+event2str[i]+'-behaviour='+beh2str(i)+CRLF;

for st:=SC_ONLINE to pred(SC_OFFLINE) do
  begin
  result:=result
  +status2str[st]+'-disable-blinking='+yesno[onStatusDisable[st].blinking]+CRLF
  +status2str[st]+'-disable-tips='+yesno[onStatusDisable[st].tips]+CRLF
  +status2str[st]+'-disable-sounds='+yesno[onStatusDisable[st].sounds]+CRLF
  end;

result:=result
+'auto-size='+yesno[autosizeRoaster]+CRLF
+'auto-size-full='+yesno[autosizeFullRoaster]+CRLF
+'public-email='+yesno[icq.publicEMail]+CRLF
+'server-host='+loginServer+CRLF
+'reopen-chats-on-start='+yesno[reopenchats]+CRLF
+'skip-splash='+yesno[skipSplash]+CRLF
+'fix-windows-position='+yesno[dofixwindows]+CRLF
+'flash-chat-window='+yesno[doflashchat]+CRLF
+'start-minimized='+yesno[startMinimized]+CRLF
+'auto-reconnect='+yesno[autoReconnect]+CRLF
+'use-last-status='+yesno[useLastStatus]+CRLF
+'server-port='+icq.loginserverPort+CRLF
+'lang='+lang+CRLF
+'close-auth-after-reply='+yesno[closeAuthAfterReply]+CRLF
+'last-update-info='+intToStr(checkupdate.lastSerial)+CRLF
+'last-update-check-time='+datetimeToStr(checkupdate.last)+CRLF
+'check-betas='+yesno[checkupdate.betas]+CRLF
+'wheel-velocity='+intToStr(wheelVelocity)+CRLF
+'inactive-hide='+yesno[inactivehide]+CRLF
+'get-offline-msgs='+yesno[getOfflineMsgs]+CRLF
+'del-offline-msgs='+yesno[delOfflineMsgs]+CRLF
+'roaster-bar-on-top='+yesno[roasterbarOnTop]+CRLF
+'inactive-hide-time='+intToStr(inactivehideTime)+CRLF
+'send-balloon-on='+intToStr(sendBalloonOn)+CRLF
+'send-balloon-on-date='+datetimeToStr(sendBalloonOnDate)+CRLF
+'dont-save-password='+yesno[dontSavePwd]+CRLF
+'oncoming-on-away='+yesno[oncomingOnAway]+CRLF
+'show-client-id='+yesno[showClientID]+CRLF
+'auto-connect='+yesno[autoconnect]+CRLF
+'minimize-roaster='+yesno[minimizeRoaster]+CRLF
+'connect-on-connection='+yesno[connectOnConnection]+CRLF
+'quit-confirmation='+yesno[quitconfirmation]+CRLF
+'min-on-off='+yesno[minOnOff]+CRLF
+'min-on-off-time='+intToStr(minOnOffTime)+CRLF
+'play-sounds='+yesno[playSounds]+CRLF
+'lock-on-start='+yesno[lockOnStart]+CRLF
+'ok-double-enter-auto-msg='+yesno[okOn2enter_autoMsg]+CRLF
+'auto-check-update='+yesno[checkupdate.enabled]+CRLF
+'show-only-online-contacts='+yesno[showOnlyOnline]+CRLF
+'show-only-im-visible-to-contacts='+yesno[showOnlyImvisibleto]+CRLF
+'show-oncoming-dialog='+yesno[showOncomingDlg]+CRLF
+'send-added-you='+yesno[sendTheAddedYou]+CRLF
+'always-on-top='+yesno[alwaysOnTop]+CRLF
+'chat-always-on-top='+yesno[chatAlwaysOnTop]+CRLF
+'show-statusbar='+yesno[mainfrm.bar.visible]+CRLF
+'warn-visibility-automsgreq='+yesno[warnVisibilityAutoMsgReq]+CRLF
+'split-y='+intToStr(splitY)+CRLF
+'blink-speed='+intToStr(blinkSpeed)+CRLF
+'temp-blink-time='+intToStr(tempBlinkTime)+CRLF
+'show-contact-tip='+yesno[mainfrm.roaster.ShowHint]+CRLF
+'use-default-browser='+yesno[useDefaultBrowser]+CRLF
+'browser-command-line='+browserCmdLine+CRLF
+'close-button-hides='+yesno[hideOnClose]+CRLF
+'popup-automsg='+yesno[popupAutomsg]+CRLF
+'save-not-in-list='+yesno[saveNIL]+CRLF
+'animated-roaster='+yesno[animatedRoaster]+CRLF
+'show-groups='+yesno[showGroups]+CRLF
+'visibility-flag='+yesno[showVisibilityFlag]+CRLF
+'use-smiles='+yesno[useSmiles]+CRLF
+'send-on-enter='+intToStr(sendOnEnter)+CRLF
+'sort-by='+sortby2str[sortby]+CRLF
+'show-status-on-tabs='+yesno[showStatusOnTabs]+CRLF
+'auto-deselect='+yesno[autodeselect]+CRLF
+'single-message-by-default='+yesno[singledefault]+CRLF
+'auto-copy='+yesno[autocopyhist]+CRLF
+'webaware='+yesno[webaware]+CRLF
+'auth-needed='+yesno[ICQ.authneeded]+CRLF
+'indent-contact-list='+yesno[indentRoaster]+CRLF
+'auto-consume-events='+yesno[autoconsumeevents]+CRLF
+'show-disconnected-dialog='+yesno[showDisconnectedDlg]+CRLF
+'italic-mode='+intToStr(roasterItalic)+CRLF
+'disabled-plugins='+disabledPlugins+CRLF
+'keep-alive='+yesno[keepalive.enabled]+CRLF
+'keep-alive-freq='+intTostr(keepalive.freq)+CRLF
+'focus-on-chat-popup='+yesno[focusOnChatPopup]+CRLF
+'enable-ignore-list='+yesno[enableIgnorelist]+CRLF
+'theme='+theme.fn+CRLF
+'rounded-windows='+yesno[roundedWindows]+CRLF
+'preferences-height='+intToStr(prefHeight)+CRLF
+'docking-enabled='+yesno[docking.enabled]+CRLF
+'docking-active='+yesno[docking.active]+CRLF
+'docking-resize='+yesno[docking.appbar]+CRLF
+'docking-right='+yesno[docking.pos=DP_right]+CRLF
+'docking-bak-x='+intToStr(docking.bakOfs.x)+CRLF
+'docking-bak-y='+intToStr(docking.bakOfs.y)+CRLF
+'docking-bak-width='+intToStr(docking.bakSize.x)+CRLF
+'docking-bak-height='+intToStr(docking.bakSize.y)+CRLF
+'autoaway-exit='+yesno[autoaway.autoexit]+CRLF
+'autoaway-away='+yesno[autoaway.away]+CRLF
+'autoaway-away-time='+intToStr(autoaway.awayTime)+CRLF
+'autoaway-na='+yesno[autoaway.na]+CRLF
+'autoaway-na-time='+intToStr(autoaway.naTime)+CRLF
+'ignore-not-in-list='+yesno[spamfilter.ignoreNIL]+CRLF
+'ignore-pagers='+yesno[spamfilter.ignorePagers]+CRLF
+'spam-ignore-not-in-list='+yesno[spamfilter.notNIL]+CRLF
+'spam-ignore-empty-history='+yesno[spamfilter.notEmpty]+CRLF
+'spam-ignore-bad-words='+yesno[spamfilter.noBadwords]+CRLF
+'spam-ignore-multisend='+yesno[spamfilter.multisend]+CRLF
+'spam-bad-words='+spamfilter.badwords+CRLF
+'spam-warn='+yesno[spamfilter.warn]+CRLF
+'spam-uin-greater-than='+intToStr(spamfilter.uingt)+CRLF
+'history-crypt-enabled='+yesno[histcrypt.enabled]+CRLF
+'history-crypt-save-password='+yesno[histcrypt.savePwd]+CRLF
+'chat-lsb-popup='+yesno[popupLSB]+CRLF
+'chat-lsb-show='+yesno[showLSB]+CRLF
+'window-top='+intToStr(mainFrm.top)+CRLF
+'window-height='+intToStr(mainFrm.height)+CRLF
+'window-left='+intToStr(mainFrm.left)+CRLF
+'window-width='+intToStr(mainFrm.width)+CRLF
+'chat-top='+intToStr(chatfrmXY.top)+CRLF
+'chat-height='+intToStr(chatfrmXY.height)+CRLF
+'chat-left='+intToStr(chatfrmXY.left)+CRLF
+'chat-width='+intToStr(chatfrmXY.width)+CRLF
+'chat-maximized='+yesno[chatfrmXY.maximized]+CRLF
+'transparency='+yesno[transparency.forRoaster]+CRLF
+'transparency-chat='+yesno[transparency.forChat]+CRLF
+'transparency-active='+intToStr(transparency.active)+CRLF
+'transparency-inactive='+intToStr(transparency.inactive)+CRLF
+'proxy='+yesno[proxy.enabled]+CRLF;
for pp:=low(pp) to high(pp) do result:=result
  +'proxy-'+proxyproto2str[pp]+'-host='+proxy.addr[pp].host+CRLF
  +'proxy-'+proxyproto2str[pp]+'-port='+proxy.addr[pp].port+CRLF;
result:=result
+'proxy-auth='+yesno[proxy.auth]+CRLF
+'proxy-user='+proxy.user+CRLF
+'proxy-pass='+passCrypt(proxy.pwd)+CRLF
+'proxy-proto='+proxyproto2str[proxy.proto]+CRLF
+'starting-status='+status2str[startingStatus]+CRLF
+'starting-visibility='+visibility2str[startingVisibility]+CRLF
+'log-events-file='+yesno[logpref.evts.onfile]+CRLF
+'log-events-window='+yesno[logpref.evts.onwindow]+CRLF
+'log-events-clear='+yesno[logpref.evts.clear]+CRLF
+'log-packets-file='+yesno[logpref.pkts.onfile]+CRLF
+'log-packets-window='+yesno[logpref.pkts.onwindow]+CRLF
+'log-packets-clear='+yesno[logpref.pkts.clear]+CRLF
+'font-style-codes='+yesno[fontstylecodes.enabled]+CRLF
+'write-history='+yesno[logpref.writehistory]+CRLF
+'quote-selected='+yesno[quoting.quoteselected]+CRLF
+'quoting-width='+intToStr(quoting.width)+CRLF
+'quoting-cursor-below='+yesno[quoting.cursorBelow]+CRLF
+'texturized-windows='+yesno[texturizedWindows]+CRLF
+'roaster-title='+roasterTitle+CRLF
+'auto-switch-keyboard-layout='+yesno[autoSwitchKL]+CRLF
+'show-roaster-minimize-button='+yesno[showRoasterMinButton]+CRLF
+'warn-visibility-exploit='+yesno[warnVisibilityExploit]+CRLF
end; // getCFG

procedure saveCFG;
begin savefile(userPath+configFileName, getCFG) end;

procedure setcommoncfg(cfg:string);
var
  l,h:string;

  function yesno:boolean;
  begin result:=l='yes' end;

  function int:integer;
  begin result:=strToInt(l) end;

begin
if cfg = '' then exit;
docking.pos:=DP_right;

while cfg > '' do
  begin
  l:=chop(CRLF,cfg);
  h:=chop('=',l);
  try
  if h='auto-start-uin' then autostartUIN:=int;
  if h='check-read-only' then check4readonly:=yesno;
  if h='last-server-ip' then lastserverIP:=l;
  if h='last-user' then lastUser:=int;
  if h='users-path' then usersPath:=l;
  except end
  end
end; // setcommoncfg

function getCommonCFG:string;
begin
result:=''
+'auto-start-uin='+intToStr(autostartUIN)+CRLF
+'check-read-only='+yesno[check4readonly]+CRLF
+'last-server-ip='+lastserverIP+CRLF
+'users-path='+usersPath+CRLF
+'last-user='+intToStr(lastUser)+CRLF
end;

procedure resetCommonCFG;
begin
lastServerIP:='205.188.179.233';
check4readonly:=TRUE;
autostartUIN:=0;
lastUser:=0;
usersPath:='';
end; // resetCommonCFG

procedure setCFG(cfg:string);
var
  l,h:string;
  lastVersion:integer;
  i:integer;
  st:Tstatus;
  pp:Tproxyproto;

  function yesno:boolean;
  begin result:=comparetext(l,'yes')=0 end;

  function int:integer;
  begin result:=strToInt(l) end;

  function dt:Tdatetime;
  begin result:=StrToDate(l) end;

  function sc:TShortCut;
  begin
  if comparetext(l,'none')=0 then result:=0
  else result:=textToShortCut(l);
  end;

begin
if cfg = '' then exit;
lastVersion:=0;
docking.pos:=DP_right;

while cfg > '' do
  begin
  l:=chop(CRLF,cfg);
  h:=chop('=',l);
  try
  if h='version' then lastVersion:=str2ip(l);
  if h='public-email' then icq.publicEMail:=yesno;
  if h='server-host' then loginServer:=l;
  if h='server-port' then ICQ.loginserverport:=l;
  if h='theme' then theme.fn:=l;
  if h='roaster-title' then roasterTitle:=l;
  if h='fix-windows-position' then dofixwindows:=yesno;
  if h='flash-chat-window' then doflashchat:=yesno;
  if h='reopen-chats-on-start' then reopenchats:=yesno;
  if h='connect-on-connection' then connectOnConnection:=yesno;
  if h='get-offline-msgs' then getOfflineMsgs:=yesno;
  if h='del-offline-msgs' then delOfflineMsgs:=yesno;
  if h='minimize-roaster' then minimizeRoaster:=yesno;
  if h='last-update-info' then checkupdate.lastSerial:=int;
  if h='browser-command-line' then browserCmdLine:=l;
  if h='use-default-browser' then useDefaultBrowser:=yesno;
  if h='wheel-velocity' then wheelVelocity:=int;
  if h='split-y' then splitY:=int;
  if h='auto-switch-keyboard-layout' then autoSwitchKL:=yesno;
  if h='last-update-check-time' then checkupdate.last:=dt;
  if h='skip-splash' then skipSplash:=yesno;
  if h='ok-double-enter-auto-msg' then okOn2enter_autoMsg:=yesno;
  if h='start-minimized' then startMinimized:=yesno;
	if h='warn-visibility-automsgreq' then warnVisibilityAutoMsgReq:=yesno;
  if h='auto-reconnect' then autoReconnect:=yesno;
  if h='auto-check-update' then checkupdate.enabled:=yesno;
  if h='lock-on-start' then lockOnStart:=yesno;
  if h='show-client-id' then showClientID:=yesno;
  if h='chat-lsb-popup' then popupLSB:=yesno;
  if h='chat-lsb-show' then showLSB:=yesno;
  if h='popup-automsg' then popupAutomsg:=yesno;
  if h='rounded-windows' then roundedWindows:=yesno;
  if h='animated-roaster' then animatedRoaster:=yesno;
  if h='inactive-hide' then inactivehide:=yesno;
  if h='font-style-codes' then fontstylecodes.enabled:=yesno;
  if h='roaster-bar-on-top' then roasterbaronTop:=yesno;
  if h='oncoming-on-away' then oncomingOnAway:=yesno;
  if h='use-last-status' then useLastStatus:=yesno;
  if h='send-on-enter' then sendOnEnter:=int;
  if h='inactive-hide-time' then inactivehideTime:=int;
  if h='blink-speed' then blinkSpeed:=int;
  if h='send-balloon-on' then sendBalloonOn:=int;
  if h='send-balloon-on-date' then sendBalloonOnDate:=dt;
  if h='texturized-windows' then texturizedWindows:=yesno;
  if h='dont-save-password' then dontSavePwd:=yesno;
  if h='always-on-top' then alwaysOnTop:=yesno;
  if h='chat-always-on-top' then chatAlwaysOnTop:=yesno;
  if h='check-betas' then checkupdate.betas:=yesno;
  if h='send-added-you' then sendTheAddedYou:=yesno;
  if h='show-groups' then showGroups:=yesno;
  if h='show-contact-tip' then mainfrm.roaster.ShowHint:=yesno;
  if h='close-auth-after-reply' then closeAuthAfterReply:=yesno;
  if h='quoting-cursor-below' then quoting.cursorBelow:=yesno;
  if h='quote-selected' then quoting.quoteselected:=yesno;
  if h='quoting-width' then quoting.width:=int;
  if h='quit-confirmation' then quitconfirmation:=yesno;
  if h='log-events-file' then logpref.evts.onfile:=yesno;
  if h='log-events-window' then logpref.evts.onwindow:=yesno;
  if h='log-events-clear' then logpref.evts.clear:=yesno;
  if h='log-packets-file' then logpref.pkts.onfile:=yesno;
  if h='log-packets-window' then logpref.pkts.onwindow:=yesno;
  if h='log-packets-clear' then logpref.pkts.clear:=yesno;
  if h='write-history' then logpref.writehistory:=yesno;
  if h='indent-contact-list' then indentRoaster:=yesno;
  if h='auto-consume-events' then autoConsumeEvents:=yesno;
  if h='focus-on-chat-popup' then focusOnChatPopup:=yesno;
  if h='save-not-in-list' then saveNIL:=yesno;
  if h='show-status-on-tabs' then showStatusOnTabs:=yesno;
  if h='show-disconnected-dialog' then showDisconnectedDlg:=yesno;
  if h='italic-mode' then roasterItalic:=int;
  if h='show-statusbar'then mainfrm.bar.visible:=yesno;
  if h='use-smiles' then useSmiles:=yesno;
  if h='auth-needed' then ICQ.authneeded:=yesno;
  if h='webaware' then webaware:=yesno;
  if h='auto-copy' then autocopyhist:=yesno;
  if h='visibility-flag' then showVisibilityFlag:=yesno;
  if h='single-message-by-default' then singledefault:=yesno;
  if h='show-oncoming-dialog' then showOncomingDlg:=yesno;
  if h='min-on-off' then minOnOff:=yesno;
  if h='min-on-off-time' then minOnOffTime:=int;
  if h='keep-alive' then keepalive.enabled:=yesno;
  if h='keep-alive-freq' then keepalive.freq:=int;
  if h='enable-ignore-list' then enableIgnorelist:=yesno;
  if h='ignore-not-in-list' then spamfilter.ignoreNIL:=yesno;
  if h='ignore-pagers' then spamfilter.ignorePagers:=yesno;
  if h='spam-warn' then spamfilter.warn:=yesno;
  if h='spam-ignore-not-in-list' then spamfilter.notNIL:=yesno;
  if h='spam-ignore-empty-history' then spamfilter.notEmpty:=yesno;
  if h='spam-ignore-bad-words' then spamfilter.noBadwords:=yesno;
  if h='spam-ignore-multisend' then spamfilter.multisend:=yesno;
  if h='spam-bad-words' then spamfilter.badwords:=ansiReplaceStr(l,CRLF,';');
  if h='spam-uin-greater-than' then spamfilter.uingt:=int;
  if h='history-crypt-enabled' then histcrypt.enabled:=yesno;
  if h='history-crypt-save-password' then histcrypt.savePwd:=yesno;
  if h='history-crypt-password' then histcrypt.pwd:=passDecrypt(l);
  if h='window-top' then mainfrm.top:=int;
  if h='window-height' then mainfrm.height:=int;
  if h='window-left' then mainfrm.left:=int;
  if h='window-width' then mainfrm.width:=int;
	if h='show-roaster-minimize-button' then showRoasterMinButton:=yesno;
  if h='preferences-height' then prefHeight:=int;
  if h='docking-enabled' then docking.enabled:=yesno;
  if h='docking-active' then docking.active:=yesno;
  if h='docking-resize' then docking.appbar:=yesno;
  if h='docking-bak-x' then docking.bakOfs.x:=int;
  if h='docking-bak-y' then docking.bakOfs.y:=int;
  if h='docking-bak-width' then docking.bakSize.x:=int;
  if h='docking-bak-height' then docking.bakSize.y:=int;
  if h='docking-right' then if not yesno then docking.pos:=DP_left;
  if h='sort-by' then sortBy:=str2sortby(l);
  if h='lang' then lang:=l;
  if h='chat-top' then chatfrmXY.top:=int;
  if h='chat-height' then chatfrmXY.height:=int;
  if h='chat-left' then chatfrmXY.left:=int;
  if h='chat-width' then chatfrmXY.width:=int;
  if h='chat-maximized' then chatfrmXY.maximized:=yesno;
  if h='auto-size' then autosizeRoaster:=yesno;
  if h='auto-size-full' then autosizeFullRoaster:=yesno;
  if h='auto-connect' then autoconnect:=yesno;
  if h='play-sounds' then playSounds:=yesno;
  if h='show-only-online-contacts' then showOnlyOnline:=yesno;
  if h='show-only-im-visible-to-contacts' then showOnlyImvisibleto:=yesno;
  if h='close-button-hides' then hideOnClose:=yesno;
  if h='auto-deselect' then autodeselect:=yesno;
  if h='temp-blink-time' then tempBlinkTime:=int;
  if h='transparency' then transparency.forRoaster:=yesno;
  if h='transparency-chat' then transparency.forChat:=yesno;
  if h='transparency-active' then transparency.active:=int;
  if h='transparency-inactive' then transparency.inactive:=int;
	if h='warn-visibility-exploit' then warnVisibilityExploit:=yesno;
  if h='proxy' then proxy.enabled:=yesno;
  for pp:=low(pp) to high(pp) do
    begin
    if h='proxy-'+proxyproto2str[pp]+'-host' then proxy.addr[pp].host:=l;
    if h='proxy-'+proxyproto2str[pp]+'-port' then proxy.addr[pp].port:=l;
    end;
  if h='proxy-auth' then proxy.auth:=yesno;
  if h='proxy-user' then proxy.user:=l;
  if h='proxy-pass' then proxy.pwd:=passDecrypt(l);
  if h='proxy-proto' then
    begin
    i:=findInStrings(l, proxyproto2str);
    if i < 0 then
      begin
      proxy.enabled:=FALSE;
      proxy.proto:=PP_SOCKS5;
      end
    else
      proxy.proto:=TproxyProto(i);
    end;
  if h='autoaway-exit' then autoaway.autoexit:=yesno;
  if h='autoaway-away' then autoaway.away:=yesno;
  if h='autoaway-away-time' then autoaway.awayTime:=int;
  if h='autoaway-na' then autoaway.na:=yesno;
  if h='autoaway-na-time' then autoaway.naTime:=int;
  if h='crypted-password' then ICQ.pwd:=passDecrypt(l);
  for i:=1 to EK_last do
    if h = event2str[i]+'-behaviour' then behaviour[i]:=str2beh(l);
  if h='starting-status' then startingStatus:=str2status(l);
  if h='starting-visibility' then startingVisibility:=str2visibility(l);
  if h='disabled-plugins' then disabledPlugins:=l;

  // backward compatibility
  if h='key-action' then addMacro(sc, TRUE, OP_tray);
  if h='key-only-online' then addMacro(sc, FALSE, OP_offlineContacts);
  if h='key-chat-window' then addMacro(sc, TRUE, OP_chat);
  if h='key-show-groups' then addMacro(sc, FALSE, OP_groups);
  if h='key-auto-size' then addMacro(sc, FALSE, OP_autosize);
  if h='key-msgs-read' then addMacro(sc, TRUE, OP_clearEvent);

  for st:=SC_ONLINE to pred(SC_OFFLINE) do
    begin
    if h=status2str[st]+'-disable-blinking' then onStatusDisable[st].blinking:=yesno;
    if h=status2str[st]+'-disable-tips' then onStatusDisable[st].tips:=yesno;
    if h=status2str[st]+'-disable-sounds' then onStatusDisable[st].sounds:=yesno;
    end;
  if h='send-on-double-enter' then sendOnEnter:=2;
  if h='oncoming-tip-time' then behaviour[EK_oncoming].tiptime:=int;
  if h='msg-tip-time' then behaviour[EK_msg].tiptime:=int;
  if h='msg-tip-time' then behaviour[EK_url].tiptime:=int;
  if h='show-oncoming-tip' then
    if yesno then include(behaviour[EK_oncoming].trig, BE_tip)
    else exclude(behaviour[EK_oncoming].trig, BE_tip);
  if h='show-msg-tip' then
    if yesno then
      begin
      include(behaviour[EK_msg].trig, BE_tip);
      include(behaviour[EK_url].trig, BE_tip);
      end
    else
      begin
      exclude(behaviour[EK_msg].trig, BE_tip);
      exclude(behaviour[EK_url].trig, BE_tip);
      end;
  if h='autoaway-msg' then autoaway.msg:=l;
  if h='proxy-ver5' then
    if yesno then proxy.proto:=PP_SOCKS5
    else proxy.proto:=PP_SOCKS4;
  // end of backward compatibility

  except end;
  end;

// backward compatibility
if lastVersion < $00080104 then  // here i introduced BE_history
  for i:=1 to EK_last do
    if BE_history in supportedBehactions[i] then
      include(behaviour[i].trig, BE_history);
// end of backward compatibility
boundInt(inactivehideTime, 0,60*60*10);
boundInt(blinkSpeed, 1,15);
boundInt(transparency.active, 0,255);
boundInt(transparency.inactive, 0,255);
histcrypt.pwdKey:=calculate_KEY1(histcrypt.pwd);
setVisibility(startingVisibility);
setLang(lang);
dockSet;
applyTransparency;
end; // setcfg

procedure loadCFG;
begin
setCFG(loadfile(userPath+configFileName));
setCFG(loadfile(cmdlinepar.extraini));
end;

procedure loadCommonCFG;
begin setcommonCFG(loadfile(userpath+commonFileName)) end;

procedure saveCommonCFG;
begin savefile(myPath+commonFileName, getCommonCFG) end;

function readOnlyFiles:boolean;

  function recur(const path:string):boolean;
  var
    sr:TsearchRec;
  begin
  result:=TRUE;
  if FindFirst(path+'*.*', faAnyFile, sr)=0 then
    repeat
    if (sr.Attr and faReadOnly > 0) or (sr.name[1]<>'.') and (sr.Attr and faDirectory >0) and recur(path+sr.name+'\') then
      begin
      findClose(sr);
      exit;
      end;
    until FindNext(sr) > 0;
  findClose(sr);
  result:=FALSE;
  end;

var
  i:integer;
  sr:TsearchRec;
begin
result:=TRUE;
i:=FileGetAttr(myPath+commonFileName);
if (i >= 0) and (i and faReadOnly >0) then
  exit;
if FindFirst(mypath+'*.*', faDirectory, sr)=0 then
  repeat
  if (sr.Attr and faDirectory >0) and isOnlyDigits(sr.name) and recur(mypath+sr.name+'\') then
    begin
    findClose(sr);
    exit;
    end;
  until FindNext(sr) > 0;
findClose(sr);
result:=FALSE;
end; // readOnlyFiles

procedure beforeWindowsCreation;

  procedure parseCmdLinePar;
  var
    i:integer;
    s:string;
  begin
  myPath:=ExtractFilePath(paramStr(0));
  cmdlinepar.extraini:='';
  cmdlinepar.startUser:='';
  i:=0;
  while i < paramCount() do
    begin
    inc(i);
    s:=paramStr(i);
    // is it an UIN ?
    try
      if validUIN(strToInt(ExtractFileName(s))) then
        cmdlinepar.startUser:=s;
    except end;
    if s='--add-ini' then
      begin
      inc(i);
      cmdlinepar.extraini:=paramstr(i);
      end;
    end;
  end; // parseCmdLinePar

var
  langs:TstringDynArray;
begin
if initOnce then
  begin
  langs:=NIL;  // shut up compiler
  exit;
  end;
initOnce:=TRUE;
startTime:=now;
Application.Initialize;
Application.ShowMainForm := False;
application.HintHidePause:=60000;
Application.Title := '&RQ';
parseCmdLinePar;
langs:=availableLangs;
if length(langs)=0 then
  begin
  msgDlg('No language module available',mtError);
  halt(1);
  end
else
  if not setLang('default') then
    setLang(langs[0]);
loadLanguage(lang);
WM_TASKBARCREATED:=RegisterWindowMessage('TaskbarCreated');
timeformat.chat:=shortdateformat+' hh:nn:ss';
timeformat.info:=shortdateformat+' hh:nn';
timeformat.clock:='hh:nn';
timeformat.log:=shortdateformat+' hh:nn:ss.zzz';
timeformat.automsg:='hh:nn';
ICQ:=TicqSession.create;
acks:=Toutbox.create;
visibleList:=TcontactList.create;
invisibleList:=TcontactList.create;
notinlist:=TcontactList.create;
ignoreList:=TcontactList.create;
autoMessages:=TstringList.create;
updateViewInfoQ:=Tcontactlist.create;

supportedBehactions[EK_msg]:=allBehactions;
supportedBehactions[EK_url]:=allBehactions;
supportedBehactions[EK_oncoming]:=allBehactions;
supportedBehactions[EK_offgoing]:=allBehactions;
supportedBehactions[EK_contacts]:=allBehactions;
supportedBehactions[EK_addedyou]:=allBehactions;
supportedBehactions[EK_auth]:=allBehactions;
supportedBehactions[EK_authReq]:=allBehactions;
supportedBehactions[EK_authDenied]:=allBehactions;
supportedBehactions[EK_automsgreq]:=allBehactions;
supportedBehactions[EK_statuschange]:=allBehactions;
supportedBehactions[EK_gcard]:=allBehactions;
supportedBehactions[EK_file]:=allBehactionsButTip;
supportedBehactions[EK_automsg]:=allBehactions;

audioPresent:=TRUE;

groups:=Tgroups.create;
theme.smiles.root:=myPath;
outbox:=Toutbox.create;
uinlists:=Tuinlists.create;
retrieveQ:=TcontactList.create;

resetCommonCFG;
loadCommonCFG;
if check4readonly and readOnlyFiles then
  begin
  msgDlg(___('error readonly files'), mtWarning);
  halt;
  end;

refreshAvailableUsers;
uin2Bstarted:=0;
if cmdlinepar.startUser > '' then
  uin2Bstarted:=strToInt(extractFileName(cmdlinepar.startuser))
else
  if findInAvailableUsers(autostartUIN) >= 0 then
    uin2Bstarted:=autostartUIN
  else
    if length(availableusers)=1 then
      uin2Bstarted:=availableusers[0].uin
    else
      uin2Bstarted:=showUsers;
if uin2Bstarted=0 then halt(0);

tipFrm:=Ttipfrm.create(application);
childWindows:=Tlist.create;
resolving:=FALSE;
locked:=FALSE;
autoaway.time:=0;
userTime:=-1;
eventQ:=TeventQ.create;
statusIcon:=TstatusIcon.create;
eventQ.onNewTop:=statusIcon.update;
hotkeysEnabled:=TRUE;
plugins:=Tplugins.create;
end; // beforeWindowsCreation

procedure startUser;

  function loadCodes(name:string):Tcodes;
  begin result:=Tcodes.createAndLoad(langDependentFile('codes\'+name+'.txt')) end;

const
  maxProg=17;
var
  i:integer;
  langs:TstringDynArray;
begin
i:=findInAvailableUsers(uin2Bstarted);
if i < 0 then
  begin
  msgDlg('StartUser: Bad UIN',mtError);
  halt(1);
  end;

mainfrm.setProgBar(1/maxProg);
resetCFG;
resetLanguage;
showForm(mainfrm);
mainfrm.setProgBar(2/maxProg);
loadLanguage('default');
mainfrm.setProgBar(3/maxProg);
keepalive.timer:=0;
with availableUsers[i] do userPath:=path+uinStr+'\';
stayconnected:=FALSE;
ICQ.pwd:='';
setVisibility(VI_normal);
status:=SC_OFFLINE;
loadCommonCFG;
mainfrm.setProgBar(4/maxProg);
lang:='';
offlineMsgsChecked:=TRUE;
langs:=availableLangs;
loadCFG;
mainfrm.setProgBar(5/maxProg);
// reset log files
if logpref.evts.clear then deletefile(mypath+eventslogFilename);
if logpref.pkts.clear then deletefile(mypath+packetslogFilename);

loggaEvt('user: '+availableUsers[i].uinStr+' starting');
loggaEvt('theme: loading');
loadTheme(mypath+themesPath+theme.fn);
loggaEvt('theme: loading usertheme');
loadThemeScript(userPath+userthemeFilename);
mainfrm.setProgBar(7/maxProg);
loggaEvt('theme: applying');
applyTheme;
loggaEvt('theme: loaded');
loggaEvt('hotkeys: loading');
loadMacros;
mainfrm.setProgBar(8/maxProg);
updateSWhotkeys;
loggaEvt('hotkeys: loaded');
if not skipsplash then showSplash;
lastUser:=uin2Bstarted;
lastStatus:=startingStatus;
loggaEvt('DB: loading');
loadDB;
loggaEvt('DB: loaded');
mainfrm.setProgBar(9/maxProg);
loggaEvt('lists: loading');
loadLists;
retrieveQ.fromString( loadNewOrOldVersionContactList(retrieveFileName), contactsDB );
loggaEvt('lists: loaded');
mainfrm.setProgBar(10/maxProg);
if reopenchats then chatFrm.loadPages;
icq.webaware:=webaware;
ICQ.myinfo:=contactsDB.get(lastUser);
ICQ.myinfo.status:=SC_OFFLINE;
applyClientID;
if not skipsplash then playSound(theme.sounds.onStart);
applyBalloon();
applyMinButton();

if lang='' then
  if length(langs)=1 then
    setlang(langs[0])
  else
    TlangFrm.doAll
else
  if not setLang(lang) then
    TlangFrm.doAll;
loadLanguage(lang);
mainfrm.setProgBar(11/maxProg);
// load tables
countryCodes:=loadCodes('countries');
ageCodes:=loadCodes('ages');
pastCodes:=loadCodes('pasts');
interestCodes:=loadCodes('interests');
languageCodes:=loadCodes('languages');
genderCodes:=loadCodes('gender');
gmtCodes:=loadCodes('gmt');
mainfrm.setProgBar(12/maxProg);
loadAutoMessages;
mainfrm.setProgBar(13/maxProg);

loggaEvt('outbox: loading');
loadOutbox;
loggaEvt('outbox: loaded');
loggaEvt('inbox: loading');
loadInbox;
loggaEvt('inbox: loaded');
mainfrm.setProgBar(14/maxProg);

loggaEvt('groups: loading');
groups.load;
with contactsDB do
  for i:=0 to count-1 do
    with getAt(i) do
      if not groups.exists(group) then
        group:=0;
loggaEvt('groups: loaded');
roasterRebuildDelayed:=TRUE;
mainFrm.updateCaption;
mkdir(userPath+historyPath);
IOresult;
setRoasterAnimation(animatedRoaster);
statusIcon.trayicon.show;
statusIcon.update;
contactsPnl.text:=intToStr(ICQ.readRoaster.count);
acks.clear;
if assigned(prefFrm) then
  prefFrm.reset;
mainfrm.setProgBar(15/maxProg);
plugins.load;
mainfrm.setProgBar(16/maxProg);
translateWindows;

if lockOnStart then
  begin
  startingLock:=TRUE;
  doLock;
  enD;
startingLock:=FALSE;

bringForeground:=mainfrm.handle;
userTime:=0;
if autoConnect then
  doConnect;
mainfrm.setProgBar(0);
loggaEvt('user: started');
end; // startUser

procedure quitUser;
begin
if userTime < 0 then exit;
userTime:=-1;

playSound(theme.sounds.onQuit);

if not startingLock then
  begin
  groups.save;
  saveInbox;
  saveOutbox;
  saveCFG;
  saveAutoMessages;
  saveMacros;
  savecommonCFG;
  saveDB;                    
  saveLists;
  saveRetrieveQ;
  if reopenchats then chatFrm.savePages;
  end;

chatFrm.closeAllPages;
freeandnil(prefFrm);
freeandnil(wpFrm);  // we must free it before closeAllChildWindows to avoid AV
mainFrm.closeAllChildWindows;

if notInList.empty or (not saveNIL and (messageDlg(___('save not-in-list?'),mtConfirmation,[mbyes,mbNo],0) = mrNo)) then
  deleteFile(userPath+nilFileName+'.txt')
else
  if not saveFile(userPath+nilFileName+'.txt', notinlist.toString) then
    msgDlg(___('error saving not-in-list'),mtError);
tipFrm.hide();

plugins.unload;
roasterLib.clear;
eventQ.clear;
ICQ.myinfo:=NIL;
clearDB(contactsDB);
ICQ.readroaster.clear;
visibleList.clear;
invisibleList.clear;
notinlist.clear;
retrieveQ.clear;
unloadTheme;
end; // quitUser

const
  splitMsg='automsg: ';
  autoaway_name='AUTO-AWAY';

procedure saveAutomessages;
var
  i:integer;
  s:string;
begin
s:=automessages[0]+CRLF;
i:=1;
while i < automessages.count do
  begin
  s:=s+splitMsg+automessages[i]+CRLF+automessages[i+1]+CRLF;
  inc(i,2);
  end;

s:=s+splitMsg+autoaway_name+CRLF+autoaway.msg+CRLF;
saveFile(userPath+automsgFileName, s);
s:='';
end; // saveautomessages

procedure loadAutomessages;
var
  s,name,text:string;

  function split(sp:string):string;
  var
    i:integer;
  begin
  i:=pos(sp,s);
  if i=0 then i:=length(s)+1;
  result:=copy(s,1,i-1);
  delete(s,1,i+length(sp)-1);
  end; // chop

begin
s:=loadFile(userPath+automsgFileName);
if s = '' then
  begin
  s:=loadFile(langPath+defaultPrefix+automsgFileName);
  if s = '' then
    s:=loadFile(defaultlangPath+defaultPrefix+automsgFileName);
  end;
automessages.clear;
automessages.add(excludeTrailingCRLF(split(splitMsg)));
while s > '' do
  begin
  name:=excludeTrailingCRLF(split(CRLF));
  text:=excludeTrailingCRLF(split(splitMsg));
  if name = autoaway_name then
    autoaway.msg:=text
  else
    begin
    automessages.add(name);
    automessages.add(text);
    end;
  end;
end; // loadAutomessages

procedure saveMacros;
begin saveFile(userPath+macrosFileName, macros2str(macros)) end;

procedure loadMacros;
begin str2macros(loadFile(userPath+macrosFileName), macros) end;

procedure quit;
begin
if not initOnce then exit;
initOnce:=FALSE;
icq.disconnect;
mainfrm.hide;
stopTimer;
eventQ.OnNewTop:=NIL;
quitUser;
freeAndNIL(plugins);
freeAndNIL(gmtCodes);
freeAndNIL(countryCodes);
freeAndNIL(ageCodes);
freeAndNIL(pastCodes);
freeAndNIL(interestCodes);
freeAndNIL(genderCodes);
uninstallHook;
freeAndNIL(retrieveQ);
freeAndNIL(acks);
freeAndNIL(outbox);
freeAndNIL(eventQ);
freeAndNIL(statusIcon);
freeAndNIL(uinlists);
freeAndNIL(ICQ);
freeAndNIL(prefFrm);
loggaEvt('shutdown');
application.Terminate;
end; // quit

procedure afterWindowsCreation;
var
  i:integer;
begin
hintMode:=HM_null;
application.OnHint:=mainfrm.displayHint;
running:=TRUE;
mainfrmHandleUpdate;
applyTransparency;
for i:=0 to Screen.FormCount-1 do
  applyCommonSettings(screen.forms[i]);
if not isHooked then
  msgDlg(___('no hook.dll'),mtWarning);
end; // afterWindowsCreation

begin
initOnce:=FALSE;
onContactCreation:=ContactCreation;
onContactDestroying:=contactDestroying;
end.
