unit lang_fr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, StrUtils, types;

type
  TlangFr = class(TFrame)
    listBox: TListBox;
    Label1: TLabel;
    infoLbl: TLabel;
    flag: TImage;
    procedure listBoxClick(Sender: TObject);
  public
    loaded:Tstringdynarray;
    procedure load(langs:TStringDynArray=NIL);
    function selectedLang:string;
  end;

implementation

{$R *.dfm}

uses
  globalLib, utilLib;

procedure TlangFr.load(langs:TStringDynArray=NIL);
var
  i:integer;
  s:string;
begin
if length(langs)=0 then
  langs:=availableLangs;
loaded:=langs;
listBox.clear;
if length(langs) > 0 then
  begin
  for i:=0 to length(langs)-1 do
    begin
    s:=loadfile(myPath+'lang\'+langs[i]+'\lang.txt');
    if pos('\title\',s) > 0 then
      begin
      chop('\title\',s);
      listbox.additem(chop('\',s), NIL);
      end
    else
      listbox.additem(langs[i], NIL);
    end;
  if lang='' then
    listBox.itemIndex:=0
  else
    listBox.itemIndex:=findInStrings(lang, langs);
  listBoxClick(self);
  end;
end; // load

procedure TlangFr.listBoxClick(Sender: TObject);
var
  path,info,s:string;
begin
infoLbl.caption:='';
flag.visible:=FALSE;
if listbox.itemindex<0 then exit;
path:=myPath+'lang\'+selectedlang+'\';
infoLbl.top:=flag.top;
s:=path+'lang.png';
if not fileExists(s) then
  begin
  s:=path+'lang.bmp';
  if not fileExists(s) then s:='';
  end;
if s>'' then
  begin
  loadPic(s,flag);
  flag.visible:=TRUE;
  infoLbl.top:=flag.BoundsRect.bottom+10;
  end;
info:=loadfile(path+'lang.txt');
if pos('\end info block\',info) > 0 then
  infoLbl.caption:=chop('\end info block\',info)
else
  infoLbl.caption:='';
end; // load

function TlangFr.selectedlang:string;
begin
if listbox.itemIndex<0 then
  result:=''
else
  result:=loaded[listbox.itemIndex]
end; // selectedlang

end.

