{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit msgsDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ImgList;

type
  TmsgsFrm = class(TForm)
    listbox: TListBox;
    okBtn: TBitBtn;
    icons: TImageList;
    procedure listboxMeasureItem(Control: TWinControl; Index: Integer;
      var Height: Integer);
    procedure listboxDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure okBtnClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  public
    function kind2iconIndex(kind:TMsgDlgType):integer;
  end;

var
  msgsFrm: TmsgsFrm;

implementation

{$R *.dfm}

uses
  globalLib, utilLib, Types;

const
  GAP_X=3;
  GAP_Y=3;

function TmsgsFrm.kind2iconIndex(kind:TMsgDlgType):integer;
begin
case kind of
  mtWarning: result:=1;
  mtError: result:=2;
  else result:=0;
  end;
end;

procedure TmsgsFrm.listboxMeasureItem(Control: TWinControl; Index: Integer;
  var Height: Integer);
var
  r:Trect;
  s:string;
begin
r:=rect(0, 0, control.width, 0);
s:=msgs[index].text;
s:=CRLF+s;
inc(r.Left, GAP_X);
dec(r.right, GAP_X);
DrawText(listbox.canvas.Handle, pchar(s), -1, r,
  DT_WORDBREAK+DT_EXTERNALLEADING+DT_NOPREFIX+DT_CALCRECT);
height:=r.Bottom+GAP_Y*2;
end;

procedure TmsgsFrm.listboxDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  cnv:Tcanvas;
  s:string;
  selected:boolean;
begin
selected:=odSelected in state;
cnv:=listbox.Canvas;
cnv.fillrect(Rect);
inc(rect.Top, GAP_Y);
inc(rect.left, GAP_X);
dec(rect.Right, GAP_X);
if not selected and (index>0) then
  cnv.Font.Color:=clGrayText;
s:=msgs[index].text;
if index > 0 then s:='        '+datetimeToStr(msgs[index].time)+CRLF+s;
DrawText(cnv.Handle, pchar(s), -1, rect,
  DT_WORDBREAK+DT_EXTERNALLEADING+DT_NOPREFIX);
if index > 0 then
  icons.Draw(cnv, rect.left,rect.top, kind2iconIndex(msgs[index].kind),
    dsSelected, itImage);
end;

procedure TmsgsFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
listbox.Items.Clear;
setlength(msgs, 0);
end;

procedure TmsgsFrm.okBtnClick(Sender: TObject);
begin close end;

procedure TmsgsFrm.FormResize(Sender: TObject);
begin
listbox.Height:=clientheight-40;
okBtn.Top:=clientheight-30;
end;

procedure TmsgsFrm.FormCreate(Sender: TObject);
begin
applyTaskButton(self);
end;

end.
