{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit newaccountDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, icqv7;

type
  TnewaccountFrm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    pwdBox: TEdit;
    okBtn: TButton;
    logBox: TMemo;
    procedure okBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  public
    newICQ:TicqSession;
    procedure icqEvent(thisICQ:TicqSession; ev:TicqEvent);
  end;

var
  newaccountFrm: TnewaccountFrm;

implementation

uses
  globalLib, mainDlg, usersDlg, utilLib;

{$R *.DFM}

procedure TnewaccountFrm.okBtnClick(Sender: TObject);
begin
logBox.clear;
if pwdBox.text = '' then
  begin
  msgDlg(___('new account no pwd'),mtError);
  exit;
  end;
newICQ.pwd:=pwdBox.text;
newICQ.connect(TRUE);
pwdBox.enabled:=FALSE;
okBtn.enabled:=FALSE;
end; // ok

procedure TnewaccountFrm.icqEvent(thisICQ:TicqSession; ev:TicqEvent);
var
  s:string;
begin
case ev of
  IE_offline: logBox.lines.add(___('offline'));
  IE_connecting:
    begin
    proxySettings(thisICQ.sock);
    logBox.lines.add(___('connecting'));
    end;
  IE_creatingUIN: logBox.lines.add(___('new account creating'));
  IE_newUIN:
    begin
    logBox.lines.add(___('new account created',[thisICQ.eventContact.uin]));
    IOresult;
    s:=intToStr(thisICQ.eventContact.uin);
    mkdir(myPath+s);
    mkdir(myPath+s+'\history');
    IOresult;
    usersFrm.usersBox.items.add(s);
    end;
  IE_error:
    begin
    playSound(theme.sounds.onError);
    logBox.lines.add(___('icqerror '+icqerror2str[thisICQ.eventError], [thisICQ.eventInt]));
    end;
  end;
end; // icqEvent

procedure TnewaccountFrm.FormShow(Sender: TObject);
begin
applyTaskButton(self);
pwdBox.onKeyDown:=mainfrm.pwdBoxKeyDown;
newICQ:=TicqSession.create;
newICQ.listener:=icqEvent;
pwdBox.enabled:=TRUE;
okBtn.enabled:=TRUE;
pwdBox.setFocus;
logBox.clear;
end; // formshow

procedure TnewaccountFrm.FormPaint(Sender: TObject);
begin wallpaperize(canvas) end;

procedure TnewaccountFrm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
newICQ.free;
action:=caFree;
destroyHandle;
end;

end.
