unit plugins_fr;

interface

uses 
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, CheckLst, JvCheckListBox;

type
  TpluginsFr = class(TFrame)
    list: TJvCheckListBox;
    prefBtn: TBitBtn;
    reloadBtn: TBitBtn;
    Label1: TLabel;
    fileBox: TLabeledEdit;
    procedure reloadBtnClick(Sender: TObject);
    procedure prefBtnClick(Sender: TObject);
    procedure listClick(Sender: TObject);
  public
    procedure updatePluginList;
  end;

implementation

uses
  globalLib, pluginLib, utilLib;

{$R *.dfm}

procedure TpluginsFr.updatePluginList;
var
  pl:Tplugin;
begin
list.Clear;
plugins.resetEnumeration;
while plugins.hasMore do
  begin
  pl:=plugins.getNext;
  with list do
    begin
    if pl.screenname='' then
      items.add('('+___('filename')+') '+pl.filename)
    else
      items.add(pl.screenName);
    items.objects[items.count-1]:=Tobject(pl);
    checked[items.count-1]:= 0=pos(pl.filename, disabledPlugins);
    end;
  end;
end; // updateList

procedure TpluginsFr.reloadBtnClick(Sender: TObject);
begin
plugins.unload;
plugins.load;
updatePluginList;
end;

procedure TpluginsFr.prefBtnClick(Sender: TObject);
begin
with list do
  if ItemIndex >= 0 then
    Tplugin(items.Objects[ItemIndex]).cast_preferences;
end;

procedure TpluginsFr.listClick(Sender: TObject);
begin
with list do
  if ItemIndex >= 0 then
    fileBox.text:=Tplugin(items.Objects[ItemIndex]).filename;
end;

end.
