{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit prefDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons, ExtCtrls, globalLib, utilLib, menus,
  autoaway_fr, start_fr, exit_fr, hotkeys_fr, security_fr, events_fr,
  update_fr, plugins_fr, other_fr, design_fr, connection_fr, antispam_fr,
  ignore_fr, log_fr, disable_fr, lang_fr, chat_fr, themes_fr, themedit_fr,
  strutils;

type
  TprefFrm = class(TForm)
    resetBtn: TBitBtn;
    applyBtn: TBitBtn;
    okBtn: TBitBtn;
    closeBtn: TBitBtn;
    framePnl: TPanel;
    pagesBox: TListBox;
    procedure FormShow(Sender: TObject);
    procedure resetBtnClick(Sender: TObject);
    procedure applyBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure okBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure pagesBoxClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  public
    connectionFr :TconnectionFr;
    autoawayFr :TautoawayFr;
    designFr :TdesignFr;
    startFr :TstartFr;
    pluginsFr :TpluginsFr;
    securityFr :TsecurityFr;
    hotkeysFr :ThotkeysFr;
    otherFr :TotherFr;
    antispamFr :TantispamFr;
    ignoreFr :TignoreFr;
    eventsFr :TeventsFr;
    updateFr :TupdateFr;
    logFr :TlogFr;
    disableFr :TdisableFr;
    langFr :TlangFr;
    chatFr :TchatFr;
    themesFr :TthemesFr;
    themeditFr :TthemeditFr;

    procedure reset;
    procedure apply;
    procedure resetAutosize;
    procedure updateVisible;
    procedure setStrings();
    procedure setPics();
  public procedure destroyHandle;
  end;

var
  prefFrm :TprefFrm;
  newHistPwd :string;
  tempBeh :Tbehaviours;

implementation

{$R *.DFM}

uses
  hook, contacts, iniLib, pluginLib, events, mainDlg, themesLib, icqv7;

procedure warnOnlineOption;
begin msgDlg(___('online option'),mtWarning) end;

const
  sb2index:array [TsortBy] of integer=(0,1,2);

function index2sb(i:integer):TsortBy;
begin
result:=low(TsortBy);
while result <= high(TsortBy) do
  if i = sb2index[result] then
    exit
  else
    inc(result);
end; // index2sb

procedure placeComboBox(cb:TcomboBox; obj:Tobject);
var
  i:integer;
begin
for i:=0 to cb.items.count-1 do
  if cb.items.objects[i] = obj then
    begin
    cb.itemindex:=i;
    exit;
    end;
cb.itemIndex:=-1;
end; // placeComboBox

procedure TprefFrm.reset;
var
  i:integer;
begin
resetAutosize();
with themeditFr do
  textBox.text:=loadfile(userPath+userthemeFilename);
with themesFr do
  select(theme.fn);
with chatFr do
  begin
  stylecodesChk.checked:=fontstylecodes.enabled;
  autocopyChk.checked:=autoCopyHist;
  autodeselectChk.checked:=autodeselect;
  singleChk.checked:=singleDefault;
  statusontabChk.checked:=showStatusOnTabs;
  cursorbelowChk.checked:=quoting.cursorBelow;
  sendOnEnterTmp:=sendonenter;
  quoteselectedChk.checked:=quoting.quoteselected;
  chatOnTopChk.Checked:=chatAlwaysOnTop;
  end;
with langFr do
  load;
with pluginsFr do
  updatePluginList;
with startFr do
  begin
  userspathBox.text:=userspath;
  reopenchatsChk.checked:=reopenchats;
  getofflinemsgsChk.checked:=getofflinemsgs;
  delofflinemsgsChk.checked:=delofflinemsgs;
  readonlyChk.checked:=check4readonly;
  if autostartUIN = 0 then
    autostart1.text:=''
  else
    autostart1.text:=intToStr(autostartUIN);
  minimizedChk.checked:=startMinimized;
  autoconnectChk.checked:=autoconnect;
  placeComboBox(startingStatusBox, Tobject(startingstatus));
  placeComboBox(startingvisibilityBox, Tobject(startingvisibility));
  lastStatus1.checked:=uselaststatus;
  splashChk.checked:=skipSplash;
  lockOnStartChk.checked:=lockOnStart;
  end;
with designFr do
  begin
  onlycloseChk.checked:=TRUE;
  hideoncloseChk.Checked:=hideOnClose;
  closeandminChk.checked:=showRoasterMinButton;
  roundwindowsChk.Checked:=roundedWindows;
  roasterTitleBox.Text:=roasterTitle;
  if not mainfrm.bar.visible then roasterbarGrp.ItemIndex:=2
  else
    if roasterbarOnTop then roasterbarGrp.ItemIndex:=0
    else roasterbarGrp.ItemIndex:=1;
  aniroasterChk.checked:=animatedRoaster;
  italicGrp.itemindex:=roasterItalic;
  eyeChk.checked:=showVisibilityFlag;
  blinkSlider.position:=blinkSpeed;
  if not docking.enabled then
    dockGrp.itemIndex:=0
  else
    if not docking.appBar then
      dockGrp.itemIndex:=1
    else
      dockGrp.itemIndex:=2;
  sortbyGrp.itemIndex:=sb2index[sortBy];
  groupsChk.checked:=showGroups;
  indentChk.checked:=indentRoaster;
  onlyonlineChk.checked:=showonlyonline;
  onlyvisibletoChk.checked:=showOnlyImVisibleTo;
  ontop1.checked:= alwaysOnTop;
  roastertranspChk.checked:=transparency.forRoaster;
  chattranspChk.checked:=transparency.forChat;
  transpActive.position:=transparency.active;
  transpInactive.position:=transparency.inactive;
  textureChk.checked:=texturizedWindows;
  end;
with connectionFr do
  begin
  conOnConChk.checked:=connectOnConnection;
  autoreconnectChk.checked:=autoreconnect;
  proxyGroup.visible:=proxy.enabled;
  authGroup.visible:=proxy.auth;

  pwdBox.text:=ICQ.pwd;
  hostBox.text:=loginServer;
  portBox.text:=ICQ.loginServerPort;
  useproxy1.checked:=proxy.enabled;
  proxyhostBox.text:=proxy.addr[proxy.proto].host;
  proxyportBox.text:=proxy.addr[proxy.proto].port;
  disconnectedChk.checked:=showDisconnectedDlg;
  proxyproto.itemIndex:=ord(proxy.proto);
  proxyuserBox.text:=proxy.user;
  proxypwdBox.text:=proxy.pwd;
  auth.checked:=proxy.auth;
  kaChk.checked:=keepalive.enabled;
  kaSpin.value:=keepalive.freq;
  end;
with hotkeysFr do
  begin
  fillMacrosGrid(macros);
  end;
with securityFr do
  begin
  case ICQ.DCmode of
    DC_NONE: dcGrp.ItemIndex:=0;
    DC_ROASTER: dcGrp.ItemIndex:=1;
    DC_EVERYONE: dcGrp.ItemIndex:=2;
    end;
  visibilityexploitChk.checked:=warnVisibilityExploit;
  clientidChk.checked:=showclientid;
  webawareChk.checked:=webaware;
  authNeededChk.checked:=ICQ.authNeeded;
  addedYouChk.checked:=sendTheAddedYou;
  dontsavepwdChk.checked:=dontSavePwd;
  histcryptEnableChk.checked:=histcrypt.enabled;
  histcryptSavePwdChk.checked:=histcrypt.savePwd;
  newHistPwd:=histcrypt.pwd;
  end;
with otherFr do
  begin
  minimizeroasterChk.checked:=minimizeroaster;
  birthGrp.ItemIndex:=sendBalloonOn;
  bdayBox.Date:=sendBalloonOnDate;
  autoconsumeChk.checked:=autoconsumeevents;
  switchklChk.checked:=autoswitchKL;
  savenilChk.checked:=saveNIL;
  playSounds1.checked:=playSounds;
  fixwindowsChk.checked:=doFixWindows;
  wheel.value:=wheelVelocity;
  inactivehideChk.checked:=inactivehide;
  quitChk.checked:=quitconfirmation;
  inactivehideSpin.value:=inactivehideTime/10;
  browserBox.text:=browserCmdLine;
  defaultbrowserChk.checked:=useDefaultBrowser;
  custombrowserChk.checked:=not useDefaultBrowser;
  showcontacttipChk.Checked:=mainfrm.roaster.ShowHint;
  end;
with autoawayFr do
  begin
  exitawayChk.checked:=autoaway.autoexit;
  setawayChk.checked:=autoaway.away;
  setnaChk.checked:=autoaway.na;
  awaySpin.Value:=autoaway.awayTime/(10*60);
  naSpin.Value:=autoaway.naTime/(10*60);
  automsgBox.text:=autoaway.msg;
  end;
with antispamFr do
  begin
  ignorenilChk.checked:=spamfilter.ignoreNIL;
  ignorepagersChk.checked:=spamfilter.ignorePagers;
  warnChk.checked:=spamfilter.warn;
  notnilChk.checked:=spamfilter.notNil;
  notemptyChk.checked:=spamfilter.notEmpty;
  multisendChk.checked:=spamfilter.multisend;
  badwordsChk.checked:=spamfilter.noBadwords;
  badwordsBox.lines.text:=AnsiReplaceStr(spamfilter.badwords,';',CRLF);
  uingtChk.checked:=spamfilter.uingt > 0;
  if spamfilter.uingt=0 then uingtSpin.value:=150000000
  else uingtSpin.value:=spamfilter.uingt;
  end;
with ignoreFr do
  begin
  ignoreChk.checked:=enableIgnorelist;
  ignoreBox.clear;
  with ignoreList do
    for i:=0 to count-1 do
      ignoreBox.addItem(getAt(i).displayed,getAt(i));
  end;
with eventsFr do
  begin
  focuschatpopupChk.checked:=focusOnChatPopup;
  flashchatChk.checked:=doflashchat; 
  minOnOffSpin.value:=minOnOffTime;
  minOnOffChk.checked:=minOnOff;
  oncomingOnAwayChk.checked:=oncomingOnAway;
  tempBeh:=behaviour;
  if eventBox.itemIndex=-1 then
    eventBox.itemIndex:=0;
  eventBox.onSelect(self);
  end;
with updateFr do
  begin
  betaChk.checked:=checkupdate.betas;
  updateChk.checked:=checkupdate.enabled;
  checkSpin.value:=checkupdate.every;
  end;
with logFr do
  begin
  writehistoryChk.checked:=logpref.writehistory;
  pktwndChk.checked:=logpref.pkts.onWindow;
  pktfileChk.checked:=logpref.pkts.onFile;
  pktclearChk.checked:=logpref.pkts.clear;
  evtwndChk.checked:=logpref.evts.onWindow;
  evtfileChk.checked:=logpref.evts.onFile;
  evtclearChk.checked:=logpref.evts.clear;
  end;
with disableFr do
  begin
  if statusBox.itemIndex=-1 then
    statusBox.itemIndex:=0;
  statusBox.onSelect(self);
  end;
updateVisible;
end; // reset

procedure TprefFrm.apply;
var
  i,j,code:integer;
  haveToQuit,haveToApplyTheme:boolean;
  s,pluginsOn,pluginsOff:string;
begin
haveToQuit:=FALSE;
haveToApplyTheme:=FALSE;

with themesFr do
  if theme.fn<>current.fn then
    begin
    theme.fn:=current.fn;
    haveToApplyTheme:=TRUE;
    end;
with themeditFr do
  if textBox.Modified then
    begin
    savefile(userPath+userthemeFilename, textBox.text);
    haveToApplyTheme:=TRUE;
    end;
with chatFr do
  begin
  fontstylecodes.enabled:=stylecodesChk.checked;
  autoCopyHist:=autocopyChk.checked;
  autodeselect:=autodeselectChk.checked;
  singleDefault:=singleChk.checked;
  showStatusOnTabs:=statusontabChk.checked;
  quoting.cursorBelow:=cursorbelowChk.checked;
  sendOnEnter:=sendOnEnterTMP;
  quoting.quoteselected:=quoteselectedChk.checked;
  chatAlwaysOnTop:=chatOnTopChk.Checked;
  end;
with langFr do
  if selectedLang <> lang then
    if messageDlg(___('quit feature, quit?'), mtConfirmation, [mbYes,mbNo], 0) = mrYes then
      begin
      haveToQuit:=TRUE;
      setLang(selectedLang);
      end;
with pluginsFr do
  begin
  i:=0;
  pluginsOn:='';
  pluginsOff:='';
  plugins.resetEnumeration;
  while plugins.hasMore do
    with plugins.getNext do
      begin
      if list.checked[i] then
        begin
        pluginsOn:=pluginsOn+filename+';';
        activate;
        end
      else
        begin
        pluginsOff:=pluginsOff+filename+';';
        disactivate;
        end;
      inc(i);
      end;
  // add to pluginsOff all disabledPlugins that do not appear in the list
  // to remember old disabled plugins
  while disabledPlugins > '' do
    begin
    s:=chop(';', disabledPlugins);
    if (s>'') and (0=pos(s,pluginsOn+pluginsOff)) then
      pluginsOff:=s+';'+pluginsOff;
    end;
  disabledPlugins:=pluginsOff;
  end;
with connectionFr do
  begin
  connectOnConnection:=conOnConChk.checked;
  autoreconnect:=autoreconnectChk.checked;
  ICQ.pwd:=pwdBox.text;
  loginServer:=hostBox.text;
  ICQ.loginServerPort:=portBox.text;
  showDisconnectedDlg:=disconnectedChk.checked;
  proxy.enabled:=useproxy1.checked;
  proxy.proto:=Tproxyproto(proxyproto.itemIndex);
  proxy.addr[proxy.proto].host:=proxyhostBox.text;
  proxy.addr[proxy.proto].port:=proxyportBox.text;
  proxy.user:=proxyuserBox.text;
  proxy.pwd:=proxypwdBox.text;
  proxy.auth:=auth.checked;
  keepalive.enabled:=kaChk.checked;
  keepalive.freq:=round(kaSpin.value);
  keepalive.timer:=keepalive.freq;
  end;
with designFr do
  begin
  showRoasterMinButton:=closeandminChk.checked;
  hideOnClose:=hideoncloseChk.checked;
  roundedWindows:=roundwindowsChk.Checked;
  roasterbarOnTop:= roasterbarGrp.ItemIndex=0;
  animatedRoaster:=aniroasterChk.checked;
  roasterItalic:=italicGrp.itemindex;
  showVisibilityFlag:=eyeChk.checked;
  docking.enabled:=dockGrp.itemIndex>0;
  docking.appBar:=dockGrp.itemIndex=2;
  dockSet;
  roasterTitle:=roasterTitleBox.Text;
  blinkSpeed:=blinkSlider.position;
  mainfrm.bar.visible:=roasterbarGrp.itemIndex<>2;
  texturizedWindows:=textureChk.checked;
  if sortBy <> index2sb(sortbyGrp.itemIndex) then
    sortBy:=index2sb(sortbyGrp.itemIndex);
  showGroups:=groupsChk.checked;
  indentRoaster:=indentChk.checked;
  case autosizeGrp.ItemIndex of
    0: autosizeRoaster:=FALSE;
    1:begin
      autosizeRoaster:=TRUE;
      autosizeFullRoaster:=FALSE;
      end;
    2:begin
      autosizeRoaster:=TRUE;
      autosizeFullRoaster:=TRUE;
      end;
    end;
  showonlyonline:=onlyonlineChk.checked;
  showOnlyImVisibleTo:=onlyvisibletoChk.checked;
  alwaysOnTop:=ontop1.checked;
  transparency.forRoaster:=roastertranspChk.checked;
  transparency.forChat:=chattranspChk.checked;
  transparency.active:=transpActive.position;
  transparency.inactive:=transpInactive.position;
  end;
with startFr do
  begin
  userspath:=userspathBox.text;
  reopenchats:=reopenchatsChk.checked;
  getofflinemsgs:=getofflinemsgsChk.checked;
  delofflinemsgs:=delofflinemsgsChk.checked;
  check4readonly:=readonlyChk.checked;
  val(autostart1.text,i,code);
  if (code=0) and validUIN(i) then
    autostartUIN:=i
  else
    autostartUIN:=0;
  startMinimized:=minimizedChk.checked;
  skipSplash:=splashChk.checked;
  autoconnect:=autoconnectChk.checked;
  with startingstatusBox do startingStatus:=Tstatus(items.objects[itemIndex]);
  with startingVisibilityBox do startingVisibility:=Tvisibility(items.objects[itemIndex]);
  uselastStatus:=laststatus1.checked;
  lockOnStart:=lockOnStartChk.checked;
  end;
with securityFr do
  begin
  case dcGrp.ItemIndex of
    0: ICQ.DCmode:=DC_NONE;
    1: ICQ.DCmode:=DC_ROASTER;
    2: ICQ.DCmode:=DC_EVERYONE;
    end;
  showclientid:=clientidChk.checked;
  warnVisibilityExploit:=visibilityexploitChk.checked;
  webaware:=webawareChk.checked; ICQ.webaware:=webaware;
  ICQ.authNeeded:=authNeededChk.checked;
  dontSavePwd:=dontsavepwdChk.checked;
  sendTheAddedYou:=addedYouChk.checked;
  histcrypt.savePwd:=histcryptSavePwdChk.checked;
  with histcrypt do
    if histcryptEnableChk.checked and (newHistPwd='') then
      msgDlg(___('no pwd, no encryption'),mtError)
    else
      if (pwd<>newHistPwd) or (enabled<>histcryptEnableChk.checked) then
        begin
        if (pwd='') and enabled then
          begin
          msgDlg(___('insert old pwd'),mtWarning);
          enterPwdDlg(pwd);
          end;
        if messageDlg(___('change history encryption?'), mtConfirmation, [mbYes,mbNo], 0)=mrYes then
          if histcryptEnableChk.checked then
            convertHistoriesDlg(pwd, newHistPwd)
          else
            convertHistoriesDlg(pwd, '');
        end;
  end;
with otherFr do
  begin
  quitconfirmation:=quitChk.checked;
  mainfrm.roaster.ShowHint:=showcontacttipChk.Checked;
  minimizeroaster:=minimizeroasterChk.checked;
  sendBalloonOn:=birthGrp.itemindex;
  sendBalloonOnDate:=bdayBox.Date;
  browserCmdLine:=browserBox.text;
  useDefaultBrowser:=defaultbrowserChk.checked;
  autoconsumeevents:=autoconsumeChk.checked;
  autoswitchKL:=switchklChk.checked;
  saveNIL:=savenilChk.checked;
  showOncomingDlg:=oncomingDlgChk.checked;
  playSounds:=playSounds1.checked;
  doFixWindows:=fixwindowsChk.checked;
  wheelVelocity:=round(wheel.value);
  inactivehideTime:=round(inactivehideSpin.value*10);
  inactiveHide:=inactivehideChk.checked;
  end;
with autoawayFr do
  begin
  autoaway.autoexit:=exitawayChk.checked;
  autoaway.away:=setawayChk.checked;
  autoaway.na:=setnaChk.checked;
  autoaway.awayTime:=round(awaySpin.Value*(10*60));
  autoaway.naTime:=round(naSpin.Value*(10*60));
  autoaway.msg:=automsgBox.text;
  end;
with antispamFr do
  begin
  spamfilter.ignoreNIL:=ignorenilChk.checked;
  spamfilter.ignorepagers:=ignorepagersChk.checked;
  spamfilter.warn:=warnChk.checked;
  spamfilter.notnil:=notnilChk.checked;
  spamfilter.notEmpty:=notemptyChk.checked;
  spamfilter.noBadwords:=badwordsChk.checked;
  spamfilter.multisend:=multisendChk.checked;
  spamfilter.badwords:=AnsiReplaceStr(badwordsBox.text,CRLF,';');
  if uingtChk.checked then spamfilter.uingt:=round(uingtSpin.value)
  else spamfilter.uingt:=0;
  end;
with ignoreFr do
  begin
  enableIgnorelist:=ignoreChk.checked;
  Ignorelist.clear;
  with ignoreBox do
    for i:=0 to count-1 do
      Ignorelist.add(items.objects[i]);
  end;
with updateFr do
  begin
  checkupdate.enabled:=updateChk.checked;
  checkupdate.betas:=betaChk.checked;
  checkupdate.every:=round(checkSpin.value);
  end;
with eventsFr do
  begin
  focusOnChatPopup:=focuschatpopupChk.checked;
  doflashchat:=flashchatChk.checked;
  minOnOff:=minOnOffChk.checked;
  minOnOffTime:=round(minOnOffSpin.value);
  oncomingOnAway:=oncomingOnAwayChk.checked;
  end;
with logFr do
  begin
  logpref.writehistory:=writehistoryChk.checked;
  logpref.pkts.onWindow:=pktwndChk.checked;
  logpref.pkts.onFile:=pktfileChk.checked;
  logpref.pkts.clear:=pktclearChk.checked;
  logpref.evts.onWindow:=evtwndChk.checked;
  logpref.evts.onFile:=evtfileChk.checked;
  logpref.evts.clear:=evtclearChk.checked;
  end;
behaviour:=tempBeh;

if havetoApplyTheme then reloadCurrentTheme;
roasterRebuildDelayed:=TRUE;
applyTransparency;
applyBalloon;
applyClientID;
applyRoundedWindows();
applyMinButton();
mainfrm.updateCaption;
setRoasterAnimation(animatedRoaster);
mainfrm.formresize(self);
repaintAllWindows;
saveCFG;
saveLists;
saveCommonCFG;
if haveToQuit then mainfrm.close;
end; // apply

procedure TprefFrm.FormShow(Sender: TObject);
begin
applyTaskButton(self);
caption:=___('preferences for',[ICQ.myinfo.displayed]);
connectionFr.pwdBox.onKeyDown:=mainfrm.pwdboxKeyDown;
connectionFr.proxypwdBox.onKeyDown:=mainfrm.pwdboxKeyDown;
ignoreFr.addBtn.glyph.assign(getPic(PIC_ADD_CONTACT));
ignoreFr.removeBtn.glyph.assign(getPic(PIC_DELETE));
pluginsFr.prefBtn.glyph.assign(getPic(PIC_PREFERENCES));
designFr.blinkImg.picture.Bitmap.assign(getPic(PIC_MSG));
icon:=pic2ico(PIC_PREFERENCES);
reset;
end;

procedure TprefFrm.resetBtnClick(Sender: TObject);
begin reset end;

procedure TprefFrm.applyBtnClick(Sender: TObject);
begin
apply;
reset; // to update screen
end;

procedure TprefFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
updateSWhotkeys;
hotkeysEnabled:=TRUE;
end;

procedure TprefFrm.okBtnClick(Sender: TObject);
begin
hide;
apply;
close;
end;

procedure TprefFrm.destroyHandle; begin inherited end;

procedure TprefFrm.updateVisible;
begin
with connectionFr do
  begin
  proxyGroup.visible:=useproxy1.checked;
  auth.enabled:=proxyproto.ItemIndex<>ord(PP_SOCKS4);
  authGroup.visible:=auth.checked and auth.enabled;
  end;
with securityFr do cryptGroup.visible:=histcryptEnableChk.checked;
with updateFr do updateGrp.visible:=updateChk.checked;
with eventsFr do
  begin
  minOnOffSpin.enabled:=minOnOffChk.checked;
  tipplusSpin.enabled:=tiptimesChk.checked;
  end;
with otherFr do inactivehideSpin.enabled:=inactivehideChk.checked;
with autoawayFr do
  begin
  awaySpin.enabled:=setawayChk.checked;
  naSpin.enabled:=setnaChk.checked;
  end;
end;

procedure TprefFrm.FormCreate(Sender: TObject);
var
  i:integer;
  st:Tstatus;
begin
prefFrm.height:=prefHeight;
connectionFr:=TconnectionFr.create(self);
autoawayFr:=TautoawayFr.create(self);
designFr:=TdesignFr.create(self);
startFr:=TstartFr.create(self);
pluginsFr:=TpluginsFr.create(self);
securityFr:=TsecurityFr.create(self);
hotkeysFr:=ThotkeysFr.create(self);
otherFr:=TotherFr.create(self);
antispamFr:=TantispamFr.create(self);
ignoreFr:=TignoreFr.create(self);
eventsFr:=TeventsFr.create(self);
updateFr:=TupdateFr.create(self);
logFr:=TlogFr.create(self);
disableFr:=TdisableFr.create(self);
langFr:=TlangFr.create(self);
chatFr:=TchatFr.create(self);
themesFr:=TthemesFr.create(self);
themeditFr:=TthemeditFr.create(self);
pagesBox.Items.objects[0]:=connectionFr;
pagesBox.items.objects[1]:=autoawayFr;
pagesBox.items.objects[2]:=designFr;
pagesBox.items.objects[3]:=startFr;
pagesBox.items.objects[4]:=pluginsFr;
pagesBox.items.objects[5]:=securityFr;
pagesBox.items.objects[6]:=hotkeysFr;
pagesBox.items.objects[7]:=otherFr;
pagesBox.items.objects[8]:=antispamFr;
pagesBox.items.objects[9]:=ignoreFr;
pagesBox.items.objects[10]:=eventsFr;
pagesBox.items.objects[11]:=disableFr;
pagesBox.items.objects[12]:=updateFr;
pagesBox.items.objects[13]:=logFr;
pagesBox.items.objects[14]:=langFr;
pagesBox.items.objects[15]:=chatFr;
pagesBox.items.objects[16]:=themesFr;
pagesBox.items.objects[17]:=themeditFr;
themesFr.refreshBtnClick(NIL);
for i:=0 to pagesBox.Items.count-1 do
  with Tframe(pagesBox.Items.objects[i]) do
    begin
    align:=alClient;
    Parent:=framePnl;
    end;
for i:=1 to EK_last do eventsFr.eventBox.Items.AddObject('',Tobject(i));
for st:=SC_ONLINE to pred(SC_OFFLINE) do
  begin
  disableFr.statusBox.Items.AddObject('',Tobject(st));
  startFr.startingStatusBox.Items.AddObject('',Tobject(st));
  end;
setStrings();
setPics();
themeditFr.propsBox.itemIndex:=0;
themeditFr.propsBoxChange(self);
pagesBox.ItemIndex:=0;
pagesBoxClick(NIL);
end; // formcreate

procedure TprefFrm.FormResize(Sender: TObject);
const
  gap=4;
begin
roundWindow(self);
prefHeight:=height;
resetBtn.top:=clientHeight-resetBtn.height-gap;
okBtn.top:=resetBtn.top-okBtn.height-gap;
closeBtn.top:=resetBtn.top;
applyBtn.top:=okBtn.top;
pagesBox.height:=okBtn.top-gap;
end; // formresize

procedure TprefFrm.pagesBoxClick(Sender: TObject);
var
  i:integer;
  fr:Tframe;
begin
i:=pagesBox.itemIndex;
if i<0 then exit;
fr:=Tframe(pagesBox.items.objects[i]);
fr.BringToFront;
if fr = hotkeysFr then
  removeSWhotkeys
else
  updateSWhotkeys;
end;

procedure TprefFrm.FormDestroy(Sender: TObject);
begin freeAndNIL(prefFrm) end;

procedure TprefFrm.resetAutosize();
begin
with designFr do
  if not autosizeRoaster then autosizeGrp.ItemIndex:=0
  else
    if not autosizeFullRoaster then autosizeGrp.ItemIndex:=1
    else autosizeGrp.ItemIndex:=2;
end; // resetAutosize

procedure TprefFrm.setStrings();
var
  vi:Tvisibility;
  pp:Tproxyproto;
  i:integer;
begin
startFr.startingVisibilityBox.Items.Clear();
for vi:=low(vi) to high(vi) do
  startFr.startingVisibilityBox.Items.AddObject('',Tobject(vi));
hotkeysFr.actionBox.Items.Clear();
for i:=succ(OP_none) to OP_last do
  hotkeysFr.actionBox.items.add(macroopcodeName(i));
themeditFr.propsBox.items.clear();
for i:=0 to length(themeprops)-1 do
  themeditFr.propsBox.items.add(format('[%s] %s',[themeprops[i].section,themeprops[i].name]));
otherFr.bdayBox.Format:=___('month-day format');
chatFr.sendonenterLbl.Caption:=___('preferences send on enter',[sendonenter]);
connectionFr.proxyproto.Items.Clear();
for pp:=low(pp) to high(pp) do
  connectionFr.proxyproto.Items.add(proxyproto2str[pp]);
end; // setStrings

procedure TprefFrm.setPics();
begin
resetBtn.glyph.assign(getPic(PIC_REFRESH));
themesFr.refreshBtn.glyph.assign(getPic(PIC_REFRESH));
pluginsFr.reloadBtn.glyph.assign(getPic(PIC_REFRESH));
end; // setPics

end.
