{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit removeDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ICQv7;

type
  TremoveFrm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    passwordBox: TEdit;
    Label3: TLabel;
    okBtn: TButton;
    logBox: TMemo;
    procedure okBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    procedure icqEvent(thisICQ:TicqSession; ev:TicqEvent);
  end;

var
  removeFrm: TremoveFrm;

implementation

uses
  globalLib, iniLib, usersDlg, utilLib;

{$R *.DFM}

procedure TremoveFrm.icqEvent(thisICQ:TicqSession; ev:TicqEvent);
begin
case ev of
  IE_loggin: logBox.lines.add('loggin in');
  IE_redirecting: logBox.lines.add('redirecting');
  IE_redirected: logBox.lines.add('redirected');
  IE_online:
    begin
    logBox.lines.add('online...deletion requested');
    thisICQ.sendDeleteUin;
    end;
  IE_offline: logBox.lines.add('offline');
  IE_connecting: logBox.lines.add('connecting');
  IE_uinDeleted:
    begin
    logBox.lines.add('UIN deleted');
    thisICQ.disconnect;
    end;
  IE_error:
    begin
    playSound(theme.sounds.OnError);
    logBox.lines.add(___('icqerror '+icqerror2str[thisICQ.eventError], [thisICQ.eventInt]));
    end;
  end;
end; // icqEvent

procedure TremoveFrm.okBtnClick(Sender: TObject);
begin
logBox.clear;
if not ICQ.isOffline then
  ICQ.disconnect;
userPath:=myPath+intToStr(ICQ.myinfo.uin)+'\';
loadCFG;
ICQ.listener:=icqEvent;
ICQ.pwd:=passwordBox.text;
ICQ.connect;
end; // ok

procedure TremoveFrm.FormShow(Sender: TObject);
begin
applyTaskButton(self);
logBox.clear;
passwordBox.setFocus;
end;

procedure TremoveFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
destroyHandle;
end;

end.
