{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit searchhistDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TsearchhistFrm = class(TForm)
    w2sBox: TEdit;
    Label1: TLabel;
    directionGrp: TRadioGroup;
    searchBtn: TBitBtn;
    caseChk: TCheckBox;
    statusbar: TStatusBar;
    reChk: TCheckBox;
    procedure w2sBoxKeyPress(Sender: TObject; var Key: Char);
    procedure searchBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  public
    procedure doSearch;
    procedure searchFrom(start:integer);
  public procedure destroyHandle;
  end;

var
  searchhistFrm: TsearchhistFrm;

implementation

uses
  historyVCL, chatDlg, events, utilLib, regexpr, globalLib;

{$R *.DFM}

procedure TsearchhistFrm.searchFrom(start:integer);
var
  i:integer;
  w2s,s:string;
  re:Tregexpr;
  use_re, found:boolean;
begin
use_re:=reChk.checked;
w2s:=trim(w2sBox.text);
if not use_re and not caseChk.checked then
  w2s:=uppercase(w2s);
if w2s = '' then
  begin
  statusbar.simpletext:=___('search history type');
  w2sBox.setFocus;
  exit;
  end;
if chatFrm.thisChat<>NIL then with chatFrm.thisChat do
  begin
  if use_re then
    begin
    re:=TRegExpr.Create;
    re.ModifierI:=not caseChk.checked;
    re.Expression := w2s;
      try
        re.Compile
      except
        FreeAndNIL(re);
        exit;
      end;
    end;
  i:=start;
  while (i >= historyNowOffset) and (i < historyBox.history.Count) do
    begin
    s:=Thevent(historyBox.history[i]).decrittedInfo;
    if use_re then
     	found:=re.exec(s)
    else
      begin
      if not caseChk.checked then
        s:=uppercase(s);
      found:=pos(w2s,s) > 0;
      end;
    if found then
      begin
      rsb.position:=i-historyBox.offset;
      historyBox.topVisible:=i;
      historyBox.topOfs:=0;
      chatFrm.autoscrollBtn.down:=autoscroll;
      historyBox.repaint;
      autoscroll:=historyBox.lastEventIsFullyVisible;
      statusbar.simpletext:=___('search history found');
      case directionGrp.itemIndex of
        0: directionGrp.itemIndex:=3;
        1: directionGrp.itemIndex:=2;
        end;
      exit;
      end;
    case directionGrp.itemIndex of
      0,3: inc(i);
      1,2: dec(i);
      end;
    end;
  end;
statusbar.simpletext:=___('search history nothing found');
w2sBox.setFocus;
end; // searchFrom

procedure TsearchhistFrm.doSearch;
begin
if chatFrm.thisChat<>NIL then with chatFrm.thisChat do
  case directionGrp.itemIndex of
    0:searchFrom(historyNowOffset);
    1:searchFrom(historyBox.history.count-1);
    2:searchFrom(historyBox.topVisible-1);
    3:searchFrom(historyBox.topVisible+1);
    end;
end; // doSearch

procedure TsearchhistFrm.w2sBoxKeyPress(Sender: TObject; var Key: Char);
begin
if key=#13 then
  doSearch
end;

procedure TsearchhistFrm.searchBtnClick(Sender: TObject);
begin
doSearch;
end;

procedure TsearchhistFrm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
destroyHandle;
end;

procedure TsearchhistFrm.destroyHandle; begin inherited end;

procedure TsearchhistFrm.FormShow(Sender: TObject);
begin
searchHistFrm.icon:=pic2ico(PIC_SEARCH);
applyTaskButton(self);
end;

end.
