{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit selectcontactsDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  contacts, StdCtrls, Buttons, Grids, checklst, ICQv7, ExtCtrls,
  ComCtrls, JvMenus, Menus;

type
  TchkState=(CK_on,CK_off);

  Tlistitem=class
    kind:(LI_group, LI_contact);
    check:TchkState;
    grpId:integer;
    contact:Tcontact;
    end;

  TscOptions=set of (sco_multi,sco_groups, sco_selected, sco_predefined);

  TselectContactsFrm = class(TForm)
    doBtn: TBitBtn;
    selectBtn: TBitBtn;
    unselectBtn: TBitBtn;
    list: TListBox;
    sbar: TStatusBar;
    listPnl: TPanel;
    Label1: TLabel;
    saveBtn: TSpeedButton;
    addBtn: TSpeedButton;
    uinlistBox: TComboBox;
    menu: TJvPopupMenu;
    Viewinfo1: TMenuItem;
    Sendmessage1: TMenuItem;
    subBtn: TSpeedButton;
    delBtn: TSpeedButton;
    procedure selectBtnClick(Sender: TObject);
    procedure unselectBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure listDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure listMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure listKeyPress(Sender: TObject; var Key: Char);
    procedure saveBtnClick(Sender: TObject);
    procedure addBtnlick(Sender: TObject);
    procedure Viewinfo1Click(Sender: TObject);
    procedure Sendmessage1Click(Sender: TObject);
    procedure subBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure delBtnClick(Sender: TObject);
  public
    cl:TcontactList;
    extra:Tobject;
    options:TscOptions;
    constructor doAll(owner_ :Tcomponent;
                      caption_,
                      doBtn_ :string;
                      cl_ :TcontactList;      // this object will be freed at close
                      what2do :TnotifyEvent;
                      options_:TscOptions
                      );
    procedure updateNumLbl;
    function selectedList:TcontactList;
    function unselectedList:TcontactList;
    procedure updateList;
    procedure clearList;
    procedure toggleAt(i:integer);
    procedure toggle(c:Tcontact);
    function  current:Tcontact;
  end;

implementation

uses
  globalLib, utilLib, chatDlg, mainDlg, langLib, uinlistLib;

{$R *.DFM}

constructor TselectContactsFrm.doAll(owner_:Tcomponent; caption_,doBtn_:string; cl_:TcontactList; what2do:TnotifyEvent; options_:TscOptions);
begin
if cl_ = NIL then exit;
inherited create(owner_);
applyTaskButton(self);
applyCommonSettings(self);
options:=options_;
caption:=caption_;
doBtn.caption:=doBtn_;
doBtn.onClick:=what2do;
cl:=cl_;
listPnl.visible:=SCO_predefined in options;
if not listPnl.visible then
  height:=height-listPnl.height;

updateList;
translateWindow(self);
showForm(self);
bringForeground:=handle;
end; // doAll

procedure TselectContactsFrm.clearList;
var
  i:integer;
begin
i:=list.Items.count;
while i > 0 do
  begin
  dec(i);
  Tlistitem(list.items.objects[i]).free;
  end;
list.clear;
end; // clearList

procedure TselectContactsFrm.updateList;
var
  li,ligrp:Tlistitem;
  grp:integer;
begin
uinlistBox.Items.text:=uinlists.names;
uinlistBox.text:='';

clearList;
if SCO_groups in options then
  sortCLbyGroups(cl)
else
  sortCL(cl);
cl.resetEnumeration;
grp:=0;
while cl.hasMore do
  begin
  li:=Tlistitem.create;
  li.kind:=LI_contact;
  li.contact:=cl.getNext;
  li.kind:=LI_contact;
  if SCO_selected in options then
    li.check:=CK_on
  else
    li.check:=CK_off;
  if (SCO_groups in options) and (grp<>li.contact.group) then
    begin
    grp:=li.contact.group;
    ligrp:=Tlistitem.create;
    ligrp.check:=li.check;
    ligrp.kind:=LI_group;
    ligrp.grpId:=grp;
    ligrp.contact:=NIL;
    list.items.addObject('',ligrp);
    end;
  list.items.addObject(li.contact.displayed,li);
  end;
updateNumLbl;
end; // updateList

procedure TselectContactsFrm.selectBtnClick(Sender: TObject);
var
  i:integer;
begin
i:=list.Items.count;
while i > 0 do
  begin
  dec(i);
  Tlistitem(list.items.objects[i]).check:=CK_on;
  end;
list.repaint;
updateNumLbl;
end; // select

procedure TselectContactsFrm.unselectBtnClick(Sender: TObject);
var
  i:integer;
begin
i:=list.Items.count;
while i > 0 do
  begin
  dec(i);
  Tlistitem(list.items.objects[i]).check:=CK_off;
  end;
list.repaint;
updateNumLbl;
end; // unselect

procedure TselectContactsFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
clearList;
cl.free;
cl:=NIL;
action:=caFree;
destroyHandle;
end;

procedure TselectContactsFrm.updateNumLbl;
var
  i,cnt:integer;
begin
cnt:=0;
i:=list.Items.count;
while i > 0 do
  begin
  dec(i);
  with Tlistitem(list.items.objects[i]) do
    if (check=CK_on) and (kind=LI_contact) then
      inc(cnt);
  end;
sbar.simpletext:=___('select contacts selected',[cnt,cl.count]);
end; // updateNumLbl

function TselectContactsFrm.selectedList:TcontactList;
var
  i:integer;
begin
result:=TcontactList.create;
i:=list.Items.count;
while i > 0 do
  begin
  dec(i);
  with Tlistitem(list.items.objects[i]) do
    if (check=CK_on) and (kind=LI_contact) then result.add(contact);
  end;
end; // selectedList

function TselectContactsFrm.unselectedList:TcontactList;
var
  i:integer;
begin
result:=TcontactList.create;
i:=list.Items.count;
while i > 0 do
  begin
  dec(i);
  with Tlistitem(list.items.objects[i]) do
  if (check=CK_off) and (kind=LI_contact) then result.add(contact);
  end;
end; // unselectedList

procedure TselectContactsFrm.listDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  x,y:integer;
  cnv:Tcanvas;
begin
cnv:=list.canvas;
if odSelected in state then
  cnv.brush.color:=selectedColor;
cnv.fillRect(rect);
x:=rect.Left+2;
y:=rect.top;
with Tlistitem(list.items.objects[index]) do
  begin
  if sco_multi in options then
    if check=CK_on then
      inc(x, drawPic(cnv, x,y,PIC_CHECKED).cx+2)
    else
      inc(x, drawPic(cnv, x,y,PIC_UNCHECKED).cx+2);
  case kind of
    LI_contact:
      begin
      cnv.font.style:=[];
      drawTxt(cnv.handle, x,y+1, contact.displayed);
      end;
    LI_group:
      begin
      inc(x, drawPic(cnv, x,y, PIC_CLOSE_GROUP).cx+2);
      cnv.font.color:=clMaroon;
      cnv.font.style:=[fsBold];
      drawTxt(cnv.handle, x,y+1, groups.id2name(grpId));
      end;
    end;
  end;
end;

procedure TselectContactsFrm.listMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  i:integer;
begin
if not (sco_multi in options) then exit;
i:=list.ItemAtPos(point(x,y),TRUE);
if i<0 then exit;
case button of
  mbLeft:
    if (x>=2) and (x<=2+getPic(PIC_CHECKED).width) then
      toggleAt(i);
  mbRight:
    begin
    list.itemIndex:=i;
    if current<>NIL then
      with mousePos do
        menu.popup(x,y);
    end;
  end;
end;

procedure TselectContactsFrm.toggle(c:Tcontact);
var
  i:integer;
begin
with list.items do
  for i:=0 to count-1 do
    with Tlistitem(objects[i]) do
      if (kind=LI_contact) and contact.equals(c) then
        begin
        toggleAt(i);
        exit;
        end;
end; // toggle

procedure TselectContactsFrm.toggleAt(i:integer);
var
  R:Trect;
begin
if (i<0) or (i>=list.items.count) then exit;
with Tlistitem(list.items.objects[i]) do
  begin
  case check of
    CK_on: check:=CK_off;
    CK_off: check:=CK_on;
    end;
  if kind=LI_group then
    begin
    inc(i);
    with list.items do
      while (i<count) and (Tlistitem(objects[i]).kind=LI_contact) do
        begin
        Tlistitem(objects[i]).check:=check;
        inc(i);
        end;
    list.repaint;
    updateNumLbl;
    exit;
    end;
  end;
R:=list.itemRect(i);
invalidateRect(list.handle, @R, FALSE);
updateNumLbl;
end; // toggleAt

procedure TselectContactsFrm.listKeyPress(Sender: TObject; var Key: Char);
begin
if key in [' ','+','-'] then
  toggleAt(list.itemIndex);
if key=' ' then key:=#0;
end;

procedure TselectContactsFrm.saveBtnClick(Sender: TObject);
begin
if uinlistBox.text = '' then
  msgDlg(___('select contacts enter name'), mtWarning)
else
  if not uinlists.exists(uinlistbox.text) or (messageDlg(___('uinlist overwrite?'), mtConfirmation, [mbYes,mbNo], 0)=mrYes) then
    begin
    uinlists.put(uinlistbox.text).cl:=selectedList;
    uinlistBox.Items.text:=uinlists.names;
    if not saveFile(userPath+uinlistFilename, uinlists.toString) then
      msgDlg(___('uinlist error'), mtError);
    end;
end;

procedure TselectContactsFrm.addBtnlick(Sender: TObject);
var
  i:integer;
  cl:TcontactList;
begin
if not uinlists.exists(uinlistbox.text) then exit;
cl:=uinlists.get(uinlistbox.text).cl;
for i:=0 to list.items.count-1 do
  with Tlistitem(list.items.objects[i]) do
    if (kind=LI_contact) and cl.exists(contact) then
      check:=CK_on;
list.repaint;
updateNumLbl;
exit;
end;

function TselectContactsFrm.current:Tcontact;
begin
result:=NIL;
if list.itemindex<0 then exit;
result:=Tlistitem(list.items.objects[list.itemIndex]).contact;
end;

procedure TselectContactsFrm.Viewinfo1Click(Sender: TObject);
begin viewinfoAbout(current) end;

procedure TselectContactsFrm.Sendmessage1Click(Sender: TObject);
begin chatFrm.openOn(current) end;

procedure TselectContactsFrm.subBtnClick(Sender: TObject);
var
  i:integer;
  cl:TcontactList;
begin
if not uinlists.exists(uinlistbox.text) then exit;
cl:=uinlists.get(uinlistbox.text).cl;
for i:=0 to list.items.count-1 do
  with Tlistitem(list.items.objects[i]) do
    if (kind=LI_contact) and cl.exists(contact) then
      check:=CK_off;
list.repaint;
updateNumLbl;
exit;
end;

procedure TselectContactsFrm.FormShow(Sender: TObject);
begin applyTaskButton(self) end;

procedure TselectContactsFrm.delBtnClick(Sender: TObject);
var
  ul:Puinlist;
begin
ul:=uinlists.get(uinlistBox.text);
if ul=NIL then exit;
if messageDlg(___('delete?'),mtConfirmation,[mbYes,mbNo],0)<>mrYes then exit;
if uinlists.remove(ul) then
	begin
	uinlistBox.Items.text:=uinlists.names;
  with uinlistBox do if Items.count=0 then text:='' else text:=items[0];
	msgDlg(___('done'), mtInformation)
  end
else
	msgDlg(___('failed'), mtError)
end;

end.
