{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit smilesLib;

interface

uses
  graphics, classes, sysutils;

type
  Tsmiles=class
    n:integer;
    ascii:array of string;
    pics:array of Tbitmap;
    root:string;
    maxH:integer;
    procedure clear;
    procedure add(sm:string;pic:Tbitmap);
    destructor destroy; override;
    end; // Tsmiles

implementation

uses
  iniLib, globalLib, utillib;

destructor Tsmiles.destroy;
begin
clear;
inherited;
end;

procedure Tsmiles.add(sm:string;pic:Tbitmap);
begin
if sm='' then exit;
inc(n);
if n=33 then     // skip 32, cause it's trimmed
  add('PtS',NIL);
setlength(ascii,n);
setlength(pics,n);
ascii[n-1]:=sm;
pics[n-1]:=pic;
if (pic<>NIL) and (pic.Height > maxH) then
  maxH:=pic.height;
end; // add

procedure Tsmiles.clear;
begin
while n > 0 do
  begin
  dec(n);
  if n=33 then dec(n);
  if (n=0) or (pics[n]<>pics[n-1]) then pics[n].free;
  end;
setLength(pics,0);
setLength(ascii,0);
maxH:=0;
end; // clear

end.
 
