procedure Tbuddies.rebuild;
var
  c:Tcontact;
  d:Tdivisor;
  i:integer;
  roaster:TcontactList;
  under:Ttreenode;
  node:Tnode;
  lastDiv:Tdivisor;
  lastGroupId:integer;
  contactOnline:boolean;
begin
mainFrm.list.visible:=FALSE;
building:=TRUE;
// reset
clear;
offlineTree:=NIL;

fillChar(divs,sizeOf(divs),0);
if groups=NIL then exit;
for i:=0 to groups.count-1 do
  with groups.a[i] do
    fillchar(node, sizeOf(node), 0);
// roaster section
roaster:=icq.readroaster.clone;
roaster.sort(compareContacts4build);

buildingOnline:=icq.isOnline;
with roaster do
  if not empty then
    begin
    lastGroupId:=0;
    if buildingOnline then
      begin
      insertDivisor(d_online);
      lastDiv:=d_online;
      end
    else
      begin
      insertDivisor(d_contacts);
      lastDiv:=d_contacts;
      end;
    under:=divs[lastDiv].treenode;

    resetEnumeration;
    while hasMore do
      begin
      c:=getNext;
      contactOnline:=c.status <> SC_OFFLINE;
      if buildingOnline and not contactOnline and showOnlyOnline then
        break;
      node:=Tnode.create(c);
      TCE(c.data^).node:=node;
      if buildingOnline then
        if not contactOnline and (lastDiv=d_online) then
          begin
          insertDivisor(d_offline);
          lastDiv:=d_offline;
          under:=divs[lastDiv].treenode;
          lastGroupId:=0;
          end;
      if showGroups and (c.group<>lastGroupId) then
        begin
        lastGroupId:=c.group;
        under:=insertGroupUnder(groups.idxOf(c.group), lastDiv).treenode;
        end;
      node.treenode:=mainFrm.list.items.addChildObject(under, '', node)
      end;//while
    if buildingOnline and not showOnlyOnline then
      insertDivisor(d_offline);
    end;

roaster.free;
// NIL section
if assigned(notInList) then
  with notInList do
    if not empty then
      begin
      insertDivisor(d_nil);
      resetEnumeration;
      while hasMore do
        insertBuddy(getNext, d_nil);
      end;
// expands all divs
for d:=low(d) to high(d) do
  if assigned(divs[d]) then
    begin
    divs[d].treenode.expand(FALSE);
    for i:=0 to groups.count-1 do
      with groups.a[i] do
        if node[d]<>NIL then
          if expanded[d] then
            node[d].treenode.expand(FALSE)
          else
            node[d].treenode.collapse(FALSE);
    end;
building:=FALSE;
fixListTimer:=5;
with mainfrm.list do
  begin
  autosizeDelayed:=TRUE;
  visible:=TRUE;
  if mainfrm.visible then
    setFocus;
  if items.count > 0 then
    begin
    topItem:=items.getFirstNode;
    topItem.selected:=TRUE;
    end;
  end;
end; // rebuild

begin
if notInList.exists(c) then
  begin
  result:=fromNILtoCL(c);
  exit;
  end;
result:=FALSE;
if (c=NIL) or assigned(TCE(c.data^).node) then exit;
saveListsDelayed:=TRUE;
ICQ.addContact(c);

if icq.isOnline then
  begin
  addDivisor(d_online);
  if not showonlyonline then addDivisor(d_offline);
  end
else
  addDivisor(D_contacts);

if not icq.isOnline then
  insertBuddy(c, d_contacts)
else
  if c.status = SC_OFFLINE then
    begin
    if not showonlyonline then insertBuddy(c, d_offline)
    end
  else
    insertBuddy(c, d_online);
fixListTimer:=5;
autosizeDelayed:=TRUE;
buddiesRepaintDelayed:=TRUE;
end; // addBuddy

function Tbuddies.addBuddy_NIL(c:Tcontact):boolean;
begin
result:=not assigned(TCE(c.data^).node);
if not result then
  exit;
addNIL(c);
addDivisor(D_nil);
insertBuddy(c, d_nil);
saveListsDelayed:=TRUE;
buddiesRepaintDelayed:=TRUE;
end; // addBuddy_NIL

function Tbuddies.contactsIn(node:Tnode):integer;
procedure Tbuddies.stopEditing(sender:Tobject);
begin
inplace.edit.hide;
end;

procedure Tbuddies.keyEditing(Sender: TObject; var Key: Char);
begin
case key of
  #27:
    begin
    key:=#0;
    inplace.edit.hide;
    mainfrm.list.setfocus;
    end;
  #13:
    begin
    key:=#0;
    with inplace do
      case what of
        NODE_GROUP:
          begin
          groups.a[groups.idxOf(groupId)].name:=edit.text;
          sortGroup(inplace.groupId);
          saveGroupsDelayed:=TRUE;
          end;
        NODE_CONTACT:
          begin
          if edit.text <> contact.displayed then
            contact.display:=edit.text;
          chatFrm.userChanged(contact);
          dbUpdateDelayed:=TRUE;
          updateViewInfo(contact);
          end;
        end;
    inplace.edit.hide;
    mainFrm.list.SetFocus;
    exit;
    end;
  end;
end;

var
  i:integer;
begin
result:=0;
if assigned(node) then
  if node.kind = NODE_CONTACT then
    result:=1
  else
    for i:=0 to node.treenode.count-1 do
      inc(result, contactsIn(Tnode(node.treenode.item[i].data)));
end; // contactsIn

procedure Tbuddies.sortGroup(id:integer);
var
  d:Tdivisor;
  bak:pointer;
begin
with groups.a[groups.idxOf(id)] do
  for d:=low(d) to high(d) do
    if node[d]<>NIL then
      with node[d].treenode do
        begin
        bak:=data;
        data:=NIL;
        data:=bak;
        end;
end; // sortGroup


procedure TmainFrm.roasterBeforeItemPaint(
  Sender: TBaseVirtualTree; TargetCanvas: TCanvas; Node: PVirtualNode;
  ItemRect: TRect; var CustomDraw: Boolean);
const
  embossColor:array [boolean] of Tcolor=(clBtnShadow,clBtnHighlight);
var
  c:Tcontact;
  x,y,w:integer;
  ev:Thevent;
  n:Tnode;
  s:string;
  R:Trect;
  b:boolean;
  pic:Tbitmap;
begin
exit;
customdraw:=TRUE;
R:=itemrect;
n:=Tnode(sender.getnodedata(node)^);
if not assigned(n) then exit;
with targetcanvas do
  begin
  if node=sender.focusednode then
    Brush.color := selectedColor
  else
    Brush.color := roaster.color;
  fillRect(R);
  font.assign(roasterFont);
  x:=0;
  if indentRoaster then
    inc(x, getPic(PIC_OPEN_GROUP).width*pred(integer(roaster.getnodelevel(node))));
  y:=R.Top;
  case n.kind of
    NODE_CONTACT:
      begin
      inc(x,2);
      c:=n.contact;
      if ICQ.imVisibleTo(c) and showVisibilityFlag then
        inc(x, drawPic(targetcanvas, x,y+1, PIC_VISIBLE_TO).x+2);
      ev:=eventQ.firstEventFor(c);
      w:=drawPic(targetcanvas, x,y+1, roasterImgIdxFor(c)).x;
      if (ev<>NIL) and blinking or onStatusDisable[icq.myinfo.status].blinking then
        drawPic(targetcanvas, x,y, ev.pic);
      inc(x, w+2);
      if outbox.stFor(c) then
        begin
        pic:=getPic(PIC_OUTBOX);
        n.outboxRect:=rect(x,y,x+pic.width,y+pic.height);
        inc(x, drawPic(targetcanvas, x,y,pic).x+2);
        end
      else
        n.outboxRect:=rect(-1,-1,-1,-1);
      if ICQ.isOnline and not notinlist.exists(c) then
        case c.status of
          SC_OFFLINE: font.color:=clRed;
          SC_UNK: ;
          else font.color:=clBlue
          end;
      case roasterItalic of
        RI_list: b:=visibleList.exists(c);
        RI_visibleTo: b:=ICQ.imVisibleTo(c);
        else b:=FALSE;
        end;
      if b then
        font.style:=font.style+[fsItalic];
      n.textOfs:=x;
      drawTxt(handle, x,y+2, c.displayed);
      end;
    NODE_DIV:
      begin
      s:=___('divisor '+divisor2str[Tdivisor(n.divisor)]);
      w:=textWidth(s);
      x:=r.left+(r.right-r.left-w) div 2;
      if x < 10 then
        x:=10;
      pen.color:=embossColor[FALSE];
      moveTo(r.left, y+6);
      lineTo(r.right, penpos.y);
      pen.color:=embossColor[TRUE];
      moveTo(r.left, penpos.y+1);
      lineTo(r.right, penpos.y);
      font.color:=embossColor[TRUE];
      r.left:=x+1;
      r.top:=y+1;
      drawText(handle, pchar(s), length(s), R, DT_NOCLIP);
      font.color:=embossColor[FALSE];
      SetBkMode(handle, TRANSPARENT);
      dec(R.left); dec(R.top);
      n.textOfs:=R.left;
      drawText(handle, pchar(s), length(s), R, DT_NOCLIP);
      SetBkMode(handle, OPAQUE);
      end;
    NODE_GROUP:
      begin
      if n.expanded and (n.childrenCount>0) then
        inc(x, drawPic(targetcanvas, x+2,y,PIC_OPEN_GROUP).x+4)
      else
        inc(x, drawPic(targetcanvas, x+2,y,PIC_CLOSE_GROUP).x+4);

      n.textOfs:=x;
      s:=___('roaster group', [groups.id2name(n.groupId), n.childrenCount] );
      font.style:=font.style+[fsBold];
      font.Color:=clMaroon;
      drawTxt(handle, x,y+2,s);
      end;
    end;//case
  end;//with
end;
