unit themes_fr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, themesLib, utilLib, globalLib;

type
  TthemesFr = class(TFrame)
    themeBox: TComboBox;
    descBox: TMemo;
    logoImg: TImage;
    refreshBtn: TBitBtn;
    procedure refreshBtnClick(Sender: TObject);
    procedure themeBoxSelect(Sender: TObject);
  public
    function  current:Pthemeinfo;
    procedure select(fn:string);
  end;

implementation

{$R *.dfm}

function TthemesFr.current:Pthemeinfo;
begin
with themeBox do
  if itemIndex<0 then
    result:=NIL
  else
    result:=Pthemeinfo(Items.Objects[itemIndex])
end;

procedure TthemesFr.select(fn:string);
var
  i:integer;
begin
for i:=0 to length(themelist)-1 do
  if themelist[i].fn=fn then
    begin
    themeBox.itemindex:=i;
    exit;
    end;
end;

procedure TthemesFr.refreshBtnClick(Sender: TObject);
var
  i,idx:integer;
  old:string;
begin
if current=NIL then
  old:=theme.fn
else
  old:=current.fn;
refreshThemelist;
themeBox.Clear;
for i:=0 to length(themelist)-1 do
  begin
  idx:=themeBox.Items.addObject(themelist[i].title, @themelist[i]);
  if themelist[i].fn = old then
    themeBox.ItemIndex:=idx;
  end;
if themeBox.ItemIndex < 0 then
  themeBox.ItemIndex:=0;
themeBoxSelect(NIL);
end;

procedure TthemesFr.themeBoxSelect(Sender: TObject);
begin
if current=NIL then exit;
descBox.Text:=current.desc;
if current.logo = '' then
  logoImg.Height:=0
else
  loadPic(myPath+themesPath+current.logo, logoImg);
end;

end.

