{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit tipDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, contacts, events;

type
  TtipFrm = class(TForm)
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
  protected
    function preshow():boolean;
    procedure postshow();
    procedure drawEvent(cnv:Tcanvas; var maxX,maxY:integer);
  public
    evkind:integer;
    contact:Tcontact;
    info:string;
    counter:integer;
    time:Tdatetime;
    action: (TA_NULL, TA_LCLICK, TA_2LCLICK, TA_RCLICK, TA_2RCLICK);
    mode: (TM_EVENT, TM_PIC);
    actionCount: integer;
    prevWnd:Thandle;
    mouseDown:boolean;
    pic:Tbitmap;
    procedure WndProc(var msg:TMessage); override;
    procedure paint; override;
    procedure hide();
    procedure show(ev:Thevent); overload;
    procedure show(bmp:Tbitmap); overload;
  end;

var
  tipFrm: TtipFrm;

implementation

{$R *.dfm}

uses
  globalLib, mainDlg, utilLib, chatDlg, langLib;
var
  processing:boolean=FALSE;

procedure Ttipfrm.hide();
begin
// hide task button
setwindowlong(handle, GWL_HWNDPARENT, mainfrm.handle);
showWindow(handle, SW_HIDE);
counter:=0;
if prevWnd>0 then
  begin
  forceForegroundWindow(prevWnd);
  prevWnd:=0;
  end;
end; // hide

function Ttipfrm.preshow():boolean;
begin
result:=FALSE;
if processing or mousedown then exit;
hide();
if locked then exit;
if actionCount>0 then exit;  // user interacting with tipfrm
actioncount:=0;
processing:=TRUE;
result:=TRUE;
end; // preshow

procedure Ttipfrm.postshow();
var
  i:integer;
begin
for i:=1 to length(info) do
  if info[i] = #9 then
    info[i]:=' ';
paint;
showWindow(handle, SW_SHOWNA);
processing:=FALSE;
end; // postshow

procedure Ttipfrm.show(bmp:Tbitmap);
begin
mode:=TM_PIC;
if bmp=NIL then hide();
if pic=NIL then pic:=Tbitmap.create;
if not preshow() then exit;
pic.Assign(bmp);
mode:=TM_PIC;
counter:=0;
roundWindow(handle, bmp.Width, bmp.height);
time:=now;
postShow();
end; // show

procedure Ttipfrm.show(ev:Thevent);
begin
if (ev<>NIL) and not (BE_TIP in supportedBehactions[ev.kind]) then exit;
if (ev.kind in [EK_msg,EK_url]) // user reading this message in chat window
and chatFrm.isVisible
and (ev.who.equals(chatFrm.thisChat.who)) then
  exit;
if not preshow() then exit;
mode:=TM_EVENT;
unroundWindow(self.handle);
evkind:=ev.kind;
counter:=behaviour[evkind].TipTime;
info:=ev.decrittedinfo;
if behaviour[evkind].TipTimes then
  counter:=counter*length(info)+behaviour[evkind].TipTimePlus;
contact:=ev.who;
time:=ev.when;
postShow();
end; // show

procedure Ttipfrm.WndProc(var msg:TMessage);
begin
case msg.msg of
  WM_ACTIVATE:
    if word(msg.wparam) = WA_CLICKACTIVE then
      prevWnd:=msg.lParam;
  end;
inherited;
end; // wndproc

procedure Ttipfrm.drawEvent(cnv:Tcanvas; var maxX,maxY:integer);
var
  x,y,h:integer;
  R,work:Trect;
  cname,s:string;
  pc:pchar;
  size:Tsize;
begin
inherited;
if contact=NIL then exit;
cname:=contact.displayed;
work:=desktopWorkArea;
cnv.font.assign(theme.tip.contactfont);
cnv.Brush.Style:=bsSolid;
cnv.brush.color:=theme.tip.bgcolor;
cnv.fillRect(cnv.ClipRect);
x:=4;
y:=2;
maxX:=4;
maxY:=2;
R.left:=x;
size:=drawPic(cnv, x,y, event2imgidx(evkind));
inc(x,size.cx+2);
h:=cnv.textHeight('J')*4 div 3;
if size.cy > h then
  h:=size.cy;

cnv.textOut(x,y+2,cname);
inc(x, cnv.textWidth(cname)+3);

cnv.font.assign(theme.tip.font);

s:=___('tip '+event2str[evkind]);
cnv.textOut(x,y+2, s);
inc(x, cnv.textWidth(s)+2);
if evkind = EK_statuschange then
  inc(x, drawPic(cnv, x,y, status2imgIdx(Tstatus(str2int(info)), FALSE)).cx);
inc(y, h);
maxX:=x;
maxY:=y;

if evkind in [EK_url,EK_msg,EK_contacts,EK_authReq,EK_automsg] then
  begin
  R.top:=y;
  R.right:=(work.right-work.left) div 3;
  R.bottom:=y;
  pc:=@info[1];
  if evkind=EK_automsg then
    inc(pc);
  drawText(cnv.handle, pc, -1, R, DT_WORDBREAK+DT_EXTERNALLEADING+DT_NOPREFIX+DT_CALCRECT );
  drawText(cnv.handle, pc, -1, R, DT_WORDBREAK+DT_EXTERNALLEADING+DT_NOPREFIX );
  inc(R.bottom,7);
  inc(R.right,7);
  maxY:=R.bottom;
  if R.right > maxX then
    maxX:=R.right;
  end;
cnv.brush.color:=theme.tip.font.color;
cnv.frameRect(rect(0,0,maxX,maxY));
end; // drawEvent

procedure Ttipfrm.paint;
var
  maxX,maxY:integer;
  work:Trect;
begin
work:=desktopWorkArea;
case mode of
  TM_EVENT: drawEvent(canvas, maxX,maxY);
  TM_PIC:
    begin
    canvas.Draw(0,0,pic);
    maxX:=pic.Width;
    maxY:=pic.Height;
    end;
  end;
boundInt(maxY, 0, work.bottom-work.top);
boundInt(maxX, 0, work.right-work.left);
if not visible then
  setBounds( work.right-maxX, work.bottom-maxY, maxX, maxY);
end; // paint

procedure TtipFrm.FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
mousedown:=FALSE;
end;

procedure Ttipfrm.FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
mousedown:=TRUE;
actionCount:=3;
if action=TA_null then
  begin
  if shift=[ssLeft] then action:=TA_lclick;
  if shift=[ssRight] then action:=TA_rclick;
  end
else
  case action of
    TA_lclick: action:=TA_2lclick;
    TA_rclick: action:=TA_2rclick;
    end;
end;

procedure TtipFrm.FormCreate(Sender: TObject);
begin

end;

end.
