{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit usersDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons;

type
  TusersFrm = class(TForm)
    usersBox: TListBox;
    Panel1: TPanel;
    newuserBtn: TButton;
    newaccountBtn: TButton;
    importBtn: TButton;
    okBtn: TBitBtn;
    deleteuserBtn: TBitBtn;
    deleteaccountBtn: TBitBtn;
    procedure usersBoxDblClick(Sender: TObject);
    procedure newaccountBtnClick(Sender: TObject);
    procedure newuserBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure usersBoxKeyPress(Sender: TObject; var Key: Char);
    procedure importBtnClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure deleteuserBtnClick(Sender: TObject);
    procedure deleteaccountBtnClick(Sender: TObject);
    procedure okBtnClick(Sender: TObject);
    procedure usersBoxClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    selected:boolean;
  public
    startIt:boolean;
    procedure refreshUsers;
    function  doSelect:integer;
    function  selectUIN(uin:integer):boolean;
    function  uinAt(idx:integer):integer;
    procedure newuser(uin:integer);
  end;

var
  usersFrm: TusersFrm;

implementation

{$R *.DFM}

uses
  globallib, mainDlg, contacts, importDlg, newaccountDlg, utilLib, langLib,
  strutils, iniLib;

var
  deletedMe:boolean;

procedure TusersFrm.refreshUsers;
var
  toSelect:integer;
  i:integer;
begin
usersBox.clear;
toSelect:=-1;
for i:=0 to length(availableUsers)-1 do
  with availableUsers[i] do
    begin
    usersBox.items.add(uinStr+'  '+name);
    if uin=lastUser then
      toSelect:=i;
    end;
if toSelect >= 0 then
  begin
  usersBox.itemIndex:=toSelect;
  okbtn.enabled:=TRUE;
  end
else
  if usersBox.items.count > 0 then
    begin
    usersBox.itemIndex:=0;
    okBtn.enabled:=TRUE;
    end
  else
    begin
    usersBox.itemIndex:=-1;
    okBtn.enabled:=FALSE;
    end;
end;  // refreshUsers

function TusersFrm.doSelect:integer;
begin
startIt:=FALSE;
showModal;
if not selected and not startIt then
  result:=0
else
  result:=uinAt(usersBox.itemIndex);
end; // doSelect

procedure TusersFrm.usersBoxDblClick(Sender: TObject);
begin okBtnClick(sender) end;

procedure TusersFrm.newaccountBtnClick(Sender: TObject);
begin
newaccountFrm:=TnewaccountFrm.create(NIL);
translateWindow(newaccountFrm);
newaccountFrm.showModal;
ForceForegroundWindow(handle);
end;

procedure TusersFrm.newuserBtnClick(Sender: TObject);
var
  uin:integer;
begin
uin:=0;
if enterUINdlg(uin,'New user UIN') then
  newUser(uin);
end;

procedure TusersFrm.FormShow(Sender: TObject);
begin
applyTaskButton(self);
selected:=FALSE;
hideTaskButtonIfUhave2;
end;

procedure TusersFrm.usersBoxKeyPress(Sender: TObject; var Key: Char);
begin
if key=#13 then
  begin
  selected:= usersBox.itemIndex>=0;
  close;
  end;
end;

procedure TusersFrm.importBtnClick(Sender: TObject);
begin
importFrm:=TimportFrm.create(NIL);
importFrm.fnBox.filename:=getICQfolder;
translateWindow(importFrm);
importFrm.showModal;
ForceForegroundWindow(handle);
if startIt then
  close;
end;

procedure TusersFrm.FormPaint(Sender: TObject);
begin wallpaperize(canvas) end;

function TusersFrm.selectUIN(uin:integer):boolean;
var
  i:integer;
begin
result:=FALSE;
i:=0;
while i < usersBox.items.count do
  begin
  if uinAt(i) = uin then
    begin
    usersBox.itemIndex:=i;
    okBtn.enabled:=TRUE;
    result:=TRUE;
    exit;
    end;
  inc(i);
  end;
end;

function TusersFrm.uinAt(idx:integer):integer;
begin
if idx >= length(availableUsers) then
  result:=0
else
  result:=availableUsers[idx].uin;
end; // uinAt

procedure TusersFrm.deleteuserBtnClick(Sender: TObject);
var
  itsme:boolean;
  UINtoDelete:integer;
  continue:boolean;
begin
if usersBox.itemIndex < 0 then
  msgDlg(___('select user to delete'),mtInformation)
else
  begin
  UINtoDelete:=uinAt(usersBox.ItemIndex);
  itsme:=(ICQ.myinfo<>NIL) and (ICQ.myInfo.uin = UINtoDelete);
  if itsme then
    begin
    continue:=messageDlg(___('delete myself?',[UINtoDelete]), mtConfirmation, [mbYes,mbNo], 0) = mrYes;
    deletedMe:=continue;
    if continue then quitUser;
    end
  else
    continue:=messageDlg(___('delete user?',[UINtoDelete]), mtConfirmation, [mbYes,mbNo], 0) = mrYes;
  if continue then
    if deltree(myPath+intToStr(UINtoDelete)) then
      begin
      refreshAvailableUsers;
      refreshUsers;
      msgDlg(___('user deleted'),mtInformation)
      end
    else
      msgDlg(___('error deleting user'),mtError);
  end
end;

procedure TusersFrm.deleteaccountBtnClick(Sender: TObject);
begin
//removeFrm:=TremoveFrm.create(mainFrm);
notAvailable
end;

procedure TusersFrm.okBtnClick(Sender: TObject);
begin
if usersBox.itemIndex < 0 then exit;
selected:=TRUE;
close;
end;

procedure TusersFrm.usersBoxClick(Sender: TObject);
begin
OKbtn.enabled:=usersBox.itemIndex >= 0;
end;

procedure TusersFrm.newuser(uin:integer);
var
  s:string;
  i:integer;
begin
s:=intToStr(uin);
if selectUIN(uin) then
  msgDlg(___('already exists',[s]),mtError)
else
  begin
  IOresult;
  mkdir(myPath+s);
  mkdir(myPath+s+'\history');
  IOresult;
  i:=usersBox.items.add(s);
  refreshAvailableUsers;
  usersBox.itemIndex:=i;
  usersBoxClick(NIL);
  end;
end; // newuser

procedure TusersFrm.FormCreate(Sender: TObject);
begin
refreshAvailableUsers;
refreshUsers;
end;

procedure TusersFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if deletedMe and not selected then
  begin
  hideForm(mainFrm);
  quit;
  end;
end;

end.
