{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit utilLib;

interface

uses
  dialogs, shellapi, windows, sysutils, graphics, classes, extctrls, outboxLib,
  forms, contacts, viewinfoDlg, history, stdctrls, controls, ICQv7, flap,
  roasterLib, jvcaptionButton,
  menus, registry, comctrls, mmsystem, converthistoriesDlg, messages, types,
  tipDlg, VirtualTrees, wsocket, sendfileDlg, strutils, httpProt, events, MD5,
  globalLib, pngunit, JvMenus, dateutils, grids, wininet, themesLib, Buttons;

procedure processOevent(oe:Toevent);
function  md5(s:string):string;
procedure addTempVisibleFor(time:integer; c:Tcontact);
function  getShiftState():integer;
procedure applyTaskButton(frm:Tform);
procedure applyMinButton();
procedure applyRoundedWindows();
function  exitFromAutoaway():boolean;
function  infoToStatus(info:string):Tstatus;
procedure drawNodeHint(cnv:Tcanvas; node:Pvirtualnode; var r:Trect);
procedure popupHintByMacro();
function  within(pt:Tpoint; x,y,w,h:integer):boolean; overload;
function  within(a,b,c:integer):boolean; overload;
function  dateTocoolstr(d:Tdatetime):string;
function  datetimeToStrMinMax(dt:Tdatetime; min:Tdatetime; max:Tdatetime):string;
function  getClientFor(c:Tcontact):string;
function  isAbort(pluginReply:string):boolean;
function  findInAvailableUsers(uin:integer):integer;
function  unexistant(uin:integer):boolean;
procedure setupChatButtons;
procedure reloadCurrentTheme();
procedure reloadCurrentLang();
procedure assignImgIco(img:Timage; ico:Ticon);
procedure assignImgBmp(img:Timage; bmp:Tbitmap);
function  connectionAvailable:boolean;
procedure releaseResources;
function  showUsers:integer;
procedure refreshAvailableUsers;
procedure applyCommonSettings(c:Tcomponent);
procedure repaintAllWindows;
function  getLeadingInMsg(s:string; ofs:integer=1):string;
procedure applyUserCharset(f:Tfont);
function  isURL(s:string; ofs:integer=1):boolean;
function  ipos(ss:string; s:string):integer;
procedure applyBalloon;
function  addToNIL(c:Tcontact):boolean;
procedure NILifNIL(c:Tcontact);
function  template(src:string; table:array of string):string;
function  setRoasterAnimation(v:boolean):boolean;
function  IfThen(AValue: Boolean; const ATrue: Integer; const AFalse: Integer = 0): Integer; overload;
function  eventName(ev:integer):string;
function  visibilityName(vi:Tvisibility):string;
function  langDependentFile(filename:string):string;
function  availableLangs:TStringDynArray;
function  setlang(l:string):boolean;
function  behactionName(a:Tbehaction):string;
function  macroopcodeName(m:integer):string;
function  ___(const key:string):string; overload;
function  ___(const key:string; const args:array of const):string; overload;
function  statusName(s:Tstatus):string;
function  sendMCIcommand(cmd:PChar):string;
procedure doLock;
function  packArray(a:array of integer; zero:integer):TintegerDynArray;
procedure startMenuViaMacro;
procedure stopMenuViaMacro;
function  loadNewOrOldVersionContactList(fn:string; altpath:string=''):string;
procedure trayAction;
function  chopAndRealizeEvent:boolean;
procedure realizeEvent(ev:Thevent);
function  removeMacro(i:integer):boolean;
function  findHK(hk:Tshortcut):integer;
function  addMacro(hk:Tshortcut; sw:boolean; op:integer):boolean;
procedure fillMacrosGrid(macros:Tmacros);
procedure executeMacro(m:integer);
procedure removeSWhotkeys;
function  updateSWhotkeys:boolean;
procedure hideTaskButtonIfUhave2;
procedure loggaEvt(s:string);
procedure loggaPkt(what:TwhatLog; data:string='');
function  behave(ev:Thevent; kind:integer=-1; info:string=''):boolean;
procedure startTimer;
procedure stopTimer;
procedure contactCreation(c:Tcontact);
procedure contactDestroying(c:Tcontact);
procedure clearDB(db:TcontactList);
procedure freeDB(var db:TcontactList);
function  isSpam(c:Tcontact; msg:string=''; flags:dword=0):boolean;
function  filterRefuse(c:Tcontact; msg:string=''; flags:dword=0):boolean;
function  roasterImgIdxFor(c:Tcontact):integer;
procedure setAppBarSize;
procedure check4update;
function  setAutomsg(s:string):string;
function  getAutomsgFor(c:Tcontact):string;
procedure toggleOnlyOnline;
procedure toggleOnlyImVisibleTo;
function  dontBotherStatus:boolean;
function  invisibleMode:boolean;
function  compareInt(a,b:integer):integer;
function  getDefaultBrowser(proto:string='http'):string;
procedure openURL(url:string);
function  calculate_KEY1(pwd:string):integer;
function  enterICQpwd:boolean;
function  enterPwdDlg(var pwd:string; title:string=''; maxLength:integer=0):boolean;
function  enterUinDlg(var uin:integer; title:string=''):boolean;
procedure swap(var a,b:integer); overload;
procedure swap(var src,dest; count:dword; cond:boolean); overload;
function  mousePos:Tpoint;
procedure addGroupsToMenu(own:Tcomponent; mi:Tmenuitem; action:TnotifyEvent);
procedure addSmilesToMenu(own:Tcomponent; mi:Tmenuitem; action:TnotifyEvent);
function  sendEmailTo(c:Tcontact):boolean;
function  childParent(child,parent:integer):boolean;
procedure redrawUIN(uin:integer);
procedure msgDlg(msg:string; kind:TMsgDlgType);
procedure myBeep;
procedure playSound(fn:string);
procedure exec(cmd:string; pars:string='');
function  findViewInfo(c:Tcontact):TviewInfoFrm;
function  findSendfile(id:integer):TsendfileFrm;
function  boundInt(var i:integer; min,max:integer):integer;
procedure sortCL(cl:TcontactList);
procedure sortCLbyGroups(cl:TcontactList);
procedure toggleShowGroups;
procedure updateViewInfo(c:Tcontact);
procedure convertHistoriesDlg(oldPwd, newPwd:string);
procedure openSendContacts(dest:Tcontact);
function  isEmailAddress(s:string; start:integer):integer;
procedure notAvailable;
// strings
function  capitalize(s:string):string;
procedure convertAllNewlinesToCRLF(var s:string);
function  separated(sep:string; ss:array of string):string;
function  TLV(code:integer; data:string):string;
function  newline2slashn(s:string):string;
function  chop(i:integer; var s:string):string; overload;
function  chop(i,l:integer; var s:string):string; overload;
function  chop(ss:string; var s:string):string; overload;
function  chopline(var s:string):string;
function  mb(q:extended):string;
function  excludeTrailingCRLF(s:string):string;
function  findInStrings(s:string;ss:Tstrings):integer; overload;
function  findInStrings(s:string;ss:array of string):integer; overload;
function  findInStrings(s,ss,separator:string):integer; overload;
function  dupAmperstand(s:string):string;
function  isOnlyDigits(s:string):boolean;
function  onlyDigits(s:string):string; overload;
procedure onlyDigits(obj:Tobject); overload;
function  matches(s:string; from:integer; sub:string):boolean;
function  Imatches(s:string; from:integer; sub:string):boolean;
function  dupString(s:string):string;
function  trailing(s,ss:string):boolean;
// crypting
function  passCrypt(s:string):string;
function  passDeCrypt(s:string):string;
function  decritted(s:string; key:integer):string;
function  critted(s:string; key:integer):string;
procedure critt(var s:string; key:integer);
procedure decritt(var s:string; key:integer);
// icq communication
procedure applyClientID;
function  addToRoaster(c:Tcontact):boolean; overload;
function  addToRoaster(c:Tcontact; group:integer):boolean; overload;
procedure removeFromRoaster(c:Tcontact);
procedure removeFromIgnorelist(c:Tcontact);
procedure addToIgnorelist(c:Tcontact);
procedure receiveFile(d:Tdirect);
procedure sendfile(c:Tcontact; fn:string);
procedure proxySettings(sock:Twsocket);
function  sendICQmsg(oe:Toevent):boolean;
procedure sendICQcontacts(uin,flags:integer; cl:TcontactList);
procedure sendICQauth(uin:integer);
procedure sendICQauthDenied(uin:integer; msg:string='');
procedure sendICQaddedYou(uin:integer);
function  sendICQfiles(uin:integer; files:string):integer;
procedure sendICQautomsgreq(uin:integer);
procedure updateICQvisibility;
function  doConnect:boolean;
procedure connect_after_dns;
function  setStatus(st:Tstatus):Tstatus;
procedure setVisibility(vi:Tvisibility);
procedure userSetStatus(st:Tstatus);
procedure usersetVisibility(vi:Tvisibility);
// convert
function  str2fontstyle(s:string):Tfontstyles;
function  fontstyle2str(fs:Tfontstyles):string;
function  ints2cl(a:TintegerDynArray):Tcontactlist;
function  event2ico(e:integer):Ticon;
function  event2imgidx(e:integer):integer;
procedure str2macros(s:string; var m:Tmacros);
function  str2macro(s:string):Tmacro;
function  macros2str(m:Tmacros):string;
function  contactlist2clb(cl:Tcontactlist):string;
function  clb2contactlist(data:string):Tcontactlist;
function  intToStr(i,d:integer):string; overload;
function  beh2str(kind:integer):string;
function  str2beh(s:string):Tbehaviour;
function  str2int(s:string):integer; overload;
function  str2int(p:pointer):integer; overload;
function  str2status(s:string):Tstatus;
function  hexDump(data:string):string;
function  ip2str(ip:integer):string;
function  str2ip(s:string):integer;
function  bool2str(b:boolean):string;
function  status2imgIdx(s:Tstatus; inv:boolean=FALSE):integer;
function  visibility2imgIdx(vi:Tvisibility):integer;
function  str2visibility(s:string):Tvisibility;
function  hexToInt(s:string):integer;
function  str2valor(s:string):integer;
function  str2color(s:string):Tcolor;
function  color2str(color:Tcolor):string;
function  str2html(s:string):string;
function  int2str(i:integer):string;
function  strings2str(split:string; ss:Tstrings):string; overload;
function  strings2str(split:string; ss:array of string):string; overload;
procedure str2strings(split, src:string; var ss:Tstrings);
function  dt2str(dt:Tdatetime):string;
function  db2str(db:TcontactList):string;
function  str2db(s:string; var ok:boolean):TcontactList; overload;
function  str2db(s:string):TcontactList; overload;
// window management
procedure roundWindow(hnd:Thandle; w,h:integer); overload;
procedure roundWindow(frm:Tform); overload;
procedure unroundWindow(hnd:Thandle);
procedure toggleMainfrmBorder;
procedure mainfrmHandleUpdate;
procedure dockSet(on:boolean); overload;
procedure dockSet(var r:Trect); overload;
procedure dockSet; overload;
procedure fixWindowPos(frm:Tform);
procedure showAuthreq(c:Tcontact; msg:string);
procedure showSplash;
function  viewTextWindow(title,body:string):Tform;
function  viewHeventWindow(ev:Thevent):Tform;
procedure viewinfoAbout(c:Tcontact);
procedure clearMenu(root:Tmenuitem);
procedure createFavMenu(root:Tmenuitem; action:TnotifyEvent);
function  getRegion(bmp:Tbitmap):HRGN;
function  isTopMost(frm:Tform):boolean;
function  setTopMost(frm:Tform; val:boolean):boolean;
function  formVisible(frm:Tform):boolean;
procedure hideForm(frm:Tform);
procedure showForm(frm:Tform); overload;
procedure showForm(whatForm:TwhatForm); overload;
function  desktopWorkArea:Trect;
function  ForceForegroundWindow(hwnd:THandle; doRestore:boolean=TRUE):boolean;
procedure restoreForeWindow;
procedure applyTransparency(forced:integer=-1);
function  whatStatusPanel(statusbar:Tstatusbar; x:integer):integer;
// graphic
function  createBitmap(dx,dy:integer):Tbitmap; overload;
function  createBitmap(cnv:Tcanvas):Tbitmap; overload;
procedure freePic(idx:integer);
function  dupePic(pic:Tbitmap):Tbitmap;
function  pic2ico(pic:integer):Ticon; overload;
function  pic2ico(pic:Tbitmap):Ticon; overload;
function  getIco(idx:integer):Ticon; overload;
function  getIco(st:Tstatus; inv:boolean):Ticon; overload;
procedure loadIco(fn:string; var result:Ticon);
procedure wallpaperize(canvas:Tcanvas);
function  drawPic(cnv:Tcanvas; x,y:integer; pic:integer):Tsize; overload;
function  drawPic(cnv:Tcanvas; x,y:integer; pic:Tbitmap):Tsize; overload;
function  getPic(idx:integer):Tbitmap;
function  statusImgIdx:integer;
function  visibilityImgIdx:integer;
function  isSupportedPicFile(fn:string):boolean;
function  loadPic(fn:string):Tbitmap; overload;
function  loadPic(fn:string; bmp:Tbitmap):boolean; overload;
function  loadPic(fn:string; img:Timage):boolean; overload;
function  color2hls(clr:Tcolor):Thls;
function  hls2color(hls:Thls):Tcolor;
function  addLuminosity(clr:Tcolor; q:real):Tcolor;
function  into(p:Tpoint; r:Trect):boolean;
procedure drawTxt(hnd:Thandle; x,y:integer; s:string);
procedure drawTxtL(hnd:Thandle; x,y:integer; s:pchar; L:integer);
function  txtSize(hnd:Thandle; s:string):Tsize;
function  txtSizeL(hnd:Thandle; s:pchar; L:integer):Tsize;
function  blend(c1,c2:Tcolor; left:real):Tcolor;
function  traspBmp(bmp:Tbitmap; bg:Tcolor; transpLevel:integer):Tbitmap;
procedure drawTiled(canvas:Tcanvas; bmp:Tbitmap);
// file management
function  mostRecentFileFrom(path:string):integer;
function  saveCachedTheme(fn:string):boolean;
function  loadCachedTheme(fn:string):boolean;
procedure saveRetrieveQ;
function  appendFile(fn:string; data:string):boolean;
function  writeInFile(var f:file; data:string):boolean; overload;
function  writeInFile(var f:file; pos:integer; data:string):boolean; overload;
function  deltree(path:string):boolean;
function  loadFile(fn:string):string;
function  saveFile(fn:string; data:string):boolean;
function  sizeOfFile(fn:string):integer;
function  partDeleteFile(fn:string; from,length:integer):boolean;
function  deleteFromTo(fn:string; from,to_:integer):boolean;
function  getSpecialFolder(what:string):string;
function  getURLfromFav(fn:string):string;
function  loadDB:boolean;
procedure saveDB;
procedure saveLists;
procedure loadLists;
function  savedlg(parent:Tform; ext:string):string;
function  opendlg(parent:Tform; ext:string):string;
procedure saveInbox;
procedure loadInbox;
procedure saveOutbox;
procedure loadOutbox;
function  validFilename(s:string):string;
procedure addLinkToFavorites(link:string);
function  str2sortby(s:string):TsortBy;

implementation

uses
  mainDlg, iniLib, hook, chatDlg, selectContactsDlg, incapsulate,
  pluginLib, automsgDlg, authreqDlg, filetransferDlg, WinSock, prefDlg, logDlg,
  lockDlg, langLib, groupsLib, dbDlg, outboxDlg, msgsDlg, pwdDlg,
  addContactDlg, wpDlg, usersDlg, visibilityDlg, searchhistDlg, changepwdDlg;

function absPath(fn:string):boolean;
begin result:=(length(fn)>2) and ((fn[2]=':') or (fn[1]='\') and (fn[2]='\')) end;

function str2sortby(s:string):TsortBy;
begin
result:=low(TsortBy);
while result <= high(TsortBy) do
  if s = sortby2str[result] then
    exit
  else
    inc(result);
end; // str2sortby

function int2str(i:integer):string;
begin
setLength(result, 4);
move(i, result[1], 4);
end;
  
procedure msgDlg(msg:string; kind:TMsgDlgType);
const
  kind2str:array [TmsgDlgType] of string=('WARNING','ERROR','INFO','','');
var
  i:integer;
begin
loggaEvt(kind2str[kind]+': '+msg);
application.bringToFront;
i:=length(msgs);
setlength(msgs, i+1);
msgs[i].text:=msg;
msgs[i].kind:=kind;
msgs[i].time:=now;
if msgsFrm=NIL then
  messageDlg(msg, kind, [mbOk], 0)
else
  begin
  msgsFrm.listbox.AddItem('',NIL);
  with msgsFrm do icons.getIcon(kind2iconIndex(kind), Icon);
  showForm(msgsFrm);
  msgsFrm.BringToFront;
  end;
end; // msgDlg

procedure exec(cmd:string; pars:string='');
begin shellexecute(0, 'open', pchar(cmd), pchar(pars), NIL, SW_SHOWNORMAL) end;

function isURL(s:string; ofs:integer=1):boolean;
begin
while s[ofs] in ['0'..'9','a'..'z','A'..'Z'] do
  inc(ofs);
result:= copy(s,ofs,3) = '://' ;
end; // isURL

function ipos(ss:string; s:string):integer;
begin
for result:=1 to length(s) do
  if ansiCompareText(ss, copy(s,result,length(ss)))=0 then
    exit;
result:=0;
end; // ipos

procedure openURL(url:string);
var
  prg,par,proto:string;
  i:integer;
begin
if url='' then exit;
if pos('://',url) = 0 then
  proto:=''
else
  begin
  proto:=url;
  proto:=chop('://',proto);
  end;
i:=length(url);
if url[i]='?' then setlength(url,i-1);
if (proto='') or (proto='http') then
  begin
  if useDefaultBrowser then
    begin
    exec(url);
    exit;
    end;
  prg:=browserCmdLine;
  par:='';
  // search the point where the filename ends (and then come parameters)
  i:=ipos('.exe',prg);
  if i>0 then
    begin
    inc(i,4);
    if prg[i]='"' then inc(i);
    end;
  if i<length(prg) then
    begin
    par:=copy(prg,i+1,length(prg))+' ';
    delete(prg,i,length(prg));
    end;
  if pos('%1', par) = 0 then par:=par+' '+url
  else par:=AnsiReplaceStr(par,'%1',url);
  exec(prg,trim(par));
  end
else
  exec(url);
end; // openURL

function isOnlyDigits(s:string):boolean;
var
  i:integer;
begin
result:=FALSE;
i:=1;
while i <= length(s) do
  if s[i] in ['0'..'9'] then
    inc(i)
  else
    exit;
result:=TRUE;
end; // isOnlyDigits

function onlyDigits(s:string):string;
var
  i:integer;
begin
i:=1;
while i <= length(s) do
  if s[i] in ['0'..'9'] then
    inc(i)
  else
    delete(s,i,1);
result:=s;
end; // onlyDigits

procedure onlyDigits(obj:Tobject);
var
  i:integer;
begin
if obj is Tcustomedit then
  with (obj as Tcustomedit) do
    begin
    i:=selstart;
    text:=onlyDigits(text);
    if i>length(text) then i:=length(text);
    selStart:=i;
    end;
end; // onlyDigits

function getRegion(bmp:Tbitmap):HRGN;
var
  span:HRGN;
  x,y,sx:integer;
  p:^integer;
  transcolor:integer;

  procedure addspan;
  begin
  span:=CreateRectRgn(sx,y,x,y+1);
  CombineRgn(result,result,span, RGN_OR);
  DeleteObject(span);
  sx:=-1;
  end;

begin
if not bmp.Transparent then
  begin
  result:=0;
  exit;
  end;
result:=CreateRectRgn(0,0,0,0);
if bmp=NIL then exit;
with bmp do
  begin
  pixelFormat:=pf32bit;
  transcolor:=bmp.TransparentColor AND $FFFFFF;
  for y:=0 to height-1 do
    begin
    p:=bmp.scanline[y];
    sx:=-1;
    for x:=0 to bmp.width-1 do
      begin
      if (p^ <> transcolor) and (sx < 0) then sx:=x;
      if (p^ = transcolor) and (sx >= 0) then addspan;
      inc(p);
      end;
    if sx >= 0 then
      addspan;
    end;
  end;
end; // getRegion

procedure playSound(fn:string);
begin
if not audioPresent or disablesounds then exit;
if length(fn) < 2 then
  exit;
if fn[2] <> ':' then
  fn:=myPath+fn;
if playSounds then
  mmsystem.PlaySound(pchar(fn),0,SND_ASYNC+SND_FILENAME+SND_NODEFAULT+SND_NOWAIT)
end; // playSound

function hexToInt(s:string):integer;
var
  i,v,c:integer;
begin
result:=0;
c:=0;
i:=length(s);
while i > 0 do
  begin
  if s[i] >= 'a' then v:=byte(s[i])-byte('a')+10 else
    if s[i] >= 'A' then v:=byte(s[i])-byte('A')+10 else
      v:=byte(s[i])-byte('0');
  inc(result, v shl c);
  inc(c,4);
  dec(i);
  end;
end; // hexToInt

function str2valor(s:string):integer;
begin
if s = '' then
  result:=-1
else
  if s[length(s)]='h' then
    result:=hexToInt(copy(s,1,length(s)-1))
  else
    try
      result:=strToInt(s)
    except
      result:=0
    end
end; // str2valor

procedure loadLists;
begin
// backward compatibility
renamefile(userpath+'uin.list', userPath+uinlistFilename);

ICQ.readRoaster.fromString( loadNewOrOldVersionContactList(roasterFileName), contactsDB );
VisibleList.fromString( loadNewOrOldVersionContactList(visibleFileName), contactsDB );
InvisibleList.fromString( loadNewOrOldVersionContactList(invisibleFileName), contactsDB );
notInlist.fromString( loadNewOrOldVersionContactList(nilFilename), contactsDB );
ignoreList.fromString( loadNewOrOldVersionContactList(ignoreFilename), contactsDB );
uinlists.fromString( loadFile(userPath+uinlistFilename) );
end; // loadLists

procedure saveLists;
begin
if not saveFile(userPath+roasterFileName+'.txt', ICQ.readroaster.toString) then msgDlg('Error saving contact list',mtError);
if not saveFile(userPath+visibleFileName+'.txt', visiblelist.toString) then msgDlg('Error saving visible list',mtError);
if not saveFile(userPath+invisibleFileName+'.txt', invisiblelist.toString) then msgDlg('Error saving invisible list',mtError);
if not saveFile(userPath+ignoreFileName+'.txt', ignorelist.toString) then msgDlg('Error saving ignore list',mtError);
if saveNIL then
  if not saveFile(userPath+nilFileName+'.txt', notinlist.toString) then msgDlg('Error saving not-in-list',mtError);
if not saveFile(userPath+uinlistFilename, uinlists.toString) then msgDlg('Error saving uinlists', mtError);
end; // saveLists

procedure proxySettings(sock:Twsocket);
begin
if sock.State <> wsClosed then exit;
if proxy.enabled and (proxy.proto in [PP_SOCKS4,PP_SOCKS5]) then
  begin
  sock.socksServer:=proxy.addr[proxy.proto].host;
  sock.socksPort:=proxy.addr[proxy.proto].port;
  if proxy.proto = PP_SOCKS4 then sock.socksLevel:='4'
  else sock.socksLevel:='5';
  sock.SocksAuthentication:=socksNoAuthentication;
  if proxy.auth then sock.SocksAuthentication:=socksAuthenticateUsercode;
  sock.SocksUsercode:=proxy.user;
  sock.SocksPassword:=proxy.pwd;
  end
else
  begin
  sock.socksServer:='';
  sock.socksPort:='';
  sock.SocksAuthentication:=socksNoAuthentication;
  end;
end; // proxySettings

function doConnect:boolean;
begin
result:=FALSE;
if not ICQ.isOffline then exit;

result:=TRUE;
if not useLastStatus then
  lastStatus:=startingStatus;
mainFrm.setProgBar(0.1/progLogonTotal);
ICQ.http.enabled:=proxy.enabled and (proxy.proto=PP_HTTPS);
ICQ.http.addr:=proxy.addr[proxy.proto].host;
ICQ.http.port:=proxy.addr[proxy.proto].port;
if proxy.auth then
  begin
  ICQ.http.user:=proxy.user;
  ICQ.http.pwd:=proxy.pwd;
  end
else
  begin
  ICQ.http.user:='';
  ICQ.http.pwd:='';
  end;
if ICQ.http.enabled then
  connect_after_dns
else
  begin
  resolving:=TRUE;
  statusicon.update;
  ICQ.sock.DnsLookup(loginServer);
  end;
end; // doConnect

procedure connect_after_dns;
begin
ICQ.loginServerAddr:=lastServerIP;
updateICQvisibility;
applyClientID;
if lastStatus = SC_OFFLINE then ICQ.setStatus(SC_ONLINE,invisibleMode)
else if not exitFromAutoaway() then ICQ.setStatus(lastStatus,invisibleMode);
end; // connect_after_dns

function setStatus(st:Tstatus):Tstatus;
begin
autoaway.triggered:=TR_none;
result:=icq.getStatus;
if not (st in [SC_away,SC_na]) then
  imAwaySince:=0
else
  if not (lastStatus in [SC_away,SC_na]) then
    imAwaySince:=now;
lastStatus:=st;
if ICQ.isOffline and (st<>SC_OFFLINE) then
  doConnect
else
  icq.setStatus(st, invisibleMode);
if st=SC_OFFLINE then
  begin
  stayconnected:=FALSE;
  mainfrm.setProgBar(0);
  resolving:=FALSE;
  end;
end; // setStatus

procedure userSetStatus(st:Tstatus);
begin
setStatus(st);
if autoaway.bakmsg > '' then
  setAutomsg(autoaway.bakmsg);
if popupAutomsg and (st in statusWithAutoMsg) then
  automsgFrm.show;
lastStatusUserSet:=st;
end; // userSetStatus

procedure setVisibility(vi:Tvisibility);
var
  changeStatus:boolean;
begin
changeStatus:=invisibleMode <> (vi in [VI_invisible,VI_privacy]);
visibility:=vi;
updateICQvisibility;
if changeStatus and not ICQ.isOffline then
  setStatus(lastStatus);
mainfrm.updateStatusGlyphs;
end; // setVisibility

procedure usersetVisibility(vi:Tvisibility);
begin
icq.clearTemporaryVisible;
setvisibility(vi);
end; // userSetStatus

function invisibleMode:boolean;
begin result:=visibility in [VI_invisible, VI_privacy] end;

procedure updateICQvisibility;
begin
case visibility of
  VI_invisible: icq.setVisibleList(NIL);
  VI_all: icq.setInvisibleList(NIL);
  VI_privacy, VI_normal:
    begin
    ICQ.setVisibleList(visibleList);
    ICQ.setInvisibleList(invisibleList);
    end;
  end;
end; // updateICQvisibility

function findViewInfo(c:Tcontact):TviewInfoFrm;
var
  i:integer;
begin
with childWindows do
  begin
  i:=0;
  while i < count do
    begin
    if Tobject(items[i]) is TviewInfoFrm then
      begin
      result:=TviewInfoFrm(items[i]);
      if result.contact.equals(c) then
        exit;
      end;
    inc(i);
    end;
  end;
result:=NIL;
end; // findViewInfo

function findAuthReq(c:Tcontact):TauthreqFrm;
var
  i:integer;
begin
with childWindows do
  begin
  i:=0;
  while i < count do
    begin
    if Tobject(items[i]) is TauthreqFrm then
      begin
      result:=TauthreqFrm(items[i]);
      if result.contact.equals(c) then
        exit;
      end;
    inc(i);
    end;
  end;
result:=NIL;
end; // findAuthreq

procedure ShowSplash;
var
  region:HRGN;
begin
region:=getRegion(getPic(PIC_SPLASH));
splashFrm:=TForm.create(application);
with splashFrm do
  begin
  color:=clBlack;
  position:=poScreenCenter;
  Width:=getPic(PIC_SPLASH).width;
  Height:=getPic(PIC_SPLASH).height;
  borderstyle:=bsNone;
  SetWindowRgn(handle,region,TRUE);
  onPaint:=mainfrm.splashPaint;
  show;
  repaint;
  end;
end; // ShowSplash

function viewTextWindow(title,body:string):Tform;
var
  form:Tform;
  memo:Tmemo;
begin
form:=Tform.create(mainFrm);
result:=form;
form.caption:=title;
form.position:=poDefaultPosOnly;
memo:=Tmemo.create(form);
memo.parent:=form;
memo.text:=body;
memo.align:=alClient;
memo.ScrollBars:=ssBoth;
memo.WordWrap:=FALSE;
with desktopworkarea do
  begin
  form.width:=(right-left) div 2;
  form.height:=(bottom-top) div 2;
  end;
applyTaskButton(form);
form.show;
end; // viewTextWindow

function viewHeventWindow(ev:Thevent):Tform;
begin
result:=NIL;
if ev=NIL then exit;
result:=viewTextWindow(ev.getHeaderText, ev.getBodyText);
result.icon:=ev.ico;
end; // viewHeventWindow

function savedlg(parent:Tform; ext:string):string;
var
  dlg:TsaveDialog;
begin
dlg:=TsaveDialog.create(parent);
dlg.DefaultExt:=ext;
if ext > '' then
  dlg.Filter:='*.'+ext+'|*.'+ext+'|'+___('all files')+'|*.*'
else
  dlg.Filter:=___('all files')+'|*.*';
dlg.options:=[ofOverwritePrompt,ofPathMustExist,ofEnableSizing ];
if dlg.Execute then
  result:=dlg.filename
else
  result:='';
dlg.free;
end; // savedlg

function opendlg(parent:Tform; ext:string):string;
var
  dlg:TopenDialog;
begin
dlg:=TopenDialog.create(parent);
dlg.DefaultExt:=ext;
if ext > '' then
  dlg.Filter:='*.'+ext+'|*.'+ext+'|'+___('all files')+'|*.*'
else
  dlg.Filter:=___('all files')+'|*.*';
dlg.options:=[ofFileMustExist,ofEnableSizing];
if dlg.Execute then
  result:=dlg.filename
else
  result:='';
dlg.free;
end; // opendlg

function ABCD_ADCB(d:dword):dword; assembler;
asm
mov EAX, d
ror EAX, 16
ror AX, 8
rol EAX, 16
ror AX, 8
rol EAX, 8
end; // ABCD_ADCB

function color2str(color:Tcolor):string;
begin
color:=ABCD_ADCB(ColorToRGB(color));
result:=intToHex(color,6);
end; // color2str

function str2color(s:string):Tcolor;
begin
if length(s) = 0 then
  result:=-1
else
  if s[1]='$' then
    result:=ABCD_ADCB(stringToColor(s))
  else
    if (length(s) > 2) and (upcase(s[1])='C') and (upcase(s[2])='L') then
      result:=stringToColor(s)
    else
      result:=ABCD_ADCB(stringToColor('$'+s))
end; // str2color

function str2html(s:string):string;
begin
result:=template(s, [
  '<', '&lt;',
  '>', '&gt;',
  #13#10, '<br>',
  #13, '<br>',
  #10, '<br>'
]);
end; // str2html

function boundInt(var i:integer; min,max:integer):integer;
begin
if i > max then i:=max;
if i < min then i:=min;
result:=i;
end; // boundInt

procedure restoreForeWindow;
begin
if oldForewindow=0 then exit;
bringForeground:=oldForeWindow;
oldForewindow:=0;
end; // restoreForeWIndow

procedure applyTransparency(forced:integer=-1);
var
  bak:Thandle;
begin
if not running then exit;
bak:=mainfrm.handle;
mainfrm.alphablend:=transparency.forRoaster or (forced>0);
chatfrm.alphablend:=transparency.forChat or (forced>0);
if mainfrm.alphablend then
  if forced >= 0 then
  	begin
    mainfrm.alphablendvalue:=forced;
    chatfrm.alphablendvalue:=forced
    end
  else
  	begin
    chatFrm.AlphaBlendValue:=transparency.active;
    if mainFrm.handle=getForegroundWindow then
      mainfrm.alphablendvalue:=transparency.active
    else
      mainfrm.alphablendvalue:=transparency.inactive;
    end;
if bak<>mainfrm.handle then mainfrmHandleUpdate;
end; // applyTransparency

procedure viewinfoAbout(c:Tcontact);
var
  vi:TviewInfoFrm;
begin
vi:=findViewInfo(c);
if vi = NIL then
  TviewinfoFrm.doAll(mainFrm, c)
else
  vi.bringToFront;
end;

function findInStrings(s:string;ss:Tstrings):integer;
begin
result:=0;
while result < ss.count do
  if ss[result] = s then
    exit
  else
    inc(result);
result:=-1;
end; // findInStrings

function findInStrings(s:string;ss:array of string):integer;
begin
result:=0;
while result < length(ss) do
  if ss[result] = s then
    exit
  else
    inc(result);
result:=-1;
end; // findInStrings

function findInStrings(s,ss,separator:string):integer;
begin
result:=0;
while ss>'' do
  if chop(separator,ss) = s then
    exit
  else
    inc(result);
result:=-1;
end; // findInStrings

function loadFile(fn:string):string;
var
  f:file;
begin
result:='';
IOresult;
assignFile(f,fn);
reset(f,1);
if IOresult <> 0 then exit;
setLength(result, fileSize(f));
blockRead(f, result[1], length(result));
closeFile(f);
end; // loadFile

function saveFile(fn:string; data:string):boolean;
var
  f:file;
begin
result:=FALSE;
if fn='' then exit;
IOresult;
assignFile(f,fn);
rewrite(f,1);
if IOresult <> 0 then exit;
blockWrite(f, data[1], length(data));
if IOresult <> 0 then exit;
closeFile(f);
result:=TRUE;
end; // saveFile

function writeInFile(var f:file; data:string):boolean;
begin
IOresult;
blockWrite(f, data[1], length(data));
result:=IOresult=0;
end; // writeInFile

function writeInFile(var f:file; pos:integer; data:string):boolean;
var
  old:integer;
begin
IOresult;
old:=filepos(f);
seek(f,pos);
blockWrite(f, data[1], length(data));
result:=IOresult=0;
seek(f,old);
end; // writeInFile

function appendFile(fn:string; data:string):boolean;
var
  f:file;
begin
IOresult;
assignFile(f,fn);
reset(f,1);
if IOresult <> 0 then
  rewrite(f,1)
else
  seek(f,fileSize(f));
blockWrite(f, data[1], length(data));
closeFile(f);
result:=IOresult=0;
end; // appendFile

function sizeOfFile(fn:string):integer;
var
  f:file;
  bak:integer;
begin
IOresult;
assignFile(f,fn);
bak:=fileMode;
filemode:=0;
reset(f,1);
filemode:=bak;
result:=filesize(f);
closeFile(f);
if IOresult<>0 then result:=-1;
end; // sizeOfFile

function loadDB:boolean;
begin
freeDB(contactsDB);
contactsDB:=str2db(loadFile(userPath+dbFileName), result)
end; // loadDB

procedure saveDB;
begin
saveFile(userPath+dbFileName, db2str(contactsDB))
end;

function compContacts(Item1, Item2: Pointer):Integer;
begin result:=compareText(Tcontact(item1).displayed, Tcontact(item2).displayed) end;

procedure sortCL(cl:TcontactList);
begin cl.sort(compContacts) end;

function compContactsByGroup(Item1, Item2: Pointer):Integer;
var
  c1,c2:Tcontact;
begin
c1:=Tcontact(item1);
c2:=Tcontact(item2);
if c1.group < c2.group then
  result:=-1
else
  if c1.group > c2.group then
    result:=+1
  else
    result:=compareText(c1.displayed, c2.displayed);
end; // compContacts

procedure sortCLbyGroups(cl:TcontactList);
begin cl.sort(compContactsByGroup) end;

//////////////////////////////////////////////////////////////////////////

procedure drawTiled(canvas:Tcanvas; bmp:Tbitmap);
begin
with canvas do
  begin
  brush.bitmap:=bmp;
  fillRect(clipRect);
  end;
end; // drawTiled

function isTopMost(frm:Tform):boolean;
begin
//result:=frm.FormStyle=fsStayOnTop
result:=getWindowLong(frm.handle, GWL_EXSTYLE) and WS_EX_TOPMOST > 0
end; // isTopMost

function setTopMost(frm:Tform; val:boolean):boolean;
//begin frm.FormStyle:=fsStayOnTop;
var
  i:integer;
begin
with frm do
  begin
  i:=getWindowLong(Frm.handle, GWL_EXSTYLE);
  if val then
    begin
    result:=setWindowLong(handle, GWL_EXSTYLE,  i or WS_EX_TOPMOST) = i;
    SetWindowPos(Handle, HWND_TOPMOST, 0,0,0,0, SWP_NOMOVE+SWP_NOSIZE+SWP_NOACTIVATE)
    end
  else
    begin
    result:=setWindowLong(handle, GWL_EXSTYLE,  i and not WS_EX_TOPMOST) = i;
    SetWindowPos(Handle, HWND_NOTOPMOST, Left, Top, Width, Height, SWP_NOMOVE+SWP_NOSIZE+SWP_NOACTIVATE);
    end;
  end;
end; // setTopMost

function matches(s:string; from:integer; sub:string):boolean;
begin result:=sub=copy(s,from,length(sub)) end;

function Imatches(s:string; from:integer; sub:string):boolean;
begin result:=compareText(sub,copy(s,from,length(sub)))=0 end;

function formVisible(frm:Tform):boolean;
begin result:=(frm<>NIL) and isWindowVisible(frm.handle) end;

procedure hideForm(frm:Tform);
begin
if frm=NIL then exit;
if frm = mainFrm then
  begin
  if formvisible(mainfrm) then mainfrm.toggleVisible;
  exit;
  end;
frm.hide;
ShowWindow(application.handle,SW_HIDE)
end;

procedure showForm(frm:Tform);
begin
if frm=NIL then exit;
if frm = mainFrm then
  begin
  if not formvisible(mainfrm) then mainfrm.toggleVisible;
  exit;
  end;
frm.show;
ShowWindow(application.handle,SW_HIDE)
end;

procedure showForm(whatForm:TwhatForm);
var
  frm:^Tform;
  frmclass:TcomponentClass;
begin
case whatForm of
  WF_PREF: begin frmclass:=TprefFrm; frm:=@prefFrm end;
  WF_USERS: begin frmclass:=TusersFrm; frm:=@usersFrm end;
  WF_WP: begin frmclass:=TwpFrm; frm:=@wpFrm end;
  else exit;
  end;
if frm^=NIL then
  begin
  application.createForm(frmclass, frm^);
  applyCommonsettings(frm^);
  translateWindow(frm^);
  end;
showForm(frm^);
end; // showPref

function showUsers:integer;
begin
application.createForm(TusersFrm, usersFrm);
applyCommonsettings(usersFrm);
translateWindow(usersFrm);
result:=usersFrm.doSelect;
freeandNIL(usersFrm);
end; // showUsers

function desktopWorkArea:Trect;
begin SystemParametersInfo(SPI_GETWORKAREA,0,@result,0) end;

procedure toggleAutosize;
begin
autosizeRoaster:=not autosizeRoaster;
if assigned(prefFrm) then prefFrm.resetAutosize();
autosizeDelayed:=TRUE;
end; // toggleAutosize

procedure toggleShowGroups;
begin
showGroups:=not showGroups;
if assigned(prefFrm) then prefFrm.designFr.groupsChk.checked:=showGroups;
roasterRebuildDelayed:=TRUE;
end;

procedure updateViewInfo(c:Tcontact);
begin
if not updateViewInfoQ.exists(c) then
  updateViewInfoQ.add(c);
end;

function strings2str(split:string; ss:array of string):string;
var
  i:integer;
begin
result:='';
if length(ss)=0 then exit;
for i:=0 to length(ss)-2 do
  result:=result+ss[i]+split;
result:=result+ss[length(ss)-1];
end;

function strings2str(split:string; ss:Tstrings):string;
var
  i:integer;
begin
result:='';
i:=0;
while i < ss.count-1 do
  begin
  result:=result+ss[i]+split;
  inc(i);
  end;
// the last one without split
if ss.count > 0 then
  result:=result+ss[ss.count-1]
end; // strings2str

procedure str2strings(split, src:string; var ss:Tstrings);
var
  i:integer;
begin
ss.clear;
while src > '' do
  begin
  i:=pos(split,src);
  if i=0 then i:=length(src)+1;
  ss.add( copy(src,1,i-1) );
  delete(src, 1, i+length(split)-1);
  end;
end; // strings2str

function ForceForegroundWindow(hwnd:THandle; doRestore:boolean=TRUE):boolean;
const
  SPI_GETFOREGROUNDLOCKTIMEOUT = $2000;
  SPI_SETFOREGROUNDLOCKTIMEOUT = $2001;
var
  ForegroundThreadID: DWORD;
  ThisThreadID : DWORD;
  timeout : DWORD;
begin
result:=FALSE;
if IsIconic(hwnd) and isWindowVisible(hwnd) then
  if doRestore then
    ShowWindow(hwnd, SW_RESTORE)
  else
    exit;

if GetForegroundWindow = hwnd then
  begin
  result:=TRUE;
  exit;
  end;
// Windows 98/2000 doesn't want to foreground a window when some other
// window has keyboard focus
if ((Win32Platform = VER_PLATFORM_WIN32_NT) and (Win32MajorVersion > 4)) or
   ((Win32Platform = VER_PLATFORM_WIN32_WINDOWS) and
   ((Win32MajorVersion > 4) or ((Win32MajorVersion = 4) and
   (Win32MinorVersion > 0)))) then
   begin
   ForegroundThreadID:=GetWindowThreadProcessID(GetForegroundWindow,nil);
   ThisThreadID:=GetWindowThreadPRocessId(hwnd,nil);
   if AttachThreadInput(ThisThreadID, ForegroundThreadID, true) then
     begin
     BringWindowToTop(hwnd); // IE 5.5 related hack
     SetForegroundWindow(hwnd);
     AttachThreadInput(ThisThreadID, ForegroundThreadID, false);
     end;
   if GetForegroundWindow<>hwnd then
     begin
     SystemParametersInfo(SPI_GETFOREGROUNDLOCKTIMEOUT, 0, @timeout, 0);
     SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, NIL,SPIF_SENDCHANGE);
     BringWindowToTop(hwnd); // IE 5.5 related hack
     SetForegroundWindow(hWnd);
     SystemParametersInfo(SPI_SETFOREGROUNDLOCKTIMEOUT, 0, TObject(timeout), SPIF_SENDCHANGE);
     end;
  end
else
  begin
  BringWindowToTop(hwnd); // IE 5.5 related hack
  SetForegroundWindow(hwnd);
  end;
Result := (GetForegroundWindow = hwnd);
end; // ForceForegroundWindow

procedure saveInbox;
begin saveFile( userPath+inboxFilename, eventQ.toString ) end;

procedure loadInbox;
begin
eventQ.fromString( loadFile(userPath+inboxFilename) );
eventQ.removeExpiringEvents;
end;

procedure saveOutbox;
begin saveFile( userPath+outboxFilename, outbox.toString ) end;

procedure loadOutbox;
begin outbox.fromString( loadFile(userPath+outboxFilename) ) end;

function dt2str(dt:Tdatetime):string;
begin
setLength(result, 8);
move(dt, result[1], 8);
end;

function dupString(s:string):string;
begin result:=copy(s,1,length(s)) end;

function decritted(s:string; key:integer):string;
begin
result:=dupString(s);
decritt(result, key);
end;

function critted(s:string; key:integer):string;
begin
result:=dupString(s);
critt(result, key);
end;

procedure critt(var s:string; key:integer);
  asm
  mov ecx, key
  mov dl, cl
  shr ecx, 20
  mov dh, cl

  mov esi, s
  mov esi, [esi]
  or  esi, esi    // nil string
  jz  @OUT

  mov ecx, [esi-4]   // length
  or  ecx, ecx
  jz  @OUT
  mov ah, 10111000b
@IN:
  mov al, [esi]
  add al, dl
  xor al, dh
  ror al, 3
  xor al, ah

  mov [esi], al
  inc esi
  ror ah, 3
  dec ecx
  jnz @IN
@OUT:
  end; // critt

procedure decritt(var s:string; key:integer);
  asm
  mov ecx, key
  mov dl, cl
  shr ecx, 20
  mov dh, cl

  mov esi, s
  mov esi, [esi]
  or  esi, esi    // nil string
  jz  @OUT
  mov ah, 10111000b

  mov ecx, [esi-4]
  or  ecx, ecx
  jz  @OUT
@IN:
  mov al, [esi]
  xor al, ah
  rol al, 3
  xor al, dh
  sub al, dl

  mov [esi], al
  inc esi
  ror ah, 3
  dec ecx
  jnz @IN
@OUT:
  end; // decritt

function sendICQmsg(oe:TOevent):boolean;
var
  c:Tcontact;
  ev:THevent;
begin
c:=contactsDB.get(oe.uin);

{if (c.lastPriority>0) and (c.status in [SC_dnd,SC_occupied]) then
  oe.flags:=oe.flags or c.lastPriority;}
oe.flags:=oe.flags or IF_urgent;

if oe.flags and IF_multiple > 0 then
  oe.flags:=oe.flags or IF_noblink and not IF_urgent;

plugins.castEv( PE_MSG_SENT, c.uin,oe.flags,oe.info);
oe.id:=ICQ.sendMsg(c.uin,oe.flags,oe.info,result);
oe.timeSent:=now;
if result then acks.add(oe);
ev:=Thevent.new(EK_MSG, ICQ.myinfo, oe.timeSent, oe.info, oe.flags);
writeHistorySafely(ev, c);
chatFrm.addEvent_openchat(c, ev);
end; // sendICQmsg

procedure sendICQaddedYou(uin:integer);
var
  c:Tcontact;
  ev:THevent;
begin
c:=contactsDB.get(uin);
plugins.castEv( PE_ADDEDYOU_SENT, uin);
ICQ.sendAddedYou(uin);
ev:=Thevent.new(EK_ADDEDYOU, ICQ.myinfo, now, '', 0);
writeHistorySafely(ev, c);
chatFrm.addEvent_openchat(c, ev);
end; // sendICQaddedYou

procedure sendICQcontacts(uin,flags:integer; cl:TcontactList);
var
  ev:THevent;
  c:Tcontact;
begin
c:=contactsDB.get(uin);
plugins.castEv( PE_CONTACTS_SENT, uin,flags,cl);
ICQ.sendContacts(uin,flags,cl);
ev:=Thevent.new(EK_CONTACTS, ICQ.myinfo, now, cl.tostring, flags);
writeHistorySafely(ev, c);
chatFrm.addEvent_openchat(c, ev);
end; // sendICQcontacts

procedure sendICQauth(uin:integer);
var
  c:Tcontact;
  ev:THevent;
begin
c:=contactsDB.get(uin);
plugins.castEv( PE_AUTH_SENT, uin);
ICQ.sendAuth(uin);
ev:=Thevent.new(EK_auth, ICQ.myinfo, now, '', 0);
writeHistorySafely(ev, c);
chatFrm.addEvent_openchat(c, ev);
end; // sendICQauth

procedure sendICQauthDenied(uin:integer; msg:string='');
var
  c:Tcontact;
  ev:THevent;
begin
c:=contactsDB.get(uin);
plugins.castEv( PE_AUTHDENIED_SENT, uin,msg);
ICQ.sendAuthDenied(uin,msg);
ev:=Thevent.new(EK_authDenied, ICQ.myinfo, now, msg, 0);
writeHistorySafely(ev, c);
chatFrm.addEvent_openchat(c, ev);
end; // sendICQauthDenied

procedure sendICQautomsgreq(uin:integer);
var
  oe:Toevent;
begin
oe:=Toevent.create;
oe.kind:=OE_automsgreq;
oe.uin:=uin;
oe.timeSent:=now;
oe.ID:=ICQ.sendAutoMsgReq(uin);
plugins.castEv( PE_AUTOMSG_REQ_SENT, uin);
acks.add(oe);
end; // sendICQautomsgreq

function sendICQfiles(uin:integer; files:string):integer;
var
  ss:Tstrings;
  i,size:integer;
begin
size:=0;
ss:=TstringList.create;
ss.Text:=files;
for i:=0 to ss.Count-1 do
  inc(size, sizeOfFile(ss[i]));
if ss.count=1 then
  result:=ICQ.sendFileReq(uin,'PROVA!',extractFileName(ss[0]), size)
else
  result:=ICQ.sendFileReq(uin,'PROVA!', intToStr(ss.count)+' files', size);
ss.free;
end; // sendICQfiles

procedure openSendContacts(dest:Tcontact);
var
  wnd:TselectContactsFrm;
begin
wnd:=TselectContactsFrm.doAll( mainFrm,
                              ___('send contacts title',[dest.displayed]),
                              ___('send contacts button'),
                              notInList.clone.add(icq.readroaster),
                              mainFrm.sendContactsAction,
                              [sco_multi,sco_groups,sco_predefined]
                              );
wnd.icon:=getIco(ICO_CONTACTS);
wnd.extra:=Tincapsulate.anInt(dest.uin);
end; // openSendContacts

function isEmailAddress(s:string; start:integer):integer;
const
  emailChar=['a'..'z','A'..'Z','0'..'9','-','_','.'];
var
  j:integer;
  existsDot:boolean;
begin
result:=-1;
if s[start] in emailChar then   // chi comincia bene...
  begin
  // try to find the @
  j:=start+1;
  while (j < length(s)) and (s[j] in emailChar) do
    inc(j);
  if s[j]='@' then
    begin
    // @ found, now skip the @ and search for .
    inc(j);
    existsDot:=FALSE;
    while (j < length(s)) and (s[j+1] in emailChar) do
      begin
      if s[j]='.' then
        begin
        existsDot:=TRUE;
        break;
        end;
      inc(j);
      end;
    if existsDot and (s[j] in emailChar) then // at least a valid char after the . must exists
      begin
        repeat
        inc(j);
        until (j > length(s)) or not  (s[j] in emailChar); // go forth till we're out or we meet an invalid char
      result:=j-1;
      end;
    end;
  end;
end; // isEmailAddress

procedure notAvailable;
begin msgDlg(___('not available yet'),mtInformation) end;

procedure clearMenu(root:Tmenuitem);
var
  i:integer;
begin
i:=root.count-1;
while i >= 0 do
  begin
  clearmenu(root.Items[i]);
  root.Delete(i);
  dec(i);
  end;
end; // clearMenu

function getURLfromFav(fn:string):string;
var
  f:TextFile;
  s:string;
begin
result:='';
assignFile(f,fn);
reset(f);
while not eof(f) do
  begin
  readln(f,s);
  if s='[InternetShortcut]' then
    begin
    readln(f,s);
    result:=copy(s,5,length(s));
    break;
    end;
  end;
closeFile(f);
end; // getURLfromFav

function dupAmperstand(s:string):string;
var
  i,last:integer;
begin
result:='';
last:=1;
for i:=1 to length(s) do
  if s[i]='&' then
    begin
    result:=result+copy(s,last,i-last+1)+'&';
    last:=i+1;
    end;
if last<=length(s) then
  result:=result+copy(s,last,length(s)-last+1);
end; // dupAmperstand

procedure createFavMenuFrom(path:String; root:TMenuItem; action:TnotifyEvent );
var
  sr:TSearchRec;
  item:TMenuItem;
Begin
path:=IncludeTrailingPathDelimiter(path);
if findFirst( path+'*.*', faDirectory, sr ) = 0 then
  repeat
  if sr.attr and faDirectory <> 0 then
    begin
    if (sr.name='.') or (sr.name='..') then continue;
    item:=TMenuItem.Create( mainFrm );
    item.caption:=dupAmperstand(sr.name);
    item.tag:=PIC_CLOSE_GROUP;
    root.add(item);
    createFavMenuFrom(path+sr.name, item, action);
    continue;
    end;
  if compareText(copy(sr.name, length(sr.name)-3, 4), '.url')=0 then
    begin
    item:=TMenuItem.Create( mainFrm );
    item.caption:=dupAmperstand(copy(sr.name, 1, length(sr.name)-4));
    item.tag:=PIC_URL;
    item.hint:=path+sr.name;
    item.onClick:=action;
    root.add(item);
    end;
  until findNext(sr) <> 0;
findClose( SR );
end; // createFavMenuFrom

function getSpecialFolder(what:string):string;
const
  keyName='Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders';
var
  reg:Tregistry;
begin
result:='';

reg:=Tregistry.create;
if reg.openKey(keyName, FALSE) then
  begin
  result:=IncludeTrailingPathDelimiter(reg.readString(what));
  reg.closeKey;
  end;
reg.free;
end; // getSpecialFolder

procedure createFavMenu(root:Tmenuitem; action:TnotifyEvent);
begin createFavMenuFrom(getSpecialFolder('Favorites'), root, action) end;

function validFilename(s:string):string;
const
  invalid='\/:*?"<>|';
var
  i:integer;
begin
result:=s;
i:=length(result);
while i > 0 do
  begin
  if pos(result[i], invalid) > 0 then
    delete(result,i,1);
  dec(i);
  end;
end; // validFilename 

procedure addLinkToFavorites(link:string);
var
  s:string;
  f:textFile;
begin
s:=getSpecialFolder('Favorites')+'\'+___('favorites folder');
mkdir(s);
IOresult;
assignFile(F,IncludeTrailingPathDelimiter(s)+validFilename(link)+'.url');
rewrite(f);
writeln(f,'[InternetShortcut]');
writeln(f,'URL='+link);
closeFile(f);
end; // addLinkToFavorites

procedure redrawUIN(uin:integer);
begin roasterLib.redraw(contactsDB.get(uin)) end;

function childParent(child,parent:integer):boolean;
begin
result:=TRUE;
  repeat
  if child = parent then
    exit;
  child:=getParent(child);
  until child=0;
result:= parent=0;
end; // childParent

procedure myBeep;
begin if playSounds then beep end;

function passCrypt(s:string):string;
var
  i:integer;
begin
result:='';
randSeed:=55555;
i:=length(s);
while i > 0 do
  begin
  inc(randSeed, ord(s[i]));
  dec(i);
  end;

i:=length(s);
while i > 0 do
  begin
  result:=result+char(40+ord(s[i]) and 15)+char(40+ord(s[i]) shr 4)+char(35+random(35));
  while random(3) <> 0 do
    result:=result+char(70+random(250-70));
  dec(i);
  end;
end; // passCrypt

function passDecrypt(s:string):string;
var
  i:integer;
begin
result:='';
i:=length(s);
while i > 0 do
  begin
  if s[i] < #70 then
    begin
    result:=result+char((ord(s[i-1])-40) shl 4+ord(s[i-2])-40);
    dec(i,2);
    end;
  dec(i);
  end;
end; // passDecrypt

function blend(c1,c2:Tcolor; left:real):Tcolor;
var
  right:real;
begin
right:=1-left;
c1:=colorToRGB(c1);
c2:=colorToRGB(c2);
result:=rgb(
  round(left*(c1 and $FF)+right*(c2 and $FF)),
  round(left*(c1 shr 8 and $FF)+right*(c2 shr 8 and $FF)),
  round(left*(c1 shr 16)+right*(c2 shr 16))
);
end; // blend

function traspBmp(bmp:Tbitmap; bg:Tcolor; transpLevel:integer):Tbitmap;
var
  a,t:Tcolor;
  x,y, r,g,b:integer;
begin
result:=Tbitmap.create;
result.assign(bmp);
bg:=colorToRGB(bg);
r:=transpLevel*(bg and $FF);
g:=transpLevel*(bg shr 8 and $FF);
b:=transpLevel*(bg shr 16);
bg:=r+g+b;
t:=result.TransparentColor and $FFFFFF;
with result.Canvas do
  for x:=0 to result.width-1 do
    for y:=0 to result.height-1 do
      begin
      a:=Pixels[x,y] and $FFFFFF;
      if a=t then continue;
      r:=a and $FF;
      g:=a shr 8 and $FF;
      b:=a shr 16;
      a:=(r+g+b+bg) div ((transpLevel+1)*3);
      pixels[x,y]:=rgb(a,a,a);
      end;
result.transparent:=bmp.transparent;
result.transparentcolor:=bmp.transparentcolor;
end; // traspBmp

function whatStatusPanel(statusbar:Tstatusbar; x:integer):integer;
var
  x1:integer;
begin
result:=0;
x1:=statusbar.panels[0].width;
while (x > x1) and (result<statusbar.Panels.Count-1) do
  begin
  inc(result);
  inc(x1, statusbar.panels[result].width);
  end;
end; // whatStatusPanel

function sendEmailTo(c:Tcontact):boolean;
begin
result:=c.email > '';
if result then exec('mailto:'+c.email);
end; // sendEmailTo

procedure drawTxt(hnd:Thandle; x,y:integer; s:string);
begin textOut(hnd, x,y, pchar(s), length(s)) end;

procedure drawTxtL(hnd:Thandle; x,y:integer; s:pchar; L:integer);
begin textOut(hnd, x,y, pchar(s), L) end;

function txtSize(hnd:Thandle; s:string):Tsize;
begin GetTextExtentPoint32(hnd,pchar(s),length(s),result) end;

function txtSizeL(hnd:Thandle; s:pchar; L:integer):Tsize;
begin GetTextExtentPoint32(hnd,s,l,result) end;

procedure addGroupsToMenu(own:Tcomponent; mi:Tmenuitem; action:TnotifyEvent);
var
  item:Tmenuitem;
  i:integer;
  ss:Tstringlist;
begin
mi.clear;
item:=TmenuItem.Create(own);
item.OnClick:=action;
item.caption:=___('out of groups');
item.tag:=2000;
mi.add(item);

item:=TmenuItem.Create(own);
item.caption:='-';
mi.add(item);

ss:=Tstringlist.create;
for i:=0 to groups.count-1 do
  ss.AddObject(groups.a[i].name, Tobject(groups.a[i].id));
ss.sort;
for i:=0 to ss.Count-1 do
  begin
  item:=TmenuItem.Create(own);
  item.OnClick:=action;
  item.caption:=ss[i];
  item.tag:=integer(ss.objects[i]);
  mi.add(item);
  end;
ss.free;
end; // addGroupsToMenu

procedure addSmilesToMenu(own:Tcomponent; mi:Tmenuitem; action:TnotifyEvent);
var
  item:Tmenuitem;
  i,n:integer;
begin
mi.clear;
n:=0;
for i:=0 to theme.smiles.n-1 do
  begin
  if i=32 then continue;
  if i>0 then with theme.smiles do if pics[i]=pics[i-ifThen(i=33,2,1)] then continue;
  item:=TmenuItem.Create(own);
  item.OnClick:=action;
  item.caption:=theme.smiles.ascii[i];
  item.tag:=4000+i;
  if n mod 10=0 then item.Break:=mbBarBreak;
  mi.add(item);
  item.Default:=FALSE;
  inc(n);
  end;
end; // addSmilesToMenu

function mousePos:Tpoint;
begin getCursorPos(result) end;

function into(p:Tpoint; r:Trect):boolean;
begin result:=(r.Left <= p.x) and (r.right >= p.x) and (r.top <= p.y) and (r.bottom >= p.y) end;

function max(a,b:double):double;
begin if a > b then result:=a else result:=b end;

function min(a,b:double):double;
begin if a < b then result:=a else result:=b end;

function color2hls(clr:Tcolor):Thls;
var
  r,g,b,a,z,d:double;
begin
clr:=colorToRGB(clr);
r:=GetRvalue(clr)/255;
g:=GetGvalue(clr)/255;
b:=GetBvalue(clr)/255;
a:=min(min(r,g),b);
z:=max(max(r,g),b);
d:=z-a;
with result do
  begin
  l:=z;
  if d=0 then
    begin
    h:=0;
    s:=0;
    exit;
    end;
  //if l < 0.5 then s:=d/(z+a) else s:=d/(2-z-a);
  if z=0 then s:=0 else result.s:=d/z;
  if r=z then h:=(g-b)/d;
  if g=z then h:=2+(b-r)/d;
  if b=z then h:=4+(r-g)/d;
  end;
end; // color2hls

function hls2color(hls:Thls):Tcolor;
var
  r,g,b, p,q,t:double;
begin
with hls do
  if s = 0 then
    begin
    r:=l;
    g:=l;
    b:=l;
    end
  else
    begin
    p:=l*(1.0-s);
    q:=l*(1.0-(s*frac(h)));
    t:=l*(1.0-(s*(1.0-frac(h))));

    case trunc(h) of
      0:begin r:=l; g:=t; b:=p end;
      1:begin r:=q; g:=l; b:=p end;
      2:begin r:=p; g:=l; b:=t end;
      3:begin r:=p; g:=q; b:=l end;
      4:begin r:=t; g:=p; b:=l end;
      else begin r:=l; g:=p; b:=q end;
      end;
    end;
result:=round(r*255)+round(g*255) shl 8+round(b*255) shl 16;
end; // hls2color

function isSupportedPicFile(fn:string):boolean;
begin
fn:=lowercase(ExtractFileExt(fn));
result:=(fn='.bmp') or (fn='.png')
end; // isSupportedPicFile

function loadPic(fn:string; img:Timage):boolean;
var
  bmp:Tbitmap;
begin
bmp:=createBitmap(1,1);
result:=loadPic(fn, bmp);
img.Picture.Bitmap.assign(bmp);
img.transparent:=bmp.transparent;
img.Width:=img.picture.bitmap.width;
img.height:=img.picture.bitmap.height;
bmp.free;
end; // loadpic

function loadPic(fn:string; bmp:Tbitmap):boolean;
var
  ext:string;
begin
  try
    result:=TRUE;
    if not absPath(fn) then fn:=myPath+fn;
    ext:=extractFileExt(fn);
    if comparetext(ext,'.png')=0 then
      begin
      bmp.Transparent:=FALSE;
      ReadBitmapFromPngFile(fn,bmp);
      bmp.PixelFormat:=pf24bit;
      end
    else
      begin
      if ext <> '.bmp' then fn:=fn+'.bmp';
      bmp.loadFromFile(fn);
      bmp.transparent:=TRUE;
      end;
  except
    result:=FALSE
  end
end; // loadPic

function loadPic(fn:string):Tbitmap;
begin
result:=Tbitmap.create;
loadPic(fn, result);
end; // loadPic

function partDeleteFile(fn:string; from,length:integer):boolean;
const
  bufdim=64*1024;
var
  f:file;
  buf:string;
  dim,i,left:integer;
begin
result:=FALSE;
IOresult;
assignFile(f,fn);
reset(f,1);
if IOresult<>0 then exit;
i:=from;
if length<0 then
  seek(f,from)
else
  begin
  left:=fileSize(f)-from-length;
  setLength(buf, bufdim);
  while left > 0 do
    begin
    seek(f,i+length);
    blockRead(f, buf[1], bufdim, dim);
    seek(f,i);
    blockWrite(f, buf[1], dim);
    inc(i, dim);
    dec(left, dim);
    if IOresult<>0 then exit;
    end;
  if from+length < filesize(f) then
    seek(f,filesize(f)-length)
  else
    seek(f,from);
  end;
truncate(f);
closeFile(f);
result:=IOresult=0;
end; // partDeleteFile

procedure swap(var a,b:integer);
var
  bak:integer;
begin
bak:=a;
a:=b;
b:=bak;
end; // swap

procedure swap(var src,dest; count:dword; cond:boolean);
var
  temp:pointer;
begin
if not cond then exit;
getmem(temp, count);
move(src, temp^, count);
move(dest, src, count);
move(temp^, dest, count);
freemem(temp, count);
{  asm
  mov ESI, src
  mov EDI, dest
  mov ECX, count
@L:
  mov AL, [ESI]
  xchg AL, [EDI]
  mov [ESI], AL
  inc ESI
  inc EDI
  loop @L
  end;}
end; // swapMem

function deleteFromTo(fn:string; from,to_:integer):boolean;
begin result:=partDeleteFile(fn,from,to_-from) end;

function enterUinDlg(var uin:integer; title:string=''):boolean;
var
  res: string;
  i, e: integer;
begin
if title='' then title:='uin';
res:='';
  repeat
  result:=InputQuery(___(title), ___('uin'), res);
  if result then
    begin
    val(trim(res), i, e);
    result:=(e=0) and validUIN(i);
    if result then break
    else msgDlg(___('invalid uin'), mtError)
    end;
  until not result;
end; // enterUinDlg

function enterPwdDlg(var pwd:string; title:string=''; maxLength:integer=0):boolean;
var
  frm: TpwdFrm;
begin
frm:=TpwdFrm.create(NIL);
frm.pwdBox.MaxLength:=maxLength;
translateWindow(frm);
setwindowlong(frm.handle, GWL_HWNDPARENT, 0);
if title > '' then
  frm.caption:=title;
frm.pwdBox.text:='';
bringForeground:=frm.handle;
frm.showModal;
result:= frm.exitCode=pwdDlg.EC_enter;
if result then
  pwd:=trim(frm.pwdBox.text);
frm.Free;
end; // enterPwdDlg

procedure convertHistoriesDlg(oldPwd, newPwd:string);
begin
if oldPwd=newPwd then exit;
if not ICQ.isOffline then
  if messageDlg(___('go offline'),mtConfirmation,[mbYes,mbNo],0)=mrNo then
    exit
  else
    ICQ.disconnect;
chatFrm.closeAllPages;
convhistFrm.oldPwd:=oldPwd;
convhistFrm.newPwd:=newPwd;
convhistFrm.showModal;
end; // convertHistoriesDlg

function calculate_KEY1(pwd:string):integer;
var
  i,L:integer;
  p:^integer;
begin
L:=length(pwd);
result:=L shl 16;
p:=NIL;  // shut up compiler warning
if pwd>'' then p:=@pwd[1];
i:=0;
while i+4 < L do
  begin
  inc(result, p^);
  inc(p);
  inc(i,4);
  end;
while i < L do
  begin
  inc(result, ord(pwd[i]));
  inc(i);
  end;
end; // calculate_KEY1

function addToRoaster(c:Tcontact):boolean;
begin
notInList.remove(c);
result:=ICQ.addContact(c);
if not result then exit;
roasterlib.update(c);
roasterLib.focus(c);
saveListsDelayed:=TRUE;
autosizeDelayed:=TRUE;
plugins.castEvList( PE_LIST_ADD, PL_ROASTER, c);
if c.infoUpdatedTo=0 then ICQ.sendQueryInfo(c.uin);
if sendTheAddedYou then
  outbox.add(OE_addedYou, c.uin);
end; // addToRoaster

function addToRoaster(c:Tcontact; group:integer):boolean;
begin
result:=FALSE;
if c=NIL then exit;
if group=2000 then group:=0;
c.group:=group;
saveGroupsDelayed:=TRUE;
result:=addToRoaster(c) or roasterLib.update(c);
end; // addToRoaster

function addToNIL(c:Tcontact):boolean;
begin
result:=FALSE;
ICQ.removeContact(c);
if not notInList.add(c) then exit;
roasterlib.update(c);
saveListsDelayed:=TRUE;
plugins.castEvList( PE_LIST_ADD, PL_NIL, c);
result:=TRUE;
end; // addToNIL

procedure NILifNIL(c:Tcontact);
begin
if not ICQ.readroaster.exists(c) then
  begin
  addToNIL(c);
  if c.infoUpdatedTo=0 then
    ICQ.sendQueryInfo(c.uin);
  end;
end; // eventFrom

function TLV(code:integer; data:string):string;
begin result:=int2str(code)+int2str(length(data))+data end;

function deltree(path:string):boolean;
var
  sr:TsearchRec;
begin
result:=FALSE;
if (path='') or not directoryExists(path) then exit;
path:=includeTrailingPathDelimiter(path);
if findFirst(path+'*.*', faAnyFile, sr) = 0 then
  repeat
  if (sr.name<>'.') and (sr.name<>'..') then
    if sr.Attr and faDirectory > 0 then
      deltree(path+sr.name)
    else
      deleteFile(path+sr.name);
  until findNext(sr) <> 0;
findClose(sr);
//path:=ExcludeTrailingPathDelimiter(path);
result:=RemoveDir(path);
end; // deltree

function getDefaultBrowser(proto:string='http'):string;
var
  reg:Tregistry;
begin
result:='';
reg:=Tregistry.create;
reg.RootKey:=HKEY_CLASSES_ROOT;
if reg.openKey(proto+'\shell\open\command', FALSE) then
  begin
  result:=reg.readString('');
  reg.closeKey;
  end;
reg.free;
end; // getDefaultBrowser

function statusImgIdx:integer;
begin
if ICQ.isOnline then
  result:=status2imgIdx(status, FALSE)
else
  result:=status2imgIdx(SC_OFFLINE, FALSE)
end; // statusImgIdx

function visibilityImgIdx:integer;
begin result:=visibility2imgIdx(visibility) end;

function status2imgIdx(s:Tstatus; inv:boolean=FALSE):integer;
begin
case s of
  SC_ONLINE: result:=PIC_STATUS_ONLINE;
  SC_occupied: result:=PIC_STATUS_OCCUPIED;
  SC_f4c: result:=PIC_STATUS_F4C;
  SC_dnd: result:=PIC_STATUS_DND;
  SC_na: result:=PIC_STATUS_NA;
  SC_away: result:=PIC_STATUS_AWAY;
  SC_OFFLINE: result:=PIC_STATUS_OFFLINE;
  else
    begin
    result:=PIC_STATUS_UNK;
    exit;
    end;
  end;
if inv then
  inc(result, PIC_INVISIBLE_STATUS_ONLINE-PIC_STATUS_ONLINE);
end; // status2imgdx

function visibility2imgIdx(vi:Tvisibility):integer;
begin result:=PIC_VISIBILITY_NONE+ord(vi) end;

function compareInt(a,b:integer):integer;
begin
if a<b then
  result:=-1
else
  if a>b then
    result:=+1
  else
    result:=0
end; // compareInt

function str2visibility(s:string):Tvisibility;
begin
s:=uppercase(s);
for result:=low(result) to high(result) do
  if compareText(visibility2str[result], s) = 0 then
    exit;
result:=VI_normal; // shut up compiler warning
end; // str2visibility

function addLuminosity(clr:Tcolor; q:real):Tcolor;
var
  hls:Thls;
begin
hls:=color2hls(clr);
with hls do
  begin
  l:=l+q;
  if l<0 then l:=0;
  if l>1 then l:=1;
  end;
result:=hls2color(hls);
end; // addLuminosity

function bool2str(b:boolean):string;
begin result:=char(b) end;

function dontBotherStatus:boolean;
begin result:=ICQ.getStatus in [SC_occupied,SC_dnd] end;

function excludeTrailingCRLF(s:string):string;
begin
result:=s;
if s='' then exit;
if s[length(s)]=#10 then setLength(s,length(s)-1);
if s[length(s)]=#13 then setLength(s,length(s)-1);
result:=s;
end; // excludeTrailingCRLF

procedure showAuthreq(c:Tcontact; msg:string);
var
  ar:TauthreqFrm;
begin
msg:=dupString(msg);
ar:=findAuthreq(c);
if ar = NIL then
  TauthreqFrm.doAll(mainFrm, c, msg)
else
  begin
  ar.msgBox.text:=msg;
  ar.bringToFront;
  end;
end; // showAuthreq

function countContactsIn(st:Tstatus):integer;
var
  cl:Tcontactlist;
  i:integer;
begin
result:=0;
cl:=ICQ.readroaster;
for i:=0 to cl.count-1 do
  if Tcontact(cl[i]).status = st then
    inc(result); 
end; // countContactsIn

procedure toggleOnlyOnline;
begin
roasterLib.setOnlyOnline(not showOnlyOnline);
if assigned(prefFrm) then prefFrm.designFr.onlyonlineChk.checked:=showOnlyOnline;
end;

procedure toggleOnlyImVisibleTo;
begin
showOnlyImvisibleto:=not showOnlyImvisibleto;
updateHiddenNodes;
end; // toggleOnlyImVisibleto

function setAutomsg(s:string):string;
begin
result:=automessages[0];
automessages[0]:=s;
end; // setAutomsg

function getAutomsgFor(c:Tcontact):string;
var
  h:Tdatetime;
begin
if imAwaySince > 0 then
  h:=(now-imAwaySince)*24
else
  h:=0;
result:=template(automessages[0], [
  '%you%',   c.displayed,
  '%nick%',  c.nick,
  '%first%', c.first,
  '%last%', c.last,
  '%ip%', ifThen(c.ip=0,___('unk'),ip2str(c.ip)),
  '%status%', statusName(c.status),
  '%proto%', ifThen(c.proto=0, ___('unk'),  intToStr(c.proto)),
  '%awaysince%', formatDatetime(timeformat.automsg, imAwaySince),
  '%awaysince-gmt%', formatDatetime(timeformat.automsg, imAwaySince-GMToffset),
  '%elapsedhours%', intToStr(trunc(h)),
  '%elapsedminutes%', intToStr(trunc(frac(h)*60)),
  '%h%', intToStr(hourof(now)),
  '%m%', intToStr(minuteof(now)),
  '%s%', intToStr(secondof(now)),
  '%D%', intToStr(dayof(now)),
  '%M%', intToStr(monthof(now)),
  '%Y%', intToStr(yearof(now)),
  '%hh%', intToStr(hourof(now),2),
  '%mm%', intToStr(minuteof(now),2),
  '%ss%', intToStr(secondof(now),2),
  '%DD%', intToStr(dayof(now),2),
  '%MM%', intToStr(monthof(now),2),
  '%onlinecontacts%', intToStr(ICQ.readroaster.count-countContactsIn(SC_OFFLINE)),
  '%offlinecontacts%', intToStr(countContactsIn(SC_OFFLINE)),
  '%events%', intToStr(eventQ.Count)
]);
end; // getAutomsg

function ip2str(ip:integer):string;
begin result:=dword_LE2ip(ip) end;

function str2ip(s:string):integer;
var
  i:integer;
begin
result:=0;
 try
  repeat
  result:=result shl 8;
  i:=pos('.',s);
  if i > 0 then
    begin
    inc(result, strToInt(copy(s,1,i-1)));
    delete(s,1,i);
    end;
  until i = 0;
  inc(result, strToInt(s));
 except
  result:=0;
 end;
end; // str2ip

procedure receiveFile(d:Tdirect);
begin
TfiletransferFrm.doAll(d);
d.connect;
end; // receiveFile

procedure sendfile(c:Tcontact; fn:string);
begin
with TfiletransferFrm.doAll(ICQ.directTo(c)) do
  direct.connect;
end; // sendfile

function hexDump(data:string):string;
const
  cols=16;
var
  ofs,i:integer;
  s,s2:string;
begin
result:='';
ofs:=0;
while ofs < length(data) do
  begin
  s:='';
  s2:='';
  for i:=1 to cols do
    if ofs+i <= length(data) then
      begin
      s:=s+intToHex(ord(data[ofs+i]),2);
      if i=8 then s:=s+'  '
      else s:=s+' ';
      if data[ofs+i] < #32 then s2:=s2+'.'
      else s2:=s2+data[ofs+i];
      end;
  s:=s+stringOfChar(' ',cols*3+4-length(s));
  result:=result+s+s2+CRLF;
  inc(ofs,cols);
  end;
end; // hexDump

procedure check4update;
begin
if mainfrm.httpClient.state <> httpReady then 
  exit;
checkupdate.info:='';
proxysettings(mainfrm.httpClient.CtrlSocket);
mainfrm.httpClient.url:='http://www.rejetto.com/&RQ/updateinfo.txt';
mainfrm.httpClient.Abort;
mainfrm.httpClient.GetASync;
end; // check4update

procedure dockSet(on:boolean);
var
  abd:APPBARDATA;
begin
if on = docking.appBarFlag then exit;
docking.appbarFlag:=on;
abd.cbsize:=sizeOf(abd);
abd.hWnd:=mainfrm.handle;
abd.uCallbackMessage:=WM_DOCK;
if on then
  SHAppBarMessage(ABM_NEW, abd)
else
  SHAppBarMessage(ABM_REMOVE, abd);
end; // dockSet

procedure dockSet;
var
  r:Trect;
begin
if mainfrm=NIL then exit;
r:=mainfrm.boundsrect;
dockset(r);
mainfrm.boundsrect:=r;
end; // dockSet

procedure dockSet(var r:Trect);
var
  w:integer;
begin
if not mainFrm.visible or not running then exit;
dockSet(docking.appBar and docking.active and not docking.tempOff);
if not docking.active then exit;
w:=r.right-r.left;
r:=desktopWorkArea;
if docking.appBar then
  begin
  r.left:=0;
  r.right:=screen.width;
  end;
if docking.pos=DP_left then
  begin
  dec(r.left,getsystemmetrics(SM_CXFRAME));
  r.right:=r.left+w;
  end
else
  begin
  inc(r.right,getsystemmetrics(SM_CXFRAME));
  r.left:=r.right-w;
  end;
appbarResizeDelayed:=TRUE;
end; // dockSet

procedure setAppBarSize;
var
  abd:APPBARDATA;
begin
abd.cbsize:=sizeOf(abd);
abd.hWnd:=mainfrm.handle;
abd.uCallbackMessage:=WM_DOCK;
abd.rc:=mainfrm.boundsrect;
if docking.pos=DP_left then
  abd.uedge:=ABE_LEFT
else
  abd.uedge:=ABE_RIGHT;
SHAppBarMessage(ABM_SETPOS, abd);
end; // setAppBarSize

function trailing(s,ss:string):boolean;
begin result:=ss=copy(s,length(s)-length(ss)+1,length(ss)) end;

procedure fixWindowPos(frm:Tform);
var
  dwa:Trect;
begin
if frm=NIL then exit;
if not doFixWindows or docking.active or (frm.WindowState<>wsNormal) then exit;
dwa:=desktopWorkArea;
if fixingWindows.lastWidth <> dwa.right then
  begin
  if fixingWindows.onTheRight then
    frm.left:=dwa.right-fixingWindows.lastRightSpace;
  fixingWindows.lastWidth:=dwa.right;
  end;
if frm.left < dwa.left then frm.left:=dwa.left+10;
if frm.top < dwa.top then frm.top:=dwa.top+10;
if frm.left > dwa.right-10 then frm.left:=dwa.Right-10;
if frm.top > dwa.bottom-10 then frm.Top:=dwa.bottom-10;
if frm.height > screen.height then frm.height:=screen.height-20;
if frm.width > screen.width then frm.width:=screen.width-20;
fixingWindows.onTheRight:=centerPoint(frm.BoundsRect).x > (screen.Width div 2);
fixingWindows.lastRightSpace:=dwa.right-frm.left;
end; // fixWindowPos

function roasterImgIdxFor(c:Tcontact):integer;
begin
if notinlist.exists(c) then
  result:=status2imgIdx(SC_UNK, FALSE)
else
  result:=status2imgIdx(c.status, c.invisible)
end; // roasterImgIdxFor

function isSpam(c:Tcontact; msg:string=''; flags:dword=0):boolean;
var
  b,filter:boolean;
  s:string;
begin
if spamfilter.ignoreNIL and not roasterLib.exists(c)
or spamfilter.ignorepagers and (IF_pager and flags>0) then
  begin
  result:=TRUE;
  exit;
  end;
result:=FALSE;
filter:=FALSE;
if spamfilter.uingt>0 then
  if c.uin <= spamfilter.uingt then exit
  else filter:=TRUE;
if spamfilter.notnil then
  if roasterLib.exists(c) then exit
  else filter:=TRUE;
if spamfilter.multisend then
  if flags and IF_multiple = 0 then exit
  else filter:=TRUE;
if spamfilter.notEmpty then
  if sizeoffile(userPath+historyPath+intToStr(c.uin)) > 0 then exit
  else filter:=TRUE;
if spamfilter.nobadwords then
  begin
  b:=FALSE;
  s:=spamfilter.badwords;
  while not b and (s>'') do
    b:=ansiContainsText(msg, chop(';',s));
  if b then filter:=TRUE
  else exit;
  end;
result:=filter;
end; // isSpam

function filterRefuse(c:Tcontact; msg:string=''; flags:dword=0):boolean;
begin
result:=TRUE;
if isSpam(c,msg, flags) then
  begin
  if spamfilter.warn then
    msgDlg(___('spam filtered',[c.displayed]),mtInformation);
  exit;
  end;
result:=enableignorelist and ignorelist.exists(c);
end; // filterRefuse

function findSendfile(id:integer):TsendfileFrm;
var
  i:integer;
begin
with childWindows do
  begin
  i:=0;
  while i < count do
    begin
    if Tobject(items[i]) is TsendfileFrm then
      begin
      result:=TsendfileFrm(items[i]);
      if result.id = id then
        exit;
      end;
    inc(i);
    end;
  end;
result:=NIL;
end; // findSendfile

// costants for files
const
  DBFK_UIN         = 00;
  DBFK_NICK        = 01;
  DBFK_FIRST       = 02;
  DBFK_LAST        = 03;
  DBFK_EMAIL       = 04;
  DBFK_CITY        = 05;
  DBFK_STATE       = 06;
  DBFK_ABOUT       = 07;
  DBFK_DISPLAY     = 08;
  DBFK_QUERY       = 09;      
  DBFK_ZIP         = 10;
  DBFK_COUNTRY     = 11;
  DBFK_BIRTH       = 12;
  DBFK_LANG        = 13;
  DBFK_HOMEPAGE    = 14;
  DBFK_CELLULAR    = 15;
  DBFK_IP          = 16;
  DBFK_AGE         = 17;
  DBFK_GMT         = 18;
  DBFK_GENDER      = 19;
  DBFK_GROUP       = 20;
  DBFK_LASTUPDATE  = 21;
  DBFK_LASTONLINE  = 22;
//  DBFK_LASTMSG     = 23;   DON'T USE, it was badly updated
  DBFK_LASTMSG     = 24;
  DBFK_NOTES       = 25;
  DBFK_DONTDELETE  = 26;
  DBFK_ASKEDAUTH   = 27;
  DBFK_MEMBERSINCE = 28;
  DBFK_ONLINESINCE = 29;
  DBFK_SMSABLE     = 30;
  DBFK_NODB        = 31;

function db2str(db:TcontactList):string;

  function languages2str(l:Tlanguages):string;
  begin
  setLength(result, 3);
  move(l, result[1], 3);
  end;

var
  dim:integer;

  procedure addStr(s:string);
  begin
  while dim+length(s) > length(result) do
    setLength(result, length(result)+10000);
  system.move(s[1], result[dim+1], length(s));
  inc(dim, length(s));
  end; // addStr
  
var
  i:integer;
begin
result:='';
dim:=0;

i:=0;
while i < db.count do
  with db.getAt(i) do with TCE(data^) do
    begin
    addStr( TLV(DBFK_UIN, int2str(uin))
      +TLV(DBFK_DISPLAY, display)
      +TLV(DBFK_NICK, nick)
      +TLV(DBFK_FIRST, first)
      +TLV(DBFK_LAST, last)
      +TLV(DBFK_EMAIL, email)
      +TLV(DBFK_CITY, city)
      +TLV(DBFK_STATE, state)
      +TLV(DBFK_ABOUT, about)
      +TLV(DBFK_ZIP, zip)
      +TLV(DBFK_NODB, bool2str(nodb))
      +TLV(DBFK_COUNTRY, int2str(country))
      +TLV(DBFK_BIRTH, dt2str(birth))
      +TLV(DBFK_LANG, languages2str(lang))
      +TLV(DBFK_HOMEPAGE, homepage)
      +TLV(DBFK_CELLULAR, cellular)
      +TLV(DBFK_IP, int2str(ip))
      +TLV(DBFK_AGE, int2str(age))
      +TLV(DBFK_GMT, char(GMThalfs))
      +TLV(DBFK_GENDER, int2str(gender))
      +TLV(DBFK_GROUP, int2str(group))
      +TLV(DBFK_LASTUPDATE, dt2str(infoUpdatedTo))
      +TLV(DBFK_LASTONLINE, dt2str(lastTimeSeenOnline))
      +TLV(DBFK_LASTMSG, dt2str(lastMsgTime))
      +TLV(DBFK_NOTES, notes)
      +TLV(DBFK_DONTDELETE, bool2str(dontdelete))
      +TLV(DBFK_ASKEDAUTH, bool2str(askedAuth))
      +TLV(DBFK_ONLINESINCE, dt2str(onlineSince))
      +TLV(DBFK_MEMBERSINCE, dt2str(memberSince))
      +TLV(DBFK_SMSABLE, bool2str(smsable))
      +TLV(DBFK_QUERY, bool2str(toquery))
    );
    inc(i);
    end;
setLength(result, dim);
end; // db2str

function str2db(s:string):TcontactList;
var
  asd:boolean;
begin
result:=str2db(s,asd)
end;

function str2db(s:string; var ok:boolean):TcontactList;
var
  t,l,i:integer;
  d:string;
  c:Tcontact;
begin
ok:=FALSE;
result:=TcontactList.create;
C:=NIL;  // shut up compiler
i:=0;
while i < length(s) do
  begin
  if length(s)-pred(i) < 8 then
    begin
    msgDlg(___('corrupted database'),mtError);
    exit;
    end;
  t:=dword_LEat(@s[i+1]); // 1234
  l:=dword_LEat(@s[i+5]); // 5678
  if length(s)-pred(i) < l then
    begin
    msgDlg(___('corrupted database'),mtError);
    exit;
    end;
  d:=copy(s,i+9,l);
  case t of
    DBFK_UIN: c:=result.get(str2int(d));
    DBFK_DISPLAY:c.display:=d;
    DBFK_NICK:c.nick:=d;
    DBFK_FIRST:c.first:=d;
    DBFK_LAST:c.last:=d;
    DBFK_EMAIL:c.email:=d;
    DBFK_CITY:c.city:=d;
    DBFK_STATE:c.state:=d;
    DBFK_ABOUT:c.about:=d;
    DBFK_ZIP:c.zip:=d;
    DBFK_NODB: c.nodb:=boolean(d[1]);
    DBFK_COUNTRY:system.move(d[1], c.country, 4);
    DBFK_BIRTH:system.move(d[1], c.birth, 8);
    DBFK_LANG:system.move(d[1], c.lang, 3);
    DBFK_HOMEPAGE:c.homepage:=d;
    DBFK_CELLULAR:c.cellular:=d;
    DBFK_IP:system.move(d[1], c.ip, 4);
    DBFK_AGE:system.move(d[1], c.age, 4);
    DBFK_GMT:system.move(d[1], c.GMThalfs, 1);
    DBFK_GENDER:system.move(d[1], c.gender, 4);
    DBFK_GROUP:system.move(d[1], c.group, 4);
    DBFK_LASTUPDATE:system.move(d[1], c.infoUpdatedTo, 8);
    DBFK_LASTONLINE:system.move(d[1], c.lastTimeSeenOnline, 8);
    DBFK_LASTMSG:system.move(d[1], TCE(c.data^).lastMsgTime, 8);
    DBFK_ONLINESINCE: system.move(d[1], c.onlinesince, 8);
    DBFK_MEMBERSINCE: system.move(d[1], c.membersince, 8);
    DBFK_SMSABLE: c.smsable:=boolean(d[1]);
    DBFK_NOTES: TCE(c.data^).notes:=d;
    DBFK_DONTDELETE: TCE(c.data^).dontdelete:=boolean(d[1]);
    DBFK_ASKEDAUTH: TCE(c.data^).askedAuth:=boolean(d[1]);
    DBFK_QUERY: TCE(c.data^).toquery:=boolean(d[1]);
    end;//case
  inc(i, 8+l);
  end;
ok:=TRUE;
end; // str2db

function str2status(s:string):Tstatus;
begin
s:=uppercase(s);
for result:=low(result) to high(result) do
  if uppercase(status2str[result]) = s then
    exit;
result:=SC_ONLINE; // shut up compiler warning
end; // str2status

function str2int(s:string):integer;
begin result:=dword_LEat(@s[1]) end;

function str2int(p:pointer):integer;
begin result:=dword_LEat(p) end;

procedure clearDB(db:TcontactList);
var
  i:integer;
begin
for i:=0 to db.count-1 do
  with db.getAt(i) do
    free;
db.clear;
end; // clearDB

procedure freeDB(var db:TcontactList);
begin
clearDB(db);
db.free;
db:=NIL;
end; // freeDB

procedure contactCreation(c:Tcontact);
begin
getMem(c.data, sizeof(TCE));
fillChar(c.data^, sizeOf(TCE),0);
TCE(c.data^).toquery:=TRUE;
end;

procedure contactDestroying(c:Tcontact);
begin
freeMem(c.data);
end;

procedure startTimer;
begin mainfrm.timer.enabled:=TRUE end;

procedure stopTimer;
begin mainfrm.timer.enabled:=FALSE end;

function behave(ev:Thevent; kind:integer=-1; info:string=''):boolean;
var
  ok:boolean;
begin
result:=FALSE;
if info > '' then ev.setInfo(info);
if kind > 0 then ev.kind:=kind;

case kind of
  EK_GCARD,
  EK_MSG,
  EK_URL: ok:=not filterRefuse(ev.who,ev.decrittedInfo);
  EK_AUTHREQ: ok:=not (enableignorelist and ignorelist.exists(ev.who));
  else ok:=not filterRefuse(ev.who);
  end;

if not ok then exit;

// prevent annoying fast oncoming/offgoing sequences
if minOnOff then
  if (ev.kind=EK_ONCOMING) and (now-ev.who.lastTimeSeenOnline < minOnOffTime*DTseconds)
  or (ev.kind=EK_OFFGOING) and (now-TCE(ev.who.data^).lastOncoming < minOnOffTime*DTseconds) then
    exit;

result:=TRUE;

TCE(ev.who.data^).lastEventTime:=now;
if ev.kind in [EK_MSG,EK_URL,EK_CONTACTS,EK_auth,EK_authDenied,EK_AUTHREQ] then
  TCE(ev.who.data^).lastMsgTime:=ev.when;
// SOUND
if (BE_sound in behaviour[ev.kind].trig) and not onStatusDisable[icq.myinfo.status].sounds then
  playSound(theme.sounds.onEvent[ev.kind]);
// TIP
if (BE_tip in behaviour[ev.kind].trig) and (ev.flags and IF_offline=0) and not onStatusDisable[icq.myinfo.status].tips then
  tipfrm.show(ev);
// TRAY
if (ev.kind = EK_CONTACTS) and chatFrm.isVisible and (ev.who=chatFrm.thisChat.who) then
  TselectContactsFrm.doAll( mainfrm,___('got contacts title',[ev.who.displayed]),___('got contacts button'), ev.cl.clone, mainfrm.addContactsAction, [])
else
  if BE_tray in behaviour[ev.kind].trig then
    eventQ.add(ev.clone);
    
// SAVE
if logpref.writehistory and (BE_save in behaviour[ev.kind].trig) then
  writeHistorySafely(ev)
else
  ev.fpos:=-1;
// OPENCHAT
if BE_openchat in behaviour[ev.kind].trig then
  if chatFrm.openchat(ev.who) then
    chatFrm.flash;
// HISTORY
if BE_history in behaviour[ev.kind].trig then
  if chatFrm.addEvent(ev.who.uin, ev.clone) then
    chatFrm.flash;
// POP UP
if BE_popup in behaviour[ev.kind].trig then
  if not chatFrm.isVisible then
    chatFrm.openOn(ev.who, focusOnChatPopup);
end; // behave

function beh2str(kind:integer):string;
var
  s:string;
begin
s:='';
if behaviour[kind].tiptimes then s:=s+'times('+intToStr(behaviour[kind].tiptimeplus)+')+';
if BE_tip in behaviour[kind].trig then s:=s+'tip('+intToStr(behaviour[kind].tiptime)+')+';
if BE_tray in behaviour[kind].trig then s:=s+'tray+';
if BE_openchat in behaviour[kind].trig then s:=s+'openchat+';
if BE_save in behaviour[kind].trig then s:=s+'save+';
if BE_sound in behaviour[kind].trig then s:=s+'sound+';
if BE_history in behaviour[kind].trig then s:=s+'history+';
if BE_popup in behaviour[kind].trig then s:=s+'popup+';
delete(s,length(s),1);
result:=s;
end; // beh2str

function str2beh(s:string):Tbehaviour;

  function extractPar(lab:string):string;
  var
    i,j:integer;
  begin
  result:='';
  i:=AnsiPos(lab+'(',s);
  if i > 0 then
    begin
    inc(i,length(lab)+1);
    j:=i;
    while (length(s) > j) and (s[j]<>')') do
      inc(j);
    result:=copy(s,i,j-i);
    end;
  end; // extractPar

begin
result.trig:=[];
s:=ansiLowercase(s);
result.tiptimes:=ansiContainsText(s, 'times');
try result.tiptimeplus:=strToInt(extractPar('times')) except end;
if ansiContainsText(s, 'tip') then include(result.trig, BE_tip);
try result.tiptime:=strToInt(extractPar('tip')) except end;
if ansiContainsText(s, 'tray') then include(result.trig, BE_tray);
if ansiContainsText(s, 'openchat') then include(result.trig, BE_openchat);
if ansiContainsText(s, 'save') then include(result.trig, BE_save);
if ansiContainsText(s, 'sound') then include(result.trig, BE_sound);
if ansiContainsText(s, 'history') then include(result.trig, BE_history);
if ansiContainsText(s, 'popup') then include(result.trig, BE_popup);
end; // str2beh

function getDescForSnac(s:string):string;
begin
case getSnacService(s) of
  $0102:result:='ready';
  $0103:result:='ready';
  $0106:result:='ask rates';
  $0107:result:='rates';
  $0108:result:='rates ack';
  $010A:result:='sending too fast';
  $010E:result:='ask my info';
  $010F:result:='my info';
  $0113:result:='motd';
  $0117:result:='i''m icq';
  $0118:result:='you''re icq';
  $011E:result:='set status';
  $0202:result:='ask location rights';
  $0203:result:='location rights';
  $0204:result:='set capabilities';
  $0205:result:='ask user info';
  $0206:result:='user info';
  $0302:result:='ask buddy rights';
  $0303:result:='buddy rights';
  $0304:result:='+roaster';
  $0305:result:='-roaster';
  $030a:result:='can''t notify';
  $030b:result:='oncoming/new status';
  $030c:result:='offgoing';
  $0401:result:='error msg';
  $0402:result:='ask im rights';
  $0404:result:='ask im rights';
  $0405:result:='im rights';
  $0406:result:='out msg';
  $0407:result:='in msg';
  $040B:result:='ack msg';
  $040C:result:='server ack msg';
  $0902:result:='ask bos rights';
  $0903:result:='bos rights';
  $0905:result:='+visible';
  $0906:result:='-visible';
  $0907:result:='+invisible';
  $0908:result:='-invisible';
  $1502:
    case getMPservice(s) of
      $3C:result:='ask offline msgs';
      $3E:result:='delete offline msgs';
      $D098:result:='xml';
      $D01F,
      $D069:result:='ask short contact info';
      $D0BA:result:='ask short contact info (2001)';
      $D0B2:result:='ask contact info';
      $D015:result:='ask wp (short)';
      $D05F:result:='ask wp (short) (2001)';
      $D033:result:='ask wp (full)';
      $D0D0:result:='ask my contact info';
      $D0EA:result:='save my info (home)';
      $D0FD:result:='save my info (hp/more)';
      $D006:result:='save my info (about)';
      $D0F3:result:='save my info (work)';
      $D00B:result:='save my info (emails)';
      $D02E:result:='change password';
      $D0C4:result:='remove user';
      $D024:result:='set permissions';
      $D082:result:='out sms';
      $D029:result:='search by email';
      $D073:result:='search by email (2001)';
      else result:='out multipurpose';
      end;
  $1503:
    case getMPservice(s) of
      $41:result:='offline msg';
      $42:result:='no more offline msgs';
      $DA9A,
      $DAA4:result:='short contact info';
      $DAAE:result:='short contact info (last)';
      $DAE6:result:='contact info (about)';
      $DAC8:result:='contact info (main)';
      $DADC:result:='contact info (hp)';
      $DAD2:result:='contact info (work)';
      $DA0E:result:='contact info (unk)';
      $DAFA:result:='contact info (past background)';
      $DAF0:result:='contact info (interests)';
      $DAEB:result:='contact info (emails)';
      $DAB4:result:='uin deleted';
      $DAAA:result:='password changed';
      $DA64:result:='info saved (main)';
      $DA78:result:='info saved (hp/more)';
      $DA82:result:='info saved (about)';
      $DA6E:result:='info saved (work)';
      $DA87:result:='info saved (emails)';
      else result:='in multipurpose';
      end;
  else
    if getSnacService(s) and $FF=1 then
      result:=___('error')
    else
      result:=___('unk');
  end;
end; // getDescForSnac

function logTimestamp:string;
begin result:=formatDatetime(timeformat.log, now)+'> ' end;

procedure addToLog(s:string; obj:Tobject);
var
  i:integer;
begin
with logfrm.pktsbox do
  begin
  items.add(s);
  i:=itemIndex;
  items.objects[count-1]:=obj;
  if i = count-2 then itemIndex:=count-1;
  end;
end; // addToLog

procedure loggaPkt(what:TwhatLog; data:string='');
const
  names:array [TwhatLog] of string=('CONNECTED','DISCONNECTED','CLIENT','SERVER','DC RCVD','DC SENT');
var
  head,s:string;
begin
s:=names[what];
if data>'' then
  if what in [WL_CONNECTED, WL_DISCONNECTED] then
    begin
    s:=s+' '+data;
    data:='';
    end
  else
    s:=s+' size:'+intToStr(length(data),4);
case what of
  WL_serverGot, WL_serverSent:
    if length(data) >= FLAP_HEAD_SIZE then
      case getFlapChannel(data) of
        LOGIN_CHANNEL: s:=s+' (login flap)';
        LOGOUT_CHANNEL: s:=s+' (logout flap)';
        KEEPALIVE_CHANNEL: s:=s+' (keepalive flap)';
        SNAC_CHANNEL: s:=s+' ref:'+intToHex(getSnacRef(data),8)+' '+getDescForSnac(data);
        end;
  end;
head:=logtimestamp+s;
s:=hexDump(data);

if logpref.pkts.onwindow then
  addToLog(head, Tincapsulate.aString(head+CRLF+s));
if logpref.pkts.onfile then
  appendFile(mypath+packetslogFilename, head+CRLF+s+CRLF);
end; // loggaPkt

procedure loggaEvt(s:string);
var
  h:string;
begin
h:='';
while s>'' do
  h:=h+chopline(s)+CRLF;
s:=logtimestamp+h;
if logpref.evts.onwindow and assigned(logfrm) then
  begin
  h:=s;
  addToLog(chopline(h), Tincapsulate.aString(s));
  end;

if logpref.evts.onfile then
  appendFile(mypath+eventslogFilename, s);
end; // loggaEvt

function event2imgidx(e:integer):integer;
begin
case e of
  EK_URL: result:=PIC_URL;
  EK_MSG: result:=PIC_MSG;
  EK_CONTACTS: result:=PIC_CONTACTS;
  EK_ADDEDYOU: result:=PIC_ADDEDYOU;
  EK_AUTHREQ: result:=PIC_AUTH_REQ;
  EK_ONCOMING: result:=PIC_ONCOMING;
  EK_OFFGOING: result:=PIC_OFFGOING;
  EK_file: result:=PIC_FILE;
  EK_GCARD: result:=PIC_GCARD;
  else result:=PIC_OTHER_EVENT;
  end;
end; // event2imgidx

function event2ico(e:integer):Ticon;
begin
case e of
  EK_URL: result:=getIco(ICO_URL);
  EK_MSG: result:=getIco(ICO_MSG);
  EK_CONTACTS: result:=getIco(ICO_CONTACTS);
  EK_ADDEDYOU: result:=getIco(ICO_ADDEDYOU);
  EK_AUTHREQ: result:=getIco(ICO_AUTH_REQ);
  EK_ONCOMING: result:=getIco(ICO_ONCOMING);
  EK_OFFGOING: result:=getIco(ICO_OFFGOING);
  EK_file: result:=getIco(ICO_FILE);
  EK_GCARD: result:=getIco(ICO_GCARD);
  else result:=getIco(ICO_OTHER_EVENT);
  end;
end; // event2imgidx

procedure hideTaskButtonIfUhave2;
begin
if not menuViaMacro then
  ShowWindow(application.handle,SW_HIDE)
end;

function intToStr(i,d:integer):string; overload;
begin
result:=intToStr(i);
while length(result) < d do
  result:='0'+result;
end; // intToStr

function registerHK(id:integer; hk:word):boolean;
var
  m:integer;
begin
m:=0;
if hk and $1000>0 then inc(m, MOD_WIN);
if hk and $2000>0 then inc(m, MOD_SHIFT);
if hk and $4000>0 then inc(m, MOD_CONTROL);
if hk and $8000>0 then inc(m, MOD_ALT);
result:=RegisterHotKey(mainfrm.handle, id, m, LOBYTE(hk));
end; // registerHK

function updateSWhotkeys:boolean;
var
  i:integer;
begin
removeSWhotkeys;
result:=TRUE;
for i:=0 to length(macros)-1 do
  if macros[i].sw then
    result:=result and registerHK(i, macros[i].hk);
end; // updateSWhotkeys

procedure removeSWhotkeys;
var
  i:integer;
begin
for i:=0 to 200 do
  unregisterHotKey(mainfrm.handle, i);
end; // removeSWhotkeys

procedure saveRetrieveQ;
begin
if retrieveQ.empty then
  deleteFile(userPath+retrieveFileName+'.txt')
else
  saveFile(userPath+retrieveFileName+'.txt', retrieveQ.toString);
end; // saveRetrieveQ

procedure addToignorelist(c:Tcontact);
begin
if (c=NIL) or ignoreList.exists(c) then exit;
ignoreList.add(c);
if assigned(prefFrm) and prefFrm.visible then
  with prefFrm.ignoreFr.ignoreBox do
    addItem(c.displayed,c);
saveListsDelayed:=TRUE;
end; // addToIgnorelist

procedure removeFromIgnorelist(c:Tcontact);
begin
if (c=NIL) or not ignoreList.exists(c) then exit;
ignoreList.remove(c);
if assigned(prefFrm) and prefFrm.visible then
  with prefFrm.ignoreFr.ignoreBox do
    items.delete(items.indexOfObject(c));
saveListsDelayed:=TRUE;
end; // removeFromIgnorelist

procedure removeFromRoaster(c:Tcontact);
var
  grp:integer;
begin
if c=NIL then exit;
if ICQ.readroaster.exists(c) then
  plugins.castEvList( PE_LIST_REMOVE, PL_ROASTER, c);
autosizeDelayed:=TRUE;
grp:=c.group;
roasterLib.remove(c);
if (grp>0) and (icq.readroaster.count(grp) = 0) then
  if messageDlg(___('delete not empty group?',[groups.id2name(grp)]),mtConfirmation, [mbYes,mbNo], 0) = mrYes then
    roasterLib.removeGroup(grp);
c.group:=0;
end; // removeFromRoaster

procedure popupMenu(m:Tpopupmenu);
begin
bringForeground:=mainfrm.Handle;
m.Popup(Screen.Width div 2, screen.Height div 2);
end; // popupMenu

procedure executeMacro(m:integer);
var
  s:string;
  c:Tcontact;
begin
case m of
  OP_CHAT:
    if chatFrm.isVisible then
      begin
      chatFrm.close;
      restoreForeWindow;
      end
    else
      if chatFrm.chats.count > 0 then
        begin
        oldForeWindow:=getForegroundWindow;
        bringForeground:=chatFrm.handle;
        chatFrm.open;
        end;
  OP_ROASTER: mainfrm.toggleVisible;
  OP_TRAY: trayAction;
  OP_CLEAREVENT:
    begin
    if not (chatFrm.isVisible and chatFrm.sawAllHere) and not eventQ.empty then
      eventQ.pop.free;
    tipFrm.hide();
    end;
  OP_CLEAREVENTS:
    begin
    eventQ.clear;
    tipfrm.hide();
    end;
  OP_POPEVENT: chopAndRealizeEvent;
  OP_QUIT: mainfrm.close;
  OP_SHUTDOWN: ExitWindows(0,0);
  OP_GROUPS: toggleShowGroups;
  OP_MAINMENU: popupMenu(mainfrm.menu);
  OP_STATUSMENU: popupMenu(mainfrm.statusmenu);
  OP_VISIBILITYMENU: popupMenu(mainfrm.vismenu);
  OP_BROWSER: openURL(' ');
  OP_OFFLINECONTACTS: toggleOnlyOnline;
  OP_AUTOSIZE: toggleAutosize;
  OP_CONNECT: doConnect;
  OP_CD_PLAY:
    begin
    if sendMCIcommand('status cdaudio mode')='open' then
      sendMCIcommand('set cdaudio door closed');
    sendMCIcommand('play cdaudio');
    end;
  OP_CD_STOP:
    begin
    if s='playing' then
      sendMCIcommand('stop cdaudio')
    else
      if s='open' then
        sendMCIcommand('set cdaudio door closed')
      else
        sendMCIcommand('set cdaudio door open');
    end;
  OP_VIEWINFO: viewinfoAbout(clickedcontact);
  OP_ADDBYUIN: showForm(addContactFrm);
  OP_WP: showForm(wpFrm);
  OP_TOGGLEBORDER: toggleMainfrmBorder;
  OP_PREFERENCES: showForm(WF_PREF);
  OP_LOCK: doLock;
  OP_HINT: popupHintByMacro();
  OP_TIP:
    begin
    tipFrm.actionCount:=1;
    tipFrm.action:=TA_2lclick;
    end;
  OP_RELOADTHEME: reloadCurrentTheme();
  OP_RELOADLANG: reloadCurrentLang();
  OP_VISIBLE_TO:
    begin
    c:=focusedContact;
    if (c=NIL) or ICQ.imVisibleTo(c) then exit;
    ICQ.addTemporaryVisible(c);
    roasterLib.redraw(c);
    end;
  OP_TOGGLE_SOUND:
    begin
    playSounds:=not playSounds;
    saveCFG;
    end;
  end;
end; // executeMacro

procedure fillMacrosGrid(macros:Tmacros);
var
  i:integer;
  grid:TStringGrid;
begin
if not assigned(prefFrm) or not prefFrm.visible then exit;
grid:=prefFrm.hotkeysFr.grid;
grid.rowCount:=length(macros)+1;
grid.cells[0,0]:='SW';
grid.cells[1,0]:='HOTKEY';
grid.cells[2,0]:='ACTION';
for i:=0 to length(macros)-1 do
  begin
  grid.cells[0,i+1]:=ifThen(macros[i].sw, ___('yes'),___('no'));
  grid.cells[1,i+1]:=ifThen(macros[i].hk and $1000>0,'WIN+')
    +shortcutToText(macros[i].hk);
  grid.cells[2,i+1]:=macroopcodeName(macros[i].opcode);
  end;
end; // fillMacrosGrid

function removeMacro(i:integer):boolean;
begin
result:=(i>=0) and (i<length(macros));
if result then
  begin
  while i<length(macros)-1 do
    begin
    macros[i]:=macros[i+1];
    inc(i);
    end;
  setLength(macros, i);
  end;
end; // removeMacro

function findHK(hk:Tshortcut):integer;
begin
for result:=0 to length(macros)-1 do
  if macros[result].hk = hk then
    exit;
result:=-1;
end; // findHK

function addMacro(hk:Tshortcut; sw:boolean; op:integer):boolean;
var
  i:integer;
begin
if hk=0 then
  begin
  result:=FALSE;
  exit;
  end;
i:=findHK(hk);
result:=i<0;
if result then
  begin
  i:=length(macros);
  setLength(macros, i+1);
  end;

macros[i].hk:=hk;
macros[i].sw:=sw;
macros[i].opcode:=op;
end; // addMacro

const
  MFK_HK=1;
  MFK_SW=2;
  MFK_OP=3;

function macro2str(m:Tmacro):string;
begin
result:=
  TLV(MFK_HK, int2str(m.hk))
 +TLV(MFK_SW, bool2str(m.sw))
 +TLV(MFK_OP, int2str(m.opcode))
end; // macro2str

function str2macro(s:string):Tmacro;
var
  t,l:integer;
  d:string;
begin
while s > '' do
  begin
  t:=dword_LEat(@s[1]); // 1234
  l:=dword_LEat(@s[5]); // 5678
  d:=copy(s,9,l);
  case t of
    MFK_HK: result.hk:=str2int(d);
    MFK_SW: result.sw:=boolean(d[1]);
    MFK_OP: result.opcode:=str2int(d);
    end;
  delete(s,1,8+l);
  end;
end; // str2macro

function macros2str(m:Tmacros):string;
var
  i:integer;
  s:string;
begin
result:='';
for i:=0 to length(m)-1 do
  begin
  s:=macro2str(m[i]);
  result:=result+int2str(length(s))+s;
  end;
end; // macros2str

procedure str2macros(s:string; var m:Tmacros);
var
  l,n:integer;
begin
n:=0;
while length(s) > 0 do
  begin
  l:=str2int(s);
  inc(n);
  setLength(m, n);
  m[n-1]:=str2macro( copy(s,5,l) );
  delete(s, 1, 4+l);
  end;
end; // str2macros

procedure realizeEvent(ev:Thevent);
begin
roasterLib.redraw(ev.who);
tipfrm.hide();
if ev.kind in [EK_ADDEDYOU, EK_AUTHREQ, EK_MSG, EK_GCARD, EK_URL, EK_CONTACTS] then
  NILifNIL(ev.who);
case ev.kind of
  EK_ADDEDYOU:
    if ICQ.readroaster.exists(ev.who) then
      msgDlg(___('added you',[ev.who.displayed]), mtInformation)
    else
      if messageDlg(___('added you, add?',[ev.who.displayed]), mtConfirmation, [mbYes,mbNo], 0) = mrYes then
        addToRoaster(ev.who);
  EK_AUTHREQ: showAuthreq(ev.who, ev.decrittedinfo);
  EK_ONCOMING:
    if showOncomingDlg then
      msgDlg(ev.who.displayed+___('tray oncoming'), mtInformation);
  EK_GCARD,
  EK_URL,
  EK_MSG:
    with chatFrm do
      begin
      openOn(ev.who);
      moveToTimeOrEnd(ev.who, ev.when);
      end;
  EK_CONTACTS:
    TselectContactsFrm.doAll( mainFrm,___('got contacts title',[ev.who.displayed]),___('got contacts button'), ev.cl.clone, mainfrm.addContactsAction, [sco_multi,sco_selected])
  end;
ev.free;
end; // realizeEvent

function chopAndRealizeEvent:boolean;
var
  ev:Thevent;
begin
result:=FALSE;
if eventQ=NIL then exit;
ev:=eventQ.pop;
if not assigned(ev) then
  exit;
result:=TRUE;
realizeEvent(ev);
saveInboxDelayed:=TRUE;
end; // chopAndRealizeEvent

procedure trayAction;
begin
if not chopAndRealizeEvent then
  if not mainfrm.visible then
    mainfrm.toggleVisible
  else
    if not doConnect then
      mainfrm.toggleVisible;
end; // trayAction

function loadNewOrOldVersionContactList(fn:string; altpath:string=''):string;
var
  s:string;
begin
if altpath='' then altpath:=userpath;
if fileExists(altPath+fn+'.txt') then
  result:=loadFile(altPath+fn+'.txt')
else
  begin
  s:=loadFile(altPath+fn);
  result:='';
  while s>'' do
    begin
    result:=result+copy(s,2, ord(s[1]))+CRLF;
    delete(s, 1, ord(s[1])+1);
    end;
  end;
end; // loadNewOrOldVersionContactList

procedure startMenuViaMacro;
begin
menuViaMacro:=TRUE;
ShowWindow(application.handle,SW_SHOW);
application.bringtofront;
end; // startMenuViaMacro

procedure stopMenuViaMacro;
begin menuViaMacro:=FALSE end;

function ints2cl(a:TintegerDynArray):Tcontactlist;
var
  i:integer;
begin
result:=Tcontactlist.create;
for i:=0 to length(a)-1 do
  result.add(contactsDB.get(a[i]));
end; // ints2cl

function packArray(a:array of integer; zero:integer):TintegerDynArray;
var
  i,n:integer;
begin
n:=0;
setlength(result, length(a));
for i:=0 to length(a)-1 do
  if a[i]<>zero then
    begin
    result[n]:=a[i];
    inc(n);
    end;
setlength(result, n);
end; // packArray

procedure doLock;
begin
if ICQ.pwd = '' then msgDlg(___('no pwd, no lock'),mtInformation)
else lockFrm.showModal;
end; // doLock

function sendMCIcommand(cmd:PChar):string; 
var
  res:array [0..100] of char;
  trash:Thandle;
begin
trash:=0; // shut up compiler
mciSendString(cmd, res, length(res), trash);
result:=res;
end; // sendMCI

function statusName(s:Tstatus):string;
begin result:=___(status2str[s]) end;

function ___(const key:string):string;
begin result:=getTranslation(key,[]) end;

function  ___(const key:string; const args:array of const):string; overload;
begin result:=getTranslation(key,args) end;

function macroopcodeName(m:integer):string;
begin result:=___('macro '+globalLib.macro2str[m]) end;

function behactionName(a:Tbehaction):string;
begin result:=___('behaction '+behactions2str[a]) end;

function mb(q:extended):string;
begin result:=floatToStrF(q/(1024*1024),ffFixed,20,1)+___('mb') end;

function setlang(l:string):boolean;
begin
lang:=l;
langPath:=myPath+'lang\'+lang+'\';
result:=directoryExists(langPath);
end; // setLang

function availableLangs:TStringDynArray;
var
  n:integer;
  sr:TsearchRec;
begin
result:=NIL;
n:=0;
if findFirst(myPath+'lang\*.*', faDirectory, sr) = 0 then
  repeat
  if (sr.Attr and faDirectory>0) and (sr.name[1]<>'.') then
    begin
    setlength(result, n+1);
    result[n]:=sr.name;
    inc(n);
    end;
  until findNext(sr) <> 0;
findClose(sr);
end; // availableLangs

function chopline(var s:string):string;
var
  i:integer;
begin
for i:=1 to length(s) do
  case s[i] of
    #10:
      begin
      result:=chop(i,s);
      exit;
      end;
    #13:
      begin
      if (i < length(s)) and (s[i+1]=#10) then result:=chop(i,2,s)
      else result:= chop(i,s);
      exit;
      end;
    end;
result:=chop(0,0,s);
end; // chopline

function chop(ss:string; var s:string):string;
begin result:=chop(pos(ss,s),length(ss),s) end;

function chop(i:integer; var s:string):string;
begin result:=chop(i,1,s) end;

function chop(i,l:integer; var s:string):string;
begin
if i=0 then
  begin
  result:=s;
  s:='';
  exit;
  end;
result:=copy(s,1,i-1);
delete(s,1,i-1+l);
end; // chop

function langDependentFile(filename:string):string;
begin
if fileExists(langPath+filename) then result:=langPath+filename
else result:=defaultLangPath+filename;
end; // langDependentFile

function visibilityName(vi:Tvisibility):string;
begin result:=___('visibility '+visibility2str[vi]) end;

function clb2contactlist(data:string):Tcontactlist;
var
  grpname,line:string;
  grp,uin:integer;
  c:Tcontact;
begin
result:=Tcontactlist.create;
while data>'' do
  try
    line:=trim(chop(#10,data));
    grpname:=chop(';',line);
    uin:=strToInt(chop(';',line));
    c:=contactsDB.get(uin);
   	if c.nick='' then c.nick:=chop(';',line)
    else c.display:=chop(';',line);
    if (c.group=0) and (grpname>'') then
      begin
      grp:=groups.name2id(grpname);
      if grp<0 then
        begin
        grp:=groups.add;
        groups.a[groups.idxOf(grp)].name:=grpname;
        end;
      c.group:=grp;
      end;
    result.add(c);
  except
  end;
end; // clb2contactlist

function contactlist2clb(cl:Tcontactlist):string;
var
  i:integer;
  s:string;
begin
result:='';
for i:=0 to cl.count-1 do
  begin
  s:='';
  with cl.getat(i) do
    result:=result+
      groups.id2name(group)+';'+intToStr(uin)+';'+displayed+';'+CRLF
  end;
end; // contactlist2clb

function eventName(ev:integer):string;
begin result:=___(event2str[ev]) end;

function IfThen(AValue: Boolean; const ATrue: Integer; const AFalse: Integer = 0): Integer; 
begin if avalue then result:=atrue else result:=afalse end;

function setRoasterAnimation(v:boolean):boolean;
begin
with mainfrm.roaster.TreeOptions do
  begin
  result:=toAnimatedToggle in animationoptions;
  if v then
    animationoptions:=[toAnimatedToggle]
  else
    animationoptions:=[]
  end;
end; // setRoasterAnimation

function template(src:string; table:array of string):string;
var
  i:integer;
begin
result:=src;
i:=0;
while i < length(table) do
  begin
  result:=AnsiReplaceStr(result, table[i], table[i+1]);
  inc(i,2);
  end;
end; // template

function sameMonthDay(d1,d2:Tdatetime):boolean;
begin result:=(MonthOf(d1)=monthOf(d2)) and (dayOf(d1)=dayOf(d2)) end;

procedure applyBalloon;
begin
if ICQ.myinfo=NIL then
  raise Exception.create('applyBalloon: ICQ.myinfo is NIL');
icq.birthdayFlag:=(sendBalloonOn=BALLOON_BDAY) and sameMonthDay(ICQ.myinfo.birth,now)
               or (sendBalloonOn=BALLOON_DATE) and sameMonthDay(sendBalloonOnDate,now)
               or (sendBalloonOn=BALLOON_ALWAYS);
if icq.isOnline then
  icq.sendStatusCode;
end; // applyBalloon

function enterICQpwd:boolean;
var
  s:string;
  res:boolean;
begin
result:=FALSE;
if enteringICQpwd then exit;
enteringICQpwd:=TRUE;
s:=ICQ.pwd;
res:=enterPwdDlg(s,'',8);
enteringICQpwd:=FALSE;
if not res or (s='') then exit;
ICQ.pwd:=s;
if ICQ.pwd<>s then
  begin
  msgDlg('pwd too long',mtError);
  exit;
  end;
saveCFG;
result:=TRUE;
end; // enterICQpwd

function drawPic(cnv:Tcanvas; x,y:integer; pic:integer):Tsize;
begin result:=drawPic(cnv,x,y,getPic(pic)) end;

function drawPic(cnv:Tcanvas; x,y:integer; pic:Tbitmap):Tsize;
begin
if pic=NIL then exit;
cnv.draw(x,y,pic);
result.cx:=pic.width;
result.cy:=pic.height;
end; // drawPic

procedure freePic(idx:integer);
begin freeAndNIL(theme.pics[idx]) end;

function getPic(idx:integer):Tbitmap;
begin if idx<0 then result:=NIL else result:=theme.pics[idx] end;

function getIco(idx:integer):Ticon;
begin if idx<0 then result:=NIL else result:=theme.icons[idx] end;

procedure wallpaperize(canvas:Tcanvas);
begin
if (getPic(PIC_WALLPAPER)<>NIL) and texturizedWindows then
  drawTiled(canvas, getPic(PIC_WALLPAPER))
end; // wallpaperize

procedure loadIco(fn:string; var result:Ticon);
var
  ext:string;
  pic:Tbitmap;
begin
if not absPath(fn) then fn:=myPath+fn;
ext:=extractFileExt(fn);
if ext='.png' then
  begin
  pic:=loadpic(fn);
  result:=pic2ico(pic);
  pic.free;
  end
else
  begin
  if result=NIL then result:=Ticon.create;
  if ext <> '.ico' then fn:=fn+'.ico';
  result.loadFromFile(fn);
  end;
end; // loadIco

function bmp2ico(bitmap:Tbitmap):Ticon;
var
  iconX, iconY : integer;
  IconInfo: TIconInfo;
  IconBitmap, MaskBitmap: TBitmap;
  dx,dy,x,y: Integer;
  tc: TColor;
begin
if bitmap=NIL then
  begin
  result:=NIL;
  exit;
  end;
iconX := GetSystemMetrics(SM_CXICON);
iconY := GetSystemMetrics(SM_CYICON);
IconBitmap:= TBitmap.Create;
IconBitmap.Width:= iconX;
IconBitmap.Height:= iconY;
IconBitmap.TransparentColor:=Bitmap.TransparentColor;
tc:=Bitmap.TransparentColor and $FFFFFF;
Bitmap.transparent:=FALSE;
with IconBitmap.Canvas do
  begin
  dx:=bitmap.width*2;
  dy:=bitmap.height*2;
  if (dx < iconX) and (dy < iconY) then
    begin
    brush.color:=tc;
    fillrect(clipRect);
    x:=(iconX-dx) div 2;
    y:=(iconY-dy) div 2;
    StretchDraw(Rect(x,y,x+dx,y+dy), Bitmap);
    end
  else
    IconBitmap.Canvas.StretchDraw(Rect(0, 0, iconX, iconY), Bitmap);
  end;
MaskBitmap:= TBitmap.Create;
MaskBitmap.Assign(IconBitmap);
Bitmap.transparent:=TRUE;
with IconBitmap.Canvas do
  for y:= 0 to iconY - 1 do
    for x:= 0 to iconX - 1 do
      if Pixels[x, y]=tc then
        Pixels[x, y]:=clBlack;
IconInfo.fIcon:= True;
IconInfo.hbmMask:= MaskBitmap.MaskHandle;
IconInfo.hbmColor:= IconBitmap.Handle;
Result:= TIcon.Create;
Result.Handle:= CreateIconIndirect(IconInfo);
MaskBitmap.Free;
IconBitmap.Free;
end; // bmp2ico

function pic2ico(pic:integer):Ticon;
begin result:=pic2ico(getpic(pic)) end;

function pic2ico(pic:Tbitmap):Ticon;
begin result:=bmp2ico(pic) end;

function getIco(st:Tstatus; inv:boolean):Ticon;
var
  idx:integer;
begin
case st of
  SC_ONLINE: idx:=ICO_STATUS_ONLINE;
  SC_OFFLINE: idx:=ICO_STATUS_OFFLINE;
  SC_occupied: idx:=ICO_STATUS_OCCUPIED;
  SC_dnd: idx:=ICO_STATUS_DND;
  SC_away: idx:=ICO_STATUS_AWAY;
  SC_na: idx:=ICO_STATUS_NA;
  SC_f4c: idx:=ICO_STATUS_F4C;
  else idx:=0;
  end;
if inv then
  inc(idx, 8);
result:=getIco(idx);
end; // getIco

function dupePic(pic:Tbitmap):Tbitmap;
begin
result:=Tbitmap.create;
result.assign(pic);
end; // dupepic

procedure applyUserCharset(f:Tfont);
begin if userCharset >= 0 then f.charset:=usercharset end;

function getLeadingInMsg(s:string; ofs:integer=1):string;
var
  i:integer;
begin
i:=0;
while (i<length(s)) and (s[i+ofs] in ['>',' ']) do
  inc(i);
result:=copy(s,ofs,i);
end; // getLeadingInMsg

procedure repaintAllWindows;

  procedure repaintRecur(c:Tcontrol);
  var
    i:integer;
  begin
  if c is Twincontrol then with c as Twincontrol do
    for i:=controlCount-1 downto 0 do
      repaintRecur(controls[i]);
  c.repaint;
  end; // repaintRecur

var
  i:integer;
begin
for i:=0 to Screen.FormCount-1 do
  repaintRecur(screen.forms[i]);
end;

procedure applyCommonSettings(c:Tcomponent);
var
  i:integer;
begin
for i:=c.componentCount-1 downto 0 do
  applyCommonSettings(c.components[i]);
if c is Tjvpopupmenu then
  with Tjvpopupmenu(c) do
    begin
    Style:=msOwnerDraw;
    OnDrawItem:=mainfrm.menuDrawitem;
    onDrawMargin:=mainfrm.menuDrawMargin;
    onMeasureItem:=mainFrm.menuMeasureItem;
    end;
end; // applyCommonSettings

procedure refreshAvailableUsers;
var
  uin,code:integer;
  sr:TsearchRec;

  function getNick(path:string):string;
  var
    db:TcontactList;
    ini:Tstrings;
    s:string;
  begin
  result:='';
  ini:=TstringList.create;
  s:=path+'\'+configFileName;
  if fileExists(s) then
    begin
    ini.LoadFromFile(s);
    result:=ini.values['account-name'];
    end;
  if result='' then
    begin
    db:=str2db( loadFile(path+'\'+dbFilename) );
    result:=db.get(uin).nick;
    if result = '' then result:=' ';
    ini.values['account-name']:=result;
    ini.saveToFile(s);
    freeDB(db);
    end;
  ini.free;
  end; // getNick

  procedure addAvailableUser(path:string);
  var
    n: integer;
  begin
  n:=length(availableUsers);
  setlength(availableUsers,n+1);
  availableUsers[n].uinStr:=extractFileName(path);
  availableUsers[n].uin:=strToInt(availableUsers[n].uinStr);
  availableUsers[n].name:=getNick(path);
  availableUsers[n].path:=ExtractFilePath(path);
  end; // addAvailableUser

  procedure searchIn(path:string);
  begin
  path:=includeTrailingPathDelimiter(path);
  if FindFirst(path+'*', faDirectory, sr)=0 then
    repeat
    if sr.Attr and faDirectory > 0 then
      begin
      val(sr.Name, uin, code);
      if (code = 0) and validUIN(uin) then
        addAvailableUser(path+sr.name);
      end;
    until FindNext(sr) > 0;
  FindClose(sr);
  end;

var
  s:string;
  i,j,n:integer;
begin
setlength(availableUsers,0);
searchIn(myPath);
searchIn(getSpecialFolder('AppData')+'&RQ\');
if cmdLinePar.startUser > '' then
  addAvailableUser(cmdLinePar.startUser);

s:=usersPath;
while s>'' do
  searchIn(chop(';',s));
n:=length(availableUsers);
for i:=0 to n-2 do
  for j:=i+1 to n-1 do
    swap(availableUsers[i], availableUsers[j], sizeOf(availableUsers[i]),
      availableUsers[i].uin > availableUsers[j].uin );
end; // refreshAvailableUsers

procedure releaseResources;
var
  i:integer;
begin
convhistFrm.destroyHandle;
automsgFrm.destroyHandle;
addcontactFrm.destroyHandle;
visibilityFrm.destroyHandle;
searchhistFrm.destroyHandle;
changepwdFrm.destroyHandle;
dbFrm.destroyHandle;
outboxFrm.destroyHandle;
lockFrm.destroyHandle;
exit;
for i:=1 to PIC_LAST do
  if assigned(theme.pics[i]) then
    theme.pics[i].dormant;
end; // releaseResources

function connectionAvailable:boolean;
var
  d:dword;
begin
result:=InternetGetConnectedState(@d,0);
end; // connectionAvailable

procedure assignImgBmp(img:Timage; bmp:Tbitmap);
begin
img.Picture.Bitmap.assign(bmp);
img.Transparent:=bmp.Transparent;
img.height:=bmp.height;
img.width:=bmp.width;
end; // assignImgBmp

procedure assignImgIco(img:Timage; ico:Ticon);
begin
img.Picture.icon.assign(ico);
img.width:=ico.width*2;
img.height:=ico.height*2;
end; // assignImgIco

function str2fontstyle(s:string):Tfontstyles;
begin
result:=[];
if ansipos('b',s) > 0 then include(result, fsBold);
if ansipos('i',s) > 0 then include(result, fsItalic);
if ansipos('u',s) > 0 then include(result, fsUnderline);
end; // str2fontstyle

function fontstyle2str(fs:Tfontstyles):string;
begin
result:='';
if fsBold in fs then result:=result+'b';
if fsItalic in fs then result:=result+'i';
if fsUnderline in fs then result:=result+'u';
end; // str2fontstyle

function newline2slashn(s:string):string;
var
  i:integer;
begin
  repeat
  i:=pos(#13,s);
  if i>0 then
    begin
    s[i]:='\';
    if (i>=length(s)) or (s[i+1]<>#10) then
      insert('n',s,i)
    else
      s[i+1]:='n';
    end;
  until i=0;
result:=s;
end; // newline2slashn

procedure mainfrmHandleUpdate;
begin
DragAcceptFiles(mainfrm.roaster.handle, FALSE);
statusIcon.handleChanged;
updateSWhotkeys;
end; // mainfrmhandleupdate

procedure reloadCurrentTheme();
begin
DeleteFile(myPath+themesPath+theme.fn+'.cache');
loadTheme(mypath+themesPath+theme.fn);
loadThemeScript(userPath+userthemeFilename);
applyTheme;
end; // reloadCurrentTheme

procedure reloadCurrentLang();
begin
loadLanguage(lang);
translateWindows();
end; // reloadCurrentLang

procedure setupChatButtons;
{ weird behaviour of ToolBar component: the autosize property only affects
{ height. So we collect the max height for the buttons we display, and set
{ Toolbar.buttonheight to the right value. Width is instead set for each
{ button }
var
  h:integer;

  procedure setupChatButton(newBtn:TspeedButton; pic:Tbitmap); overload;
  begin
  newBtn.glyph.assign(pic);
  newBtn.top:=(chatFrm.panel.clientheight-newBtn.height) div 2;
  if h < pic.height then h:=pic.height;
  newBtn.width:=pic.width+5;
  end; // setupChatButton

  procedure setupChatButton(newBtn:TspeedButton; pic:integer); overload;
  begin setupChatButton(newbtn, getPic(pic)) end;

begin
if not assigned(chatFrm) then exit;
h:=0;
chatFrm.pagectrl.tabHeight:=getPic(PIC_STATUS_ONLINE).height+6;
chatFrm.closeTB.left:=chatFrm.sendTB.boundsrect.right+10;
chatFrm.closeTB.top:=chatFrm.sendTB.top;
setupChatButton(chatFrm.historyBtn, PIC_HISTORY);
setupChatButton(chatFrm.findBtn, PIC_SEARCH);
setupChatButton(chatFrm.quoteBtn, PIC_QUOTE);
setupChatButton(chatFrm.smilesBtn, PIC_SMILES);
setupChatButton(chatFrm.autoscrollBtn, PIC_DOWN);
setupChatButton(chatFrm.singleBtn, PIC_1_MSG);
setupChatButton(chatFrm.urlBtn, PIC_URL);
setupChatButton(chatFrm.contactsBtn, PIC_CONTACTS);
setupChatButton(chatFrm.infoBtn, PIC_INFO);
setupChatButton(chatFrm.prefBtn, PIC_PREFERENCES);
chatFrm.toolbar.left:=chatFrm.closeTB.boundsrect.right+10;
chatfrm.panel.Height:=18+getPic(PIC_HISTORY).Height;
with chatFrm.toolbar do top:=(chatfrm.panel.ClientHeight-height) div 2;
chatFrm.toolbar.buttonheight:=h+5;
end; // setupChatButtons

procedure applyClientID;
begin
if showClientID then
  begin
  ICQ.myInfo.extracapabilities:='&RQinside'+int2str(ANDRQversion)+#0#0#0;
  ICQ.myinfo.lastUpdate_dw:=ANDRQclientID;
  ICQ.myinfo.lastInfoUpdate_dw:=ANDRQversion;
  end
else
  begin
  ICQ.myInfo.extracapabilities:='';
  ICQ.myinfo.lastUpdate_dw:=0;
  ICQ.myinfo.lastInfoUpdate_dw:=0;
  end;
if ICQ.isOnline then ICQ.sendStatusCode;
end; // applyClientID

procedure toggleMainfrmBorder;
begin
with mainfrm do
  if borderstyle=bsNone then
    borderStyle:=bsSizeToolWin
  else
    borderStyle:=bsNone;
mainfrmHandleUpdate;
end; // toggleMainfrmBorder

function unexistant(uin:integer):boolean;
begin
result:=not (ICQ.myInfo.uin = uin)
    and not ICQ.readroaster.exists(uin)
    and not notInlist.exists(uin)
end; // unexistant

const
  CTK_ICON = 1;

function saveCachedTheme(fn:string):boolean;
var
  stream:TStringStream;
  i:integer;
  s,ss:string;
begin
loggaEvt('theme cache: saving');
ss:='';
for i:=1 to ICO_LAST do
  begin
  if theme.icons[i]=NIL then s:=''
  else
    begin
    stream:=TStringStream.Create('');
    theme.icons[i].SaveToStream(stream);
    s:=stream.DataString;
    stream.free;
    end;
  ss:=ss+TLV(CTK_ICON, s);
  end;
result:=savefile(fn, ss);
loggaEvt('theme cache: saved');
end; // savecacheTheme

function loadCachedTheme(fn:string):boolean;
var
  s:string;
  t,i,icoI,l:integer;
  stream:TStringStream;
begin
loggaEvt('theme cache: loading');
result:=FALSE;
s:=loadfile(fn);
if s='' then exit;
icoI:=1;
i:=1;
while i < length(s) do
  begin
  t:=dword_LEat(@s[i]);
  l:=dword_LEat(@s[i+4]);
  case t of
    CTK_ICON:
      begin
      if l > 0 then
        begin
        if theme.icons[icoI]=NIL then theme.icons[icoI]:=Ticon.create;
        stream:=TStringStream.Create(copy(s,i+8,l));
        theme.icons[icoI].LoadFromStream(stream);
        stream.Free;
        end
      else
        if assigned(theme.icons[icoI]) then
          begin
          theme.icons[icoI].free;
          theme.icons[icoI]:=Ticon.create;
          end;
      inc(icoI);
      end;
    end;//case
  inc(i, 8+l);
  end;
result:=TRUE;
loggaEvt('theme cache: loaded');
end; // loadCachedTheme

function mostRecentFileFrom(path:string):integer;
var
  sr:TsearchRec;
  t:integer;
begin
result:=0;
path:=IncludeTrailingPathDelimiter(path);
if FindFirst(path+'*.*', faAnyFile, sr)=0 then
  repeat
  if sr.time > result then result:=sr.time;
  if (sr.name[1]<>'.') and (sr.Attr and faDirectory >0) then
    begin
    t:=mostRecentFileFrom(path+sr.name+'\');
    if t > result then result:=t;
    exit;
    end;
  until FindNext(sr) > 0;
findClose(sr);
end; // mostRecentFileFrom

function findInAvailableUsers(uin:integer):integer;
begin
for result:=0 to length(availableusers)-1 do
  if availableusers[result].uin = uin then
    exit;
result:=-1;
end; // findInAvailableUsers

function isAbort(pluginReply:string):boolean;
begin result:= (pluginReply>'') and (ord(pluginReply[1])=PM_ABORT) end;

function separated(sep:string; ss:array of string):string;
var
  i:integer;
begin
result:='';
for i:=0 to length(ss)-1 do
  if ss[i] > '' then
    result:=result+ifThen(result>'', ',')+ss[i];
end; // separated

procedure drawCoolText(cnv:Tcanvas; text:string);
var
  i,l,n,escpos:integer;
  r:Trect;
  st:Tfontstyles;
  startX:integer;

  procedure turnStyle(v:Tfontstyle);
  begin
  if v in st then st:=st-[v] else st:=st-[v];
  cnv.font.style:=st;
  end;

begin
i:=1;
r:=cnv.ClipRect;
l:=length(text);
st:=cnv.font.Style;
startX:=cnv.penpos.x;
while i<=l do
  begin
  escpos:=i;
  while (escpos<=l) and (text[escpos]<>#27) do inc(escpos);
  if escpos>l then n:=l-i+1
  else n:=escpos-i;
  r.Left:=cnv.PenPos.X;
  r.top:=cnv.PenPos.y;
  DrawText(cnv.handle, @text[i], n, r, DT_SINGLELINE);
  inc(i,n);
  if escpos <= l then
    begin
    inc(i,2);
    case text[escpos] of
      'b': turnStyle(fsBold);
      'i': turnStyle(fsItalic);
      'u': turnStyle(fsItalic);
      'r': cnv.MoveTo(startX, cnv.penpos.Y+cnv.TextHeight('I'));
      end;
    end;
  end;
end; // drawCoolText

function createBitmap(dx,dy:integer):Tbitmap;
begin
result:=Tbitmap.create;
result.width:=dx;
result.height:=dy;
end;

function createBitmap(cnv:Tcanvas):Tbitmap;
begin
with cnv.cliprect do
  result:=createBitmap(right-left+1, bottom-top+1);
end;

procedure convertAllNewlinesToCRLF(var s:string);
var
  i:integer;
begin
i:=length(s);
while i>0 do
  begin
  case s[i] of
    #13: if (i=length(s)) or (s[i+1]<>#10) then insert(#10,s,i+1);
    #10: if (i=1) or (s[i-1]<>#13) then insert(#13,s,i);
    end;
  dec(i);
  end
end; // convertAllNewlinesToCRLF

function getClientFor(c:Tcontact):string;
var
  s, capa:string;
  i:integer;
begin
result:='';
if c=NIL then exit;
if c=ICQ.myinfo then
	begin
  result:='&RQ '+ip2str(ANDRQversion);
  exit;
  end;

s:=c.extracapabilities;
while s > '' do
  begin
  capa:=chop(17,0,s);
  if pos('&RQinside',capa) > 0 then
    result:='&RQ '+ip2str(str2int(@capa[10]));
  if pos(#$97#$B1#$27#$51#$24#$3C#$43#$34#$AD#$22#$D6#$AB#$F7#$3F#$14,capa) > 0 then
  	begin
    i:=ord(capa[16]);
    case i of
      65..255:result:=format('SIM %d.%d',[pred(i shr 6),i and 63]);
      1,64:result:='Kopete';
      end;
    end;
  if pos('SIM client',capa) > 0 then
    result:='SIM '+ip2str(invert(str2int(@capa[13])));
  if pos(#$97#$B1#$27#$51#$24#$3C#$43#$34#$AD#$22#$D6#$AB#$F7#$3F#$14#$09,capa) > 0 then
    result:='Trillian';
  if pos(#$09#$49#$13#$44#$4c#$7f#$11#$d1#$82#$22#$44#$45#$53#$54#$00#$00,capa) > 0 then
    result:='kxICQ2';
	if pos(#$DD#$16#$F2#$02#$84#$E6#$11#$D4#$90#$DB#$00#$10#$4B#$9B#$4B#$7D,capa) > 0 then
    result:='MacICQ';
  if pos(#$09#$49#$13#$49#$4C#$7F#$11#$D1#$82#$22#$44#$45#$53#$54#$00#$00,capa) > 0 then
  	result:='LICQ';
  if pos('mICQ  R.K. ',capa) > 0 then
    result:='mICQ '+ip2str(str2int(@capa[13]));
  end;
if result > '' then exit;

case c.lastupdate_dw of
  YSMclientID: result:='YSM';
  MICQclientID,
  MICQ2clientID: result:='MICQ '+ip2str(c.lastinfoupdate_dw);
  LICQclientID: result:='LICQ '+ip2str(c.lastinfoupdate_dw);
  ANDRQclientID: result:='&RQ '+ip2str(c.lastinfoupdate_dw);
  STRICQclientID: result:='StrICQ 2';
  MIRANDAclientID: result:='Miranda '+ip2str(abs(integer(c.lastinfoupdate_dw)));
  end;
if result > '' then exit;

if c.icq2go then result:='ICQ2GO'
else
  case c.proto of
    4: result:='ICQ 98';
    6: result:='ICQ 99';
    7: result:='ICQ 2000';
    8:
      if 7 in c.capabilities then result:='Trillian' else
      if 5 in c.capabilities then result:='ICQ 2003' else
      if 4 in c.capabilities then result:='ICQ 2001' else
      if 3 in c.capabilities then result:='ICQ 2002' else
      	result:='ICQ 2001';
    9: result:='ICQ Lite';
    else
      if 6 in c.capabilities then result:='ICQ Lite' else
      if 7 in c.capabilities then result:='Trillian' else
      if 5 in c.capabilities then result:='ICQ 2003' else
      if 4 in c.capabilities then result:='ICQ 2001' else
      if 3 in c.capabilities then result:='ICQ 2002' else
        result:='ICQ 2000';
    end;
end; // getClientFor

function datetimeToStrMinMax(dt:Tdatetime; min:Tdatetime; max:Tdatetime):string; overload;
begin
if dt=0 then
  result:=''
else
  if (dt<min) or (dt>max) then
    result:=___('invalid')
  else
    result:=formatDatetime(timeformat.info, dt);
end; // datetimeToStrMinMax

function dateTocoolstr(d:Tdatetime):string;
begin
case trunc(now)-trunc(d) of
  0: result:=___('today');
  1: result:=___('yesterday');
  2..5: result:=longDayNames[dayofweek(d)];
  else result:=capitalize(LongMonthNames[monthOf(d)])+' '+intToStr(dayOf(d));
  end
end; // dateToCoolstr

procedure unroundWindow(hnd:Thandle);
begin SetWindowRgn(hnd,0,True) end;

procedure roundWindow(hnd:Thandle; w,h:integer); overload;
var
  R:HRGN;
begin
if not roundedWindows then
  begin
  unroundWindow(hnd);
  exit;
  end;
R:=CreateRoundRectRgn(0,0,w,h,15,15);
SetWindowRgn(hnd,R,True);
deleteObject(R);
{h:=getWindowDC(frm.handle);
roundRect(h, 0,0,w,h,15,15);
SetDCBrushColor(h, dword(clBtnFace));
SetDCPenColor(h, dword(clBtnHighlight));}
end;

procedure roundWindow(frm:Tform); overload;
begin if frm<>NIL then roundWindow(frm.handle, frm.width, frm.height) end;

function capitalize(s:string):string;
begin
if s>'' then s[1]:=upcase(s[1]);
result:=s;
end; // capitalize

function within(a,b,c:integer):boolean; overload;
begin result:=(b>=a) and (b<=c) end;

function within(pt:Tpoint; x,y,w,h:integer):boolean; overload;
begin result:=(pt.x>=x) and (pt.y>=y) and (pt.x < x+w) and (pt.y < y+h) end;

procedure drawNodeHint(cnv:Tcanvas; node:Pvirtualnode; var r:Trect);
const
  border=5;
  roundsize=16;
var
  n:Tnode;
  maxX,x,y,dy:integer;

  procedure textout(s:string); overload;
  begin
  cnv.TextOut(x,y, s);
  x:=cnv.penpos.x;
  if x > maxX then maxX:=x;
  end; // textout

  procedure textout(s:string; a:TFontStyles); overload;
  begin
  cnv.Font.Style:=a;
  textout(s);
  end; // textout

  procedure fieldOut(fn,fc:string);
  begin
  textout(fn, []);
  if fc='' then textout('unk', [fsItalic])
  else textout(fc, [fsBold]);
  x:=border; inc(y, dy+1);
  end; // fieldout

  procedure lineOut(clr:Tcolor);
  begin
  cnv.Pen.color:=clr;
  cnv.moveTo(r.left+15,y);
  cnv.LineTo(r.right-15,y);
  end; // lineout

  procedure rulerOut();
  begin
  inc(y,dy div 2);
  lineOut(clInfoText);
  inc(y,2);
  lineOut(clInfoText);
  inc(y,dy div 2);
  end; // rulerOut

  procedure picOut(idx:integer);
  begin
  with drawpic(cnv,x,y, idx) do
    begin
    inc(x, cx+3);
    inc(y, cy-dy);
    end;
  end; // picOut

  function timeToStr(t:Tdatetime):string;
  begin
  if t=0 then result:=''
  else result:=dateTocoolstr(t)+', '+FormatDateTime('h:nn',t)
  end;

var
  i,a,b:integer;
  cl:Tcontactlist;
begin
n:=getNode(node);
if n=NIL then exit;
if cnv=NIL then exit;
cnv.Pen.Color:=clInfoText;
cnv.font.Color:=clInfoText;
dy:=cnv.TextHeight('I');
cnv.Brush.Color:=clInfoBk;
cnv.RoundRect(r.Left,r.top,r.Right,r.bottom, roundsize,roundsize);
maxX:=0;
x:=border;
y:=roundsize div 2;
case n.kind of
  NODE_CONTACT:
    begin
    picOut(roasterImgIdxFor(n.contact));
    fieldOut(___('uin')+'# ', n.contact.uinAsStr);
    rulerOut();
    fieldOut(___('nickname')+': ',n.contact.nick);
    fieldOut(___('firstname')+': ',n.contact.first);
    fieldOut(___('lastname')+': ',n.contact.last);
    fieldOut(___('group')+': ', groups.id2name(n.contact.group));
    fieldOut(___('ip address')+': ',
      ifThen(n.contact.ip<>0,
        ifThen(n.contact.ip = ICQ.myinfo.ip,
          ip2str(n.contact.internal_ip),
          ip2str(n.contact.ip)
        )
      )
    );
    if not (n.contact.status in [SC_OFFLINE,SC_UNK]) then
      begin
      fieldOut(___('info client')+': ', getClientFor(n.contact));
      fieldOut(___('info online since')+': ', timeToStr(n.contact.onlinesince));
      end
    else
      fieldOut(___('info last online')+': ', timeToStr(n.contact.lastTimeSeenOnline));
    if visibleList.exists(n.contact) then fieldOut('',___('visible list'));
    if ICQ.readTemporaryVisible.exists(n.contact) then fieldOut('',___('temp visible list'));
    if invisibleList.exists(n.contact) then fieldOut('',___('invisible list'));
    if ignoreList.exists(n.contact) then fieldOut('',___('ignore list'));
    end;
  NODE_GROUP:
    begin
    picOut(PIC_CLOSE_GROUP);
    cl:=ICQ.readroaster;
    fieldOut(___('total')+': ', intToStr(cl.count(n.groupid)));
    if ICQ.isOnline then
      begin
      a:=0;
      b:=0;
      for i:=0 to cl.count-1 do
        with cl.getAt(i) do
          if group = n.groupid then
            if status = SC_OFFLINE then inc(a)
            else inc(b);
      fieldOut(___('divisor online')+': ',inttostr(b));
      fieldOut(___('divisor offline')+': ',inttostr(a));
      end;
    end;
  else
    begin
    r:=rect(0,0,0,0);
    exit;
    end;
  end;
r:=rect(0,0,maxX+ShadowSize+roundsize,y+ShadowSize+roundsize);
end; // drawNodeHint

procedure popupHintByMacro();
var
  bmp:Tbitmap;
  r:Trect;
  node:Tnode;
  pt:Tpoint;
begin
bmp:=createBitmap(1,1);
pt:=mainfrm.roaster.ScreenToClient(mousepos);
if within(0, pt.x, mainfrm.roaster.width)
and within(0, pt.y, mainfrm.roaster.height) then
  node:=roasterLib.nodeAt(pt.x,pt.y)
else
  node:=NIL;
if node=NIL then node:=clickedNode;
if node<>NIL then
	begin
	drawNodeHint(bmp.canvas, node.treenode, r);
	bmp.Width:=r.Right+1;
	bmp.Height:=r.bottom+1;
	drawNodeHint(bmp.canvas, node.treenode, r);
	tipfrm.show(bmp);
  end;
bmp.free;
end; // popupHintByMacro

function infoToStatus(info:string):Tstatus;
begin
if length(info) < 4 then result:=SC_UNK
else result:=Tstatus(str2int(info));
if (result<SC_ONLINE) or (result>SC_UNK) then result:=SC_UNK;
end; // infoToStatus

function exitFromAutoaway():boolean;
begin
result:=FALSE;
if autoaway.triggered=TR_none then exit;
setStatus(autoaway.bakstatus);
setAutomsg(autoaway.bakmsg);
autoaway.bakmsg:='';
result:=TRUE;
end; // exitFromAutoaway

procedure applyRoundedWindows();
begin
roundWindow(mainfrm);
roundWindow(chatFrm);
roundWindow(prefFrm);
end; // applyRoundedWindows

procedure applyMinButton();
begin
mainfrm.updateCaption();
if not showRoasterMinButton then
  begin
  freeAndNIL(mainfrm.minBtn);
  exit;
  end;
if mainFrm.minBtn = NIL then
  mainFrm.minBtn:=TjvcaptionButton.Create(mainfrm);
with mainFrm.minBtn do
  begin
  buttonWidth:=GetSystemMetrics(SM_CXSMSIZE);
  buttonHeight:=GetSystemMetrics(SM_CYSMSIZE)-4;
  buttonTop:=6;
  buttonleft:=(buttonWidth)*2+6;
  standard:=tsbMin;
  toggle:=FALSE;
  onClick:=mainfrm.minBtnClick;
  end;
end; // applyMinButton

procedure applyTaskButton(frm:Tform);
var
  i:integer;
begin
//setParent(frm.handle, 0);   this seems to work not, ugh
setwindowlong(frm.handle, GWL_HWNDPARENT, 0);
i:=getWindowLong(frm.handle, GWL_EXSTYLE);
setWindowLong(frm.handle, GWL_EXSTYLE, i or WS_EX_APPWINDOW);
end;

function getShiftState():integer;
var
  keys:TkeyboardState;
begin
result:=0;
if not GetKeyboardState(keys) then exit;
if keys[VK_SHIFT] >= $80 then	inc(result, 1);
if keys[VK_CONTROL] >= $80 then	inc(result, 2);
if keys[VK_MENU] >= $80 then	inc(result, 4);
end; // getShiftState

procedure addTempVisibleFor(time:integer; c:Tcontact);
begin
ICQ.addTemporaryVisible(c);
removeTempVisibleTimer:=time;
removeTempVisibleContact:=c;
end; // addTempVisibleFor

function md5(s:string):string;
begin result:=StrMD5(s) end;

procedure processOevent(oe:Toevent);
begin
case oe.kind of
  OE_MSG: if sendICQmsg(oe) then exit;
  OE_CONTACTS:
    begin
    sendICQcontacts( oe.uin, oe.flags, oe.cl);
    end;
  OE_AUTH: sendICQauth( oe.uin );
  OE_AUTHDENIED: sendICQauthDenied( oe.uin, oe.info );
  OE_ADDEDYOU: sendICQaddedYou(oe.uin);
  end;
end; // processOevent

INITIALIZATION

end.
