{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit viewinfoDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, contacts, ICQv7, Buttons, Mask, ToolEdit, ExtCtrls,
  ComCtrls, clipbrd, Menus, wsocket, strutils, JVSpin, JvMenus, JvEdit,
  JvMaskEdit;

type
  TviewinfoFrm = class(TForm)
    pagectrl: TPageControl;
    mainSheet: TTabSheet;
    Label7: TLabel;
    Label8: TLabel;
    Label2: TLabel;
    Label14: TLabel;
    Label13: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label20: TLabel;
    statusImg: TImage;
    aboutBox: TMemo;
    ipBox: TEdit;
    genderBox: TComboBox;
    countryBox: TComboBox;
    lang1Box: TComboBox;
    lang2Box: TComboBox;
    lang3Box: TComboBox;
    gmtBox: TComboBox;
    TabSheet2: TTabSheet;
    dontdeleteChk: TCheckBox;
    mailBtn: TSpeedButton;
    resolveBtn: TSpeedButton;
    ipbox2: TMemo;
    Label26: TLabel;
    copyBtn: TSpeedButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Label28: TLabel;
    uinlistsBox: TMemo;
    onlinesinceBox: TLabeledEdit;
    membersinceBox: TLabeledEdit;
    lastonlineBox: TLabeledEdit;
    lastmsgBox: TLabeledEdit;
    lastupdateBox: TLabeledEdit;
    groupBox: TLabeledEdit;
    TabSheet1: TTabSheet;
    notesBox: TMemo;
    protoBox: TLabeledEdit;
    publicChk: TCheckBox;
    goBtn: TSpeedButton;
    addmenu: TJvPopupMenu;
    smsChk: TCheckBox;
    clientBox: TLabeledEdit;
    topPnl: TPanel;
    deleteBtn: TSpeedButton;
    saveBtn: TSpeedButton;
    updateBtn: TSpeedButton;
    nickBox: TLabeledEdit;
    lastBox: TLabeledEdit;
    firstBox: TLabeledEdit;
    emailBox: TLabeledEdit;
    displayBox: TLabeledEdit;
    uinBox: TLabeledEdit;
    statusBox: TLabeledEdit;
    cityBox: TLabeledEdit;
    stateBox: TLabeledEdit;
    zipBox: TLabeledEdit;
    timeBox: TLabeledEdit;
    cellularBox: TLabeledEdit;
    homepageBox: TLabeledEdit;
    birthBox: TDateTimePicker;
    ageSpin: TJvSpinEdit;
    birthageBox: TComboBox;
    birthageLbl: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure updateBtnClick(Sender: TObject);
    procedure deleteBtnClick(Sender: TObject);
    procedure saveBtnClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure goBtnClick(Sender: TObject);
    procedure mailBtnClick(Sender: TObject);
    procedure resolveBtnClick(Sender: TObject);
    procedure dnslookup(Sender: TObject; Error: Word);
    procedure copyBtnClick(Sender: TObject);
    procedure addcontactAction(sender:Tobject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure birthBoxChange(Sender: TObject);
    procedure birthageBoxChange(Sender: TObject);
    procedure ageSpinChange(Sender: TObject);
    procedure FormResize(Sender: TObject);
  public
    contact:Tcontact;
    lookup:Twsocket;
    readOnlyContact:boolean;
    procedure updateInfo;
    constructor doAll(owner_ :Tcomponent; c:Tcontact);
    function isUpToDate:boolean;
    procedure setupBirthage;
  end;

var
  viewinfoFrm: TviewinfoFrm;

implementation

uses
  flap, globalLib, utilLib, mainDlg, langLib, roasterLib, chatDlg;

{$R *.DFM}

procedure TviewinfoFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
visible:=FALSE;
if displayBox.text <> contact.displayed then
  begin
  contact.display:=displayBox.text;
  roasterLib.sort(contact);
  chatFrm.userChanged(contact);
  end;
TCE(contact.data^).dontdelete:=dontdeleteChk.checked;
TCE(contact.data^).notes:=notesBox.text;
childWindows.remove(self);
action:=caFree;
destroyHandle;
end;

function findInStrings(s:string;ss:Tstrings):integer;
begin
result:=0;
while result < ss.count do
  if ss[result] = s then
    exit
  else
    inc(result);
result:=-1;
end; // findInStrings

procedure TviewinfoFrm.updateInfo;

  function gmt2str(gmt:Tdatetime):string;
  var
    halfs:integer;
  begin
  result:=___('gmt')+' ';
  if gmt < 0 then
    begin
    result:=result+'-';
    gmt:=-gmt;
    end
  else
    result:=result+'+';
  halfs:=round(gmt*48);
  if halfs = 100 then
    begin
    result:='';
    exit;
    end;
  result:=result+intToStr(halfs div 2);
  if odd(halfs) then
    result:=result+':30'
  else
    result:=result+':00';
  end; // gmt2str

  function datetime2str(dt:Tdatetime):string; overload;
  begin result:=datetimeTostrMinMax(dt,{1980}80*365,now) end;

begin
pagectrl.visible:=FALSE;
with contact do
  begin
  caption:=___('info title',[displayed]);
  if nodb then
    caption:=caption+___('info not found')
  else
    if infoUpdatedTo = 0 then
      caption:=caption+___('info no info')
    else
      if not isUpToDate then
        caption:=caption+___('info newer');
  displayBox.text:=displayed;
  firstBox.text:=first;
  lastBox.text:=last;
  emailBox.text:=email;
  cityBox.text:=city;
  stateBox.text:=state;
  aboutBox.text:=about;
  nickBox.text:=nick;
  uinBox.text:=intTOStr(uin);
  if contact=ICQ.myinfo then
    ipBox.text:=ICQ.getLocalIPstr
  else
    if ip = 0 then
      ipBox.text:=''
    else
      ipBox.text:=ip2str(ip);
  if ipBox.text='' then
    begin
    ipBox.text:=___('unk');
    resolveBtn.enabled:=FALSE;
    end
  else
    resolveBtn.enabled:=TRUE;
  copyBtn.enabled:=resolveBtn.enabled;
  ipbox2.text:=ipbox.text;
  if internal_ip<>0 then
    ipBox2.text:=ipBox2.text+CRLF+___('internal ip')+': '+ip2str(internal_ip);
  statusBox.text:=statusName(status);
  statusImg.Picture.bitmap.assign(getPic(status2imgIdx(status, invisible)));
  if zip='' then zipbox.text:=''
  else zipBox.text:=StringOfChar('0',5-length(zip))+zip;
  timeBox.text:='';
  cellularBox.text:=cellular;
  smsChk.checked:=smsable;

  with gmtBox do itemIndex:=findInStrings(gmt2str(getGMT), Items);
  with genderBox do itemIndex:=findInStrings(genderCodes.fromInt(gender), Items);
  with countryBox do itemIndex:=findInStrings(countryCodes.fromInt(country), Items);
  with lang1Box do itemIndex:=findInStrings(languageCodes.fromInt(lang[1]), Items);
  with lang2Box do itemIndex:=findInStrings(languageCodes.fromInt(lang[2]), Items);
  with lang3Box do itemIndex:=findInStrings(languageCodes.fromInt(lang[3]), Items);
  homepageBox.text:=homepage;
  if birth > 1 then
    begin
    birthBox.date:=birth;
    birthageBox.itemIndex:=1;
    end
  else
    if contact.age > 0 then
      begin
      ageSpin.value:=age;
      birthageBox.itemIndex:=2
      end
    else
      birthageBox.itemIndex:=0;
  setupbirthage;

  lastmsgBox.text:=datetime2str( TCE(data^).lastMsgTime );
  lastonlineBox.text:=datetime2str( lastTimeSeenOnline );
  lastupdateBox.text:=datetime2str( infoUpdatedTo );
  onlinesinceBox.text:=datetime2str( onlineSince );
  membersinceBox.text:=datetime2str( memberSince );

  notesBox.text:=TCE(data^).notes;
  publicChk.checked:=icq.publicEmail;
  dontdeleteChk.checked:=TCE(data^).dontdelete;
  clientBox.text:=getClientFor(contact);
  if clientBox.text ='' then clientBox.text:=___('unk');
  if contact=ICQ.myinfo then
    protoBox.text:='ver.'+intToStr(ICQv7.directprotoVersion)
  else
    protoBox.text:=ifThen(proto=0, ___('unk'),  'ver.'+intToStr(proto));
  if contact.group=0 then
    groupBox.text:='('+___('none')+')'
  else
    groupBox.text:=groups.id2name(contact.group);
  end;

uinlistsBox.text:='';
uinlists.resetEnumeration;
while uinlists.hasMore do
  with uinlists.getNext^ do
    if cl.exists(contact) then
      uinlistsBox.lines.add(name);
pagectrl.visible:=TRUE;
end; // updateInfo

procedure TviewinfoFrm.updateBtnClick(Sender: TObject);
begin
if ICQ.isOnline then
  ICQ.sendQueryInfo(contact.uin)
else
  msgDlg(___('online feature'),mtWarning);
end;

constructor TviewinfoFrm.doAll(owner_ :Tcomponent; c:Tcontact);
var
  i:integer;
  comp:Tcomponent;
  itsme:boolean;
begin
if c=NIL then exit;
inherited create(owner_);
position:=poDefaultPosOnly;
contact:=c;
applyCommonSettings(self);

countryBox.Items.text:=CRLF+countryCodes.strings;
genderBox.Items.text:=CRLF+genderCodes.strings;
lang1Box.Items.text:=CRLF+languageCodes.strings;
lang2Box.Items.text:=CRLF+languageCodes.strings;
lang3Box.Items.text:=CRLF+languageCodes.strings;
gmtBox.Items.text:=gmtCodes.strings;
if contact.infoUpdatedTo = 0 then
  ICQ.sendQueryInfo(contact.uin);
itsme:=ICQ.myinfo=c;
icon:=pic2ico(PIC_INFO);
updateBtn.Glyph.assign(getPic(PIC_LOAD_NET));
deleteBtn.Glyph.assign(getPic(PIC_DELETE));
goBtn.Glyph.assign(getPic(PIC_URL));
mailBtn.glyph.assign(getPic(PIC_MAIL));

birthBox.MinDate:=now-120*365;
birthBox.MaxDate:=now-13*365;

for i:=componentcount-1 downto 0 do
  begin
  comp:=components[i];
  if comp is Tmemo then
    (comp as Tmemo).readonly:=not itsme;
  if comp is Tedit then
    (comp as Tedit).readonly:=not itsme;
  if comp is Tdatetimepicker then
    (comp as Tdatetimepicker).enabled:=itsme;
  if comp is Tlabelededit then
    (comp as Tlabelededit).readonly:=not itsme;
  if comp is TComboBox then
    (comp as TComboBox).enabled:=itsme;
  if (comp is Tcheckbox) then
    (comp as Tcheckbox).enabled:=itsme;
  if (comp is Tdateedit) then
    (comp as Tdateedit).readonly:=not itsme;
  if (comp is TJvSpinEdit) then
    (comp as TJvSpinEdit).readonly:=not itsme;
  end;
publicChk.visible:=itsme;
displayBox.readonly:=itsme;
displayBox.visible:=not itsme;
deleteBtn.visible:=not itsme;
dontdeleteChk.visible:=not itsme;
notesBox.readonly:=FALSE;
ipBox.readonly:=TRUE;
statusBox.readonly:=TRUE;
uinBox.readonly:=TRUE;

if itsme then
  begin
  saveBtn.caption:=___('info save');
  saveBtn.Glyph.assign(getPic(PIC_SAVE_NET));
  end
else
  begin
  saveBtn.caption:=___('info add');
  saveBtn.Glyph.assign(getPic(PIC_ADD_CONTACT));
  end;

translateWindow(self);
childWindows.Add(self);
updateViewInfo(c);
end; // doAll

procedure TviewinfoFrm.deleteBtnClick(Sender: TObject);
begin
if not roasterLib.exists(contact) then
  msgDlg(___('info can''t delete'),mtWarning)
else
  if messageDlg(___('info delete?',[contact.displayed]),mtConfirmation, [mbYes,mbNo], 0) = mrYes then
    roasterLib.remove(contact);
end;

procedure TviewinfoFrm.saveBtnClick(Sender: TObject);
var
  c:Tcontact;
begin
if contact<>ICQ.myinfo then
  begin
  addGroupsToMenu(self,addmenu.items, addcontactAction);
  with topPnl.clientToScreen(saveBtn.BoundsRect.bottomRight) do
    addmenu.popup(x,y);
  end
else
  if not ICQ.isOnline then
    msgDlg(___('online feature'),mtWarning)
  else
    begin
    c:=Tcontact.create(0);
    c.uin:=contact.uin;
    c.nick:=nickBox.text;
    c.first:=firstbox.Text;
    c.last:=lastbox.text;
    c.email:=emailbox.text;
    c.city:=citybox.text;
    c.state:=statebox.text;
    c.zip:=zipBox.text;
    c.age:=0;
    c.birth:=0;
    case birthageBox.itemindex of
      1: c.birth:=birthBox.date;
      2: c.age:=round(ageSpin.value);
      end;
    c.cellular:=cellularBox.text;
    c.homepage:=homepageBox.text;
    c.about:=aboutBox.text;
    c.gender:=genderCodes.fromString(genderBox.text);
    c.country:=countryCodes.fromString(countryBox.text);
    c.lang[1]:=languageCodes.fromString(lang1Box.text);
    c.lang[2]:=languageCodes.fromString(lang2Box.text);
    c.lang[3]:=languageCodes.fromString(lang3Box.text);
    c.GMThalfs:=gmtCodes.fromString(gmtBox.text);
    icq.publicEmail:=publicChk.checked;
    ICQ.sendSaveMyInfoAs(c);
{   // retrieves new datas from the server
    ICQ.sendStatusCode;
    ICQ.sendSimpleQueryInfo(c.uin);}
    c.free;
    end;
end;

procedure TviewinfoFrm.FormPaint(Sender: TObject);
begin wallpaperize(canvas) end;

procedure TviewinfoFrm.goBtnClick(Sender: TObject);
var
  s:string;
begin
s:=homepageBox.text;
if trim(s)='' then exit;
if not Imatches(s,1,'http://') then
  s:='http://'+s;
openURL(s);
end;

procedure TviewinfoFrm.mailBtnClick(Sender: TObject);
begin sendEmailTo(contact) end;

procedure TviewinfoFrm.resolveBtnClick(Sender: TObject);
begin
lookup.OnDnsLookupDone:=dnslookup;
lookup.reverseDnsLookup(ipbox.text)
end;

procedure TviewinfoFrm.dnslookup(Sender: TObject; Error: Word);
begin
if ipbox2=NIL then exit;
if Error = 0 then
  ipbox2.text:=ipbox2.text+CRLF+Twsocket(sender).DnsResultList.text
else
  ipbox2.text:=ipbox2.text+CRLF+___('error')+' '+intToStr(error);
end; // dnslookup

procedure TviewinfoFrm.copyBtnClick(Sender: TObject);
begin
if ipbox2.Lines.Count > 1 then
  clipboard.astext:=ipbox2.lines[1];
end;

procedure TviewinfoFrm.addcontactAction(sender:Tobject);
begin addToRoaster(contact, (sender as Tmenuitem).tag) end;

procedure TviewinfoFrm.FormShow(Sender: TObject);
begin
pageCtrl.ActivePageIndex:=0;
applyTaskButton(self)
end;

procedure TviewinfoFrm.FormCreate(Sender: TObject);
begin
lookup:=Twsocket.create(self);
end;

function TviewinfoFrm.isUpToDate:boolean;

  function newer(d:Tdatetime):boolean;
  begin result:=(d>10000) and (d<now) and (d>contact.infoUpdatedTo) end; 

begin
result:=not (newer(contact.lastUpdate) or newer(contact.lastInfoUpdate) or newer(contact.lastStatusUpdate))  
end; // isUpToDate

procedure TviewinfoFrm.birthBoxChange(Sender: TObject);
begin setupBirthAge end;

procedure TviewinfoFrm.setupBirthage;
var
  i:integer;
begin
i:=birthageBox.itemIndex;
ageSpin.Visible:= i=2;
birthBox.visible:= i=1;
birthageLbl.visible:= i=0;
end;

procedure TviewinfoFrm.birthageBoxChange(Sender: TObject);
begin setupBirthage end;

procedure TviewinfoFrm.ageSpinChange(Sender: TObject);
begin onlydigits(sender) end;

procedure TviewinfoFrm.FormResize(Sender: TObject);
begin roundWindow(self) end;

end.
