{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit visibilityDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, contacts, Menus, ICQv7;

type
  TvisibilityFrm = class(TForm)
    invisibleBox: TListBox;
    normalBox: TListBox;
    visibleBox: TListBox;
    move2normal: TButton;
    move2vis: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    move2inv: TButton;
    PopupMenu1: TPopupMenu;
    selectall1: TMenuItem;
    PopupMenu2: TPopupMenu;
    PopupMenu3: TPopupMenu;
    Selectall2: TMenuItem;
    Selectall3: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure normalBoxClick(Sender: TObject);
    procedure invisibleBoxClick(Sender: TObject);
    procedure visibleBoxClick(Sender: TObject);
    procedure move2invClick(Sender: TObject);
    procedure move2normalClick(Sender: TObject);
    procedure move2visClick(Sender: TObject);
    procedure selectall1Click(Sender: TObject);
    procedure Selectall2Click(Sender: TObject);
    procedure Selectall3Click(Sender: TObject);
  private
    normal:TcontactList;
    procedure setUpBoxes;
    procedure inv2normal;
    procedure inv2vis;
    procedure normal2vis;
    procedure normal2inv;
    procedure vis2normal;
    procedure vis2inv;
    procedure selectAll(lb:Tlistbox);
  public procedure destroyHandle;
  end;

var
  visibilityFrm: TvisibilityFrm;

implementation

{$R *.DFM}

uses
  globalLib, mainDlg, utilLib;

function what2display(c:Tcontact):string;
begin result:=c.displayed+'  '+intToStr(c.uin) end;

procedure fillUp(lb:Tlistbox; cl:TcontactList);
var
  i,where:integer;
  s:string;
  ss:Tstrings;
  c:Tcontact;
begin
ss:=TstringList.create;
for i:=0 to cl.count-1 do
  begin
  c:=cl.getAt(i);
  where:=0;
  s:=what2display(c);
  while (where < ss.count) and (compareText(s, ss[where])>0) do
    inc(where);
  ss.insertObject(where, s, c);
  end;
lb.items.assign(ss);
ss.free;
end; // fillUp

procedure TvisibilityFrm.setUpBoxes;
begin
fillUp(visibleBox, visibleList);
fillUp(normalBox, normal);
fillUp(invisibleBox, invisibleList);
end; // setUpBoxes

procedure TvisibilityFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
normal.free;
saveListsDelayed:=TRUE;
destroyHandle;
end;

function clFromBox(lb:Tlistbox):TcontactList;
var
  i:integer;
begin
result:=TcontactList.create;
i:=0;
while i < lb.items.count do
  begin
  if lb.selected[i] then
    result.add(Tcontact(lb.items.objects[i]));
  inc(i);
  end;
end; // clFromBox

procedure TvisibilityFrm.inv2normal;
var
  cl:TcontactList;
begin
cl:=clFromBox(invisibleBox);
normal.add(cl);
invisibleList.remove(cl);
cl.free;
end; // inv2normal

procedure TvisibilityFrm.inv2vis;
var
  cl:TcontactList;
begin
cl:=clFromBox(invisibleBox);
visibleList.add(cl);
invisibleList.remove(cl);
cl.free;
end; // inv2vis

procedure TvisibilityFrm.normal2vis;
var
  cl:TcontactList;
begin
cl:=clFromBox(normalBox);
visibleList.add(cl);
normal.remove(cl);
cl.free;
end; // normal2vis

procedure TvisibilityFrm.normal2inv;
var
  cl:TcontactList;
begin
cl:=clFromBox(normalBox);
invisibleList.add(cl);
normal.remove(cl);
cl.free;
end; // normal2inv

procedure TvisibilityFrm.vis2normal;
var
  cl:TcontactList;
begin
cl:=clFromBox(visibleBox);
visibleList.remove(cl);
normal.add(cl);
cl.free;
end; // vis2normal

procedure TvisibilityFrm.vis2inv;
var
  cl:TcontactList;
begin
cl:=clFromBox(visibleBox);
visibleList.remove(cl);
invisibleList.add(cl);
cl.free;
end; // vis2inv

procedure TvisibilityFrm.FormShow(Sender: TObject);
begin
icon:=pic2ico(PIC_VISIBILITY);
applyTaskButton(self);
normal:=ICQ.readroaster.clone.remove(invisibleList).remove(visibleList);
setUpBoxes;
end; // formshow

procedure unselect(lb:Tlistbox);
var
  i:integer;
begin
i:=0;
with lb do
  while i < items.count do
    begin
    selected[i]:=FALSE;
    inc(i);
    end;
end; // unselect

procedure TvisibilityFrm.normalBoxClick(Sender: TObject);
begin
unselect(visiblebox);
unselect(invisiblebox);
end;

procedure TvisibilityFrm.invisibleBoxClick(Sender: TObject);
begin
unselect(visiblebox);
unselect(normalbox);
end;

procedure TvisibilityFrm.visibleBoxClick(Sender: TObject);
begin
unselect(invisiblebox);
unselect(normalbox);
end;

procedure TvisibilityFrm.move2invClick(Sender: TObject);
begin
if normalBox.SelCount > 0 then normal2inv;
if visibleBox.SelCount > 0 then vis2inv;
if invisibleBox.SelCount = 0 then setUpBoxes;
updateICQvisibility;
saveListsDelayed:=TRUE;
mainfrm.roaster.repaint;
end;

procedure TvisibilityFrm.move2normalClick(Sender: TObject);
begin
if invisibleBox.SelCount > 0 then inv2normal;
if visibleBox.SelCount > 0 then vis2normal;
if normalBox.SelCount = 0 then setUpBoxes;
updateICQvisibility;
saveListsDelayed:=TRUE;
mainfrm.roaster.repaint;
end;

procedure TvisibilityFrm.move2visClick(Sender: TObject);
begin
if normalBox.SelCount > 0 then  normal2vis;
if invisibleBox.SelCount > 0 then inv2vis;
if visibleBox.SelCount = 0 then setUpBoxes;
updateICQvisibility;
saveListsDelayed:=TRUE;
mainfrm.roaster.repaint;
end;

procedure TvisibilityFrm.selectAll(lb:Tlistbox);
var
  i:integer;
begin
if lb<>normalBox then unselect(normalbox);
if lb<>visibleBox then unselect(visiblebox);
if lb<>invisibleBox then unselect(invisiblebox);
i:=0;
with lb do
  while i < items.count do
    begin
    selected[i]:=TRUE;
    inc(i);
    end;
end; // selectAll

procedure TvisibilityFrm.selectall1Click(Sender: TObject);
begin selectAll(invisibleBox) end;

procedure TvisibilityFrm.Selectall2Click(Sender: TObject);
begin selectAll(normalBox) end;

procedure TvisibilityFrm.Selectall3Click(Sender: TObject);
begin selectAll(visibleBox) end;

procedure TvisibilityFrm.destroyHandle; begin inherited end;

end.
