{
Copyright (C) 2002-2004  Massimo Melina (www.rejetto.com)

This file is part of &RQ.

    &RQ is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    &RQ is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with &RQ; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
unit wpDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ICQv7, Grids, JvMenus, ExtCtrls, Buttons, contacts,
  ComCtrls, Menus;

type
  TwpFrm = class(TForm)
    Label5: TLabel;
    ageBox: TComboBox;
    Label8: TLabel;
    genderBox: TComboBox;
    Label9: TLabel;
    onlineChk: TCheckBox;
    countryBox: TComboBox;
    results: TStringGrid;
    sbar: TPanel;
    searchBtn: TBitBtn;
    clearBtn: TBitBtn;
    langBox: TComboBox;
    Label10: TLabel;
    menu: TJvPopupMenu;
    Viewinfo1: TMenuItem;
    Addtocontactlist1: TMenuItem;
    Sendmessage1: TMenuItem;
    nickBox: TLabeledEdit;
    firstBox: TLabeledEdit;
    cityBox: TLabeledEdit;
    lastBox: TLabeledEdit;
    emailBox: TLabeledEdit;
    uinBox: TLabeledEdit;
    stateBox: TLabeledEdit;
    Label12: TLabel;
    ani: TAnimate;
    Label1: TLabel;
    accumulateChk: TCheckBox;
    menusaveastxt1: TMenuItem;
    menusaveasclb1: TMenuItem;
    procedure clearBtnClick(Sender: TObject);
    procedure searchBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Viewinfo1Click(Sender: TObject);
    procedure resultsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure uinBoxChange(Sender: TObject);
    procedure resultsDblClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Label12Click(Sender: TObject);
    procedure Sendmessage1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure menuPopup(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Label1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure menusaveastxt1Click(Sender: TObject);
    procedure menusaveasclb1Click(Sender: TObject);
    procedure resultsDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
  private
    Nresults :integer;
  public
    procedure stopSearch;
    procedure cleanResults;
    procedure addResult(wp:TwpResult);
    procedure updateNumResults;
    function selectedContact:Tcontact;
    procedure addcontactAction(sender:Tobject);
  public procedure destroyHandle;
  end;

var
  wpFrm: TwpFrm;

implementation

uses
  globallib, mainDlg, viewinfoDlg, utilLib, chatDlg;

{$R *.DFM}

procedure TwpFrm.clearBtnClick(Sender: TObject);
begin
uinBox.text:='';
nickBox.text:='';
firstBox.text:='';
lastBox.text:='';
emailBox.text:='';
cityBox.text:='';
countryBox.itemIndex:=0;
ageBox.itemIndex:=0;
genderBox.itemIndex:=0;
langBox.itemIndex:=0;
stateBox.text:='';
onlineChk.checked:=FALSE;
end; // clearBtn

procedure TwpFrm.searchBtnClick(Sender: TObject);

  function intValue(s:string):integer;
  begin
  s:=trim(s);
  if s = '' then
    result:=0
  else
    result:=strToInt(s)
  end; // intValue

var
  wp:TwpSearch;
  uin:integer;
begin
if searchBtn.Kind = bkNo then
  begin
  stopSearch;
  exit;
  end;
if not ICQ.isOnline then
  begin
  msgDlg(___('online feature'),mtInformation);
  exit;
  end;
if uinBox.text > '' then
  begin
  uin:=strToInt(uinBox.text);
  if not validUIN(uin) then
    begin
    sbar.caption:=___('invalid uin');
    exit;
    end;
  wp.uin:=uin;
  end
else
  wp.uin:=0;
wp.nick:=trim(nickBox.Text);
wp.first:=trim(firstBox.Text);
wp.last:=trim(lastBox.Text);
wp.email:=trim(emailBox.Text);
wp.city:=trim(cityBox.Text);
wp.age:=ageCodes.FromString(trim(ageBox.Text));
wp.onlineOnly:=onlineChk.checked;
wp.gender:=genderCodes.fromString(genderBox.text);
wp.country:=countryCodes.fromString(countryBox.text);
wp.state:=trim(stateBox.text);
wp.lang:=languageCodes.fromString(langBox.text);

if not accumulateChk.checked then cleanResults;
searchBtn.kind:=bkNo;
searchBtn.Caption:=___('stop');
ani.Active:=TRUE;
ICQ.sendWPsearch(wp);
end; // searchBtn

procedure TwpFrm.stopSearch;
begin
ani.Active:=FALSE;
searchBtn.kind:=bkOK;
searchBtn.Caption:=___('search');
end;

procedure TwpFrm.updateNumResults;
begin sbar.caption:=___('wp results',[Nresults]) end;

procedure TwpFrm.FormCreate(Sender: TObject);
begin
countryBox.Items.text:=#13#10+countryCodes.strings;
genderBox.Items.text:=#13#10+genderCodes.strings;
langBox.Items.text:=#13#10+languageCodes.strings;
ageBox.items.text:=#13#10+ageCodes.strings;
results.Cells[0,0]:=___('online');
results.Cells[1,0]:=___('uin');
results.Cells[2,0]:=___('nickname');
results.Cells[3,0]:=___('firstname');
results.Cells[4,0]:=___('lastname');
results.Cells[5,0]:=___('email');
results.ColWidths[0]:=35;
results.ColWidths[1]:=60;
results.ColWidths[5]:=130;
cleanResults;
end;

procedure TwpFrm.cleanResults;
var
  i:integer;
begin
Nresults:=0;
results.rowCount:=2;
for i:=0 to results.colCount-1 do
  results.cells[i,1]:='';
updateNumResults;
end; // cleanResults

procedure TwpFrm.addResult(wp:TwpResult);
var
  s:string;
  i:integer;
begin
// does already exist ?
for i:=0 to results.RowCount-1 do
  if results.Cells[1,i]=intToStr(wp.uin) then
    exit;

inc(Nresults);
if Nresults > 1 then
  results.rowCount:=1+Nresults;
case wp.status of
  0:s:=___('no');
  1:s:=___('yes');
  else s:='?';
  end;
results.Cells[0,Nresults]:=s;
results.Cells[1,Nresults]:=intToStr(wp.uin);
results.Cells[2,Nresults]:=wp.nick;
results.Cells[3,Nresults]:=wp.first;
results.Cells[4,Nresults]:=wp.last;
results.Cells[5,Nresults]:=wp.email;
updatenumResults;
end; // addResult

function TwpFrm.selectedContact:Tcontact;
begin result:=contactsDB.get(strToInt(results.cells[1,results.row])) end;

procedure TwpFrm.Viewinfo1Click(Sender: TObject);
begin
viewInfoAbout(selectedContact);
end;

procedure TwpFrm.resultsMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  newcol,newrow:integer;
begin
results.mouseToCell(x,y, newcol,newrow);
if (newrow < 1) or (newrow > Nresults) then
  exit;
results.row:=newrow;
if button = mbRight then
  with results.clientToscreen(Point(x,y)) do
    menu.Popup(x,y);
end;

procedure TwpFrm.uinBoxChange(Sender: TObject);
begin onlyDigits(sender) end;

procedure TwpFrm.resultsDblClick(Sender: TObject);
begin
if (results.Row < 1) or (results.Row > Nresults) then
  exit;
viewinfo1click(self);
end;

procedure TwpFrm.FormPaint(Sender: TObject);
begin drawTiled(canvas, getPic(PIC_WALLPAPER)) end;

procedure TwpFrm.Label12Click(Sender: TObject);
begin with onlineChk do checked:=not checked end;

procedure TwpFrm.Sendmessage1Click(Sender: TObject);
begin chatFrm.openOn(selectedContact) end;

procedure TwpFrm.addcontactAction(sender:Tobject);
begin addToRoaster(selectedContact, (sender as Tmenuitem).tag) end;

procedure TwpFrm.destroyHandle; begin inherited end;

procedure TwpFrm.FormShow(Sender: TObject);
begin
applyTaskButton(self);
icon:=pic2ico(PIC_WP);
end;

procedure TwpFrm.menuPopup(Sender: TObject);
begin
addGroupsToMenu(self, Addtocontactlist1, addcontactAction);
end;

procedure TwpFrm.FormDestroy(Sender: TObject);
begin freeandnil(wpFrm) end;

procedure TwpFrm.Label1Click(Sender: TObject);
begin with accumulateChk do checked:=not checked end;

procedure TwpFrm.FormResize(Sender: TObject);
begin results.height:=clientHeight-sbar.BoundsRect.bottom-5 end;

procedure TwpFrm.menusaveastxt1Click(Sender: TObject);
var
  i:integer;
  s:string;
begin
s:='';
with results do
  for i:=1 to Nresults do
    s:=s+cells[1,i]+' '+cells[2,i]+', '
    	+cells[3,i]+' '+cells[4,i]+CRLF;
if savefile(savedlg(self, 'txt'), s) then msgDlg(___('done'), mtInformation)
else msgDlg(___('error'), mtError);
end;

procedure TwpFrm.menusaveasclb1Click(Sender: TObject);
var
  i:integer;
  cl:Tcontactlist;
  c:Tcontact;
begin
cl:=Tcontactlist.Create;
with results do
  for i:=1 to Nresults do
  	begin
    c:=Tcontact.create(strToInt(results.Cells[1,i]));
    c.nick:=results.Cells[2,i];
    c.first:=results.Cells[3,i];
    c.last:=results.Cells[4,i];
    c.email:=results.Cells[5,i];
    cl.add(c);
    end;
if savefile(savedlg(self, 'clb'), contactlist2clb(cl))  then
  msgDlg(___('done'), mtInformation)
else
  msgDlg(___('error'), mtError);
cl.resetEnumeration();
while cl.hasMore() do
	cl.getNext.Free();
cl.free();
end;

procedure TwpFrm.resultsDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
  cnv: Tcanvas;
  x, y: integer;
begin
x:=rect.left;
y:=rect.top;
cnv:=results.Canvas;
if gdSelected in state then
  begin
  cnv.Brush.Color:=clHighlight;
  cnv.font.Color:=clHighlightText;
  end
else
  begin
  cnv.Brush.Color:=clWindow;
  cnv.font.Color:=clWindowText;
  end;
if gdFixed in state then
  begin
  cnv.Brush.Color:=clBtnFace;
  cnv.Font.color:=clBtnText;
  inc(x,3);
  inc(y,2);
  end;
cnv.FillRect(rect);
try
  if ICQ.readRoaster.exists(strToInt(results.Cells[1,aRow])) then
    cnv.font.Color:=clGrayText;
except end;
cnv.TextRect(rect, x,y, results.Cells[acol,arow]);
end;

end.
